/*
 * Created on 19/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.answer;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestAnswer;
import il.ac.technion.cs.course236308.e3.med.model.TestAnswersFactory;
import il.ac.technion.cs.course236308.e3.med.stats.StatisticData;


/**
 * @author Alexander, Bennyamin, Svetlana and Valentin 
 * 
 *  Created in SSDL lab - Technion Israel
 *
 */
public class AnswerAddToTest extends Command {
	private Test test = null;
	private Answer answer = null;
	private TestAnswer testAnswer = null;
	private boolean updateStats = false;
	/**
	 * Method AnswerAddToTest
	 * @param test
	 * @param testVersion
	 * @param answer
	 */
	public AnswerAddToTest(Test test,  Answer answer,boolean updateStats) {
		this.test = test;
		this.answer = answer;
		this.updateStats = updateStats;
	}
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		testAnswer =
			TestAnswersFactory.getInstance().createTestAnswer(test,answer);
		if(updateStats){
			StatisticData.getInstance().updateQuestionsStatistics(test.getId());
		}
		MedReporter.report(
			"# new test answer created, id = "
				+ answer.getId()
				+ ", for test "
				+ test.getId());
	}

	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException, CriticalException {
		TestAnswersFactory.getInstance().deleteTestAnswer(testAnswer);
		if(updateStats){
			StatisticData.getInstance().updateQuestionsStatistics(test.getId());
		}
	}

	public String toString() {
		return "Adding Answer " + answer.getText() + " to Test";
	}

}
