/*
 * Created on 19/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.answer;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.TestAnswer;
import il.ac.technion.cs.course236308.e3.med.model.TestAnswersFactory;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin 
 * Created in SSDL lab - Technion Israel
 *
 */
public class AnswerRemoveFromTest extends Command {
	private TestAnswer testAnswer = null;

	/**
	 * Method AnswerRemoveFromTest
	 * @param testAnswer
	 */
	public AnswerRemoveFromTest(TestAnswer testAnswer){
		this.testAnswer = testAnswer;
	}
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException,CriticalException {
		TestAnswersFactory.getInstance().deleteTestAnswer(testAnswer);
		MedReporter.report("# test answer deleted, id = "
			+testAnswer.getAnswerId()+", for test "+ testAnswer.getTestId());
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException,CriticalException{
		TestAnswersFactory.getInstance().storeTestAnswer(testAnswer);
	}

	public String toString() {
		return "Remove answer from Test";
	}

}
