/*
 * Created on 26/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.answer;

import java.util.Iterator;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.model.VersionsFactory;

/**
 * @author sybenny
 *
 */
public class AnswerSelectNextOrdinal extends Command {

	private Answer oldAnswer = null;

	/**
	 * Method AnswerSelectNextOrdinal
	 */
	public AnswerSelectNextOrdinal() {
		this.oldAnswer = CommandDispatcher.getInstance().getCurrentAnswer();
	}
	/**
	 * Method AnswerSelectNextOrdinal
	 * @param oldAnswer
	 */
	public AnswerSelectNextOrdinal(Answer oldAnswer) {
		this.oldAnswer = oldAnswer;
	}
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (oldAnswer == null) { throw new 
			RetriableException("Can't execute no current answer defined");
		}
		Version version =
			VersionsFactory.getInstance().getVersion(oldAnswer.getVersionId());
		for (Iterator iter = version.getAnswers().iterator();
			iter.hasNext();
			) {
			Answer ans = (Answer) iter.next();
			if (ans.getOrdinal() == oldAnswer.getOrdinal() + 1) {
				runAndPush(new AnswerSelect(ans.getId()));
				MedReporter.report(
					"# answer marked as current, id = " + ans.getId());
				return;
			}
		}
		throw new RetriableException(
			"# No answer with ordinal "
				+ (oldAnswer.getOrdinal() + 1)
				+ " of version "
				+ version.getId()
				+ " was found in system");
	}

}
