/*
 * Created on 26/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.answer;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.command.version.VersionSelect;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.model.VersionsFactory;

/**
 * @author sybenny
 *
 */
public class AnswerSelectVersion extends Command {

	private Answer answer;

	/**
	 * Method AnswerSelectVersion
	 */
	public AnswerSelectVersion(){
		this.answer = CommandDispatcher.getInstance().getCurrentAnswer();
	}
	/**
	 * Method AnswerSelectVersion
	 * @param answer
	 */
	public AnswerSelectVersion(Answer answer){
		this.answer = answer;
	}
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (answer == null){ throw new 
			RetriableException("Can't execute - no current answer defined");
		}
		Version version = 
				VersionsFactory.getInstance().getVersion(answer.getVersionId());
		runAndPush(new VersionSelect(version));
		MedReporter.report(
			"# version marked as current, id = " + version.getId());

	}
}
