/*
 * Created on 21/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.answer;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.command.version.VersionSetUpdatedDate;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.model.VersionsFactory;

/**
 * @author sybenny
 *
 */
public class AnswerSetComment extends Command {

	private String newComment;
	private String oldComment;
	private Answer answer;
	private Version version;

	/**
	 * Method AnswerSetComment
	 * @param answer
	 * @param comment
	 */
	public AnswerSetComment(Answer answer, String comment) {
		newComment = comment;
		this.answer = answer;
	}

	/**
	 * Method AnswerSetComment
	 * @param comment
	 */
	public AnswerSetComment(String comment) {
		this.answer = CommandDispatcher.getInstance().getCurrentAnswer();
		this.newComment = comment;
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (answer == null) { throw new 
			RetriableException("Can't execute no current answer defined");
		}
		version = VersionsFactory.getInstance().getVersion(answer.getVersionId());
		if (version.isLocked()) {throw new 
			RetriableException("Can't update answer - locked version");
		}
		oldComment = answer.getNotes();
		answer.setNotes(newComment);
		answer.updateDB();
		runAndPush(new VersionSetUpdatedDate(version));
		version.updateDB();
		MedReporter.report(
			"# Comment for answer was set, id = "
				+ answer.getId()
				+ " New Comment:"
				+ newComment);

	}
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException, CriticalException {
		super.undo();
		answer.setNotes(oldComment);
		answer.updateDB();
		version.updateDB();
	}
	
	public String toString(){
		return "Set Note of answer " + answer.getOrdinal();
	}

}
