/*
 * Created on 20/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.answer;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.command.version.VersionSetUpdatedDate;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.model.VersionsFactory;

/**
 * @author sybenny
 *
 */
public class AnswerSetLanguage extends Command {

	private String newLanguage;
	private String oldLanguage;
	private Answer answer;
	private Version version;

	/**
	 * Method AnswerSetLanguage
	 * @param answer
	 * @param newLanguage
	 */
	public AnswerSetLanguage(Answer answer, String newLanguage) {
		this.newLanguage = newLanguage;
		this.answer = answer;
	}

	/**
	 * Method AnswerSetLanguage
	 * @param language
	 */
	public AnswerSetLanguage(String language) {
		this.answer = CommandDispatcher.getInstance().getCurrentAnswer();
		this.newLanguage = language;
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (answer == null) { throw new 
			RetriableException("Can't execute no current answer defined");
		}
		version = VersionsFactory.getInstance().getVersion(answer.getVersionId());
		if (version.isLocked()) { throw new 
			RetriableException("Can't update answer - locked version");
		}
		oldLanguage = answer.getLanguage();
		answer.setLanguage(newLanguage);
		answer.updateDB();
		runAndPush(new VersionSetUpdatedDate(version));
		version.updateDB();
		MedReporter.report(
			"# Language for answer was set, id = "
				+ answer.getId()
				+ " New Language:"
				+ newLanguage);

	}
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException, CriticalException {
		super.undo();
		answer.setLanguage(oldLanguage);
		answer.updateDB();
		version.updateDB();
	}

	public String toString(){
		return "Set language of answer " + answer.getOrdinal();
	}

}
