/*
 * Created on 20/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.answer;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.command.version.VersionSetUpdatedDate;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.model.VersionsFactory;

/**
 * @author sybenny
 *
 */
public class AnswerSetMixable extends Command {

	private boolean newMixable;
	private boolean oldMixable;
	private Answer answer;
	private Version version;

	/**
	 * Method AnswerSetMixable
	 * @param answer
	 * @param newMixable
	 */
	public AnswerSetMixable(Answer answer, boolean newMixable) {
		this.newMixable = newMixable;
		this.answer = answer;
	}

	/**
	 * Method AnswerSetMixable
	 * @param mixable
	 */
	public AnswerSetMixable(boolean mixable) {
		this.answer = CommandDispatcher.getInstance().getCurrentAnswer();
		this.newMixable = mixable;
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (answer == null) { throw new 
			RetriableException("Can't execute no current answer defined");
		}
		version = VersionsFactory.getInstance().getVersion(answer.getVersionId());
		if (version.isLocked()) {throw new 
			RetriableException("Can't update answer - locked version");
		}
		oldMixable = answer.isMixable();
		answer.setMixable(newMixable);
		answer.updateDB();
		runAndPush(new VersionSetUpdatedDate(version));
		version.updateDB();
		CommandDispatcher.getInstance().checkVersionLegality(version);
		MedReporter.report(
			"# Mixable for answer was set, id = "
				+ answer.getId()
				+ " New Mixable:"
				+ newMixable);

	}
	/**
	 * Method undo
	 * @throws CriticalException
	 * @throws RetriableException
	 * @see Command#undo()
	 */
	public void undo() throws  RetriableException, CriticalException {
		super.undo();
		answer.setMixable(oldMixable);
		answer.updateDB();
		version.updateDB();
		CommandDispatcher.getInstance().checkVersionLegality(version);
	}
	
	public String toString(){
		return "Set Answer mixable to: " + newMixable;
	}

}
