/*
 * Created on 20/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.answer;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.command.version.VersionSetUpdatedDate;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.model.VersionsFactory;
import il.ac.technion.cs.course236308.e3.med.xmlTools.TextCorrectnessChecker;

/**
 * @author sybenny
 *
 */
public class AnswerSetText extends Command {

	private String newText;
	private String oldText;
	private Answer answer;
	private Version version;

	/**
	 * Method AnswerSetText
	 * @param answer
	 * @param text
	 */
	public AnswerSetText(Answer answer, String text) {
		newText = text;
		this.answer = answer;
	}

	/**
	 * Method AnswerSetText
	 * @param text
	 */
	public AnswerSetText(String text) {
		this.answer = CommandDispatcher.getInstance().getCurrentAnswer();
		this.newText = text;
	}
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (answer == null) { throw new 
			RetriableException("Can't execute no current answer defined");
		}
		version = VersionsFactory.getInstance().getVersion(answer.getVersionId());
		if (version.isLocked()) { throw new 
			RetriableException("Can't update answer - locked version");
		}
		if(newText == null || newText.length() == 0){
			throw new RetriableException("Answer text can not be empty");
		}
		TextCorrectnessChecker tcc = new TextCorrectnessChecker(newText);
		tcc.validate();
		
		oldText = answer.getText();
		answer.setText(newText);
		answer.updateDB();
		runAndPush(new VersionSetUpdatedDate(version));
		version.updateDB();
		CommandDispatcher.getInstance().checkAnswerLegality(answer);
		MedReporter.report(
			"# Text for answer was set, id = "
				+ answer.getId()
				+ " New Text:"
				+ newText);

	}
	/**
	 * Method undo
	 * @throws CriticalException
	 * @throws RetriableException
	 * @see Command#undo()
	 */
	public void undo() throws  RetriableException, CriticalException {
		super.undo();
		answer.setText(oldText);
		answer.updateDB();
		version.updateDB();
		CommandDispatcher.getInstance().checkAnswerLegality(answer);
	}

	public String toString(){
		return "Set Text of answer " + answer.getOrdinal();
	}

}
