/*
 * Created on 20/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.answer;

import java.util.HashMap;
import java.util.Iterator;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.xmlTools.ChangeAnsRefs;
import il.ac.technion.cs.course236308.e3.med.xmlTools.FindAnsRefs;
/**
 * @author sybenny
 *
 */
public class AnswerUpdateRefsForAll extends Command {
	private Version version;
	private HashMap oldRefs =null;

	/**
	 * Method AnswerSetOrdinal
	 * @param version
	 * @param map
	 */
	public AnswerUpdateRefsForAll(Version version,HashMap map) {
		this.version = version;
		this.oldRefs = map;
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		for(Iterator it=version.getAnswers().iterator();it.hasNext();){
			runAndPush(new AnswerSetReferences((Answer)it.next(),oldRefs));
		}
	}

	
	private class AnswerSetReferences extends Command{
		private Answer ans;
		private HashMap map;
		private String[] refsArr;
		public AnswerSetReferences(Answer ans,HashMap map){
			this.ans = ans;
			this.map = map;
			
		}
		protected void execute() throws RetriableException, CriticalException {
			refsArr = FindAnsRefs.findAnsRefs(ans.getText());
			String[] newArr = new String[refsArr.length];
			
			for(int i=0; i<refsArr.length;i++){
				String newRef = (String)map.get(refsArr[i]);
				newArr[i] = newRef==null? refsArr[i]:newRef;
			}
			
			ans.setText(ChangeAnsRefs.changeAnsRefs(ans.getText(), newArr));
			ans.updateDB();
		}
		public void undo() throws RetriableException, CriticalException {
			ans.setText(ChangeAnsRefs.changeAnsRefs(ans.getText(), refsArr));
			ans.updateDB();
		}
	}
}
