/*
 * Created on 21/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.category;

import java.util.Iterator;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.command.question.QuestionAddSecondaryCategory;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.CategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.model.Category;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.QuestionsFactory;

/**
 * @author sybenny
 *
*/
public class CategoryClone extends Command {

	private Category cloneTo = null;
	private Category category = null;
	private Category newCategory = null;
	private int cloneToId;

	/**
	 * Method CategoryClone
	 * @param cloneToId
	 */
	public CategoryClone(Integer cloneToId) {
		this.category = CommandDispatcher.getInstance().getCurrentCategory();
		if (cloneToId == null) {
			this.cloneToId =
				CommandDispatcher.getInstance().getCurrentCategory().getId();
		} else {
			this.cloneToId = cloneToId.intValue();
		}
	}

	/**
	 * Method CategoryClone
	 * @param category
	 * @param cloneToId
	 */
	public CategoryClone(Category category, int cloneToId) {
		this.category = category;
		this.cloneToId = cloneToId;
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	public void execute() throws RetriableException, CriticalException {
		if (category == null) { throw new RetriableException(
				"Can't clone category - no active category defined");
		}
		if (category
			.equals(CategoriesFactory.getInstance().getRootCategory())) {
			throw new RetriableException(
				"Can't clone category - root category can't be clonned");
		}

		try {
			cloneTo = CategoriesFactory.getInstance().getCategory(cloneToId);
		} catch (RetriableException e) {
			throw new RetriableException(
				"Category with id = " + cloneToId + " doesn't exist");
		}

		newCategory =
			CategoriesFactory.getInstance().cloneCategory(category, cloneTo);
		for (Iterator it = category.getQuestions().iterator(); it.hasNext();) {
			runAndPush(
				new QuestionAddSecondaryCategory(
					newCategory,
					(Question) it.next()));
		}
		for (Iterator it = category.getLinksToQuestionIds().iterator();it.hasNext();) {
			Question quest =
				QuestionsFactory.getInstance().getQuestion(
					((Integer) it.next()).intValue());
			runAndPush(new QuestionAddSecondaryCategory(newCategory, quest));
		}
		runAndPush(new CategorySelect(newCategory));
		MedReporter.report(
			"# new category cloned, new id = "
				+ newCategory.getId()
				+ " , for category "
				+ category.getId());
	}

	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException, CriticalException {
		super.undo();
		CategoriesFactory.getInstance().deleteCategory(newCategory);
	}
	
	public String toString(){
		try{
			return "Clone category: " + category.getFullName();
		}catch(Throwable e){
			return "";
		}
	}
}
