/*
 * Created on 21/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.category;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.CategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.model.Category;

/**
 * @author sybenny
 *
 */
public class CategoryCreate extends Command {

	private Category category = null;
	private Category parentCategory = null;
	private String name = null;

	/**
	 * Method CategoryCreate
	 * @param parentCategory
	 * @param name
	 */
	public CategoryCreate(Category parentCategory,String name){
		this.parentCategory = parentCategory;
		this.name = name; 
	}
	
	/**
	 * Method CategoryCreate
	 * @param name
	 */
	public CategoryCreate(String name) {
		this.parentCategory = 
			CommandDispatcher.getInstance().getCurrentCategory();
		this.name = name;
	}	

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	public void execute() throws RetriableException,CriticalException {
		if(parentCategory == null){ throw new RetriableException(
			"Can't create category - no current category defined");
		}
		category = 
			CategoriesFactory.getInstance().createCategory(parentCategory,name);
		runAndPush( new CategorySelect(category));
		MedReporter.report("# new category created, id = " + category.getId() + 
								" , in parent category " 
								+ parentCategory.getId());
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException,CriticalException{
		super.undo();
		CategoriesFactory.getInstance().deleteCategory(category);		
	}
	
	public String toString() {
		return "Create new Category";
	}

}
