/*
 * Created on 29/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.category;

import java.util.Iterator;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.model.Category;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin 
 * Created in SSDL lab - Technion Israel
 *
 */
public class CategoryDecreaseOrdinals extends Command {

	private int removedOrdinal;
	private Category parentCategory;

	/**
	 * Method CategorySetOrdinal
	 * @param parentCategory
	 * @param removedOrdinal
	 */
	public CategoryDecreaseOrdinals(Category parentCategory, 
										int removedOrdinal) {
		this.parentCategory = parentCategory;
		this.removedOrdinal = removedOrdinal;
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws  CriticalException {
		for(Iterator it=parentCategory.getCategories().iterator();
			it.hasNext();){
			Category cat = (Category)it.next();
			if(cat.getOrdinal() > removedOrdinal){
				cat.setOrdinal(cat.getOrdinal()-1);
				cat.updateDB();
			}
		}
	}
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws CriticalException {
		for(Iterator it=parentCategory.getCategories().iterator();
				it.hasNext();){
			Category cat = (Category)it.next();
			if(cat.getOrdinal() >= removedOrdinal){
				cat.setOrdinal(cat.getOrdinal()+1);
				cat.updateDB();
			}
		}
	}

}
