/*
 * Created on 24/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.category;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.CategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.model.Category;
/**
 * @author Alexander,Bennyamin,Svetlana and Valentin 
 * Created in SSDL lab - Technion Israel
 *
 */
public class CategorySelect extends Command {
	
	private Category currActiveCategory = null;
	private Category newActiveCategory = null;

	/**
	 * Method CategorySelect
	 * @param category
	 */
	public CategorySelect(Category category){
		 this.newActiveCategory = category;
	}

	/**
	 * Method CategorySelect
	 * @param categoryId
	 * @throws CriticalException
	 * @throws RetriableException
	 */
	public CategorySelect(int categoryId) 
		throws RetriableException, CriticalException{
		this.newActiveCategory =CategoriesFactory.getInstance().
			getCategory(categoryId);		
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() {
		currActiveCategory = CommandDispatcher.getInstance().
							getCurrentCategory();
		CommandDispatcher.getInstance().setCurrentCategory(newActiveCategory);
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo(){
		CommandDispatcher.getInstance().setCurrentCategory(currActiveCategory);
	}

}
