/*
 * Created on 29/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.category;

import java.util.Iterator;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Category;

/**
 * @author Alexander,Bennyamin, Svetlana and Valentin 
 * 
 *  Created in SSDL lab - Technion Israel
 *
 */
public class CategorySelectFirstSubcategory extends Command {
	private Category category;

	/**
	 * Method CategorySelectFirstSubcategory
	 */
	public CategorySelectFirstSubcategory() {
		this.category = CommandDispatcher.getInstance().getCurrentCategory();
	}
	/**
	 * Method CategorySelectFirstSubcategory
	 * @param category
	 */
	public CategorySelectFirstSubcategory(Category category) {
		this.category = category;
	}
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (category == null) { throw new 
			RetriableException("Can't execute - no current category defined");
		}
		for (Iterator it = category.getCategories().iterator();
			it.hasNext();
			) {
			Category cat = (Category) it.next();
			if (cat.getOrdinal() == 1) {
				runAndPush(new CategorySelect(cat));
				MedReporter.report(
					"# category marked as current, id = " + cat.getId());
				return;
			}
		}
		MedReporter.report(
			"# Category "+category.getId()+" has no subcategories");

	}

}
