/*
 * Created on 29/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.category;

import java.util.Iterator;
import java.util.List;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.CategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.model.Category;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin
 * Created in SSDL lab - Technion Israel
 *
 */
public class CategorySelectNextOrdinal extends Command {

	private Category category;

	/**
	 * Method CategorySelectNextOrdinal
	 * @param category
	 */
	public CategorySelectNextOrdinal(Category category) {
		this.category = category;
	}
	/**
	 * Method CategorySelectNextOrdinal
	 */
	public CategorySelectNextOrdinal() {
		this.category = CommandDispatcher.getInstance().getCurrentCategory();
	}
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (category == null) { throw new 
			RetriableException("Can't execute -  no current category defined");
		}
		if (category.getId() == 1) { throw new 
			RetriableException("Can't execute -  current category is root");
		}
		CategoriesFactory cf = CategoriesFactory.getInstance();
		Category parent = cf.getCategory(category.getParentID().intValue());
		if (parent == null) { throw new 
			RetriableException("Can't execute - there is no parent category");
		}
		List subCategories = parent.getCategories();
		for (Iterator iter = subCategories.iterator(); iter.hasNext();) {
			Category cat = (Category) iter.next();
			if (cat.getOrdinal() == category.getOrdinal() + 1) {
				runAndPush(new CategorySelect(cat.getId()));
				MedReporter.report(
					"# category marked as current, id = " + cat.getId());
				return;
			}
		}
		MedReporter.report(
			"# No category with ordinal "
				+ (category.getOrdinal() + 1)
				+ " was found in system");
	}

}
