/*
 * Created on 29/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.category;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.CategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.model.Category;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin 
 *  Created in SSDL lab - Technion Israel
 *
 */
public class CategorySelectParent extends Command {
	private Category category;

	/**
	 * Method CategorySelectParent
	 * @param category
	 */
	public CategorySelectParent(Category category) {
		this.category = category;
	}
	/**
	 * Method CategorySelectParent
	 */
	public CategorySelectParent() {
		this.category = CommandDispatcher.getInstance().getCurrentCategory();
	}
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (category == null) {	throw new 
			RetriableException("Can't execute - no current category defined");
		}
		if (category.getId() == 1) { //meaning we have root as current category
			throw new RetriableException("Can't execute - root has no parent");
		}
		CategoriesFactory cf = CategoriesFactory.getInstance();
		Category parent = cf.getCategory(category.getParentID().intValue());
		if (parent==null){
			throw new RetriableException("Can't execute - there is no parent");
		}
		runAndPush(new CategorySelect(parent));
		MedReporter.report(
			"# category marked as current, id = " + parent.getId());

	}

}
