/*
 * QuestionSetMainCategory.java
 * 
 *  Created on 23/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.category;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Category;

/**
 * @author svekant
 *
 */
public class CategorySetComment extends Command{

	private Category category;
	private String oldComment;
	private String newComment;
	
	/**
	 * Method CategorySetComment
	 * @param newComment
	 */
	public CategorySetComment(String newComment){
		this.newComment = newComment;
		this.category = CommandDispatcher.getInstance().getCurrentCategory();
	}

	/**
	 * Method CategorySetComment
	 * @param category
	 * @param newComment
	 */
	public CategorySetComment(Category category,String newComment){
		this.newComment = newComment;
		this.category = category;
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException,CriticalException{
		if(category == null){ throw new 
			RetriableException("Can't execute - no current category defined");
		}
		oldComment = category.getComment();		
		category.setComment(newComment);		
		category.updateDB();		
		MedReporter.report("# category updated, id = "+category.getId()
			+ ", new Comment = "+ newComment);
		
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws CriticalException{
		category.setComment(oldComment);		
		category.updateDB();
	}
	
	public String toString() {
		return "Set comment for category";
	}

}
