/*
 * Created on 04/05/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.grading;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Iterator;
import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.db.DBConnect;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.AnswersFactory;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestAnswer;
import il.ac.technion.cs.course236308.e3.med.model.TestTaker;
import il.ac.technion.cs.course236308.e3.med.model.TestTakersFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;
import il.ac.technion.cs.course236308.e3.med.model.TestsFactory;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;
import il.ac.technion.cs.course236308.e3.med.stats.QuestionsStats;
import il.ac.technion.cs.course236308.e3.med.stats.StatisticData;

/**
 * @author sybenny
 *
 *
 */
public class TestCreateGradingSheet extends Command {

	private String fileName;
	private Test test;
	private FileWriter out;
	
	/**
	 * Method TestCreateGradingSheet
	 * @param fileName
	 */
	public TestCreateGradingSheet(String fileName){
		this.fileName = fileName;
		test = CommandDispatcher.getInstance().getCurrentTest();
	}
	public TestCreateGradingSheet(Test test, String fileName){
			this.fileName = fileName;
			this.test = test;
	}
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {		
		try{
			out = new FileWriter(new File(fileName));
		}catch(IOException e){
			throw new RetriableException(e.getMessage());
		}
		
		if(test == null){
			throw new 
				RetriableException("Can't execute - no current test defined");
		}
		try{
			printTestDetails();
			if (GeneralParams.scriptMode) {
				printQuestionsSheet();
				printStudentGradesSheet();
			}else{
				printQuestionsSheetGui();
				printStudentGradesSheetGui();				
			}
			
			out.close();
		}catch(CriticalException e){
			// delete file and quit
			File fileToDelete = new File(fileName);
			fileToDelete.delete();
			throw new CriticalException(e.getMessage());
		}catch(IOException e){
			File fileToDelete = new File(fileName);
			fileToDelete.delete();
			throw new CriticalException(e.getMessage());
		}
		
	}

	// print factor , min grade , max grade , threshold 
	private void printTestDetails() throws RetriableException{
		String str = "Id :," + test.getId() + "\n";
		str += "Course name :," + test.getCourseName() + "\n";
		str += "Created :," + 
			new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").
			format(test.getCreated().getTime()) + "\n";
		str += "Updated :," + 
			new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").
			format(test.getUpdated().getTime()) + "\n";
		str += "Status :," + test.getStatus() + "\n\n";
		str += "Factor formula :, a = " + test.getFactorConstA() + 
						", b = " + test.getFactorConstB() + "\n";
		str += "Min grade : ," + test.getMinGrade() + "\n";
		str += "Max grade : ," + test.getMaxGrade() + "\n";
		str += "Passing grade : ," + test.getPassingGrade() + "\n\n";
		
		try{
			out.write(str);
		}catch(IOException e){
			throw new
			 RetriableException("Can't execute : cannot write to file " 
								+ fileName );
		}
	}
	private void printQuestionsSheet() 
		throws RetriableException, CriticalException{
		test.toCanonical();
		String str = "Question, Weigth ,A , P1 , P2 ,";
		str += "B , P1 , P2 ,C , P1 , P2 ,D , P1 , P2 ,";
		str += "E , P1 , P2 ,F , P1 , P2 ,G , P1 , P2 ,";
		str += "H , P1 , P2 ,I , P1 , P2 ,J , P1 , P2 \n";
		AnswersFactory af = AnswersFactory.getInstance();
		
		for(Iterator it=test.getTestVersions().iterator();it.hasNext();){
			TestVersion v = (TestVersion) it.next();
			str +=  v.getVersion().getQuestionId() + ", " 
							+ v.getWeight() + ", ";
			
			for(Iterator itAns=v.getTestAnswers().iterator();itAns.hasNext();){
				try{
					TestAnswer tans = (TestAnswer)itAns.next(); 
					Answer ans = af.getAnswer(tans.getAnswerId());
					str += tans.getWeight() + "%, ";
					str += Math.round(DBConnect.percentTestAnswerOfAllTestTakers(test,ans)*100)
							 + "% , " ; 
					str += Math.round(DBConnect.percentTestAnswerOfVersionReplies(test,ans)*100)
					 + "% , " ; 
				}catch(MedException e){
					throw new CriticalException(e.getMessage());
				}
			}
			
			str += "\n";
		}
		
		str+="\nP1 - Percent of student who choosed Test Answer" + 
	 			" out of all Test Takers in the given Test.\n";
		str+="P2 - Percent of student who choosed Test Answer" + 
	 			" out of all Test Takers who answered to the version.\n";
		try{
			out.write(str);
		}catch(IOException e){
			throw new RetriableException("Can't execute : " +
				"cannot write to file "+ fileName );
		}
	
	}
	private void printStudentGradesSheet()
		 throws RetriableException, CriticalException{
		
		String str = "\n Failers number , " ;
		str += DBConnect.countFailedTestTakers(test) + "\n";
		
		str += "\n Student id , Student name , Final Grade \n";
		TestTakersFactory ttf = TestTakersFactory.getInstance();
		
		for(Iterator it= ttf.getTestTakersOfTest(test).iterator();
				it.hasNext();){
			TestTaker tt = (TestTaker)it.next();
			
			str += tt.getId() + " ," +
				   tt.getName() + " ," ;
				   double studGrade = Double.MIN_VALUE;
				   try{
				   		studGrade =  DBConnect.getTestTakerGrade(tt);
				   }catch(RetriableException e){
				   		str += " N/A \n";
				   }
				   if(studGrade != Double.MIN_VALUE)
						str += studGrade + " \n" ;
		}
		
		try{
			out.write(str);
		}catch(IOException e){
			throw new 
				RetriableException("Can't execute : cannot write to file "
								+ fileName );
		}	
	}
	
	private void printQuestionsSheetGui() 
		throws RetriableException, CriticalException{
		Test canonTest = TestsFactory.getInstance().getCopyOfTest(test.getId());
		canonTest.toCanonical();
		String str = "Question, Weigth ,A , P1 , P2 ,";
		str += "B , P1 , P2 ,C , P1 , P2 ,D , P1 , P2 ,";
		str += "E , P1 , P2 ,F , P1 , P2 ,G , P1 , P2 ,";
		str += "H , P1 , P2 ,I , P1 , P2 ,J , P1 , P2 \n";
		AnswersFactory af = AnswersFactory.getInstance();
		QuestionsStats qs = StatisticData.getInstance().getQuestionsStats(test.getId());
        
		for(Iterator it=canonTest.getTestVersions().iterator();it.hasNext();){
			TestVersion v = (TestVersion) it.next();
			str +=  v.getVersion().getQuestionId() + ", " 
							+ v.getWeight() + ", ";
			
			for(Iterator itAns=v.getTestAnswers().iterator();itAns.hasNext();){
				try{
					TestAnswer tans = (TestAnswer)itAns.next(); 
					Answer ans = af.getAnswer(tans.getAnswerId());
					str += tans.getWeight() + "%, ";
					str += qs.calcP1(v.getVersion().getId(), ans.getOrdinal())
							 + ", " ; 
					str += qs.calcP2(v.getVersion().getId(), ans.getOrdinal())
					 + ", " ; 
				}catch(MedException e){
					throw new CriticalException(e.getMessage());
				}
			}
			
			str += "\n";
		}
		
		str+="\nP1 - Percent of student who chose the answer" + 
				" out of all students that took the test.\n";
		str+="P2 - Percent of student who chose the answer" + 
				" out of all students who answered the question.\n";
		try{
			out.write(str);
		}catch(IOException e){
			throw new RetriableException("Can't execute : " +
				"cannot write to file "+ fileName );
		}
	
	}
	private void printStudentGradesSheetGui()
		 throws RetriableException{
		QuestionsStats qs = StatisticData.getInstance().getQuestionsStats(test.getId());
		String str = "\n Num. failed :  , " ;
		str += qs.getStudentStats().getNumStudentsFailed() + "\n";
		
		str += "\n Student id , Student name , Final Grade \n";
		TestTakersFactory ttf = TestTakersFactory.getInstance();
		
		for(Iterator it= ttf.getTestTakersOfTest(test).iterator();
				it.hasNext();){
			TestTaker tt = (TestTaker)it.next();
			
			str += tt.getId() + " ," +
				   tt.getName() + " ," ;
				   double studGrade = Double.MIN_VALUE;
				   studGrade = qs.getStudentStats().getStudentGrade(tt.getId());
				   if(studGrade != Double.MIN_VALUE)
						str += studGrade + " \n" ;
		}
		
		try{
			out.write(str);
		}catch(IOException e){
			throw new 
				RetriableException("Can't execute : cannot write to file "
								+ fileName );
		}	
	}
	
	public String toString(){
		return "Create grading sheet";
	}
}
