/*
 * Created on 24/07/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.grading;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.TestRepliesFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestReply;
import il.ac.technion.cs.course236308.e3.med.model.TestTaker;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;

/**
 * @author sybenny
 *
 */
public class TestDeleteOneReply extends Command {

	TestTaker testTaker;
	TestVersion testVersion;
	int answerId; 
	TestReply tr;
	
	public TestDeleteOneReply(TestTaker testTaker,TestVersion testVersion,int answerId){
		this.testTaker = testTaker;
		this.testVersion = testVersion;
		this.answerId = answerId;
	}
	
	protected void execute() throws RetriableException, CriticalException {

		TestRepliesFactory trf = TestRepliesFactory.getInstance();
		tr = trf.getTestReply(testTaker.getId(),testVersion.getTestId(),answerId);
		trf.deleteTestReply(tr);
	}

	public void undo() throws CriticalException, RetriableException {
		
		TestRepliesFactory trf = TestRepliesFactory.getInstance();
		trf.createTestReply(tr);
		
	}
	public String toString() {
		return "Delete Reply: TestTaker: " + tr.getTestTakerId()
				 + " AnswerId: " + tr.getAnswerId();
	}
	
}
