/*
 * Created on 24/07/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.grading;

import java.util.List;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.AnswersFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestRepliesFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestReply;
import il.ac.technion.cs.course236308.e3.med.model.TestTaker;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;

/**
 * @author sybenny
 *
 */
public class TestSetOneReply extends Command {
	TestTaker testTaker;
	TestVersion testVersion;
	int answerId;
	TestReply oldTestReply;
	TestReply newTestReply;
	public TestSetOneReply(TestTaker testTaker,TestVersion testVersion,int answerId){
		this.testTaker = testTaker;
		this.testVersion = testVersion;
		this.answerId = answerId;
	}
	
	protected void execute() throws RetriableException, CriticalException {
		TestRepliesFactory trf = TestRepliesFactory.getInstance();
		// here we get list of replies according to tTakerId,VersionId,testId
		List reps = trf.getTestRepliesByVersion(testTaker.getId(),
							testVersion.getVersion().getId(),testVersion.getTestId());
		if (reps.size()!=0){
			oldTestReply = (TestReply) reps.get(0);  
		}
			// we assume that the reply was found
		if (oldTestReply!=null)
			trf.deleteTestReply(oldTestReply);
		
		newTestReply = new TestReply();
		newTestReply.setTestId(testVersion.getTestId());
		newTestReply.setTestTakerId(testTaker.getId());
		Answer ans = AnswersFactory.getInstance().getAnswer(answerId);
		newTestReply.setAnswerId(answerId);
		newTestReply.setAnswerText(ans.getText());
		trf.createTestReply(newTestReply);
		
		
	}
	public void undo() throws CriticalException, RetriableException {
		TestRepliesFactory trf = TestRepliesFactory.getInstance();
		trf.deleteTestReply(newTestReply);
		if (oldTestReply!=null)
			trf.createTestReply(oldTestReply);
	}
	public String toString() {
		return "Set Reply: TestTaker: " + newTestReply.getTestTakerId()
				 + " AnswerId: " + newTestReply.getAnswerId();
	}
}
