/*
 * Created on 04/05/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.grading;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestRepliesFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestReply;
import il.ac.technion.cs.course236308.e3.med.model.TestTaker;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;
import il.ac.technion.cs.course236308.e3.med.model.TestsFactory;

import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;

/**
 * @author svekant
 *
 *
 */
public class TestSetStudentAnswers extends Command {
	
	private char[] answersArray;
	private int[] checkSumArray;
	private TestTaker testTaker;
	private Test test;
	private int maxAnswersNum;
	
	// colors of the first row of the answers sheet 
	private boolean[] answerFirstRowGrey =
	 {false,true,false,false,true,false,true,false,true,false};
	
	/** Field answersNumPerSheet */
	public static final int ANSWERS_NUM_PER_SHEET = 20; 
	/** Field checkSumRowsNum */
	public static final int CHECKSUM_ROWS_NUM = 3;
	
	/**
	 * Method TestSetStudentAnswers
	 * @param answersArray
	 * @param checkSumArray
	 */
	public TestSetStudentAnswers(char[] answersArray, int[] checkSumArray){
		this.answersArray = answersArray;
		this.checkSumArray = checkSumArray;
		
		testTaker = CommandDispatcher.getInstance().getCurrentTestTaker();
		test = CommandDispatcher.getInstance().getCurrentTest();
		
		maxAnswersNum = 0;
	}

	/**
	 * Method TestSetStudentAnswers
	 * @param test
	 * @param testTaker
	 * @param answersArray
	 * @param checkSumArray
	 */
	public TestSetStudentAnswers(Test test, TestTaker testTaker,
						 char[] answersArray, int[] checkSumArray){
		this.answersArray = answersArray;
		this.checkSumArray = checkSumArray;
		
		this.testTaker = testTaker;
		this.test = test;
		
		maxAnswersNum = 0;
	}
	
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {		
		checkArguments();
		
		int[] rigthCheckSumArray = checkSumCalculate();
		if(checkSumArray != null && 
				rigthCheckSumArray.length != checkSumArray.length){
			throw new 
				RetriableException("Number of checksum values is wrong");
					
		}
		if(checkSumArray != null){
			for(int i = 0; i < checkSumArray.length; ++i){
				if(checkSumArray[i] != rigthCheckSumArray[i])
					throw new RetriableException("Checksum is wrong");
			}
		}

		// mix exam using notebookNum
		test = TestsFactory.getInstance().getCopyOfTest(test.getId());
		test.toScrambled(testTaker.getNotebookNumber());
		// insert answers
		List versions = test.getTestVersions();
		for (ListIterator i=versions.listIterator(); i.hasNext(); ) {
			int index = i.nextIndex();

			TestVersion tv = (TestVersion) i.next();
			List answers = tv.getVersion().getAnswers();
			
			TestReply reply = new TestReply();
			int answerIndex = getIndex(answersArray[index]);
			if(answerIndex >= answers.size())
				continue;
			Answer ans = (Answer)answers.get(answerIndex);
			try{
			
				reply = TestRepliesFactory.getInstance().getTestReply(testTaker.getId(),test.getId(),ans.getId());
				//	reply exists - update it
				Command c2 = new UpdateTestReplyDetails(reply ,ans.getId());
				runAndPush(c2);
			}catch(RetriableException e){
				// reply doesn't exist
				List repliesForVersion =TestRepliesFactory.getInstance().getTestRepliesByVersion(testTaker.getId(),ans.getVersionId(),test.getId()); 
				for(Iterator it2=repliesForVersion.iterator();it2.hasNext();){					
					TestRepliesFactory.getInstance().deleteTestReply((TestReply) it2.next());
				}
				reply.setAnswerId(ans.getId());
				reply.setTestId(test.getId());
				reply.setAnswerText(ans.getText());
				reply.setTestTakerId(testTaker.getId());
				
				Command c1 = new TestStoreReply(reply);
				runAndPush(c1);
			}
		}
		//		print checkSum 
		if(checkSumArray == null){
			printCheckSum(rigthCheckSumArray);
		}
		MedReporter.report("# answers of student " + testTaker.getId() +
		 " , exam id = " + test.getId() + " were set");
		
	}

	private int[] checkSumCalculate(){
		int sheetsNum = test.getTestVersions().size()/ANSWERS_NUM_PER_SHEET+ 1;
		
		//int maxAnswersNum = 0;
		List versions = test.getTestVersions();
		for (ListIterator i=versions.listIterator(); i.hasNext(); ) {
			TestVersion tv = (TestVersion) i.next();
			int currNum = tv.getTestAnswers().size();
			if(currNum > maxAnswersNum)
				maxAnswersNum = currNum;
		}
		
		maxAnswersNum ++ ; // add 'H' column
		int[] calcCheckSum = new 
					int[sheetsNum * maxAnswersNum * CHECKSUM_ROWS_NUM];
		int index = 0;
		
		// for each sheet (luah)		
		for(int i = 0; i < sheetsNum; ++i){
			// get number of question on the sheet
			int sheetQuestionNum = ANSWERS_NUM_PER_SHEET;			
			if(test.getTestVersions().size() - i*ANSWERS_NUM_PER_SHEET <
													 ANSWERS_NUM_PER_SHEET){
				sheetQuestionNum = 
					test.getTestVersions().size() - i*ANSWERS_NUM_PER_SHEET;
			}
							
			// get answers for the sheet
			char[] sheetAnswers = new char[sheetQuestionNum]; 
			for(int j = 0; j < sheetQuestionNum; ++j){
				sheetAnswers[j] = answersArray[i*ANSWERS_NUM_PER_SHEET + j]; 
			}
			
			// fill checkSumArray for the sheet
			// a. create and initialize array for the sheet's checksums 
			int[][] sheetCheckSum = 
				new int[CHECKSUM_ROWS_NUM][ANSWERS_NUM_PER_SHEET];
			for(int j = 0; j < CHECKSUM_ROWS_NUM; ++j)
				for(int k = 0; k < maxAnswersNum ; ++k)
					sheetCheckSum[j][k] = 0;
			
			// b. calculate white and grey checksums
			for(int j = 0; j < sheetQuestionNum; ++j){
				if(sheetAnswers[j] == 'x')
					continue;				
				if(isGreyField(j+1,sheetAnswers[j])){
					sheetCheckSum[1][getIndex(sheetAnswers[j]) + 1]++;
				}else{
					sheetCheckSum[0][getIndex(sheetAnswers[j]) + 1]++;
				}
			}
			
			// c. calculate third row checksum
			int whiteSum = 0;
			int greySum = 0;
			for(int j = 0; j < maxAnswersNum ; ++j){
				sheetCheckSum[2][j] = sheetCheckSum[0][j] + sheetCheckSum[1][j];
				whiteSum += sheetCheckSum[0][j];
				greySum += sheetCheckSum[1][j];
			}
			sheetCheckSum[0][0] = whiteSum;
			sheetCheckSum[1][0] = greySum;
			sheetCheckSum[2][0] = whiteSum + greySum;
			
			// d. write results to calcCheckSum
			for(int j = 0; j < maxAnswersNum ; ++j){
				calcCheckSum[index++] =  sheetCheckSum[0][j];
			}
			for(int j = 0; j < maxAnswersNum ; ++j){
				calcCheckSum[index++] =  sheetCheckSum[1][j];
			}
			for(int j = 0; j < maxAnswersNum ; ++j){
				calcCheckSum[index++] =  sheetCheckSum[2][j];
			}
			
		}
		
		return calcCheckSum;
	}
	
	private int getIndex(char c){
		return c - 'a';
	}
	
	private boolean isGreyField(int questionNum, char answerLetter){
		// does the number is odd ? 
		int ans = questionNum%2;
		boolean res = answerFirstRowGrey[getIndex(answerLetter)];
		
		if(ans == 1){ // as first line
			return res;
		}
		return !res;
	}
	
	private void printCheckSum(int[] checkSum){
		int sheetsNum = test.getTestVersions().size()/ANSWERS_NUM_PER_SHEET+ 1;
		
		
		MedReporter.report("# begin checksum data");
		int j = 0;
		for(int i = 1; i <= sheetsNum ; ++i){
			MedReporter.report("#   checksums for answer sheet " + i+
			 " of " + sheetsNum);
			MedReporter.report("#     line 1 (white): horizontal total");
			MedReporter.report(String.valueOf(checkSum[j++]));
			MedReporter.report("#     line 1 (white): by answer column");
			int endIndex = j + maxAnswersNum - 1;
			for(; j < endIndex ;j++){
				MedReporter.report(String.valueOf(checkSum[j]));			
			}
			MedReporter.report("#     line 2 (gray): horizontal total");
			MedReporter.report(String.valueOf(checkSum[j++]));
			MedReporter.report("#     line 2 (gray): by answer column");
			endIndex = j + maxAnswersNum - 1;
			for(; j < endIndex ;j++){
				MedReporter.report(String.valueOf(checkSum[j]));			
			}
			MedReporter.report("#     line 3 (sum): horizontal total");
			MedReporter.report(String.valueOf(checkSum[j++]));
			MedReporter.report("#     line 3 (sum): by answer column");
			endIndex = j + maxAnswersNum - 1;
			for(; j < endIndex ;j++){
				MedReporter.report(String.valueOf(checkSum[j]));			
			}
			MedReporter.report("# end checksum data");
		}
	}
	
	private void checkArguments() throws RetriableException, CriticalException{
		if(testTaker == null){
			throw new 
				RetriableException("Can't execute - " +
										"no current student defined");
		}
		
		if(test == null){
			throw new 
				RetriableException("Can't execute - " +
					"no current test defined");
		}	
		
		if(test.getStatus().equals("U")){
			throw new
				 RetriableException("The exam " + test.getId() + " is under construction");
		}
		
		// mix exam using notebookNum
		test = TestsFactory.getInstance().getCopyOfTest(test.getId());
		test.toScrambled(testTaker.getNotebookNumber());

		if(answersArray.length != test.getTestVersions().size()){
			throw new 
				RetriableException("Wrong number of answers");
		}
		
		// check that all answers are legitimate
		List versions = test.getTestVersions();
		for (ListIterator i=versions.listIterator(); i.hasNext(); ) {
			int j = i.nextIndex();
			TestVersion tv = (TestVersion) i.next();
			char ans = answersArray[j];
			
			int index = getIndex(ans);
			if(ans != 'x' && (index < 0 ||
						 index >= tv.getVersion().getAnswers().size())){
				throw new 
					RetriableException("No answer " +
							 ans + " in version id " + tv.getVersion().getId()); 
			}
		}

	
		
	}
	
	public String toString(){
		return "Set student's answer ";
	}
	
	static class TestStoreReply extends Command {
		private TestReply newTestReply;
		
		/**
		 * Method TestStoreReply
		 * @param newTestReply
		 */
		TestStoreReply(TestReply newTestReply){
			this.newTestReply = newTestReply;
		}
		/**
		 * Method execute
		 * @throws CriticalException
		 * @throws RetriableException
		 * @see Command#execute()
		 */
		protected void execute() throws  RetriableException, CriticalException{
			TestRepliesFactory.getInstance().createTestReply(newTestReply);
		}
		/**
		 * Method undo
		 * @throws CriticalException
		 * @throws RetriableException
		 * @see Command#undo()
		 */
		public void undo() throws RetriableException, CriticalException{
			TestRepliesFactory.getInstance().deleteTestReply(newTestReply);
		}
	}
	
	static class UpdateTestReplyDetails extends Command {
		private TestReply reply;
		private int newAnswerId,oldAnswerId;
				
		/**
		 * Method UpdateTestReplyDetails
		 * @param reply
		 * @param newAnswerId
		 */
		 UpdateTestReplyDetails(TestReply reply ,int newAnswerId){
			this.reply = reply;
			this.newAnswerId = newAnswerId;
			
			oldAnswerId = reply.getAnswerId();
		}
		
		/**
		 * Method execute
		 * @see Command#execute()
		 */
		protected void execute() throws CriticalException{
			reply.setAnswerId(newAnswerId);
			reply.updateDB();
		}
		
		/**
		 * Method undo
		 * @see Command#undo()
		 */
		public void undo() throws CriticalException{
			reply.setAnswerId(oldAnswerId);
			reply.updateDB();
		}
	}
}
