/*
 * Created on 26/07/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.grading;

import java.util.Iterator;
import java.util.List;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestRepliesFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestReply;
import il.ac.technion.cs.course236308.e3.med.model.TestTaker;
import il.ac.technion.cs.course236308.e3.med.model.TestTakersFactory;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

/**
 * @author sybenny
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TestSetStudentId extends Command {

	Test test;
	String oldId,newId;
	
	public TestSetStudentId(Test test,String oldId,String newId){
		this.test = test;
		this.oldId = oldId;
		this.newId = newId;	
	}
	public String toString() {
		return "Set Student Id: " + newId ;
		}
	protected void execute() throws  RetriableException, CriticalException {
		TestRepliesFactory trf = TestRepliesFactory.getInstance();
		List trList;
		trList = trf.getTestRepliesList(oldId,test.getId());
		
		Iterator iter = trList.iterator();
		while (iter.hasNext()){
			TestReply tr = (TestReply)iter.next();
			trf.deleteTestReply(tr);
			tr.setTestTakerId(newId);
			trf.createTestReply(tr); 
		}
		TestTakersFactory ttf = TestTakersFactory.getInstance();
		TestTaker tt;
		
		try {
			tt = ttf.getTestTaker(oldId,test.getId());
			ttf.deleteTestTaker(tt);
		} catch (RetriableException e) {
			tt = new TestTaker();
			tt.setName(GeneralParams.DEFAULT_TEST_TAKER_NAME);
			tt.setTestId(test.getId());
		} 
		tt.setId(newId);
		ttf.createTestTaker(tt);
	}
	public void undo() throws CriticalException, RetriableException {
		TestTakersFactory ttf = TestTakersFactory.getInstance();
		TestRepliesFactory trf = TestRepliesFactory.getInstance();
		List trList = trf.getTestRepliesList(newId,test.getId());
		Iterator iter = trList.iterator();
		while (iter.hasNext()){
			TestReply tr = (TestReply)iter.next();
			trf.deleteTestReply(tr);
			if (oldId.equals(GeneralParams.DEFAULT_TEST_TAKER_ID)==false)
				tr.setTestTakerId(oldId);
			trf.createTestReply(tr); 
		}
		
		TestTaker tt = ttf.getTestTaker(newId,test.getId());
		long oldRid = tt.getNotebookNumber();
		String oldName = tt.getName();
		ttf.deleteTestTaker(tt);
		if (oldId.equals(GeneralParams.DEFAULT_TEST_TAKER_ID) == false){
			tt.setId(oldId);
			tt.setName(oldName);
			tt.setNotebookNumber((int)oldRid);
			ttf.createTestTaker(tt);
		}
		
	}
	

}
