/*
 * Created on 21/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.question;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.command.version.VersionCreate;
import il.ac.technion.cs.course236308.e3.med.command.version.VersionMarkAsActive;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Category;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.QuestionsFactory;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin 
 * Created in SSDL lab - Technion Israel
 *
 */
public class QuestionCreate extends Command{

	private Question question;
	private Category category;

	/**
	 * Method QuestionCreate
	 */
	public QuestionCreate(){
		this.category = CommandDispatcher.getInstance().getCurrentCategory();
	}

	/**
	 * Method QuestionCreate
	 * @param category
	 */
	public QuestionCreate(Category category){
		this.category = category;
	}
	/**
	 * Create new question. Empty version is added to the question.
	 * The version will be active version.
	 */
	protected void execute() throws CriticalException, RetriableException{
		if (category == null){ throw new 
			RetriableException("Can't execute no parent category defined");
		}
		
		question = QuestionsFactory.getInstance().createQuestion(category);
		runAndPush(new QuestionSelect(question));
		runAndPush(new VersionCreate(question));
		runAndPush(new VersionMarkAsActive());		
		CommandDispatcher.getInstance().checkQuestionLegality(question);
		MedReporter.report("# new question created, id = " + question.getId());
	}

	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException, CriticalException{
		super.undo();
		QuestionsFactory.getInstance().deleteQuestion(question);
		CommandDispatcher.getInstance().removeIllegalObject(question);
		CommandDispatcher.getInstance().checkCategoryLegality(category);		
	}
	
	public String toString() {
			return "Create new question";
	}


}
