/*
 * Created on 29/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.question;

import java.util.Iterator;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.model.Category;
import il.ac.technion.cs.course236308.e3.med.model.Question;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin 
 * Created in SSDL lab - Technion Israel
 *
 */
public class QuestionDecreaseOrdinals extends Command {

	private int removedOrdinal;
	private Category category;

	/**
	 * Method CategorySetOrdinal
	 * @param category
	 * @param removedOrdinal
	 */
	public QuestionDecreaseOrdinals(Category category, int removedOrdinal) {
		this.category = category;
		this.removedOrdinal = removedOrdinal;
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws CriticalException {
		for(Iterator it=category.getQuestions().iterator();it.hasNext();){
			Question quest = (Question)it.next();
			if(quest.getOrdinal() > removedOrdinal){
				quest.setOrdinal(quest.getOrdinal()-1);
				quest.updateDB();
			}
		}
	}
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws CriticalException {
		for(Iterator it=category.getQuestions().iterator();it.hasNext();){
			Question quest = (Question)it.next();
			if(quest.getOrdinal() >= removedOrdinal){
				quest.setOrdinal(quest.getOrdinal()+1);
				quest.updateDB();
			}
		}
	}

}
