/*
 * Created on 21/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.question;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.version.VersionDelete;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.Version;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin
 * Created in SSDL lab - Technion Israel
 *
 */
public class QuestionDeleteUnlockedVersions extends Command {

	private Question question;

	/**
	 * Method QuestionDeleteUnlockedVersions
	 */
	public QuestionDeleteUnlockedVersions() {
		this.question = CommandDispatcher.getInstance().getCurrentQuestion();
	}
	/**
	 * Method QuestionDeleteUnlockedVersions
	 * @param question
	 */
	public QuestionDeleteUnlockedVersions(Question question) {
		this.question = question;
	}
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (question == null) { throw new 
			RetriableException("Can't execute no current question defined");
		}
		int cur=0;
		while(cur < question.getVersions().size())
		{
			Version ver = (Version)question.getVersions().get(cur);
			if (!ver.isLocked() && (question.getActiveVersionId()== null
				|| (ver.getId() != question.getActiveVersionId().intValue()))) {
				runAndPush(new VersionDelete(ver));
				cur--;
			}
			cur++;
		}
	}
	
	public String toString(){
		return "Delete unlocked versions of Question " + question.getId();
	}
}
