/*
 * QuestionAddSecondaryCategory.java
 * 
 *  Created on 23/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.question;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Category;
import il.ac.technion.cs.course236308.e3.med.model.Question;

/**
 * @author svekant
 *
 */
public class QuestionRemoveSecondaryCategory extends Command
{

	private Question question;
	private Category category;
	
	/**
	 * Method QuestionRemoveSecondaryCategory
	 */
	public QuestionRemoveSecondaryCategory(){
		this.question = CommandDispatcher.getInstance().getCurrentQuestion();
		this.category = CommandDispatcher.getInstance().getCurrentCategory();
	}
	
	/**
	 * Method QuestionRemoveSecondaryCategory
	 * @param question
	 * @param category
	 */
	public QuestionRemoveSecondaryCategory(Question question,Category category){
		this.question = question;
		this.category = category;
	}
	 
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws CriticalException, RetriableException{
		if(question == null){ throw new 
			RetriableException("Can't execute - no current question defined");
		}
		if(category == null){ throw new 
			RetriableException("Can't execute - no current category defined");
		}
		category.removeLinkToQuestion(question);	
		MedReporter.report("# Secondary category " + category.getId() +
		 " removed for question " + question.getId());			
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws CriticalException{	
		category.addLinkToQuestion(question);	
	}
	
	public String toString() {
		try{
			return "Remove Secondary Category \"" + category.getFullName() +"\" of Question: " + question.getId();
		}catch(Throwable e){
			return "";
		}
	}



}
