/*
 * QuestionSelect.java
 * 
 *  Created on 24/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.question;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.QuestionsFactory;


/**
 * @author svekant
 *
 */
public class QuestionSelect extends Command{
	
	private Question currActiveQuestion = null;
	private Question newActiveQuestion = null;

	/**
	 * Method QuestionSelect
	 * @param question
	 */
	public QuestionSelect(Question question){
		 this.newActiveQuestion = question;
	}

	/**
	 * Method QuestionSelect
	 * @param questionId
	 * @throws CriticalException
	 * @throws RetriableException
	 */
	public QuestionSelect(int questionId) 
			throws RetriableException, CriticalException{
		this.newActiveQuestion = QuestionsFactory.getInstance().
								getQuestion(questionId);		
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute()  {
		currActiveQuestion = CommandDispatcher.getInstance().
		getCurrentQuestion();
		CommandDispatcher.getInstance().setCurrentQuestion(newActiveQuestion);
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo(){
		CommandDispatcher.getInstance().setCurrentQuestion(currActiveQuestion);
	}
}
