/*
 * Created on 26/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.question;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.command.version.VersionSelect;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.model.VersionsFactory;

/**
 * @author sybenny
 *
 */
public class QuestionSelectActiveVersion extends Command {

	private Question question;

	/**
	 * Method QuestionSelectActiveVersion
	 */
	public QuestionSelectActiveVersion() {
		this.question = CommandDispatcher.getInstance().getCurrentQuestion();
	}
	/**
	 * Method QuestionSelectActiveVersion
	 * @param question
	 */
	public QuestionSelectActiveVersion(Question question) {
		this.question = question;
	}
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (question == null) { throw new 
			RetriableException("Can't execute - no current question defined");
		}
		if (question.isCancelled()){ throw new 
			RetriableException("Can't execute - question is cancelled");
		}
		int activeId = question.getActiveVersionId().intValue();
		Version currVersion = VersionsFactory.getInstance().
								getVersion(activeId);
		
		runAndPush(new VersionSelect(currVersion));
		MedReporter.report("# new current version was set , id = "+ activeId);
	}
}