/*
 * Created on 26/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.question;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.command.category.CategorySelect;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.CategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.model.Category;
import il.ac.technion.cs.course236308.e3.med.model.Question;

/**
 * @author sybenny
 *
 */
public class QuestionSelectMainCategory extends Command {

	private Question question;

	/**
	 * Method QuestionSelectMainCategory
	 */
	public QuestionSelectMainCategory() {
		this.question = CommandDispatcher.getInstance().getCurrentQuestion();
	}
	/**
	 * Method QuestionSelectMainCategory
	 * @param question
	 */
	public QuestionSelectMainCategory(Question question) {
		this.question = question;
	}
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (question == null) { throw new 
			RetriableException("Can't execute - no current question defined");
		}
		int mainCategory = question.getMainCategoryId();
		Category currCategory = CategoriesFactory.getInstance().
								getCategory(mainCategory);
		
		runAndPush(new CategorySelect(currCategory));
		MedReporter.report("# new current category was set , id = "
							+ mainCategory);
	}
}