/*
 * Created on 26/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.question;

import java.util.Iterator;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.command.version.VersionSelect;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.Version;

/**
 * @author sybenny
 *
 */
public class QuestionSelectOldestVersion extends Command {

	Question question;
	/**
	 * Method QuestionSelectOldestVersion
	 */
	public QuestionSelectOldestVersion() {
		this.question = CommandDispatcher.getInstance().getCurrentQuestion();
	}
	/**
	 * Method QuestionSelectOldestVersion
	 * @param question
	 */
	public QuestionSelectOldestVersion(Question question) {
		this.question = question;

	}
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (question == null) { throw new 
			RetriableException("Can't execute - no current question defined");
		}
		
		Iterator it = question.getVersions().iterator();
		Version oldestVersion = (Version)it.next();
		while(it.hasNext()) {
			Version ver = (Version)it.next();
			if (oldestVersion.getCreated().after(ver.getCreated())) {
				oldestVersion = ver;
			}
		}
		runAndPush(new VersionSelect(oldestVersion));
		MedReporter.report("# new current version was set , id = " 
								+ oldestVersion.getId());
	}
}
