/*
 * Created on 21/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.question;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Question;

/**
 * @author sybenny
 *
 */
public class QuestionSetCanceled extends Command {

	private boolean newCancel;
	private boolean oldCancel;
	private Question question;

	/**
	 * Method QuestionSetCanceled
	 * @param cancel
	 */
	public QuestionSetCanceled(boolean cancel) {
		this.newCancel = cancel;
		this.question = CommandDispatcher.getInstance().getCurrentQuestion();
	}
	/**
	 * Method QuestionSetCanceled
	 * @param question
	 * @param cancel
	 */
	public QuestionSetCanceled(Question question, boolean cancel) {
		this.newCancel = cancel;
		this.question = question;
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (question == null) { throw new 
			RetriableException("Can't execute - no current question defined");
		}
		oldCancel = question.isCancelled();
		question.setCancelled(newCancel);
		question.updateDB();
		MedReporter.report(
			"# Cancel for question was set, id = "
				+ question.getId()
				+ " New Cancel:"
				+ newCancel);

	}
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws CriticalException {
		question.setCancelled(oldCancel);
		question.updateDB();
	}
	
	public String toString() {
		return "Set Question Cancelled Property as " + newCancel;
	}


}
