/*
 * Created on 20/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.question;

import java.util.Iterator;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.CategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.model.Category;
import il.ac.technion.cs.course236308.e3.med.model.Question;

/**
 * @author sybenny
 *
 */
public class QuestionSetOrdinal extends Command {
	private Question question;
	private Category category;
	private int newOrdinal;
	private int oldOrdinal;
	
	/**
	 * Method QuestionSetOrdinal
	 * @param question
	 * @param newOrdinal
	 */
	public QuestionSetOrdinal(Question question,int newOrdinal){
		this.question = question;
		this.newOrdinal = newOrdinal;
	}
	
	/**
	 * Method QuestionSetOrdinal
	 * @param newOrdinal
	 */
	public QuestionSetOrdinal(int newOrdinal){
		this.question = CommandDispatcher.getInstance().getCurrentQuestion();
		this.newOrdinal = newOrdinal;
	}
	
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException,CriticalException{
		if(question ==null){ throw new 
			RetriableException("Can't execute - no current answer defined");
		}
		oldOrdinal = question.getOrdinal();
		category = CategoriesFactory.getInstance().
					getCategory(question.getMainCategoryId());
		if(newOrdinal < 1 || newOrdinal > category.getQuestions().size()){
			throw new 
				RetriableException("New ordinal must be between 1 and " +
							category.getQuestions().size());
		}
		if(newOrdinal < oldOrdinal ){
			moveUp(oldOrdinal,newOrdinal);
		}
		if(newOrdinal > oldOrdinal ){
			moveDown(oldOrdinal,newOrdinal);
		}
		question.setOrdinal(newOrdinal);
		question.updateDB();
		MedReporter.report("# question ordinal changed, id = "+question.getId()
							+", new ordinal="+newOrdinal);
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws CriticalException{
		if(newOrdinal > oldOrdinal ){
			moveUp(newOrdinal,oldOrdinal);
		}
		if(newOrdinal < oldOrdinal ){
			moveDown(newOrdinal,oldOrdinal);
		}
		question.setOrdinal(oldOrdinal);
		question.updateDB();
	}
								

	private void moveDown(int newPlace,int oldPlace) 
				throws CriticalException{
		for(Iterator it=category.getQuestions().iterator();it.hasNext();){
			Question quest = (Question)it.next();
			if(quest.getOrdinal()>newPlace && quest.getOrdinal()<=oldPlace){
				quest.setOrdinal(quest.getOrdinal()-1);
				quest.updateDB();
			}
		}
	}

	private void moveUp(int newPlace,int oldPlace) 
			throws CriticalException{
		for(Iterator it=category.getQuestions().iterator();it.hasNext();){
			Question quest = (Question)it.next();
			if(quest.getOrdinal()>=oldPlace && quest.getOrdinal()<newPlace){
				quest.setOrdinal(quest.getOrdinal()+1);
				quest.updateDB();
			}
		}
	}
	
	public String toString() {
		return "Change ordinal of Question";
	}


}
