/*
 * Created on 21/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.test;

import java.util.Iterator;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.command.test.version.TestVersionClone;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;
import il.ac.technion.cs.course236308.e3.med.model.TestsFactory;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin
 * Created in SSDL lab - Technion Israel
 *
 */
public class TestClone extends Command{

	private Test test = null;
	private Test newTest;

	/**
	 * Method TestClone
	 */
	public TestClone(){
		this.test = CommandDispatcher.getInstance().getCurrentTest();
	}

	/**
	 * Method TestClone
	 * @param test
	 */
	public TestClone(Test test){
		this.test = test;
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws CriticalException, RetriableException{
		if (test == null){throw new 
			RetriableException("Can't execute - no active test defined");
		}
		newTest = TestsFactory.getInstance().cloneTest(test);
		for(Iterator it=test.getTestVersions().iterator();it.hasNext();){
			runAndPush(new TestVersionClone(newTest,(TestVersion)it.next()));
		}
		runAndPush(new TestSelect(newTest));
		CommandDispatcher.getInstance().checkTestLegality(newTest);
		MedReporter.report("# new test cloned, id = " + newTest.getId());
	}

	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException, CriticalException{
		super.undo();
		TestsFactory.getInstance().deleteTest(newTest);
		CommandDispatcher.getInstance().removeIllegalObject(newTest);

	}
	
	public String toString(){
		return "Clone test " + test.getId();
	}
}
