/*
 * Created on 08/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.test;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestsFactory;
import il.ac.technion.cs.course236308.e3.med.parameters.TestParams;
import il.ac.technion.cs.course236308.e3.med.xmlTools.XML2HTML;
/**
 * @author Alexander, Bennyamin, Svetlana and Valentin 
 * Created in SSDL lab - Technion Israel
 *
 */
public class TestPrintCopy extends Command {

	int copyNumber;
	String filename;
	Test test;

	public TestPrintCopy(Test test,int copyNumber, String filename) {
		this.copyNumber = copyNumber;
		this.filename = filename;
		this.test = test;
	}
	/**
	 * Method TestPrintCopy
	 * @param copyNumber
	 * @param filename
	 */
	public TestPrintCopy(int copyNumber, String filename) {
		this.copyNumber = copyNumber;
		this.filename = filename;
		this.test = CommandDispatcher.getInstance().getCurrentTest();
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (test == null) {	throw new 
			RetriableException("Can't execute - no active test defined");
		}
		try {
			test.isLegal();
		} catch (RetriableException e) {
			MedReporter.report("# " + e.getMessage());
			throw new RetriableException("<html>Can't execute - " +
			"test is in illegal state<br>(see details in Illegal States window)</html>");

		}
		if (filename.indexOf(".") < 0) {
			filename += "." + TestParams.xhtmlFileExtension;
		}
		TestsFactory tf = TestsFactory.getInstance();
		Test newCopy = tf.getCopyOfTest(test.getId());
		
		newCopy.toScrambled(copyNumber);
		Command c = new TestExport(newCopy,"tempfile", 
						TestParams.REPLACE_MODE, copyNumber);
		c.run();
		
		XML2HTML.xml2html("tempfile.xtt", 
					TestParams.XSL_RELATIVE_FILE_PATH_SCRAMBLED, filename);

		
		MedReporter.report("# Exam number "+ copyNumber +" " +
			"was printed in file " + filename);
	}
}
