/*
 * Created on 24/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.test;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestsFactory;
/**
 * @author Alexander, Bennyamin, Svetlana and Valentin
 * Created in SSDL lab - Technion Israel
 *
 */
public class TestSelect extends Command {
	
	private Test currActiveTest = null;
	private Test newActiveTest = null;

	/**
	 * Method TestSelect
	 * @param test
	 */
	public TestSelect(Test test){
		 this.newActiveTest = test;
	}

	/**
	 * Method TestSelect
	 * @param testId
	 * @throws CriticalException
	 * @throws RetriableException
	 */
	public TestSelect(int testId) throws RetriableException, CriticalException{
		this.newActiveTest = TestsFactory.getInstance().getTest(testId);		
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute()  {
		currActiveTest = CommandDispatcher.getInstance().getCurrentTest();
		CommandDispatcher.getInstance().setCurrentTest(newActiveTest);
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo(){
		CommandDispatcher.getInstance().setCurrentTest(currActiveTest);
	}

}
