/*
 * Created on 21/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.test;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Test;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin 
 * Created in SSDL lab - Technion Israel
 *
 */
public class TestSetCourseName extends Command{
	private Test test = null;
	private String oldCourseName = null;
	private String newCourseName = null;
	
	/**
	 * Method TestSetCourseName
	 * @param test
	 * @param newCourseName
	 */
	public TestSetCourseName(Test test,String newCourseName){
		this.test = test;
		this.newCourseName = newCourseName;
	}

	/**
	 * Method TestSetCourseName
	 * @param newCourseName
	 */
	public TestSetCourseName(String newCourseName){
		this.test = CommandDispatcher.getInstance().getCurrentTest();
		this.newCourseName = newCourseName;
	}	
	
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws CriticalException, RetriableException{
		if (test==null) { throw new 
			RetriableException("Can't execute - no active test defined");		
		}
		if (!test.getStatus().equals("U")) { throw new 
			RetriableException("Can't execute - test isn't under construction");
		}
		oldCourseName = test.getCourseName();
		test.setCourseName(newCourseName);
		runAndPush(new TestSetUpdatedDate(test));
		test.updateDB();
		MedReporter.report("# test Course Name was changed, id = "
				+ test.getId() + " new name=" + newCourseName);
	}
	
	/**
	 * Method undo
	 * @throws CriticalException
	 * @throws RetriableException
	 * @see Command#undo()
	 */
	public void undo() throws  RetriableException, CriticalException{
		super.undo();
		test.setCourseName(oldCourseName);
		test.updateDB();
	}
	
	public String toString() {
		return "Set course Name for test";
	}

}
