/*
 * Created on 21/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.test;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Test;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin 
 * Created in SSDL lab - Technion Israel
 *
 */
public class TestSetDescription extends Command{
	private Test test = null;
	private int descNum;
	private String oldDescription = null;
	private String newDescription = null;
	
	/**
	 * Method TestSetDescription
	 * @param test
	 * @param descNum
	 * @param newDescription
	 */
	public TestSetDescription(Test test,int descNum,String newDescription){
		this.test = test;
		this.descNum = descNum;
		this.newDescription = newDescription;
	}

	/**
	 * Method TestSetDescription
	 * @param descNum
	 * @param newDescription
	 */
	public TestSetDescription(int descNum,String newDescription){
		this.test = CommandDispatcher.getInstance().getCurrentTest();
		this.descNum = descNum;
		this.newDescription = newDescription;
	}	
	
	/**
	 * Method execute
	 * @throws CriticalException
	 * @throws RetriableException
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException{
		if(descNum == 1){		
			oldDescription = test.getDescription1();
			test.setDescription1(newDescription);
		}else{
			oldDescription = test.getDescription2();
			test.setDescription2(newDescription);			
		}
		runAndPush(new TestSetUpdatedDate(test));
		test.updateDB();
		MedReporter.report("# test Description"+descNum+
			" was changed, id = " + test.getId() + " new Description=" 
				+ newDescription);
	}
	
	/**
	 * Method undo
	 * @throws CriticalException
	 * @throws RetriableException
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException, CriticalException{
		super.undo();
		if(descNum == 1){		
			test.setDescription1(oldDescription);
		}else{
			test.setDescription2(oldDescription);			
		}
		test.updateDB();
	}
	
	public String toString() {
		return "Set Description for test";
	}

}
