/*
 * Created on 21/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.test;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.stats.StatisticData;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin 
 * Created in SSDL lab - Technion Israel
 *
 */
public class TestSetFactor extends Command{
	private Test test = null;
	private double newFactorA;
	private double newFactorB;
	private double oldFactorA;
	private double oldFactorB;
	
	/**
	 * Method TestSetFactor
	 * @param test
	 * @param newFactorA
	 * @param newFactorB
	 */
	public TestSetFactor(Test test,double newFactorA,double newFactorB){
		this.test = test;
		this.newFactorA = newFactorA;
		this.newFactorB = newFactorB;
	}

	/**
	 * Method TestSetFactor
	 * @param newFactorA
	 * @param newFactorB
	 */
	public TestSetFactor(double newFactorA,double newFactorB){
		this.test = CommandDispatcher.getInstance().getCurrentTest();
		this.newFactorA = newFactorA;
		this.newFactorB = newFactorB;
	}	
	
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws CriticalException, RetriableException{
		if(newFactorA == 0.0 && newFactorB == 0.0){ throw new 
			RetriableException("Both FactorA & B can not be equal to 0");
		}
		oldFactorA = test.getFactorConstA();
		oldFactorB = test.getFactorConstB();
		test.setFactorConstA(newFactorA);
		test.setFactorConstB(newFactorB);
		StatisticData.getInstance().updateQuestionsStatistics(test.getId());
		runAndPush(new TestSetUpdatedDate(test));
		test.updateDB();
		MedReporter.report("# test Factors were changed, id = "
						 + test.getId() + " new FactorA=" + newFactorA 
						 + " FactorB=" + newFactorB);
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws  RetriableException, CriticalException{
		super.undo();
		test.setFactorConstA(oldFactorA);
		test.setFactorConstB(oldFactorB);
		StatisticData.getInstance().updateQuestionsStatistics(test.getId());
		test.updateDB();
	}
	
	public String toString() {
		return "Set Factor for test";
	}

}
