/*
 * Created on 21/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.test;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.stats.StatisticData;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin 
 * Created in SSDL lab - Technion Israel
 *
 */
public class TestSetGradeRange extends Command{
	private Test test = null;
	private int oldMinGrade;
	private int newMinGrade;
	private int oldMaxGrade;
	private int newMaxGrade;
	private int oldPassingGrade;
	private int newPassingGrade;
	
	/**
	 * Method TestSetGradeRange
	 * @param test
	 * @param newMinGrade
	 * @param newMaxGrade
	 * @param newPassingGrade
	 */
	public TestSetGradeRange(Test test,int newMinGrade,int newMaxGrade,
							 int newPassingGrade){
		this.test = test;
		this.newMinGrade = newMinGrade;
		this.newMaxGrade = newMaxGrade;
		this.newPassingGrade = newPassingGrade;
	}

	/**
	 * Method TestSetGradeRange
	 * @param newMinGrade
	 * @param newMaxGrade
	 * @param newPassingGrade
	 */
	public TestSetGradeRange(int newMinGrade,int newMaxGrade, 
							int newPassingGrade){
		this.test = CommandDispatcher.getInstance().getCurrentTest();
		this.newMinGrade = newMinGrade;
		this.newMaxGrade = newMaxGrade;
		this.newPassingGrade = newPassingGrade;
	}	
	
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws CriticalException, RetriableException{
		if(!(newMinGrade <= newPassingGrade && newPassingGrade <= newMaxGrade)){
			throw new
			 RetriableException("In Exam grades must be: newMinGrade <=" +
			 	" newPassingGrade <= newMaxGrade");
		}
		oldMinGrade = test.getMinGrade();
		oldMaxGrade = test.getMaxGrade();
		oldPassingGrade = test.getPassingGrade();
		test.setMinGrade(newMinGrade);
		test.setMaxGrade(newMaxGrade);
		test.setPassingGrade(newPassingGrade);
		runAndPush(new TestSetUpdatedDate(test));
		test.updateDB();
		StatisticData.getInstance().updateQuestionsStatistics(test.getId());
		MedReporter.report("# test Grades was changed, id = " + test.getId() 
				+ " new MinGrade=" + newMinGrade + " MaxGrade=" + newMaxGrade 
				+ " PassingGrade=" + newPassingGrade);
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws  RetriableException, CriticalException{
		super.undo();
		test.setMinGrade(oldMinGrade);
		test.setMaxGrade(oldMaxGrade);
		test.setPassingGrade(oldPassingGrade);
		StatisticData.getInstance().updateQuestionsStatistics(test.getId());
		test.updateDB();
	}
	
	public String toString() {
		return "Set Grade Range for test";
	}

}
