/*
 * Created on 21/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.test.answer;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.TestAnswer;
import il.ac.technion.cs.course236308.e3.med.model.TestAnswersFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;

/**
 * @author sybenny
 *
 */
public class TestAnswerClone extends Command {

	private TestVersion testVersion = null;
	private TestAnswer testAnswer = null;
	private TestAnswer newTestAnswer = null;

	/**
	 * Method TestAnswerClone
	 * @param testVersion
	 * @param testAnswer
	 */
	public TestAnswerClone(TestVersion testVersion,TestAnswer testAnswer){
		this.testVersion = testVersion;
		this.testAnswer = testAnswer;
	}
	
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	public void execute() throws RetriableException,CriticalException {
		if(testVersion == null){ throw new 
			RetriableException("Can't clone test answer - " +
				"no test version defined");
		}
		if(testAnswer == null){	throw new 
			RetriableException("Can't clone test answer - " +
				"no test answer defined");
		}
		newTestAnswer = TestAnswersFactory.getInstance().
					cloneTestAnswer(testVersion,testAnswer);
		MedReporter.report("# new test answer cloned, new test answer id = " +
						 newTestAnswer.getTestId() + " , for test version " + 
						 testVersion.getVersion().getId());
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException,CriticalException{
		super.undo();
		TestAnswersFactory.getInstance().deleteTestAnswer(newTestAnswer);		
	}
	
	public String toString(){
		return "Clone test answer " + testAnswer.getAnswerId() + " of test " + testAnswer.getTestId();
	}
}
