/*
 * Created on 21/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.test.answer;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestAnswer;
import il.ac.technion.cs.course236308.e3.med.model.TestsFactory;
import il.ac.technion.cs.course236308.e3.med.stats.StatisticData;

/**
 * @author sybenny
 *
 */
public class TestAnswerUpdateWeight extends Command {

	private byte newWeight ;
    private byte oldWeight;
	private TestAnswer testAnswer = null;
	private Test test;

	/**
	 * Method TestAnswerUpdateWeight
	 * @param testAnswer
	 */
	public TestAnswerUpdateWeight(TestAnswer testAnswer,byte newWeight){
		this.testAnswer = testAnswer;
		this.newWeight = newWeight;
	}
	
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	public void execute() throws RetriableException,CriticalException {
		if(testAnswer == null){	throw new 
			RetriableException("Can't set answer weight - " +
				"no test answer defined");
		}
        oldWeight = testAnswer.getWeight();
		testAnswer.setWeight(newWeight);
        StatisticData.getInstance().updateQuestionsStatistics(testAnswer.getTestId());
        testAnswer.updateDB();
        test = TestsFactory.getInstance().getTest(testAnswer.getTestId());
		CommandDispatcher.getInstance().checkTestLegality(test);
		MedReporter.report("# test answer with test answer id = " +
						 testAnswer.getTestId() + " , new weight = " + newWeight);
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException,CriticalException{
        testAnswer.setWeight(oldWeight);
        StatisticData.getInstance().updateQuestionsStatistics(testAnswer.getTestId());
		testAnswer.updateDB();		
		CommandDispatcher.getInstance().checkTestLegality(test);
	}
	
	public String toString(){
		return "Set weight of test answer " + testAnswer.getAnswerId();
	}
}
