/*
 * Created on 21/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.test.version;

import java.util.Iterator;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.command.test.answer.TestAnswerClone;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestAnswer;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;
import il.ac.technion.cs.course236308.e3.med.model.TestVersionsFactory;

/**
 * @author sybenny
 *
 */
public class TestVersionClone extends Command {

	private Test test = null;
	private TestVersion testVersion = null;
	private TestVersion newTestVersion = null;

	/**
	 * Method TestVersionClone
	 * @param test
	 * @param testVersion
	 */
	public TestVersionClone(Test test,TestVersion testVersion){
		this.test = test;
		this.testVersion = testVersion;
	}
	
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	public void execute() throws RetriableException,CriticalException {
		if(test == null){ throw new 
			RetriableException("Can't clone test version - no test defined");
		}
		if(testVersion == null){ throw new 
			RetriableException("Can't clone test version - " +
				"no test version defined");
		}
		newTestVersion = TestVersionsFactory.getInstance().
						cloneTestVersion(test,testVersion);
		for(Iterator it=testVersion.getTestAnswers().iterator();it.hasNext();){
			runAndPush(new TestAnswerClone(newTestVersion,
											(TestAnswer)it.next()));
		}

		MedReporter.report("# new test version cloned, new id = " 
							+ newTestVersion.getVersion().getId() + 
							" , for test " + test.getId());
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException,CriticalException{
		super.undo();
		TestVersionsFactory.getInstance().deleteTestVersion(newTestVersion);		
	}
	
	public String toString(){
		return "Clone test Version";
	}
}
