/*
 * Created on 21/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.test.version;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;
import il.ac.technion.cs.course236308.e3.med.stats.StatisticData;

/**
 * @author sybenny
 *
 */
public class TestVersionUpdateWeight extends Command {

	private Double newWeight ;
    private Double oldWeight;
	private TestVersion testVersion = null;

	/**
	 * Method TestVersionUpdateWeight
	 * @param testVersion
	 */
	public TestVersionUpdateWeight(TestVersion testVersion,Double newWeight){
		this.testVersion = testVersion;
		this.newWeight = newWeight;
	}
	
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	public void execute() throws RetriableException,CriticalException {
		if(testVersion == null){	throw new 
			RetriableException("Can't set test version - " +
				"no test version defined");
		}
        oldWeight = testVersion.getWeight();
        testVersion.setWeight(newWeight);
		StatisticData.getInstance().updateQuestionsStatistics(testVersion.getTestId());
        testVersion.updateDB();
		MedReporter.report("# test version with test answer id = " +
                        testVersion.getTestId() + " , new weight = " + newWeight);
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException,CriticalException{
        testVersion.setWeight(oldWeight);
        StatisticData.getInstance().updateQuestionsStatistics(testVersion.getTestId());
        testVersion.updateDB();		
	}
	
	public String toString(){
		return "Update weight of test version " + testVersion.getVersion().getId();
	}
}
