/*
 * Created on 21/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.version;

import java.util.Iterator;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.command.answer.AnswerClone;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.model.VersionsFactory;

/**
 * @author sybenny
 *
 */
public class VersionClone extends Command {

	private Question question = null;
	private Version version = null;
	private Version newVersion = null;

	/**
	 * Method VersionClone
	 * @param question
	 * @param version
	 */
	public VersionClone(Question question,Version version){
		this.question = question;
		this.version = version;
	}
	
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	public void execute() throws RetriableException,CriticalException {
		if(question == null){ throw new 
			RetriableException("Can't clone version - no question defined");
		}
		if(version == null){ throw new 
			RetriableException("Can't clone version - no version defined");
		}
		newVersion = VersionsFactory.getInstance().
					cloneVersion(question,version);
		for(Iterator it=version.getAnswers().iterator();it.hasNext();){
			runAndPush(new AnswerClone(newVersion,(Answer)it.next()));
		}
		runAndPush(new VersionMarkAsActive(newVersion));
		for(Iterator it=newVersion.getAnswers().iterator();it.hasNext();){
			CommandDispatcher.getInstance().checkAnswerLegality((Answer)it.next());
		}
		CommandDispatcher.getInstance().checkVersionLegality(version);
		MedReporter.report("# new version cloned, new id = " + 
							newVersion.getId() +	" , for question " 
							+ question.getId());
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException,CriticalException{
		for(Iterator it=newVersion.getAnswers().iterator();it.hasNext();){
			CommandDispatcher.getInstance().removeIllegalObject((Answer)it.next());
		}
		super.undo();
		VersionsFactory.getInstance().deleteVersion(newVersion);	
		CommandDispatcher.getInstance().removeIllegalObject(newVersion);
	}
	
	public String toString(){
		return "Clone version";
	}

}
