/*
 * Created on 21/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.version;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.model.VersionsFactory;

/**
 * @author sybenny
 *
 */
public class VersionCreate extends Command {

	private Question question = null;
	private Version version = null;

	/**
	 * Method VersionCreate
	 * @param question
	 */
	public VersionCreate(Question question){
		this.question = question;
	}
	
	/**
	 * Method VersionCreate
	 */
	public VersionCreate() {
		this.question = CommandDispatcher.getInstance().getCurrentQuestion();
	}	

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	public void execute() throws RetriableException,CriticalException {
		if(question == null){ throw new 
			RetriableException("Can't create version - " +
				"no current question defined");
		}
		version = VersionsFactory.getInstance().createVersion(question);
		runAndPush(new VersionSelect(version));
		CommandDispatcher.getInstance().checkVersionLegality(version);
        MedReporter.report("# new version created, id = " + version.getId() + 
								" , for question " + question.getId());
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException,CriticalException{
		super.undo();
		VersionsFactory.getInstance().deleteVersion(version);
		CommandDispatcher.getInstance().removeIllegalObject(version);
		CommandDispatcher.getInstance().checkQuestionLegality(question);
	}
	
	public String toString(){
		return "Create version";
	}
}
