/*
 * Created on 21/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.version;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.command.answer.AnswerDelete;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.QuestionsFactory;
import il.ac.technion.cs.course236308.e3.med.model.Version;

/**
 * @author sybenny
 *
 */
public class VersionDelete extends Command {
	
	private boolean forbidDeleteLastVer = true;
	private Version version = null;

	/**
	 * Method VersionDelete
	 * @param version
	 * @param forbidDeleteLastVer
	 */
	public VersionDelete(Version version,boolean forbidDeleteLastVer) {
		this.forbidDeleteLastVer = forbidDeleteLastVer;
		this.version = version;
	}

	/**
	 * Method VersionDelete
	 * @param version
	 */
	public VersionDelete(Version version) {
		this.version = version;
	}
	
	/**
	 * Method VersionDelete
	 */
	public VersionDelete() {
		this.version = CommandDispatcher.getInstance().getCurrentVersion();
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException,CriticalException {
		if (version==null){	throw new 
			RetriableException("Can't execute - no current version defined");
		}				
		if (version.isAppearInTests()) {throw new 
			RetriableException("Can't delete - version was included in test(s)");
		}
        
		Question question = QuestionsFactory.getInstance().
								getQuestion(version.getQuestionId());
		// We are checking if this is the last version and if so
		// we won't do anything
		if (question.getVersions().size() == 1 && forbidDeleteLastVer) {
			throw new RetriableException("Can't delete version - " +
				"it is the last version of question");
		}

		if(version.equals(CommandDispatcher.getInstance().getCurrentVersion())){
			runAndPush( new VersionSelect(null));
		}

		while(version.getAnswers().size() > 0){
			runAndPush(new AnswerDelete((Answer)version.getAnswers().get(0)));
		}
								
		runAndPush(new VersionDeleteEmpty(question,version));
		runAndPush(new VersionDeleteIllegalObject(version));
		CommandDispatcher.getInstance().removeIllegalObject(version);
		CommandDispatcher.getInstance().checkQuestionLegality(question);
		MedReporter.report("# version deleted, id = "+version.getId()
									+ ", for question "+ question.getId());
	}
	
	public void undo() throws RetriableException, CriticalException{
		super.undo();
		CommandDispatcher.getInstance().checkVersionLegality(version);
	}
	
	public String toString(){
		return "Delete version";
	}
}
