/*
 * Created on 25/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.version;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.model.VersionsFactory;

/**
 * @author Alexander, Bennyamin, Svetlana and Valentin
 * Created in SSDL lab - Technion Israel
 *
 */
public class VersionDeleteEmpty extends Command {
	private Question question = null;
	private Version version;
	/**
	 * Method VersionDeleteEmpty
	 * @param question
	 * @param version
	 */
	public VersionDeleteEmpty(Question question, Version version) {
		this.question = question;
		this.version = version;
	}
	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		Integer activeVersionId = question.getActiveVersionId();
		if (activeVersionId != null	&& activeVersionId.intValue() == version.getId()) {
			runAndPush(new UnmarkActiveVersion());
		}
		VersionsFactory.getInstance().deleteVersion(version);
		if(question.getVersions().size() > 0){
			runAndPush(new VersionMarkAsActive(question.getUpdatedVersion()));
		}
	}

	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException, CriticalException {
		VersionsFactory.getInstance().storeVersion(question, version);
		super.undo();
	}

	class UnmarkActiveVersion extends Command {
		/**
		 * Method execute
		 * @see Command#execute()
		 */
		protected void execute() throws CriticalException {
			question.setActiveVersionId(null);
			question.updateDB();
		}
		/**
		 * Method undo
		 * @see Command#undo()
		 */
		public void undo() throws CriticalException {
			question.setActiveVersionId(new Integer(version.getId()));
			question.updateDB();
		}
	}
}
