/*
 * Created on 21/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.version;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.QuestionsFactory;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.model.VersionsFactory;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

/**
 * @author sybenny
 *
 */
public class VersionMarkAsActive extends Command {

	private Question question = null;
	private Integer oldActiveId = null;
	private Version newVersion = null;

	/**
	 * Method VersionMarkAsActive
	 * @param version
	 */
	public VersionMarkAsActive(Version version) {
		this.newVersion = version;
	}
	
	/**
	 * Method VersionMarkAsActive
	 */
	public VersionMarkAsActive(){
		this.newVersion = CommandDispatcher.getInstance().getCurrentVersion();
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException,CriticalException {
		if (newVersion==null){throw new
			 RetriableException("Can't execute - no current version defined");
		}
		if(GeneralParams.scriptMode && newVersion.getCorrectAnswerId() == 0){
			throw new RetriableException("Can't execute - no correct answer was set for version " + newVersion.getId());
		}
		QuestionsFactory qf = QuestionsFactory.getInstance();
		question = qf.getQuestion(newVersion.getQuestionId());
		oldActiveId = question.getActiveVersionId();
		question.setActiveVersionId(new Integer(newVersion.getId()));
		question.updateDB();
		try{
			CommandDispatcher.getInstance().checkVersionLegality(VersionsFactory.getInstance().getVersion(oldActiveId.intValue()));
			CommandDispatcher.getInstance().checkVersionLegality(newVersion);	
		}catch(Throwable e){
		}
		MedReporter.report("# Version marked as active id = "
					+newVersion.getId()+ " for question "+ question.getId());
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws CriticalException {
		question.setActiveVersionId(oldActiveId);
		question.updateDB();
		try{
			CommandDispatcher.getInstance().checkVersionLegality(VersionsFactory.getInstance().getVersion(oldActiveId.intValue()));
			CommandDispatcher.getInstance().checkVersionLegality(newVersion);	
		}catch(Throwable e){
		}
	}
	
	public String toString(){
		return "Mark Active Version: " + newVersion.getBody();
	}
}
