/*
 * Created on 24/04/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.command.version;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.model.VersionsFactory;
/**
 * @author Alexander, Bennyamin, Svetlana and Valentin
 * Created in SSDL lab - Technion Israel
 *
 */
public class VersionSelect extends Command {
	
	private Version currActiveVersion = null;
	private Version newActiveVersion = null;

	/**
	 * Method VersionSelect
	 * @param version
	 */
	public VersionSelect(Version version){
		 this.newActiveVersion = version;
	}

	/**
	 * Method VersionSelect
	 * @param versionId
	 * @throws CriticalException
	 * @throws RetriableException
	 */
	public VersionSelect(int versionId) 
		throws RetriableException, CriticalException{
		this.newActiveVersion = VersionsFactory.getInstance().
									getVersion(versionId);		
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute()  {
		currActiveVersion = CommandDispatcher.getInstance().getCurrentVersion();
		CommandDispatcher.getInstance().setCurrentVersion(newActiveVersion);
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo(){
		CommandDispatcher.getInstance().setCurrentVersion(currActiveVersion);
	}

}
