/*
 * Created on 26/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.version;

import java.util.Iterator;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.command.answer.AnswerSelect;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.Version;

/**
 * @author sybenny
 *
 *
 */
public class VersionSelectFirstAnswer extends Command {

	private Version version;

	/**
	 * Method VersionSelectFirstAnswer
	 */
	public VersionSelectFirstAnswer() {
		this.version = CommandDispatcher.getInstance().getCurrentVersion();
	}
	/**
	 * Method VersionSelectFirstAnswer
	 * @param version
	 */
	public VersionSelectFirstAnswer(Version version) {
		this.version = version;
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (version == null) { throw new 
			RetriableException("Can't execute - no current version defined");
		}
		for (Iterator it = version.getAnswers().iterator(); it.hasNext();) {
			Answer ans = (Answer) it.next();
			if (ans.getOrdinal() == 1) {
				runAndPush(new AnswerSelect(ans));
				MedReporter.report(
					"# answer marked as current, id = " + ans.getId());
				return;
			}
		}
		MedReporter.report(
			"# answer with id = 1 was not found");

	}
}
