/*
 * Created on 26/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.version;

import java.util.Iterator;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.QuestionsFactory;
import il.ac.technion.cs.course236308.e3.med.model.Version;

/**
 * @author sybenny
 *
 *
 */
public class VersionSelectNext extends Command {

	Version oldVersion;
	/**
	 * Method VersionSelectNext
	 */
	public VersionSelectNext() {
		this.oldVersion = CommandDispatcher.getInstance().getCurrentVersion();
	}
	/**
	 * Method VersionSelectNext
	 * @param version
	 */
	public VersionSelectNext(Version version) {
		this.oldVersion = version;

	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (oldVersion == null) {throw new 
			RetriableException("Can't execute no current version defined");
		}
		Question question = QuestionsFactory.getInstance().
							getQuestion(oldVersion.getQuestionId());
		Version closestVersion = null;
		
		for (Iterator iter = question.getVersions().iterator();
			 iter.hasNext();) {
			Version ver = (Version) iter.next();
			if (ver.getCreated().after(oldVersion.getCreated())) {
				closestVersion = ver;
				break;
			}
		}
		if(closestVersion == null){	throw new 
			RetriableException("There's no version which was created " +
				"after current version");
		}
		for (Iterator iter = question.getVersions().iterator();
			 iter.hasNext();) {
			Version ver = (Version) iter.next();
			if (ver.getCreated().after(oldVersion.getCreated()) && 
				ver.getCreated().before(closestVersion.getCreated())) {
				closestVersion = ver;
			}
		}
		runAndPush(new VersionSelect(closestVersion));
		MedReporter.report("# next version marked as current, id = "
							+ closestVersion.getId());

	}
}
