/*
 * Created on 26/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.version;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.command.question.QuestionSelect;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.QuestionsFactory;
import il.ac.technion.cs.course236308.e3.med.model.Version;

/**
 * @author sybenny
 *
 * 
 */
public class VersionSelectQuestion extends Command {

	private Version version;

	/**
	 * Method VersionSelectQuestion
	 */
	public VersionSelectQuestion() {
		this.version = CommandDispatcher.getInstance().getCurrentVersion();
	}
	/**
	 * Method VersionSelectQuestion
	 * @param version
	 */
	public VersionSelectQuestion(Version version) {
		this.version = version;
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (version == null) { throw new 
			RetriableException("Can't execute - no current version defined");
		}
		Question question = QuestionsFactory.getInstance().
								getQuestion(version.getQuestionId());
		runAndPush(new QuestionSelect(question));
		MedReporter.report(
			"# question marked as current, id = " + question.getId());

	}
}
