/*
 * Created on 21/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.version;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.xmlTools.TextCorrectnessChecker;

/**
 * @author sybenny
 *
 * 
 */
public class VersionSetBody extends Command {

	private Version version;
	private String body;
	private String oldBody = null;

	/**
	 * Method VersionSetBody
	 * @param version
	 * @param body
	 */
	public VersionSetBody(Version version, String body) {
		this.version = version;
		this.body = body;
	}

	/**
	 * Method VersionSetBody
	 * @param body
	 */
	public VersionSetBody(String body) {
		this(CommandDispatcher.getInstance().getCurrentVersion(),body);
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (version == null) {throw new 
			RetriableException("Can't execute no current version defined");
		}
		if (version.isLocked()) { throw new 
			RetriableException("Can't update version body - locked version");
		}
		if(body != null && body.length() == 0){
			body = null;
		}
		TextCorrectnessChecker tcc = new TextCorrectnessChecker(body);
		tcc.validate();
		
		oldBody = version.getBody();
		version.setBody(body);
		runAndPush(new VersionSetUpdatedDate(version));
		version.updateDB();
		MedReporter.report(
			"# Body for version was set, id = "
				+ version.getId()
				+ " New Body:"
				+ body);
	}

	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws  RetriableException, CriticalException {
		super.undo();
		version.setBody(oldBody);
		version.updateDB();
	}
	
	public String toString(){
		return "Set version body to: " + body;
	}
}
