/*
 * Created on 21/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.version;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Version;

/**
 * @author sybenny
 *
 *
 */
public class VersionSetComment extends Command {

	private Version version;
	private String comment;
	private String oldComment;
	
	/**
	 * Method VersionSetComment
	 * @param version
	 * @param comment
	 */
	public VersionSetComment(Version version,String comment) {
		this.version = version;
		this.comment = comment;
	}

	/**
	 * Method VersionSetComment
	 * @param comment
	 */
	public VersionSetComment(String comment) {
		this(CommandDispatcher.getInstance().getCurrentVersion(),comment);
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException,CriticalException {
		if (version==null){	throw new 
			RetriableException("Can't execute no current version defined");
		}
		if (version.isLocked()) { throw new 
			RetriableException("Can't update version comment - locked version");
		}
		if(comment != null && comment.length() == 0){
			comment = null;
		}
		oldComment = version.getNotes();
		version.setNotes(comment);
		runAndPush(new VersionSetUpdatedDate(version));
		version.updateDB();
		MedReporter.report("# Comment for version was set, id = "+
					version.getId()+ " New Comment:"+comment);
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException, CriticalException {
		super.undo();
		version.setNotes(oldComment);
		version.updateDB();
	}
	
	public String toString(){
		return "Set version note to: " + comment;
	}

}
