/*
 * Created on 21/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.version;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Version;

/**
 * @author sybenny
 *
 *
 */
public class VersionSetLanguage extends Command {

	private Version version;
	private String language;
	private String oldLanguage;
	
	/**
	 * Method VersionSetLanguage
	 * @param version
	 * @param language
	 */
	public VersionSetLanguage(Version version,String language) {
		this.version = version;
		this.language = language;
	}

	/**
	 * Method VersionSetLanguage
	 * @param language
	 */
	public VersionSetLanguage(String language) {
		this(CommandDispatcher.getInstance().getCurrentVersion(),language);
	}

	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException,CriticalException {
		if (version==null){	throw new 
			RetriableException("Can't execute no current version defined");
		}
		if (version.isLocked()) { throw new 
			RetriableException("Can't update version language - locked version");
		}
		if(language != null && language.length() == 0){
			language = null;
		}
		oldLanguage = version.getLanguage();
		version.setLanguage(language);
		runAndPush(new VersionSetUpdatedDate(version));
		version.updateDB();
		MedReporter.report("# Language for version was set, id = "
							+version.getId()+" New Language:"+language);
	}
	
	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws RetriableException, CriticalException {
		super.undo();
		version.setLanguage(oldLanguage);
		version.updateDB();
	}
	
	public String toString(){
		return "Set version language to: " + language;
	}
}
