/*
 * Created on 21/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.command.version;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Version;

import java.util.Calendar;
import java.util.GregorianCalendar;

/**
 * @author sybenny
 *
 * 
 */
public class VersionSetUpdatedDate extends Command {

	private Version version;
	private Calendar updatedDate;
	private Calendar oldUpdatedDate;

	/**
	 * Method VersionSetBody
	 * @param version
	 * @param body
	 */
	public VersionSetUpdatedDate(Version version) {
		this.version = version;
		updatedDate = new GregorianCalendar();
	}


	/**
	 * Method execute
	 * @see Command#execute()
	 */
	protected void execute() throws RetriableException, CriticalException {
		if (version == null) {throw new 
			RetriableException("Can't execute no current version defined");
		}
		if (version.isLocked()) { throw new 
			RetriableException("Can't update version updated Date - locked version");
		}

		oldUpdatedDate = version.getUpdated();
		version.setUpdated(updatedDate);
	}

	/**
	 * Method undo
	 * @see Command#undo()
	 */
	public void undo() throws  CriticalException {
		version.setUpdated(oldUpdatedDate);
	}
	
	public String toString(){
		return "Set version updated date " ;
	}
}
