/*
 * Created on Apr 7, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control;

import java.awt.Cursor;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DragGestureEvent;
import java.awt.dnd.DragGestureListener;
import java.awt.dnd.DragSource;
import java.awt.dnd.DragSourceDragEvent;
import java.awt.dnd.DragSourceDropEvent;
import java.awt.dnd.DragSourceEvent;
import java.awt.dnd.DragSourceListener;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetDragEvent;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.dnd.DropTargetEvent;
import java.awt.dnd.DropTargetListener;
import java.awt.dnd.InvalidDnDOperationException;
import java.util.Vector;

/**
 * @author Alex
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class DndAdapter implements DropTargetListener, DragSourceListener, DragGestureListener {
	DndComponent targetComponent;
	DropTarget dropTarget;
	
	// Debug
	static private Vector knownComponents = new Vector();
	
	
	/**
	 * Object that is currently being transfered
	 */
	static MedContainer container = null;
	
	static int dropTargetComponentOperationRequest = DnDConstants.ACTION_NONE;
	
	/**
	 * @param table
	 */
	public DndAdapter(DndComponent dndComponent) {
		
		
		
		if(knownComponents.contains(dndComponent)) {
//			System.out.println(" Component is already known as drop source/target.\nDO NOT REGISTER COMPONENT MORE THAN ONCE!");
			return;
		}
		knownComponents.add(dndComponent);
		DragSource dragSource = DragSource.getDefaultDragSource();
		targetComponent = dndComponent;
		dragSource.createDefaultDragGestureRecognizer(
					dndComponent.getComponent(), // component where drag originates
					DnDConstants.ACTION_REFERENCE, // actions
					this); // drag gesture recognizer
				
		
	
		dropTarget = new DropTarget(dndComponent.getComponent(),
									DnDConstants.ACTION_NONE,
									this);

		//comp.setDropTarget(dropTarget);
		
	}

	public void dragEnter(DropTargetDragEvent e) {
	}
	
	public void dragOver(DropTargetDragEvent e) {
		int action = targetComponent.dragUnderFeedback(e.getLocation(),
													   container);
		dropTargetComponentOperationRequest = action;		
	}
	
	public void dropActionChanged(DropTargetDragEvent e) {
	}
	
	
	public void dragExit(DropTargetEvent e) {
		// Out of drop target, show that user cannot drop into nothing
		targetComponent.undoDragUnderFeedback();
		// Default operation for DND outside of our system
		dropTargetComponentOperationRequest = DnDConstants.ACTION_COPY;
	}
	
	public void drop(DropTargetDropEvent e) {
		targetComponent.undoDragUnderFeedback();
		
		if(dropTargetComponentOperationRequest != DnDConstants.ACTION_NONE)
			targetComponent.drop(e.getLocation(),container);		
	}
	
	/* (non-Javadoc)
	 * @see java.awt.dnd.DragSourceListener#dragEnter(java.awt.dnd.DragSourceDragEvent)
	 */
	public void dragEnter(DragSourceDragEvent e) {
	}
	
	/* (non-Javadoc)
	 * @see java.awt.dnd.DragSourceListener#dragOver(java.awt.dnd.DragSourceDragEvent)
	 */
	public void dragOver(DragSourceDragEvent e) {
		e.getDragSourceContext().setCursor(getTargetCursor());
	}
	
	/* (non-Javadoc)
	 * @see java.awt.dnd.DragSourceListener#dropActionChanged(java.awt.dnd.DragSourceDragEvent)
	 */
	public void dropActionChanged(DragSourceDragEvent e) {
//		e.getDragSourceContext().setCursor(DragSource.DefaultLinkDrop);
	}
	
	/* (non-Javadoc)
	 * @see java.awt.dnd.DragSourceListener#dragExit(java.awt.dnd.DragSourceEvent)
	 */
	public void dragExit(DragSourceEvent e) {
		e.getDragSourceContext().setCursor(DragSource.DefaultMoveNoDrop);	
		//container = null;			
	}
	
	/* (non-Javadoc)
	 * @see java.awt.dnd.DragSourceListener#dragDropEnd(java.awt.dnd.DragSourceDropEvent)
	 */
	public void dragDropEnd(DragSourceDropEvent arg0) {
		targetComponent.dragFinalize();
	}
	
	/* (non-Javadoc)
	 * @see java.awt.dnd.DragGestureListener#dragGestureRecognized(java.awt.dnd.DragGestureEvent)
	 */
	public void dragGestureRecognized(DragGestureEvent e) {
		MedContainer t = targetComponent.initDrag(e.getDragOrigin());	
		if(t== null) {
			return;
		}	
		container = t;	
		try {
			e.startDrag(DragSource.DefaultMoveDrop,	t,this);
		} catch(InvalidDnDOperationException ex){
			e.getDragSource().addDragSourceListener(this);	
		} catch(RuntimeException ex) {
			System.err.println("Problem with DND detected: " + ex.getMessage() + " - Will be fixed later.");
		}
	}

	public void forceDragInitiation() {
	}
	
	private Cursor getTargetCursor() {
		switch(dropTargetComponentOperationRequest){
			case DnDConstants.ACTION_COPY:
				return DragSource.DefaultCopyDrop;
			case DnDConstants.ACTION_LINK:
				return DragSource.DefaultLinkDrop;
			case DnDConstants.ACTION_MOVE:
				return DragSource.DefaultMoveDrop;
			case DnDConstants.ACTION_NONE:
				return DragSource.DefaultMoveNoDrop;
		}
		
		return DragSource.DefaultMoveNoDrop;
	}

}