package il.ac.technion.cs.course236308.e3.med.control;


import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;

/**
 * @author Shraer Alexander
 */
public class FileChooser extends JFileChooser{
	private String fileExtention;
    private String extentionDescription;
    boolean outoComplete;
	public FileChooser(String defaultExtention, String extentionDescription, boolean outoComplete){
		super(".");
		fileExtention = defaultExtention;
		this.extentionDescription = extentionDescription;
		setFileFilter(new MedFileFilter());
        this.outoComplete = outoComplete;
	}
	public File choose(JFrame mainFrame, boolean askOverwrite, String okButtonText) {
	    String okButtonName;
        
	    if (okButtonText==null || okButtonText.length()<1) okButtonName = new String("Save");
		else okButtonName = okButtonText;
		int res = showDialog(mainFrame, okButtonName);	
		if(res != JFileChooser.APPROVE_OPTION){
			return null;
		}
		File file = getSelectedFile();
        if (outoComplete && file.getAbsolutePath().indexOf(".")<0){
                file = new File(file.getAbsolutePath()+"."+fileExtention);
        }
		if(askOverwrite && file.exists()){ 
			int reply = JOptionPane.showConfirmDialog(mainFrame, 
					"<html>"+ file.getName() + " already exists. <br>Do you want to overwrite it?<html>",okButtonName,JOptionPane.YES_NO_OPTION,  JOptionPane.WARNING_MESSAGE );
			return reply==JOptionPane.YES_OPTION ? file: null;
		}	
		return file;
	}
	class MedFileFilter extends FileFilter{
		
		public boolean accept(File f) {
			if(f.getName().endsWith(fileExtention) ||
			   f.isDirectory()){
				return true;
			}
			return false;
		}
		public String getDescription() {
			return extentionDescription;
		}
	}
	

	
}
