/*
 * Created on Jul 14, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control;

import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.control.actions.grading.TestImportAnswersAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.question.QuestionImportAct;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;

import java.util.Stack;

/**
 * @author svali
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class GuiCommandDispatcher {
	private static Stack undoStack = new Stack();
	private static Stack redoStack = new Stack();
	private static GuiCommandDispatcher guiCommandDispatcher = new GuiCommandDispatcher();
	
	private GuiCommandDispatcher(){}
	
	public static synchronized GuiCommandDispatcher getInstance(){
		return guiCommandDispatcher;	
	}
	
	public synchronized void run(CommandAction act) throws RetriableException,CriticalException {
		act.saveGuiStateForUndo();
		act.execute();
		if(act.getCommand() == null){
			return;
		}
		redoStack.clear();
		undoStack.push(act);
		if(act instanceof TestImportAnswersAct || act instanceof QuestionImportAct){
			undoStack.clear();
		}
		setUndoRedo(act);
		act.saveGuiStateForRedo();
	}
	
	public synchronized void undo() throws RetriableException,CriticalException {
		if (!undoEnabled()){
			throw (new RetriableException("Undo failed: undo stack is empty"));
		}
		CommandAction act = (CommandAction)undoStack.peek();
		act.undo();
		undoStack.pop();
		redoStack.push(act);
		setUndoRedo(act);
		act.getGuiStateForUndo().restoreGuiState();
	}

	public synchronized void redo() throws RetriableException,CriticalException {
		if (!redoEnabled())
			throw new RetriableException("Redo failed: redo stack is empty");
		CommandAction act = (CommandAction)redoStack.peek();
		act.execute();
		redoStack.pop();
		undoStack.push(act);
		setUndoRedo(act);
		act.getGuiStateForRedo().restoreGuiState();
	}
	
	private void setUndoRedo(CommandAction act){
		act.getMainWindow().setUndoEnabled(undoEnabled());
		act.getMainWindow().setRedoEnabled(redoEnabled());		
	}
	
	public boolean undoEnabled(){
		return !undoStack.isEmpty();
	}
	
	public boolean redoEnabled(){
		return !redoStack.isEmpty();
	}

	public String getLabelForUndo(){
		if(undoStack.isEmpty()){
			return "Undo not available";
		}
		return (((CommandAction)undoStack.lastElement())).toString();
	}
	
	public String getLabelForRedo(){
		if(redoStack.isEmpty()){
			return "Redo not available";
		}
		return (((CommandAction)redoStack.lastElement())).toString();
	}
	
}
