/*
 * Created on Jun 5, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.actions;

import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.MultiActionFailedActTableModel;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.MultiActionSuccessActTableModel;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MultiActionDialog;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.util.Iterator;
import java.util.List;

/**
 * @author svali
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MultiSelectionAction extends CommandAction {

	List actionsList;
	MultiActionFailedActTableModel failedModel ;
	MultiActionSuccessActTableModel successModel;
	
	public MultiSelectionAction (List actionsList,MainWindow frame) {
		super("MultiSelection Action",GeneralParams.ICON_QUESTION);
		putValue(SHORT_DESCRIPTION, "MultiSelection Action");
		init(frame);
		this.actionsList = actionsList;
		this.failedModel = new MultiActionFailedActTableModel();
		this.successModel = new MultiActionSuccessActTableModel(actionsList);
	} 
	
	public void execute() throws RetriableException, CriticalException{
		if(actionsList.size() == 1){			
			CommandAction act = ((CommandAction)actionsList.get(0));
			act.execute();
			command = act.getCommand();
			return;
		}	
		boolean undoEnabled = mainWindow.isUndoEnabled();
		boolean redoEnabled = mainWindow.isRedoEnabled();
		mainWindow.setUndoEnabled(false);
		mainWindow.setRedoEnabled(false);
		boolean showDialogs = GeneralParams.showConfirmDialogs;
		firstMultiSelectionExecution = true;
		for(Iterator it=actionsList.iterator();it.hasNext();){
			CommandAction act = (CommandAction)it.next();
			try{
				act.execute();
				if(act instanceof CancelableMultiselectionAction && 
						((CancelableMultiselectionAction)act).canceledPressed()){
					return;
				}
			}catch(RetriableException e){
				failedModel.addFailedAct(act.toString(),e.getMessage());
				it.remove();
			}
			GeneralParams.showConfirmDialogs = false;
			firstMultiSelectionExecution = false;
		}
		GeneralParams.showConfirmDialogs = showDialogs;
		firstMultiSelectionExecution = true;
		if(actionsList.size() > 0){
			command =((CommandAction) actionsList.get(0)).getCommand();
		}
		if(failedModel.getRowCount() > 0){
			String title = new String("MultiSelection Action was not successfully completed");
			new MultiActionDialog(mainWindow,successModel,failedModel,title).show();
		}
		mainWindow.setUndoEnabled(undoEnabled);
		mainWindow.setRedoEnabled(redoEnabled);
	}
		
	public void undo() throws RetriableException, CriticalException{
		for(int i=actionsList.size()-1;i>=0;--i){
			CommandAction act = (CommandAction)actionsList.get(i);
			act.undo();
		}
	}
		
	public String toString(){
		if(actionsList.size() == 1){
			return actionsList.iterator().next().toString();
		}
		String str = "<html>MultiSelection action composed of " + actionsList.size() + " commands:";
		for(Iterator it=actionsList.iterator();it.hasNext();){
			str+="<br>" + ((CommandAction)it.next()).toString();
		}
		str+="</html>";
		return str;
	}
	

}
