/*
 * Created on Jun 5, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.actions.category;

import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.category.CategoryCreate;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.MedNode;
import il.ac.technion.cs.course236308.e3.med.model.CategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.model.Category;
import il.ac.technion.cs.course236308.e3.med.parameters.CategoryParams;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

/**
 * @author svali
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class CategoryCreateAct extends CommandAction {
	private MedNode newNode;
	private MedNode parentNode;
	private int parentCatId;
	public CategoryCreateAct(int parentCatId, MainWindow frame) {
		super("Create New Category", GeneralParams.ICON_FULL_CATEGORY);
		putValue(SHORT_DESCRIPTION,"Create New Category under selected Category");
		init(frame);
		this.parentCatId = parentCatId;
	}

	public void execute() throws RetriableException, CriticalException {
		Category parentCat = CategoriesFactory.getInstance().getCategory(parentCatId);
		runCommand(new CategoryCreate(parentCat, CategoryParams.newCategoryDefaultName));
		newNode = CategoriesFactory.getInstance().buildTree(
				CommandDispatcher.getInstance().getCurrentCategory());
		parentNode = mainWindow.getCategoryTree().getNodeByObject(parentCat);
		parentNode.add(newNode);
		fireNodeAdded(newNode);

	}

	public void undo() throws RetriableException, CriticalException {
		super.undo();
		int index = parentNode.getIndex(newNode);
		parentNode.remove(newNode);
		fireNodeRemoved(newNode, parentNode, index);
	}
}