/*
 * Created on Jun 5, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.actions.category;

import il.ac.technion.cs.course236308.e3.med.command.category.CategoryDelete;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.MedNode;
import il.ac.technion.cs.course236308.e3.med.model.CategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.model.Category;
import il.ac.technion.cs.course236308.e3.med.parameters.CategoryParams;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

/**
 * @author svali
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class CategoryDeleteAct extends CommandAction {
	
	private MedNode parentNode;
	private MedNode catNode;
	private int index;
	private JDialog dialog;
	private int mode = -1;
	private int catId;
	private boolean alreadyExecuted = false;
	
	public CategoryDeleteAct (int catId,MainWindow frame) {
		super("Delete Category", GeneralParams.ICON_DELETE);
		putValue(SHORT_DESCRIPTION, "Delete Category");
		init(frame);
		this.catId = catId;
	} 
	
	public void execute() throws RetriableException, CriticalException {
		Category cat = CategoriesFactory.getInstance().getCategory(catId);
		if(!alreadyExecuted && GeneralParams.showConfirmDialogs && 
				JOptionPane.showConfirmDialog(mainWindow,"Are you sure you want to delete Category: " + cat.getFullName() +
						" ?","Deletion Confirmation",JOptionPane.OK_CANCEL_OPTION)!=JOptionPane.OK_OPTION){
			return;
		}
		alreadyExecuted = true;
		if(!cat.hasQuestInDescendant()){
			removeCategory(cat,CategoryParams.CANCEL_MODE);
			return;
		}
		dialog = new Selection();
		dialog.setVisible(true);
		if(mode == -1){
			return;
		}
		removeCategory(cat,mode);	
	}
	
	private void removeCategory(Category cat,int mode) throws RetriableException, CriticalException{
		runCommand(new CategoryDelete(cat,mode));
		catNode = mainWindow.getCategoryTree().getNodeByObject(cat);
		parentNode = catNode.getParentNode();
		index = parentNode.getIndex(catNode);
		parentNode.remove(catNode);
		fireNodeRemoved(catNode,parentNode,index);	
	}
	
	public void undo() throws RetriableException, CriticalException {
		super.undo();
		parentNode.insert(catNode,index);
		fireNodeAdded(catNode);
	}
	
	class Selection extends JDialog{
		String[] optionsStrings = {"Move Questions to Parent Node","Delete Questions"};
		JComboBox options = new JComboBox(optionsStrings);
		JButton okButton = new JButton("OK");
		JButton cancelButton = new JButton("Cancel");

		public Selection(){
			super(mainWindow,"Category contains questions",true);
			this.setContentPane(createMainPanel());
			addWindowListener(new WindowAdapter() {
				  public void windowClosing(WindowEvent e){
				  	setVisible(false);
				  }
				});
			okButton.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e) {
					mode = CategoryParams.DELETE_QUESTIONS_MODE;
					if(options.getSelectedIndex() == 0){
						mode = CategoryParams.MOVE_QUESTIONS_MODE;
					}
					setVisible(false);	
				}});
			cancelButton.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e) {
					mode = -1;
					setVisible(false);					
			}});
			this.pack();
			this.setLocation(mainWindow.getX() + mainWindow.getWidth()/2 - this.getWidth()/2,mainWindow.getY() + mainWindow.getHeight()/2 - this.getHeight()/2);
			
		}
		
		private JPanel createMainPanel(){
			JPanel main = new JPanel(new GridLayout(3,1,5,5));
			JPanel labelPanel = new JPanel();
			JLabel label = new JLabel("Selected Category contains questions.");
			labelPanel.add(label);
			label.setAlignmentX(JLabel.CENTER_ALIGNMENT);
			JPanel optionsPanel = new JPanel();
			optionsPanel.setLayout(new BoxLayout(optionsPanel, BoxLayout.X_AXIS));
			optionsPanel.add(new JLabel("Would you like to:  "));
			optionsPanel.add(options);
			main.add(labelPanel);
			main.add(optionsPanel);
			main.add(getButtonPanel());
			return main;
		}
		
		private JPanel getButtonPanel(){
			JPanel panel = new JPanel(new GridLayout(1,2,10,10));
			panel.add(okButton);
			panel.add(cancelButton);
			return panel;
		}
	}


}
