/*
 * Created on Jun 5, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.actions.category;

import il.ac.technion.cs.course236308.e3.med.command.category.CategorySetParent;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.MedNode;
import il.ac.technion.cs.course236308.e3.med.model.CategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.model.Category;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

/**
 * @author svali
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class CategorySetParentAct extends CommandAction {
	private int newParentCatId;
	private int catId;
	private MedNode catNode;
	private MedNode oldParentNode;
	private MedNode newParentNode;
	private int indexOld;
	public CategorySetParentAct(int catId, int newParentCatId, MainWindow frame) {
		super("Set Parent for Category", GeneralParams.ICON_FULL_CATEGORY);
		putValue(SHORT_DESCRIPTION,"Set Parent for Category");
		init(frame);
		this.newParentCatId = newParentCatId;
		this.catId = catId;
	}

	public void execute() throws RetriableException, CriticalException {
		Category cat = CategoriesFactory.getInstance().getCategory(catId);
		catNode = mainWindow.getCategoryTree().getNodeByObject(cat);
		oldParentNode = catNode.getParentNode();
		Category newParentCat = CategoriesFactory.getInstance().getCategory(newParentCatId);
		newParentNode = mainWindow.getCategoryTree().getNodeByObject(newParentCat);
		runCommand(new CategorySetParent(cat,newParentCatId));				
		indexOld = oldParentNode.getIndex(catNode);
		oldParentNode.remove(catNode);
		fireNodeRemoved(catNode,oldParentNode,indexOld);			
		newParentNode.add(catNode);
		fireNodeAdded(catNode);
	}

	public void undo() throws RetriableException, CriticalException {
		super.undo();
		
		int indexNew = newParentNode.getIndex(catNode);
		newParentNode.remove(catNode);
		fireNodeRemoved(catNode, newParentNode, indexNew);

		oldParentNode.insert(catNode,indexOld);
		fireNodeAdded(catNode);
	}
}