/*
 * Created on 10/08/2004
 */
package il.ac.technion.cs.course236308.e3.med.control.actions.grading;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.grading.TestCreateGradingSheet;
import il.ac.technion.cs.course236308.e3.med.control.FileChooser;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestsFactory;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.io.File;

/**
 * @author Shraer Alexander
 */
public class TestCreateGradingSheetAct extends CommandAction {
    private int testId;
    private MainWindow frame;  
    public TestCreateGradingSheetAct (int testId,MainWindow frame) {
        super("Export grading info. to Excel", GeneralParams.ICON_CSV);        
        putValue(SHORT_DESCRIPTION, "Export grading info. to Excel");
        init(frame);
        this.testId = testId;
    }
    
    public void execute() throws RetriableException, CriticalException{
    	Test test = TestsFactory.getInstance().getTest(testId);
    	FileChooser fc = new FileChooser("csv", "Comma Separated Values (csv)",true);
        File file = fc.choose(frame, true, "Save");
        if(file != null) {
            String filename = file.getAbsolutePath();
            Command c = new TestCreateGradingSheet(test, filename);
            c.run();
        }
    }
 }
