/*
 * Created on 21/07/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.actions.grading;

import il.ac.technion.cs.course236308.e3.med.command.MultiSelectionCommand;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.ExamRepliesTableModel;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.StudentReplyNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestRepliesNode;
import il.ac.technion.cs.course236308.e3.med.model.StudentReply;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestTaker;
import il.ac.technion.cs.course236308.e3.med.model.TestTakersFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestsFactory;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.util.Enumeration;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

/**
 * @author sybenny
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TestCreateReplyAct extends CommandAction {
	private int testId;
	private Test test;
	private ExamRepliesTableModel model;
	private StudentReplyNode newNode = null;
	private int index;
	private TestRepliesNode testRepliesNode;
	
	public TestCreateReplyAct(int testId,ExamRepliesTableModel model, MainWindow frame) {
		super("Create reply", GeneralParams.ICON_IMPORT);
		putValue(SHORT_DESCRIPTION, "Create reply");
		init(frame);
		this.testId = testId;
		this.model = model;
	}
	
	public StudentReplyNode getStudentReplyNode(){
		return newNode;
	}

	public void execute() throws RetriableException, CriticalException {
		test = TestsFactory.getInstance().getTest(testId);
		testRepliesNode = (TestRepliesNode) mainWindow.getTestTree().getNodeByObject(test).getChildAt(GeneralParams.TEST_REPLIES_NODE_INDEX);
		command = new MultiSelectionCommand(new LinkedList());
		StudentReply sr = new StudentReply(1+getMaxNodeId());
		sr.setID(GeneralParams.DEFAULT_TEST_TAKER_ID);
		sr.setStudentName(GeneralParams.DEFAULT_TEST_TAKER_NAME);
		if (newNode==null){
			newNode = new StudentReplyNode(sr, testRepliesNode);
		}
		testRepliesNode.add(newNode);
		testRepliesNode.nodeAdded(newNode);
		newNode.setDetails(false);
		newNode.setScrambledTest(getMaxNodeId());
		model.addOneReply(sr);
		model.fireTableDataChanged();
		fireNodeAdded(newNode);
	
	}
	public void undo() throws RetriableException, CriticalException {
		super.undo();
		TestTakersFactory ttf = TestTakersFactory.getInstance();
		if (newNode.isDetailsSet()==true &&
			!newNode.getStudentReply().getStudentId().equals(GeneralParams.DEFAULT_TEST_TAKER_ID) ){
			TestTaker tt = ttf.getTestTaker(newNode.getStudentReply().getStudentId(),test.getId());
			ttf.deleteTestTaker(tt);
		}
		model.removeReplyByRID(newNode.getStudentReply().getRid());
		model.fireTableDataChanged();
		index = testRepliesNode.getIndex(newNode);
		testRepliesNode.nodeRemoved(newNode);
		testRepliesNode.remove(newNode);
		fireNodeRemoved(newNode, testRepliesNode, index);
			
	}
	private long getMaxNodeId(){
		Enumeration en = testRepliesNode.children();
		long max = getMaxId();
		while(en.hasMoreElements()){
			StudentReplyNode srn= (StudentReplyNode)en.nextElement();
			long rid = ((StudentReply)srn.getUserObject()).getRid();
			if (rid>max) max=rid;
		}
		return max;
	}
	
	private int getMaxId() {
		int max = 0, curNotebook;
		TestTakersFactory ttf = TestTakersFactory.getInstance();
		List tTakers = ttf.getTestTakersOfTest(test);
		Iterator iter = tTakers.iterator();
		while (iter.hasNext()) {
			curNotebook = ((TestTaker) iter.next()).getNotebookNumber();
			if (curNotebook > max){
				max = curNotebook;
			}
		}
		return max;
	}
}