/*
 * Created on 24/07/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.control.actions.grading;
import il.ac.technion.cs.course236308.e3.med.command.grading.TestDeleteOneReply;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.StudentReplyNode;
import il.ac.technion.cs.course236308.e3.med.model.StudentReply;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestTaker;
import il.ac.technion.cs.course236308.e3.med.model.TestTakersFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;
import il.ac.technion.cs.course236308.e3.med.model.TestVersionsFactory;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.util.Iterator;

/**
 * @author sybenny
 *
 */
public class TestDeleteOneReplyAct extends CommandAction {

	private TestVersion testVersion;
	private TestTaker testTaker;
	private int answerId;
	private int testId;
	private int versionId;
	private String testTakerId;
	private MainWindow frame;
	private StudentReplyNode node;
	
	public TestDeleteOneReplyAct(int testId, int versionId, String testTakerId,	int answerId, MainWindow frame,StudentReplyNode node) {
		super("Delete one reply", GeneralParams.ICON_DELETE);
		putValue(SHORT_DESCRIPTION, "Delete one reply");
		init(frame);
		this.versionId = versionId;
		this.testId = testId;
		this.testTakerId = testTakerId;
		this.answerId = answerId;
		this.frame = frame;
		this.node = node;
	}
	
	public void execute() throws RetriableException, CriticalException {
		testVersion = TestVersionsFactory.getInstance().getTestVersion(testId,versionId);
		testTaker = TestTakersFactory.getInstance().getTestTaker(testTakerId,testId);
		runCommand(new TestDeleteOneReply(testTaker,testVersion,answerId));
		 
		Test test = node.getStudentsRepliesNode().getExamNode().getCanonicalTest();
		Iterator iter = test.getTestVersions().iterator();
		int count = 1;
		while(iter.hasNext()){
			TestVersion tv =(TestVersion)iter.next();
			if (tv.getVersion().equals(testVersion.getVersion())){
					break;				
			}
			count++;
		}
		StudentReply sr = (StudentReply) node.getUserObject();
		sr.removeAnswer(new Integer(count));
	}
	
	public void undo() throws RetriableException, CriticalException  {
		super.undo();
		CommandAction ca = new TestSetOneReplyAct(testId,versionId,testTakerId,answerId,frame,node);
		ca.execute();
	}
}
