/*
 * Created on 13/07/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.actions.grading;

import il.ac.technion.cs.course236308.e3.med.command.grading.TestImportAnswers;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.ExamRepliesTableModel;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.MultiActionFailedActTableModel;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.MultiActionSuccessActTableModel;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MultiActionDialog;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.StudentReplyNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestRepliesNode;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.AnswersFactory;
import il.ac.technion.cs.course236308.e3.med.model.StudentReply;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestRepliesFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestReply;
import il.ac.technion.cs.course236308.e3.med.model.TestTaker;
import il.ac.technion.cs.course236308.e3.med.model.TestTakersFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;
import il.ac.technion.cs.course236308.e3.med.model.TestsFactory;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.model.VersionsFactory;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.util.Iterator;
import java.util.List;
import java.util.Set;

import javax.swing.JOptionPane;

/**
 * @author sybenny
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TestImportAnswersAct extends CommandAction {
	private String file;
	private ExamRepliesTableModel model;
	private TestRepliesNode node;

	public TestImportAnswersAct (String fileName,ExamRepliesTableModel model, MainWindow frame,TestRepliesNode node) {
		super("Import Answers", GeneralParams.ICON_IMPORT);
		putValue(SHORT_DESCRIPTION, "Import Answers");
		init(frame);
		this.file = fileName;
		this.model = model;		
		this.node = node;
	} 
	
    private int getTestVersionOrdinal(TestReply tr) throws RetriableException, CriticalException{
       
        Answer ans = AnswersFactory.getInstance().getAnswer(tr.getAnswerId());
        Version ver = VersionsFactory.getInstance().getVersion(ans.getVersionId());
		Test test = node.getExamNode().getCanonicalTest();
        Iterator iter = test.getTestVersions().iterator();
        int counter = 1; 
        while (iter.hasNext()){
        	TestVersion tv = (TestVersion) iter.next();
        	if (ver.getId()==tv.getVersion().getId()){
        		return counter;
        	}
        	counter++;
        }
        return -1;
         
    }
	
	public void execute() throws RetriableException, CriticalException {
		TestImportAnswers act = new TestImportAnswers(node.getExamNode().getTest(),file);
		try{		
			runCommand(act);
		}catch(RetriableException e){
			JOptionPane.showMessageDialog
						(this.getMainWindow(), e.getMessage(), "Error",JOptionPane.ERROR_MESSAGE);					
		}
		
		// display information about the command success
		List failedAct = act.getFailedActionsList();
		MultiActionFailedActTableModel failedModel = new MultiActionFailedActTableModel();
		
		for(Iterator it=failedAct.iterator();it.hasNext();){
			String actionName = (String)it.next();
			String failReason = (String)it.next();
			failedModel.addFailedAct(actionName,failReason);		
		}
		MultiActionSuccessActTableModel successModel = new MultiActionSuccessActTableModel(act.getSuccessActionsList()); 		
		String title = new String("Import answers from file " + file + " report");
		new MultiActionDialog(mainWindow,successModel,failedModel,title).show();
		
		
		// update student replies in GUI
		Set updatedTests = act.getUpdatedTests();
		for(Iterator itUpdatedTest =updatedTests.iterator();itUpdatedTest.hasNext();){
			Integer updatedId = (Integer)itUpdatedTest.next();
			Test t = TestsFactory.getInstance().getTest(updatedId.intValue());
			TestRepliesNode updatedNode = (TestRepliesNode)mainWindow.getTestTree().getNodeByObject(t).getChildAt(2);
				
			TestRepliesFactory trf = TestRepliesFactory.getInstance();
			TestTakersFactory ttf = TestTakersFactory.getInstance();
			List testTakers;
			try {
				testTakers = ttf.getTestTakersOfTest(t);
				Iterator ttIter= testTakers.iterator();
				while (ttIter.hasNext()){
					TestTaker tTaker =(TestTaker) ttIter.next(); 
					List testReplies = trf.getTestRepliesList(tTaker.getId(),t.getId());
					Iterator iter = testReplies.iterator();
					StudentReply sr=new StudentReply(tTaker.getId(),tTaker.getNotebookNumber());
					sr.setStudentName(tTaker.getName());
					while(iter.hasNext()){
						TestReply tr =(TestReply) iter.next();
						if (tr.getTestTakerId().equals(tTaker.getId())){
								Answer ans = AnswersFactory.getInstance().getAnswer(tr.getAnswerId());
								sr.getAnswers().put(new Integer(getTestVersionOrdinal(tr)),
														 new Integer(ans.getOrdinal()));                                                       
						}
								// here we added one testReply
					}
					StudentReplyNode newNode = new StudentReplyNode(sr,updatedNode);
				
					int index = updatedNode.getReplyIndex(sr);
					if (index==-1){
						updatedNode.nodeAdded(newNode);
						updatedNode.add(newNode);
						newNode.setScrambledTest(sr.getRid());
						model.addOneReply(sr);
						fireNodeAdded(newNode);
					}
					else {
						StudentReplyNode oldNode = (StudentReplyNode)updatedNode.getChildAt(index);
						oldNode.setScrambledTest(sr.getRid());
						StudentReply oldsr = (oldNode).getStudentReply();
						model.removeOneReply(oldsr);
						oldNode.setUserObject(sr);
						updatedNode.getExamRepliesList().removeStudentReply(oldsr);
						updatedNode.getExamRepliesList().addStudentReply(sr);
						model.addOneReply(sr);					
					}
				}		
			} catch (Throwable e1) {
						// TODO Auto-generated catch block
				e1.printStackTrace();
			}			
		
		}
		
		
	}
	
		
		
		
		
		
		
	

}
