/*
 * Created on Aug 2, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.actions.grading;

import il.ac.technion.cs.course236308.e3.med.command.MultiSelectionCommand;
import il.ac.technion.cs.course236308.e3.med.command.grading.TestRemoveReply;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.StudentReplyNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestRepliesNode;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestTaker;
import il.ac.technion.cs.course236308.e3.med.model.TestTakersFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestsFactory;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.util.LinkedList;
/**
 * @author Valentin Kravtsov
 *
 * Created in DS Laboratory - Technion, Israel 2004
 */
public class TestRemoveReplyAct extends CommandAction {
	private int testId;
	private TestRepliesNode parent;
	private int index;
	private StudentReplyNode node;
	
	public TestRemoveReplyAct(int testId, MainWindow frame,StudentReplyNode node){
		super("Remove reply", GeneralParams.ICON_DELETE);
		putValue(SHORT_DESCRIPTION, "Remove reply");
		init(frame);
		this.testId = testId;
		this.node = node;
	}
	
	public void execute() throws CriticalException {
		String stId = node.getStudentReply().getStudentId();		
		try {
			TestTaker testTaker = TestTakersFactory.getInstance().getTestTaker(stId, testId);
			Test test = TestsFactory.getInstance().getTest(testId);
			runCommand(new TestRemoveReply(test,testTaker));
		} catch (RetriableException e) {
			command = new MultiSelectionCommand(new LinkedList());
		}		
		parent = node.getStudentsRepliesNode();
		index = parent.getIndex(node);
		parent.nodeRemoved(node);
		parent.remove(node);
		fireNodeRemoved(node, parent, index);
	}
	
	public void undo() throws RetriableException, CriticalException {
		super.undo();
		parent.nodeAdded(node);
		parent.insert(node,index);
		fireNodeAdded(node);
	}
}
