/*
 * Created on 24/07/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.control.actions.grading;

import il.ac.technion.cs.course236308.e3.med.command.grading.TestSetOneReply;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.StudentReplyNode;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.StudentReply;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestTaker;
import il.ac.technion.cs.course236308.e3.med.model.TestTakersFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;
import il.ac.technion.cs.course236308.e3.med.model.TestVersionsFactory;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.util.Iterator;

/**
 * @author sybenny
 *
 */
public class TestSetOneReplyAct extends CommandAction {
	private int testId;
	private int versionId;
	private String testTakerId;
	private int answerId;
	private int count;
	private int oldOrd;
	private StudentReplyNode studentReplyNode;
	public TestSetOneReplyAct(int testId, int versionId, String testTakerId,int answerId, MainWindow frame, StudentReplyNode node) {
		super("Set one reply", GeneralParams.ICON_SETTING);
		putValue(SHORT_DESCRIPTION, "Set one reply");
		init(frame);
		this.testId = testId;
		this.versionId = versionId;
		this.testTakerId = testTakerId;
		this.answerId = answerId;
		this.studentReplyNode = node;
		this.oldOrd = -1;
	}
	
	public void execute() throws RetriableException, CriticalException {
		TestTaker testTaker = TestTakersFactory.getInstance().getTestTaker(testTakerId,testId);
		TestVersion testVersion = TestVersionsFactory.getInstance().getTestVersion(testId,versionId);
		runCommand(new TestSetOneReply(testTaker,testVersion,answerId));
		Test test = studentReplyNode.getStudentsRepliesNode().getExamNode().getCanonicalTest();
		Iterator iter = test.getTestVersions().iterator();
		count = 1;
		int ord=0;
		while(iter.hasNext()){
			TestVersion tv =(TestVersion)iter.next();
			if (tv.getVersion().equals(testVersion.getVersion())){
				for (int i=0;i<tv.getVersion().getAnswers().size();i++){
					Answer ans =(Answer) tv.getVersion().getAnswers().get(i);
					if (ans.getId()==answerId){
						ord = 1+i; 
						break;
					}
				}
				break;				
			}
			count++;
		}
		StudentReply sr = (StudentReply) studentReplyNode.getUserObject();
		if (sr.getAnswers().keySet().contains(new Integer(count))){
			oldOrd = ((Integer)sr.getAnswers().get(new Integer(count))).intValue();
		}
		sr.addAnswer(new Integer(count),new Integer(ord));
	}
	
	public void undo() throws RetriableException, CriticalException  {
		super.undo();
		StudentReply sr = (StudentReply) studentReplyNode.getUserObject();
		sr.removeAnswer(new Integer(count));
		if (oldOrd!=-1){
			sr.addAnswer(new Integer(count),new Integer(oldOrd));
		}
		studentReplyNode.setUserObject(sr);
	}

}
