/*
 * Created on 26/07/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.actions.grading;

import il.ac.technion.cs.course236308.e3.med.command.grading.TestSetStudentId;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.StudentReplyNode;
import il.ac.technion.cs.course236308.e3.med.model.StudentReply;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestTaker;
import il.ac.technion.cs.course236308.e3.med.model.TestTakersFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestsFactory;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

/**
 * @author sybenny
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TestSetStudentIdAct extends CommandAction {

	private int testId;
	private String oldId,newId;
	private long rid;
	private long oldRid;
	private StudentReplyNode studentReplyNode;
	public TestSetStudentIdAct(int testId,String oldId,String newId,long rid,MainWindow frame, StudentReplyNode node){
		super("Set Student Id", GeneralParams.ICON_SETTING);
		putValue(SHORT_DESCRIPTION, "Set Student Id");
		init(frame);
		this.testId = testId;
		this.oldId = oldId;
		this.newId = newId;
		this.rid = rid;
		this.studentReplyNode = node;
	}
	
	public void execute() throws RetriableException, CriticalException {
		if (newId.equals(oldId)) return;
		Test test = TestsFactory.getInstance().getTest(testId);
		runCommand(new TestSetStudentId(test,oldId,newId));
		StudentReply sr = studentReplyNode.getStudentReply();
		sr.setID(newId);
		oldRid = sr.getRid();
		sr.setRID(rid);
		studentReplyNode.setUserObject(sr);
		TestTakersFactory ttf = TestTakersFactory.getInstance();
		TestTaker t = ttf.getTestTaker(newId,test.getId());
		t.setNotebookNumber((int) rid);
		t.updateDB();
		mainWindow.getTestTree().repaint();
	}
	public void undo() throws RetriableException, CriticalException {
		if (newId.equals(oldId)) return;
		super.undo();
		StudentReply sr = studentReplyNode.getStudentReply();
		sr.setID(oldId);
		studentReplyNode.setUserObject(sr);
		TestTakersFactory ttf = TestTakersFactory.getInstance();
		
		if (oldId.equals(GeneralParams.DEFAULT_TEST_TAKER_ID)==false){
			TestTaker t = ttf.getTestTaker(oldId,testId);
			t.setNotebookNumber((int) oldRid);
			t.updateDB();
		}
		mainWindow.getTestTree().repaint();	
		
	}
}
