/*
 * Created on 26/07/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.actions.grading;

import il.ac.technion.cs.course236308.e3.med.command.grading.TestSetStudentRid;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.StudentReplyNode;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.AnswersFactory;
import il.ac.technion.cs.course236308.e3.med.model.StudentReply;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestRepliesFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestReply;
import il.ac.technion.cs.course236308.e3.med.model.TestTaker;
import il.ac.technion.cs.course236308.e3.med.model.TestTakersFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;
import il.ac.technion.cs.course236308.e3.med.model.TestsFactory;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.model.VersionsFactory;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

/**
 * @author sybenny
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TestSetStudentRidAct extends CommandAction {

	
	private int testId;
	private long oldStudentRid,newStudentRid;
	private String stId;
	private HashMap selectedAnswersHash, deletedAnswersMap;
	private StudentReplyNode studentReplyNode;
	//selectedAnswers are the map we see on the screen
	//deletedMap is the rows that can't be displayed after rid change
	public TestSetStudentRidAct(int testId, String stId,long oldStudentRid, long newStudentRid,HashMap selectedAnswersHash, MainWindow frame, StudentReplyNode node){
		super("Set Student Questionnairy", GeneralParams.ICON_SETTING);
		putValue(SHORT_DESCRIPTION, "Set Student Questionnairy");
		init(frame);
		this.testId = testId;
		this.oldStudentRid = oldStudentRid;
		this.newStudentRid = newStudentRid;
		this.stId = stId;	
		this.selectedAnswersHash = selectedAnswersHash;
		this.studentReplyNode = node;
	}
	
	public void execute() throws RetriableException, CriticalException {
		if (oldStudentRid==newStudentRid) return;
		Test test = TestsFactory.getInstance().getTest(testId);
		runCommand(new TestSetStudentRid(test,stId,oldStudentRid,newStudentRid));
		updateReplies(false, false);	    
		studentReplyNode.setScrambledTest(newStudentRid);
		updateReplies(true, true);
	/*	if (deletedAnswersMap.keySet().isEmpty()==false){
			TestTaker tTaker = TestTakersFactory.getInstance().getTestTaker(stId,test.getId());
			for (Iterator it = deletedAnswersMap.keySet().iterator();it.hasNext();){
				Integer qNumber = (Integer)it.next();
				TestVersion tv = (TestVersion) test.getTestVersions().get(qNumber.intValue());
				Integer answerOrdinal = (Integer)deletedAnswersMap.get(qNumber);
				Answer curAns =(Answer) tv.getVersion().getAnswers().get(answerOrdinal.intValue());			
				(new TestSetOneReplyAct(tv,tTaker,curAns.getId(),mainWindow,node)).execute();	
			}
		}*/
		updateNode(newStudentRid);
	}
	private void updateNode(long rid) throws RetriableException, CriticalException{
		TestRepliesFactory trf = TestRepliesFactory.getInstance();
		List testReplies = trf.getTestRepliesList(stId,testId);
		Iterator iter = testReplies.iterator();
		StudentReply sr = studentReplyNode.getStudentReply();
		sr.setRID(rid);
//		((StudentReplyNode)node).setScrambledTest(rid);
//		sr.getAnswers().clear();
		while(iter.hasNext()){
			TestReply tr =(TestReply) iter.next();
			if (tr.getTestTakerId().equals(stId)){
				Answer ans = AnswersFactory.getInstance().getAnswer(tr.getAnswerId());
				sr.getAnswers().put(new Integer(getTestVersionOrdinal(tr)),
								 new Integer(ans.getOrdinal()));
			}
		}
	}
	private int getTestVersionOrdinal(TestReply tr) throws RetriableException, CriticalException{
		int place=0;
		Answer ans = AnswersFactory.getInstance().getAnswer(tr.getAnswerId());
		Version ver = VersionsFactory.getInstance().getVersion(ans.getVersionId());
		Test test = studentReplyNode.getStudentsRepliesNode().getExamNode().getCanonicalTest();
		TestVersion[] tVersions = new TestVersion[test.getTestVersions().size()];
		TestVersion[] testVersions =  (TestVersion[]) test.getTestVersions().toArray(tVersions);
		for (place=0;place<testVersions.length;place++){
			if (testVersions[place].getVersion().equals(ver))
				return place+1;
		}
		return place;
	}
	private void updateReplies(boolean set, boolean remember) throws RetriableException, CriticalException{
		TestTaker tTaker = TestTakersFactory.getInstance().getTestTaker(stId,testId);
		Test test = studentReplyNode.getScrambledTest();
		if (remember) deletedAnswersMap = new HashMap();
		for (Iterator it = selectedAnswersHash.keySet().iterator(); it.hasNext();){
			int qNumber = ((Integer)it.next()).intValue();
			int answerOrdinal = ((Integer)selectedAnswersHash.get(new Integer(qNumber))).intValue();
			TestVersion tv = (TestVersion) test.getTestVersions().get(qNumber);
			if (answerOrdinal==-1) continue;
			if (answerOrdinal+1>tv.getVersion().getAnswers().size()) {
				if (remember){
					deletedAnswersMap.put(new Integer(qNumber), new Integer(answerOrdinal));	
				}
				continue;	
			}
			Answer curAns =(Answer) tv.getVersion().getAnswers().get(answerOrdinal);
			int answerId=curAns.getId();
			if (set) (new TestSetOneReplyAct(testId,tv.getVersion().getId(),tTaker.getId(),answerId,mainWindow,studentReplyNode)).execute();
			else (new TestDeleteOneReplyAct(testId,tv.getVersion().getId(),tTaker.getId(),answerId,mainWindow,studentReplyNode)).execute();
		}
	}
	
	public void undo() throws RetriableException, CriticalException{
		if (oldStudentRid==newStudentRid) return;
		super.undo();
		updateReplies(false, false);
		studentReplyNode.setScrambledTest(oldStudentRid);
		updateReplies(true, false);
		Test test = studentReplyNode.getScrambledTest();
		TestTaker tTaker = TestTakersFactory.getInstance().getTestTaker(stId,test.getId());
		for (Iterator it = deletedAnswersMap.keySet().iterator();it.hasNext();){
			Integer qNumber = (Integer)it.next();
			TestVersion tv = (TestVersion) test.getTestVersions().get(qNumber.intValue());
			Integer answerOrdinal = (Integer)deletedAnswersMap.get(qNumber);
			Answer curAns =(Answer) tv.getVersion().getAnswers().get(answerOrdinal.intValue());			
			(new TestSetOneReplyAct(testId,tv.getVersion().getId(),tTaker.getId(),curAns.getId(),mainWindow,studentReplyNode)).execute();
		}
		updateNode(oldStudentRid);
	}
}
