/*
 * Created on Jun 5, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.actions.question;

import il.ac.technion.cs.course236308.e3.med.command.question.QuestionAddToTest;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.control.actions.test.TestCategoryAddToTestAct;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestCategoryNode;
import il.ac.technion.cs.course236308.e3.med.model.CategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.QuestionsFactory;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestCategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;
import il.ac.technion.cs.course236308.e3.med.model.TestVersionsFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestsFactory;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;
import il.ac.technion.cs.course236308.e3.med.stats.StatisticData;

/**
 * @author svali
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class QuestionAddToTestAct extends CommandAction {
	private int testId;
	private int questId;
    private String testCatFullName;
    private TestCategoryAddToTestAct testCatAddToTestAct;
	public QuestionAddToTestAct (int testId,int questId,MainWindow frame) {
		super("Add Question to Test", GeneralParams.ICON_QUESTION_SHORTCUT);
		putValue(SHORT_DESCRIPTION, "Add Question to Test");
		init(frame);
		this.testId = testId;
		this.questId = questId;
	} 
	
	public void execute() throws RetriableException, CriticalException {
		Test test = TestsFactory.getInstance().getTest(testId);
		Question quest = QuestionsFactory.getInstance().getQuestion(questId);
		runCommand(new QuestionAddToTest(test,quest));
		TestVersion testVersion;
		try {
			testCatFullName = CategoriesFactory.getInstance().getCategory(quest.getMainCategoryId()).getFullName();
			testVersion = TestVersionsFactory.getInstance().getTestVersion(test.getId(),quest.getActiveVersionId().intValue());
		} catch (Throwable ex) {
			ex.printStackTrace();
			return;
		}
		TestCategoryNode testCatNode = TestCategoriesFactory.getInstance().getTestCategoryNode(testCatFullName,test);
		testCatNode.getTestCategory().getTestVersions().add(testVersion);
		testCatAddToTestAct = new TestCategoryAddToTestAct(testCatNode.getTestCategory(),mainWindow);
		testCatAddToTestAct.execute();
		StatisticData.getInstance().updateQuestionsStatistics(test.getId());
	}
	
	public void undo() throws RetriableException, CriticalException {
		Test test = TestsFactory.getInstance().getTest(testId);
		TestVersion testVersion;
		try {
			Question quest = QuestionsFactory.getInstance().getQuestion(questId);
			testVersion = TestVersionsFactory.getInstance().getTestVersion(test.getId(),quest.getActiveVersionId().intValue());
		} catch (Throwable ex) {
			ex.printStackTrace();
			return;
		}
		super.undo();
		TestCategoryNode testCatNode = TestCategoriesFactory.getInstance().getTestCategoryNode(testCatFullName,test);
        testCatNode.getTestCategory().getTestVersions().remove(testVersion);
		testCatAddToTestAct.undo();
		StatisticData.getInstance().updateQuestionsStatistics(test.getId());
	}
}
