/*
 * Created on Jun 5, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.actions.question;

import il.ac.technion.cs.course236308.e3.med.command.question.QuestionsImport;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.CategoryNode;
import il.ac.technion.cs.course236308.e3.med.model.CategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.model.Category;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.io.File;
import java.util.Iterator;

import javax.swing.JDialog;
import javax.swing.JOptionPane;

/**
 * @author svali
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class QuestionImportAct extends CommandAction {
	File file;
	JDialog dialog;
	public QuestionImportAct (MainWindow frame) {
		super("Import Questions", GeneralParams.ICON_IMPORT);
		putValue(SHORT_DESCRIPTION, "Import Questions (not undoable action)");
		init(frame);	
	} 
	
	public void execute() throws RetriableException, CriticalException {	
		File file = mainWindow.getQuestionFileChooser().choose(mainWindow,false,"Import");	
		if(file == null){
			return;
		}
		if(!file.exists()){ 
			JOptionPane.showMessageDialog(mainWindow, "File "+file+ " does not exists", "Med Error Occured", 
												JOptionPane.ERROR_MESSAGE);
			return;
		}	
		try{
			runCommand(new QuestionsImport(file.getAbsolutePath()));
			refresh((CategoryNode) MainWindow.getCategoriesRootNode());
		}catch(RetriableException e){
			refresh((CategoryNode) MainWindow.getCategoriesRootNode());
			throw e;
		}
	}
	
	private void refresh(CategoryNode catNode){
		boolean found = false;
		for(Iterator it=catNode.getCategory().getCategories().iterator();it.hasNext();){
			Category cat = (Category)it.next();
			found = false;
			for(int i=0;i<catNode.getChildCount();++i){
				if(((CategoryNode)catNode.getChildAt(i)).getCategory().equals(cat)){
					found = true;
					break;
				}
			}
			if(!found){
				CategoryNode newNode = CategoriesFactory.getInstance().buildTree(cat);
				catNode.add(newNode);
				fireNodeAdded(newNode);
			}
		}
		for(int i=0;i<catNode.getChildCount();++i){
			refresh((CategoryNode) catNode.getChildAt(i));
		}
		firePropertiesChanged();
	}
}
