/*
 * Created on 18/07/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.actions.test;

import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.command.test.TestPrintCopy;
import il.ac.technion.cs.course236308.e3.med.control.FileChooser;
import il.ac.technion.cs.course236308.e3.med.control.NumberVerifier;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestsFactory;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;
import il.ac.technion.cs.course236308.e3.med.parameters.TestParams;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.io.File;

import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * @author svekant
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TestPrintCopyAct extends CommandAction {
	private int testId;
	private MainWindow frame; 
	private JTextField numberOfCopies = new JTextField("1");
	private JTextField firstQuestId = new JTextField("1");
	private JCheckBox openExplorerCheck = new JCheckBox("Open first copy");
	public TestPrintCopyAct (int testId,MainWindow frame) {
		super("Print scrambled tests", GeneralParams.ICON_PRINT);
		this.frame = frame;
		putValue(SHORT_DESCRIPTION, "Print scrambled tests");
		init(frame);
		this.testId = testId;
	}
	
	public void execute() throws RetriableException, CriticalException {
		Test test = TestsFactory.getInstance().getTest(testId);
		try {
			test.isLegal();
		} catch (RetriableException e) {
			MedReporter.report("# " + e.getMessage());
			throw new RetriableException("<html>Can't execute - " +
			"test is in illegal state<br>(see details in Illegal States window)</html>");
		}
		JPanel panel= new JPanel(new BorderLayout());
		JPanel dataPanel = new JPanel(new GridLayout(2,2));
		numberOfCopies.setInputVerifier(new NumberVerifier());
		firstQuestId.setInputVerifier(new NumberVerifier());
		dataPanel.add(new JLabel("Num. of copies:"));
		dataPanel.add(numberOfCopies);
		dataPanel.add(new JLabel("Starting from:"));
		dataPanel.add(firstQuestId);
		panel.add(dataPanel,BorderLayout.NORTH);
		panel.add(openExplorerCheck,BorderLayout.SOUTH);
        FileChooser fc = new FileChooser(TestParams.xhtmlFileExtension, "XHTML Files ("+TestParams.xhtmlFileExtension+")", false);
        fc.setAccessory(panel);
        File file = fc.choose(frame,false,"Save");
        if (file==null) return;
		int num = Integer.parseInt(numberOfCopies.getText());
		int firstCopy = Integer.parseInt(firstQuestId.getText());
	    String filename = file.getAbsolutePath();
        String extention = TestParams.xhtmlFileExtension;
        if (filename.indexOf(".")>=0){
            extention = filename.substring(filename.lastIndexOf(".")+1);
            filename = filename.substring(0, filename.lastIndexOf("."));
        }
        for (int i=firstCopy; i<num+firstCopy; i++){
            File f = new File(filename + i + "." + extention);
            if (f.exists()) {
                int reply = JOptionPane.showConfirmDialog(frame, 
                        "<html>"+ f.getName() + " already exists. <br>Do you want to overwrite it?<html>","Save",JOptionPane.YES_NO_OPTION,  JOptionPane.WARNING_MESSAGE );
                if (reply!=JOptionPane.YES_OPTION) continue;
            }
		    new TestPrintCopy(test,i,f.getAbsolutePath()).run();
        }    
        try {
        	if(openExplorerCheck.isSelected()){
        		Runtime.getRuntime().exec("explorer " + filename + firstCopy + "." + extention);
        	}
		} catch (Throwable e1) {
		}
	}
}
