/*
 * Created on 08/07/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.actions.test;

import il.ac.technion.cs.course236308.e3.med.command.test.version.TestVersionRemoveFromTest;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestCategoryNode;
import il.ac.technion.cs.course236308.e3.med.model.TestCategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;
import il.ac.technion.cs.course236308.e3.med.model.TestVersionsFactory;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;
import il.ac.technion.cs.course236308.e3.med.stats.StatisticData;

/**
 * @author svali
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TestVersionRemoveFromTestAct extends CommandAction {
    private int testId;
    private int verId;
    private TestCategoryRemoveFromTestAct removeCatAct;
    
	public TestVersionRemoveFromTestAct (int testId,int verId,MainWindow frame) {
		super("Remove Version from Test", GeneralParams.ICON_REMOVE);
		putValue(SHORT_DESCRIPTION, "Remove Version from Test");
		init(frame);
		this.testId = testId;
		this.verId = verId;
	} 
    
	public void execute() throws RetriableException, CriticalException {   
        TestVersion testVersion = TestVersionsFactory.getInstance().getTestVersion(testId,verId);
		TestCategoryNode testCatNode = TestCategoriesFactory.getInstance().getTestCategoryNode(testVersion);
        removeCatAct = new TestCategoryRemoveFromTestAct(testCatNode.getTestCategory(),mainWindow);
		runCommand(new TestVersionRemoveFromTest(testVersion));       
        testCatNode.getTestCategory().getTestVersions().remove(testVersion);
        removeCatAct.execute();
		StatisticData.getInstance().updateQuestionsStatistics(testVersion.getTestId());
		if(testCatNode.getParent() != null){
			firePropertiesChanged();
		}
	}
           
    public void undo() throws RetriableException, CriticalException {  	
    	removeCatAct.undo();
    	super.undo();
    	TestVersion testVersion = TestVersionsFactory.getInstance().getTestVersion(testId,verId);       
		TestCategoryNode testCatNode = TestCategoriesFactory.getInstance().getTestCategoryNode(testVersion);
        testCatNode.getTestCategory().getTestVersions().add(testVersion);
		StatisticData.getInstance().updateQuestionsStatistics(testVersion.getTestId());
    }

}
