/*
 * Created on May 28, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.controllers;
import il.ac.technion.cs.course236308.e3.med.control.ModelChangesListener;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.control.actions.MultiSelectionAction;
import il.ac.technion.cs.course236308.e3.med.control.actions.category.CategoryCloneAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.category.CategoryCreateAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.category.CategoryDeleteAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.category.CategorySetNameAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.general.RenameNodeAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.question.QuestionAddSecondaryCategoryAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.question.QuestionCancelAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.question.QuestionCloneAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.question.QuestionCreateAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.question.QuestionDeleteAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.question.QuestionDeleteUnlockedVersionsAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.question.QuestionExportAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.question.QuestionImportAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.question.QuestionRemoveSecondaryCategoryAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.version.VersionCloneAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.version.VersionCreateAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.version.VersionDeleteAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.version.VersionMarkAsActiveAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.version.VersionSetLanguageAct;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.MedTree;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.QuestionsTableModel;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.SecondaryCatTableModel;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.VersionsSingleSelectionModel;
import il.ac.technion.cs.course236308.e3.med.gui.panels.CategoryPanel;
import il.ac.technion.cs.course236308.e3.med.gui.panels.CategoryStatisticsPanel;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.states.CategoryPanelGuiState;
import il.ac.technion.cs.course236308.e3.med.gui.states.GuiState;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.CategoryNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.MedNode;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.Category;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.text.SimpleDateFormat;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;

import javax.swing.Action;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JSeparator;

/**
 * @author svali
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class CategoryPanelController extends ParentOfVersionPropertyController{
	private CategoryPanel categoryPanel;
	
	private QuestionsTableModel questTableModel;
	private SecondaryCatTableModel secCatTableModel;
	private VersionsSingleSelectionModel versionsModel;
	
	private int selectedUnsortedQuestIndex = -1;
	private int selectedVerIndex = -1;
	private CategoryNode selectedNode;
    
	private VersionPropertyPanelController versionController;
	
	public CategoryPanelController(MainWindow mainWindow,MedTree tree){
		super(mainWindow,tree);
		versionController = new VersionPropertyPanelController(mainWindow,this);
		categoryPanel = new CategoryPanel(this);
		categoryPanel.setQuestionsTableModel(questTableModel = new QuestionsTableModel());
		categoryPanel.setSecondaryCatTableModel(secCatTableModel = new SecondaryCatTableModel());
		categoryPanel.setVersionsSingleSelectionModel(versionsModel = new VersionsSingleSelectionModel());
		categoryPanel.init();
		Vector listeners = new Vector();
		listeners.add(new OneVersionRefresherListener());
		versionController.addListenersForActions(listeners);
	}
	
	public JPanel getMainPanel(){
		return categoryPanel;
	}

	public JPanel getVersionsPanel(){
		return versionController.getMainPanel();
	}

	public void versionSelected(int newVerIndex){
		selectedVerIndex = newVerIndex;
		Version selectedVersion = versionsModel.getVersionByIndex(selectedVerIndex);
		mainWindow.getStatisticsPanel().setAvgDifficultyVerLabel(selectedVersion.getAvgDifficulty());
		mainWindow.getStatisticsPanel().setAvgDIVerLabel(selectedVersion.getAvgDI());
		categoryPanel.setVerCreatedText(new SimpleDateFormat("yyyy-MM-dd   HH:mm").format(selectedVersion.getCreated().getTime()));
		categoryPanel.setVerUpdatedText(new SimpleDateFormat("yyyy-MM-dd   HH:mm").format(selectedVersion.getUpdated().getTime()));
		categoryPanel.setVerLanguageText(selectedVersion.getLanguage());
		boolean versionIsActive = false;
		Question selectedQuestion = questTableModel.getQuestionAtRow(selectedUnsortedQuestIndex);
		if(selectedQuestion.getActiveVersionId()!= null && selectedQuestion.getActiveVersionId().intValue() == selectedVersion.getId()){
			versionIsActive = true; 
		}
		categoryPanel.setVerActive(versionIsActive);
		categoryPanel.setVerIdLabelText(String.valueOf(selectedVersion.getId()));
		categoryPanel.setVerIsLockedText(String.valueOf(selectedVersion.isLocked()));
		versionController.versionSelected(selectedVersion);
	}

	public void questionSelected(int questIndex){
		selectedUnsortedQuestIndex = questIndex;
		Question quest = questTableModel.getQuestionAtRow(selectedUnsortedQuestIndex);
		mainWindow.getStatisticsPanel().setAvgDifficultyQuestLabel(quest.getAvgDifficulty());
		mainWindow.getStatisticsPanel().setAvgDIQuestLabel(quest.getAvgDI());
		versionsModel.setQuestion(quest);
		categoryPanel.addVersionsTabs();
        secCatTableModel.setQuestion(quest);
        mainWindow.enableToolBarButtons(this);
        secCatTableModel.fireTableDataChanged();
	}
	        	
	public void showGUI(MedNode activeNode){
		selectedNode = (CategoryNode)activeNode;
		versionController.setActiveNode(selectedNode);
		Category cat = selectedNode.getCategory();
		setCategoryStatistics(cat);
		try {
			categoryPanel.setCatName(cat.getFullName());
		} catch (Throwable e) {}
		questTableModel.setCategory(cat);
		questTableModel.fireTableDataChanged();
		categoryPanel.selectSortedQuestion(0);
		mainWindow.enableToolBarButtons(this);
	}
	
	private void setCategoryStatistics(Category cat){
		CategoryStatisticsPanel panel = mainWindow.getStatisticsPanel();
		panel.setAvgDifficultyCatOnlyLabel(cat.getAvgDifficultyCatOnly());
		panel.setAvgDifficultyCatAndBellowLabel(cat.getAvgDifficultyCatAndBellow());
		panel.setAvgDICatOnlyLabel(cat.getAvgDICatOnly());
		panel.setAvgDICatAndBellowLabel(cat.getAvgDICatAndBellow());
		panel.setAvgDifficultyQuestLabel(null);
		panel.setAvgDIQuestLabel(null);
		panel.setAvgDifficultyVerLabel(null);
		panel.setAvgDIVerLabel(null);
		panel.setAvgGradeAnsLabel(null);
		panel.setAvgPercentageAnsLabel(null);
		panel.setAvgCorrelationAnsLabel(null);			
	}
	
	public GuiState saveGuiState(MedNode node){
		return new CategoryPanelGuiState(node,this,selectedUnsortedQuestIndex,selectedVerIndex,versionController.getSelectedAnswerIndex());
	}	
	
	public void finalizeScreenHandling(){
		try{
			if(categoryPanel.isVerLanguageChanged()){
				categoryPanel.setVerLanguageChanged(false);
				String newLang = categoryPanel.getVerLanguageText();
				Version ver = versionsModel.getVersionByIndex(selectedVerIndex);
				CommandAction act = new VersionSetLanguageAct(ver.getId(),newLang,getMainWindow());
				act.addListener(new VersionsRefresherListener()).actionPerformed(null);
				categoryPanel.setVerLanguageText(ver.getLanguage());
			}		
			versionController.finalizeScreenHandling();
		}catch(Throwable e){}
	}
	
	public void restoreGuiState(GuiState state){
		super.restoreGuiState(state);
		if(!((CategoryNode)state.getNode()).getCategory().hasQuestionsOrLinks()){
			return;
		}
		CategoryPanelGuiState catState = (CategoryPanelGuiState)state;
		categoryPanel.selectUnsortedQuestion(catState.getQuestionIndex());
		categoryPanel.selectVersion(catState.getVersionIndex());
		versionController.restoreGuiState(catState.getAnswerIndex());
	}

	public Vector getPopUpMenuComponentsForNode(MedNode node) {
		Vector comps = new Vector();
		comps.add(new JMenuItem(getCategoryCreateMenuItem()));
		JMenuItem deleteItem; 
		if(selectedNode.equals(MainWindow.getCategoriesRootNode())){
			deleteItem = new JMenuItem(new CategoryDeleteAct(0, getMainWindow()));
			deleteItem.setEnabled(false);
		}else{
			deleteItem = new JMenuItem(getCategoryDeleteMenuItem());
		}
		comps.add(deleteItem);
		JMenuItem  cloneCatMenuItem;
		if(!selectedNode.equals(MainWindow.getCategoriesRootNode())){
			cloneCatMenuItem = new JMenuItem(getCategoryCloneMenuItem(selectedNode));
		}else{
			cloneCatMenuItem = new JMenuItem(new CategoryCloneAct(0,0,getMainWindow()));
			cloneCatMenuItem.setEnabled(false);
		}
		comps.add(cloneCatMenuItem);
		comps.add(new JSeparator());
		JMenuItem renameItem = new JMenuItem(new RenameNodeAct(getMainWindow(),selectedNode));
		if(selectedNode.equals(MainWindow.getCategoriesRootNode())){
			renameItem.setEnabled(false);
		}
		comps.add(renameItem);
		comps.add(new JMenuItem(getQuestionCreateMenuItem()));
		return comps;
	}

	public void nodeNameChanged(MedNode node, String newName) throws RetriableException, CriticalException{
		Category cat = ((CategoryNode)node).getCategory();
		CommandAction act = new CategorySetNameAct(cat.getId(),mainWindow,newName);
		act.addListener(getTree());
		act.actionPerformed(null); 
		showGUI(node);
	}
	
	public boolean isNodeEditionAllowed(MedNode node) {
		return true;
	}
	
    public Vector getSecCatPopUpItems(List secCatList){
        Vector v = new Vector();
        Question selectedQuestion = questTableModel.getQuestionAtRow(selectedUnsortedQuestIndex);
        if(secCatList.size() == 1){
        	v.add(new JMenuItem(getQuestionRemoveSecCategoryAct((Category) secCatList.get(0),selectedQuestion)));
        	return v;
        }
		List actions = new Vector();
		for(Iterator it=secCatList.iterator();it.hasNext();){
			actions.add(getQuestionRemoveSecCategoryAct((Category)it.next(),selectedQuestion));			
		}
		MultiSelectionAction act = new MultiSelectionAction(actions,getMainWindow());
		act.putValue(CommandAction.SMALL_ICON,GeneralParams.ICON_REMOVE);
		act.putValue(CommandAction.NAME,"Remove Selected Links");
		act.putValue(CommandAction.SHORT_DESCRIPTION,"Remove link to selected Secondary Categories");
		v.add(new JMenuItem(act));
		return v;
    }
    
    public Vector getQuestPopUpItems(List selectedQuestions){
    	Vector v = new Vector();
    	v.add(new JMenuItem(getQuestionCreateMenuItem()));
		if(selectedQuestions.size() == 1){   	
			v.add(new JMenuItem(getQuestionDeleteMenuItem((Question)selectedQuestions.get(0))));
			v.add(new JMenuItem(getQuestionCloneMenuItem((Question)selectedQuestions.get(0))));
			v.add(new JSeparator());
			v.add(new JMenuItem(getQuestionCancelMenuItem((Question)selectedQuestions.get(0))));
			v.add(new JMenuItem(getQuestionDeleteUnlockedVerMenuItem((Question)selectedQuestions.get(0))));
			v.add(new JMenuItem(getQuestionExportMenuItem((Question)selectedQuestions.get(0))));
		}else{
			v.add(new JMenuItem(getQuestionDeleteMenuItem(selectedQuestions)));
			v.add(new JMenuItem(getQuestionCloneMenuItem(selectedQuestions)));
			v.add(new JSeparator());
			v.add(new JMenuItem(getQuestionCancelMenuItem(selectedQuestions)));
			v.add(new JMenuItem(getQuestionDeleteUnlockedVerMenuItem(selectedQuestions)));
			v.add(new JMenuItem(getQuestionExportMenuItem(selectedQuestions)));
		}
		v.add(new JMenuItem(getQuestionImportMenuItem()));
    	return v;
    }
    
    public Vector getVersionPopUpItems(Question quest,Version ver){
		Vector v = new Vector();
		v.add(new JMenuItem(getVersionCreateMenuItem(quest)));
		v.add(new JMenuItem(getVersionDeleteMenuItem(ver)));
		v.add(new JMenuItem(getVersionCloneMenuItem(quest,ver)));
		v.add(new JSeparator());
		JMenuItem setVerActiveMenuItem = new JMenuItem(getVersionSetActiveMenuItem(ver)); 
		v.add(setVerActiveMenuItem);
		Version selectedVersion = versionsModel.getVersionByIndex(selectedVerIndex);
		Question selectedQuestion = questTableModel.getQuestionAtRow(selectedUnsortedQuestIndex);
		if(selectedQuestion.getActiveVersionId()!= null && selectedQuestion.getActiveVersionId().intValue() == selectedVersion.getId()){
			setVerActiveMenuItem.setEnabled(false); 
		}

		return v;
    }
    
    public CommandAction getAddSecCatAction(Category cat,Question quest){
        CommandAction addSecCat = new QuestionAddSecondaryCategoryAct(cat.getId(),quest.getId(),getMainWindow()); 
        addSecCat.addListener(getTree());        
        return addSecCat;
    }   
	

	public void versionSetAsActivePressed(Version ver){
		getVersionSetActiveMenuItem(ver).actionPerformed(null);
	}
 
	public CommandAction getCategoryCreateMenuItem() {
		CommandAction act =	new CategoryCreateAct(selectedNode.getCategory().getId(), getMainWindow());
		act.addListener(getTree());
		return act;
	}
	public CommandAction getCategoryDeleteMenuItem(){
		if(selectedNode.equals(MainWindow.getCategoriesRootNode())){
			return null;
		}
		CommandAction act =	new CategoryDeleteAct(selectedNode.getCategory().getId(), getMainWindow());
		act.addListener(getTree());
		return act;
	}
	public CommandAction getCategoryCloneMenuItem(){
		if(selectedNode.equals(MainWindow.getCategoriesRootNode())){
			return null;
		}
		return getCategoryCloneMenuItem(selectedNode);
	}
	public Action getCategoryRenameMenuItem(){
		if(selectedNode.equals(MainWindow.getCategoriesRootNode())){
			return null;
		}
		return new RenameNodeAct(getMainWindow(),selectedNode);
	}
    
   	public CommandAction getQuestionCreateMenuItem(){
		CommandAction act = new QuestionCreateAct(selectedNode.getCategory().getId(),getMainWindow());
		act.addListener(new PanelShowerListener());  
		act.addListener(getTree());
		return act;
   	}
	public CommandAction getQuestionDeleteMenuItem(){
   		if(questTableModel.getRowCount() == 0){
   			return null;
   		}
 		return getQuestionDeleteMenuItem(categoryPanel.getSelectedQuestions());
	}
	public CommandAction getQuestionCloneMenuItem(){
   		if(questTableModel.getRowCount() == 0){
   			return null;
   		}
 		return getQuestionCloneMenuItem(categoryPanel.getSelectedQuestions());
	}
	public CommandAction getQuestionCancelMenuItem(){
   		if(questTableModel.getRowCount() == 0){
   			return null;
   		}
 		return getQuestionCancelMenuItem(categoryPanel.getSelectedQuestions());
	}
	public CommandAction getQuestionDeleteUnlockedVerMenuItem(){
   		if(questTableModel.getRowCount() == 0){
   			return null;
   		}
   		return getQuestionDeleteUnlockedVerMenuItem(categoryPanel.getSelectedQuestions());
	}
	public CommandAction getQuestionExportMenuItem(){
		if(questTableModel.getRowCount() == 0){
			return null;
		}
		return getQuestionExportMenuItem(categoryPanel.getSelectedQuestions());
	}
	public CommandAction getQuestionImportMenuItem(){
		CommandAction act = new QuestionImportAct(getMainWindow());
		act.addListener(new PanelShowerListener());
		act.addListener(getTree());
		return act;
	}
	
	public CommandAction getVersionCreateMenuItem(){
		if(questTableModel.getRowCount() == 0){
			return null;
		}
		Question selectedQuestion = questTableModel.getQuestionAtRow(selectedUnsortedQuestIndex);
		return getVersionCreateMenuItem(selectedQuestion);		
	}
	public CommandAction getVersionDeleteMenuItem(){
		if(questTableModel.getRowCount() == 0){
			return null;
		}
		Version selectedVersion = versionsModel.getVersionByIndex(selectedVerIndex);
		return getVersionDeleteMenuItem(selectedVersion);		
	}  
	public CommandAction getVersionCloneMenuItem(){
		if(questTableModel.getRowCount() == 0){
			return null;
		}
		Question selectedQuestion = questTableModel.getQuestionAtRow(selectedUnsortedQuestIndex);
		Version selectedVersion = versionsModel.getVersionByIndex(selectedVerIndex);
		return getVersionCloneMenuItem(selectedQuestion,selectedVersion);		
	}  
	public CommandAction getVersionSetActiveMenuItem(){
		if(questTableModel.getRowCount() == 0){
			return null;
		}
		Version selectedVersion = versionsModel.getVersionByIndex(selectedVerIndex);
		Question selectedQuestion = questTableModel.getQuestionAtRow(selectedUnsortedQuestIndex);
		if(selectedQuestion.getActiveVersionId()!= null && selectedQuestion.getActiveVersionId().intValue() == selectedVersion.getId()){
			return null; 
		}
		return getVersionSetActiveMenuItem(selectedVersion);
	}
	
	public CommandAction getAnswerCreateMenuItem(){
		if(questTableModel.getRowCount() == 0){
			return null;
		}
		return versionController.getAnswerCreateAct();
	}
	public CommandAction getAnswerDeleteMenuItem(){
		if(questTableModel.getRowCount() == 0){
			return null;
		}
		return versionController.getAnswerDeleteAct();
	}
	public CommandAction getAnswerCloneMenuItem(){
		if(questTableModel.getRowCount() == 0){
			return null;
		}
		return versionController.getAnswerCloneAct();
	}
	public CommandAction getAnswerSetAsCorrectMenuItem() {
		if(questTableModel.getRowCount() == 0){
			return null;
		}
		return versionController.getAnswerSetAsCorrectAct();
	}
	public CommandAction getAnswerSetMixableMenuItem() {
		if(questTableModel.getRowCount() == 0){
			return null;
		}
		return versionController.getAnswerSetMixableMenuItem();
	}

	
	private CommandAction getCategoryCloneMenuItem(CategoryNode catNode){
		int parentId = ((CategoryNode)catNode.getParentNode()).getCategory().getId();
		CommandAction act = new CategoryCloneAct(parentId,catNode.getCategory().getId(),getMainWindow());
		act.addListener(getTree());
		return act;		
	}
	
	private MultiSelectionAction getQuestionDeleteMenuItem(List selectedQuestions){
		List actions = new LinkedList();
		for(Iterator it=selectedQuestions.iterator();it.hasNext();){
			actions.add(getQuestionDeleteMenuItem((Question)it.next()));
		}
		MultiSelectionAction act = new MultiSelectionAction(actions,getMainWindow());
		act.putValue(MultiSelectionAction.SMALL_ICON,GeneralParams.ICON_DELETE);
		act.putValue(MultiSelectionAction.SHORT_DESCRIPTION,"Delete Selected Question(s)");
		act.putValue(MultiSelectionAction.NAME,"Delete Selected Question(s)");
		return act;
	}
	
	private CommandAction getQuestionDeleteMenuItem(Question quest){
		CommandAction act = new QuestionDeleteAct(quest.getId(),getMainWindow());
		act.addListener(new PanelShowerListener()); 
		act.addListener(getTree());
		return act;
	}	

	private MultiSelectionAction getQuestionCloneMenuItem(List selectedQuestions){
		List actions = new LinkedList();
		for(Iterator it=selectedQuestions.iterator();it.hasNext();){
			actions.add(getQuestionCloneMenuItem((Question)it.next()));
		}
		MultiSelectionAction act = new MultiSelectionAction(actions,getMainWindow());
		act.putValue(MultiSelectionAction.SMALL_ICON,GeneralParams.ICON_CLONE);
		act.putValue(MultiSelectionAction.SHORT_DESCRIPTION,"Clone Selected Question(s)");
		act.putValue(MultiSelectionAction.NAME,"Clone Selected Question(s)");
		return act;
	}

	private CommandAction getQuestionCloneMenuItem(Question quest){
		CommandAction act = new QuestionCloneAct(selectedNode.getCategory().getId(),quest.getId(),getMainWindow());
		act.addListener(new PanelShowerListener()); 
		return act;
	}
	
	private CommandAction getQuestionCancelMenuItem(Question quest){
		CommandAction act = new QuestionCancelAct(quest.getId(),!quest.isCancelled(),getMainWindow());
		act.addListener(new PanelShowerListener()); 
		return act;
	}
	
	private CommandAction getQuestionDeleteUnlockedVerMenuItem(Question quest){
		CommandAction act = new QuestionDeleteUnlockedVersionsAct(quest.getId(),getMainWindow());
		act.addListener(new PanelShowerListener()); 
		return act;		
	}
		
	private MultiSelectionAction getQuestionCancelMenuItem(List selectedQuestions){
		List actions = new LinkedList();
		for(Iterator it=selectedQuestions.iterator();it.hasNext();){
			actions.add(getQuestionCancelMenuItem((Question)it.next()));
		}
		MultiSelectionAction act = new MultiSelectionAction(actions,getMainWindow());
		act.putValue(MultiSelectionAction.SMALL_ICON,GeneralParams.ICON_REMOVE);
		act.putValue(MultiSelectionAction.NAME,"Reverse Cancel Property");
		act.putValue(MultiSelectionAction.SHORT_DESCRIPTION,"Reverse Cancelled property for Selected Question(s)");
		return act;
	}

	private MultiSelectionAction getQuestionDeleteUnlockedVerMenuItem(List selectedQuestions){
		List actions = new LinkedList();
		for(Iterator it=selectedQuestions.iterator();it.hasNext();){
			actions.add(getQuestionDeleteUnlockedVerMenuItem((Question)it.next()));
		}
		MultiSelectionAction act = new MultiSelectionAction(actions,getMainWindow());
		act.putValue(MultiSelectionAction.SMALL_ICON,GeneralParams.ICON_DELETE);
		act.putValue(MultiSelectionAction.NAME,"Delete Unlocked Versions");
		act.putValue(MultiSelectionAction.SHORT_DESCRIPTION,"Delete Inactive Version(s) of selected Question(s)");
		return act;
	}

	private CommandAction getQuestionExportMenuItem(Question quest){
		return new QuestionExportAct(quest.getId(),getMainWindow());
	}
	
	private MultiSelectionAction getQuestionExportMenuItem(List selectedQuestions){
		List actions = new LinkedList();
		for(Iterator it=selectedQuestions.iterator();it.hasNext();){
			actions.add(getQuestionExportMenuItem((Question)it.next()));
		}
		MultiSelectionAction act = new MultiSelectionAction(actions,getMainWindow());
		act.putValue(MultiSelectionAction.SMALL_ICON,GeneralParams.ICON_EXPORT);
		act.putValue(MultiSelectionAction.NAME,"Export Selected Question(s)");
		act.putValue(MultiSelectionAction.SHORT_DESCRIPTION,"Export Selected Question(s) (not undoable action)");
		return act;
	}

	
	private CommandAction getQuestionRemoveSecCategoryAct(Category category,Question quest){
		CommandAction act = new QuestionRemoveSecondaryCategoryAct(category.getId(),quest.getId(),getMainWindow());
		act.addListener(new PanelShowerListener());
		act.addListener(this.getTree());
		return act; 
	}

	private CommandAction getVersionCreateMenuItem(Question quest){
		CommandAction act = new VersionCreateAct(quest.getId(),getMainWindow());
		act.addListener(new VersionsRefresherListener());  
		act.addListener(getTree());
		return act;
	}

	private CommandAction getVersionDeleteMenuItem(Version ver){
		CommandAction act = new VersionDeleteAct(ver.getId(),getMainWindow());
		act.addListener(new VersionsRefresherListener());  
		return act;
	}
	
	private CommandAction getVersionCloneMenuItem(Question quest,Version ver){
		CommandAction act = new VersionCloneAct(quest.getId(),ver.getId(),getMainWindow());
		act.addListener(new VersionsRefresherListener());  
		return act;
	}
	     
   	private CommandAction getVersionSetActiveMenuItem(Version ver){
   		CommandAction act = new VersionMarkAsActiveAct(ver.getId(),getMainWindow());
   		act.addListener(new VersionsRefresherListener());
   		return act;
   	}
   
	public CommandAction getNewToolBarAction() {
		return getQuestionCreateMenuItem().toShortFormat();
	}	
	public CommandAction getDeleteToolBarAction(){
		if(getQuestionDeleteMenuItem() == null){
			return null;
		}
		return getQuestionDeleteMenuItem().toShortFormat();
	}
	public CommandAction getExportToolBarAction(){
		if(getQuestionExportMenuItem() == null){
			return null;
		}
		return getQuestionExportMenuItem().toShortFormat();
	}
	public CommandAction getImportToolBarAction(){
		return getQuestionImportMenuItem().toShortFormat();
	}

	public void answerSelected(int ansId) {
	}	

	public void setFocusOn(CategoryNode node,Question quest,Version ver,Answer ans){
		getTree().selectNode(node);
		int questIndex = 0;
		for(Iterator it=node.getCategory().getQuestions().iterator();it.hasNext();){
			if(quest.equals(it.next())){
				break;
			}
			questIndex++;
		}
		categoryPanel.selectUnsortedQuestion(questIndex);
		if(ver == null){
			return;
		}
		int verIndex = 0;
		for(Iterator it=quest.getVersions().iterator();it.hasNext();){
			if(ver.equals(it.next())){
				break;
			}
			verIndex++;
		}
		categoryPanel.selectVersion(verIndex);	
		if(ans != null){
			versionController.setFocusOnAnswer(ans);
		}
	}
	
	class VersionsRefresherListener implements ModelChangesListener{
		public void nodeAdded(MedNode childNode) {}
		public void nodePropertiesChanged() {
			categoryPanel.selectUnsortedQuestion(selectedUnsortedQuestIndex);
		}
		public void nodeRemoved(MedNode parentNode, MedNode removedNode,int index) {}		
	}

	class OneVersionRefresherListener implements ModelChangesListener{
		public void nodeAdded(MedNode childNode) {}
		public void nodePropertiesChanged() {		
			categoryPanel.refreshVersionDates();
			categoryPanel.refreshVersionsIcons();
			
		}
		public void nodeRemoved(MedNode parentNode, MedNode removedNode,int index) {}		
	}

	class PanelShowerListener implements ModelChangesListener{
		public void nodeAdded(MedNode childNode) {}
		public void nodePropertiesChanged() {
			showGUI(selectedNode);
//			getTree().repaint();
		}
		public void nodeRemoved(MedNode parentNode, MedNode removedNode,int index) {}		
	}



}
