/*
 * Created on May 28, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.controllers;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.database.DatabaseOpen;
import il.ac.technion.cs.course236308.e3.med.control.GuiCommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.control.OptionsLoader;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.MedTree;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.IllegalStatesTableModel;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.panels.ProgressBar;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.CategoryNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.MedNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.StudentReplyNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestCategoryNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestGradingNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestQuestionsListNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestRepliesNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestStatisticsNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestsTreeRootNode;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.CategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.model.Category;
import il.ac.technion.cs.course236308.e3.med.model.LegalObject;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.QuestionsFactory;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestsFactory;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.model.VersionsFactory;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;
import il.ac.technion.cs.course236308.e3.med.stats.StatisticData;
import il.ac.technion.cs.course236308.e3.med.stats.StatsUpdateDB;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.JOptionPane;


/**
 * @author svali
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MainWindowController{
	private MainWindow mainWindow;
	private HashMap dispatchMap;
	private MedNode activeNode;
	public static ProgressBar progressBar; 
	
	public MainWindowController() throws RetriableException, CriticalException{
		progressBar.setLabel("Initializing navigation tree...");
		CategoriesFactory cf = CategoriesFactory.getInstance();
		TestsFactory tf = TestsFactory.getInstance();
		progressBar.setLabel("Initializing components...");
		mainWindow = new MainWindow(this,cf.buildTree(cf.getRootCategory()),tf.buildTree());
		activeNode = MainWindow.getTestsRootNode();
		initStatistics();
		IllegalStatesTableModel.getInstance().setMainWindow(mainWindow);
		IllegalStatesTableModel.getInstance().fireTableDataChanged();
		progressBar.setFinalStep();
		progressBar.setLabel("Preparing to run...");
		setDispatchData();
		progressBar.setVisible(false);
		mainWindow.setVisible(true);
	}
	
	private void initStatistics() throws RetriableException, CriticalException{
		for(Iterator it=TestsFactory.getInstance().getAllTestIds().iterator();it.hasNext();){
			int testId =  ((Integer)it.next()).intValue();
			StatisticData.getInstance().updateQuestionsStatisticsDontUpdateDB(testId);
		}
		for(Iterator it=TestsFactory.getInstance().getAllTestIds().iterator();it.hasNext();){
			int testId =  ((Integer)it.next()).intValue();
			StatsUpdateDB.getInstance().update(testId);
		}
	}

	private void setDispatchData(){
		MedController catPanelController = new CategoryPanelController(mainWindow,mainWindow.getCategoryTree());
		MedController testPanelController = new TestPanelController(mainWindow,mainWindow.getTestTree());
		MedController testQuestionsPanelController = new TestVersionsPanelController(mainWindow,mainWindow.getTestTree());
		MedController testGradingPanelController = new TestGradingPolicyController(mainWindow,mainWindow.getTestTree());
		MedController examRepliesPanelController = new ExamRepliesPanelController(mainWindow,mainWindow.getTestTree());
		MedController testsRootPanelController = new TestsRootPanelController(mainWindow,mainWindow.getTestTree());
		MedController replyPanelController = new ReplyPanelController(mainWindow,mainWindow.getTestTree());
		MedController examStatisticsPanelController = new TestStatisticsController(mainWindow,mainWindow.getTestTree()); 
		
		dispatchMap = new HashMap();
		dispatchMap.put(CategoryNode.class, catPanelController);
		dispatchMap.put(TestNode.class, testPanelController);
        dispatchMap.put(TestQuestionsListNode.class,testQuestionsPanelController);
		dispatchMap.put(TestGradingNode.class, testGradingPanelController);
		dispatchMap.put(TestCategoryNode.class,testQuestionsPanelController);
		dispatchMap.put(TestRepliesNode.class,examRepliesPanelController);
		dispatchMap.put(TestsTreeRootNode.class,testsRootPanelController);
		dispatchMap.put(StudentReplyNode.class,replyPanelController);
		dispatchMap.put(TestStatisticsNode.class,examStatisticsPanelController);
	}
	
	public MedController getPanelForNode(MedNode node){
		if(dispatchMap == null || node == null) {
			return null;
		}
		return (MedController) dispatchMap.get(node.getClass());
	}
	
	public MedController getActivePanel(){
		return getPanelForNode(activeNode);
	}
	
	public MedNode getActiveNode(){
		return activeNode;
	}

	public Vector requestMenuComponentsForNode(MedNode node) {
		MedController panel = getPanelForNode(node);
		if(panel == null){
			return null;
		}
		return panel.getPopUpMenuComponentsForNode(node);
	}


	public void closeSystem(){
//		if(JOptionPane.showConfirmDialog(mainWindow,"Are you sure you want to Exit?","Exit Confirmation",JOptionPane.OK_CANCEL_OPTION)==JOptionPane.OK_OPTION){
			System.exit(0);
//		}
	}
	
	
	public void treeSelectionChanged(MedNode node){
		if(activeNode == node){
			return;
		}
		activeNode = node;
		MedController activeController = (MedController) dispatchMap.get(node.getClass());
		mainWindow.setActivePanel(activeController);
		activeController.showGUI(node);
		mainWindow.enableToolBarButtons(activeController);
	}
	
	public void undoPressed(){
		try {
			GuiCommandDispatcher.getInstance().undo();
			mainWindow.setUndoEnabled(GuiCommandDispatcher.getInstance().undoEnabled());
			mainWindow.setRedoEnabled(GuiCommandDispatcher.getInstance().redoEnabled());
		} catch (RetriableException e) {
			JOptionPane.showMessageDialog
				(mainWindow, e.getMessage(), "Med Error Occured",JOptionPane.ERROR_MESSAGE);
		} catch (CriticalException e) {
			JOptionPane.showMessageDialog
				(mainWindow, e.getMessage() + "\nThe Application will be closed",
				 "Critical Med Error",JOptionPane.ERROR_MESSAGE);
			System.exit(1);
		}	
	}
	
	public void redoPressed(){
		try {
			GuiCommandDispatcher.getInstance().redo();
			mainWindow.setUndoEnabled(GuiCommandDispatcher.getInstance().undoEnabled());
			mainWindow.setRedoEnabled(GuiCommandDispatcher.getInstance().redoEnabled());
		} catch (RetriableException e) {
			JOptionPane.showMessageDialog
				(mainWindow, e.getMessage(), "Med Error Occured",JOptionPane.ERROR_MESSAGE);
		} catch (CriticalException e) {
			JOptionPane.showMessageDialog
				(mainWindow, e.getMessage() + "\nThe Application will be closed",
				 "Critical Med Error",JOptionPane.ERROR_MESSAGE);
			System.exit(1);
		}		
	}
	
	public void selectIllegalObject(LegalObject obj){
		if(obj instanceof Test){
			MedNode node = mainWindow.getTestTree().getNodeByObject(obj);
			if(((TestNode)node).getTest().getIllegalityDescription().getMessage().indexOf("100%")>-1){
				node = (MedNode)node.getChildAt(1);
			}
			mainWindow.getTestTree().selectNode(node);
			return;
		}
		Answer ans = null;
		Version ver = null;
		Question quest = null;
		try{
			if(obj instanceof Answer){
				ans = (Answer)obj;
				ver = VersionsFactory.getInstance().getVersion(ans.getVersionId());
				quest = QuestionsFactory.getInstance().getQuestion(ver.getQuestionId());
			}
			if(obj instanceof Version ){
				ver = (Version)obj;
				quest = QuestionsFactory.getInstance().getQuestion(ver.getQuestionId());
			}
			if(obj instanceof Question){
				quest = (Question)obj;
			}
			Category cat = CategoriesFactory.getInstance().getCategory(quest.getMainCategoryId());
			CategoryNode node = (CategoryNode)mainWindow.getCategoryTree().getNodeByObject(cat);
			if(node == null){
				return;
			}
			CategoryPanelController controller = (CategoryPanelController)getPanelForNode(node);
			controller.setFocusOn(node,quest,ver,ans);
		}catch(Throwable e){}
	}
	
	public void setNodeNewName(MedNode node, String newName) {
		MedController panel = (MedController) dispatchMap.get(node.getClass());
		try{
			panel.nodeNameChanged(node,newName);
		}catch(RetriableException e){
			JOptionPane.showMessageDialog
				(mainWindow, e.getMessage(), "Med Error Occured",JOptionPane.ERROR_MESSAGE);
		} catch (CriticalException e1) {
			JOptionPane.showMessageDialog
				(mainWindow, e1.getMessage() + "\nThe Application will be closed",
				 "Critical Med Error",JOptionPane.ERROR_MESSAGE);
			System.exit(1);
		}
	}

	public boolean isNodeEditionAllowed(MedNode node){
		MedController panel = (MedController) dispatchMap.get(node.getClass());
		return panel.isNodeEditionAllowed(node);
	}

	public void requestNodeEdition(MedNode node) {
		MedController panel = (MedController) dispatchMap.get(node.getClass());
		MedTree tree = panel.getTree();
		tree.requestNodeEdition(node);
	}


	public static void main(String[] args){
		
        progressBar = new ProgressBar();
		progressBar.setVisible(true);
		progressBar.setTitle("Med");
		progressBar.setLabel("Connecting to database...");
		Command c = null;
		if (args.length!=1 && args.length!=3) {
			System.out.println("# Trying to get last activated db");
			try{
				BufferedReader lastOpenedDB = new BufferedReader (new FileReader(GeneralParams.LAST_DATABASEOPEN_INFO_FILE));
				String url = lastOpenedDB.readLine();
				String username = lastOpenedDB.readLine();
				String password = lastOpenedDB.readLine();
				lastOpenedDB.close();
				if (url==null || url.length()==0 || username==null || password==null) 
					throw new RetriableException("Wrong url");
				c = new DatabaseOpen(url, username, password);
			}catch (Exception e){
				System.out.println("# Failed to get last activated db - \n# Try activating again with parameters: \n  url [username password]");
				System.exit(0);
			}		
		}
		if (c==null){	
			if (args.length == 1){
				c = new DatabaseOpen(args[0],"","");
			} else {
				c = new DatabaseOpen(args[0], args[1], args[2]);
			}
		}
		try {
            c.run();
            OptionsLoader.load();
            new MainWindowController();
            
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(1);
        }
	}

}
