/*
 * Created on Jul 13, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.controllers;

import il.ac.technion.cs.course236308.e3.med.control.actions.test.TestSetAnswerWeight;
import il.ac.technion.cs.course236308.e3.med.control.actions.test.TestSetFactorAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.test.TestSetGradeRangeAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.test.TestSetVersionWeight;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.MedTree;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.GradingTestAnswersTableModel;
import il.ac.technion.cs.course236308.e3.med.gui.panels.GradingPolicyPanel;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.MedNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestGradingNode;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestAnswer;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;
import il.ac.technion.cs.course236308.e3.med.stats.QuestionsStats;
import il.ac.technion.cs.course236308.e3.med.stats.StatisticData;
import il.ac.technion.cs.course236308.e3.med.stats.StudentsStats;

import java.util.Vector;

import javax.swing.JPanel;

/**
 * @author shralex
 *
 */

public class TestGradingPolicyController extends MedController {
	private GradingPolicyPanel gradingPolicyPanel;
	private TestGradingNode selectedNode;
	private GradingTestAnswersTableModel gradingTestAnswersTableModel;
	
	TestGradingPolicyController(MainWindow mainFrame, MedTree tree) {
		super(mainFrame,tree);
		init();
	}
	
	public void init(){
		gradingTestAnswersTableModel = new GradingTestAnswersTableModel(this);
		gradingPolicyPanel = new GradingPolicyPanel(this, gradingTestAnswersTableModel); 
		//gradingPolicyPanel.setVersionsTabbedModel(verTabbedModel = new DefaultSingleSelectionModel());
		gradingPolicyPanel.init();
	}
	public JPanel getMainPanel() {
		return gradingPolicyPanel;
	}

	public boolean isNodeEditionAllowed(MedNode node) {
		return false;
	}

	public void nodeNameChanged(MedNode node, String newName) throws RetriableException, CriticalException {
	}

	public void showGUI(MedNode activeNode){
		selectedNode = (TestGradingNode)activeNode;
			Test test = selectedNode.getTest();
			try {
				gradingPolicyPanel.setFactorAText(test.getFactorConstA());
				gradingPolicyPanel.setFactorBText(test.getFactorConstB());
				gradingPolicyPanel.setThreshGradeText(test.getPassingGrade());
				gradingPolicyPanel.setMaxGradeText(test.getMaxGrade());
				gradingPolicyPanel.setMinGradeText(test.getMinGrade());
				gradingPolicyPanel.setTestId(test.getId());
				gradingPolicyPanel.setNumStudents(test.getNumGraded());
				gradingPolicyPanel.setStatistics();
				
				Double failedNum = null;
				int studNum = 0;
				QuestionsStats qs = StatisticData.getInstance().getQuestionsStats(test.getId());
				if(qs != null){
					StudentsStats ss = qs.getStudentStats();
					if(ss != null){
						failedNum = new Double(ss.getNumStudentsFailed());
						studNum = ss.getNumStudents();
					}
				}
				
                gradingPolicyPanel.setStudentsFailed(failedNum,studNum);         
				gradingTestAnswersTableModel.setTest(test);
				gradingTestAnswersTableModel.fireTableDataChanged();

				
			} catch (Throwable e) {
			
			}
	}

	public Test getTest(){
		if(selectedNode == null)
			return null;
		return selectedNode.getTest();
	}
	public void refreshGUI(){
		showGUI(selectedNode);
	}

    public void setTestAnswerWeight(TestAnswer ta, String weightStr){
		byte weight = new Byte(weightStr.substring(0, weightStr.length()-1)).byteValue();
        if (ta.getWeight() == weight) return;
        new TestSetAnswerWeight(ta.getTestId(),ta.getAnswerId(), weight, getMainWindow()).actionPerformed(null);  
         
		refreshGUI(); 
	}
    
    public void  setTestVersionWeight(TestVersion tv, Double weight){
        if (tv.getWeight() == weight) return;
        new TestSetVersionWeight(tv.getTestId(),tv.getVersion().getId(), weight, getMainWindow()).actionPerformed(null); 
        
		refreshGUI(); 
    }
	public void factorAChanged(double newA){
		double oldA = selectedNode.getTest().getFactorConstA();
		if (oldA == newA) return;
		new TestSetFactorAct(selectedNode.getTest().getId(), newA, selectedNode.getTest().getFactorConstB(),
												getMainWindow()).actionPerformed(null);
		refreshGUI();
	}
	
	public void factorBChanged(double newB){
		double oldB = selectedNode.getTest().getFactorConstB();
		if (oldB == newB) return;
		new TestSetFactorAct(selectedNode.getTest().getId(),selectedNode.getTest().getFactorConstA(), 
										 newB, getMainWindow()).actionPerformed(null);
		refreshGUI();
	}
	public void minGradeChanged(int minGrade){
		double oldMinGrade = selectedNode.getTest().getMinGrade();
		if (oldMinGrade == minGrade) return;
		new TestSetGradeRangeAct(selectedNode.getTest().getId(),minGrade, 
										selectedNode.getTest().getMaxGrade(),
										selectedNode.getTest().getPassingGrade(),
									    getMainWindow()).actionPerformed(null);
		refreshGUI();
	}
	
	public void maxGradeChanged(int maxGrade){
			double oldMaxGrade = selectedNode.getTest().getMaxGrade();
			if (oldMaxGrade == maxGrade) return;
			new TestSetGradeRangeAct(selectedNode.getTest().getId(),
											selectedNode.getTest().getMinGrade(),
											maxGrade,
											selectedNode.getTest().getPassingGrade(),
											getMainWindow()).actionPerformed(null);
			refreshGUI();
		}
		
	public void passGradeChanged(int passGrade){
				double oldPassGrade = selectedNode.getTest().getPassingGrade();
				if (oldPassGrade == passGrade) return;
				new TestSetGradeRangeAct(selectedNode.getTest().getId(),
												selectedNode.getTest().getMinGrade(),
												selectedNode.getTest().getMaxGrade(),
												passGrade,
												getMainWindow()).actionPerformed(null);
				refreshGUI();
	}	
	
	public Vector getPopUpMenuComponentsForNode(MedNode node) {
		// TODO Auto-generated method stub
		return null;
	}



}
