/*
 * Created on Jul 23, 2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.control.controllers;

import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.MedTree;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.panels.StatisticsPanel;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.MedNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestStatisticsNode;
import il.ac.technion.cs.course236308.e3.med.model.Test;

import java.util.Vector;

import javax.swing.JPanel;

/**
 * @author svekant
 *
 */
public class TestStatisticsController extends MedController {
	private StatisticsPanel statPanel;
	private TestStatisticsNode selectedNode; 
	
	public TestStatisticsController(MainWindow mainFrame,MedTree tree){
		super(mainFrame,tree);
        init();
	}
	
	public void init() {
        statPanel = new StatisticsPanel(this);
        statPanel.init();
	}
	/* (non-Javadoc)
	 * @see il.ac.technion.cs.course236308.e3.med.control.controllers.MedController#getMainPanel()
	 */
	public JPanel getMainPanel() {
		return statPanel;
	}

	public Test getTest(){
		return selectedNode.getTest();
	}
	
	public TestStatisticsNode getSelectedNode(){
		return selectedNode;
	}
	/* (non-Javadoc)
	 * @see il.ac.technion.cs.course236308.e3.med.control.controllers.MedController#isNodeEditionAllowed(il.ac.technion.cs.course236308.e3.med.gui.treenodes.MedNode)
	 */
	public boolean isNodeEditionAllowed(MedNode node) {
		return false;
	}

	/* (non-Javadoc)
	 * @see il.ac.technion.cs.course236308.e3.med.control.controllers.MedController#nodeNameChanged(il.ac.technion.cs.course236308.e3.med.gui.treenodes.MedNode, java.lang.String)
	 */
	public void nodeNameChanged(MedNode node, String newName)
			throws RetriableException, CriticalException {
	}

	/* (non-Javadoc)
	 * @see il.ac.technion.cs.course236308.e3.med.control.controllers.MedController#showGUI(il.ac.technion.cs.course236308.e3.med.gui.treenodes.MedNode)
	 */
	public void showGUI(MedNode activeNode) {
		selectedNode = (TestStatisticsNode)activeNode;
		statPanel.updateExamStatisticsPanel();		
		statPanel.updateStudentsStatisticsPanel();		
		statPanel.updateQuestionsStatisticsPanel();
		statPanel.updateGradesStatisticsPanel();

	}

	/* (non-Javadoc)
	 * @see il.ac.technion.cs.course236308.e3.med.control.controllers.MedController#getPopUpMenuComponentsForNode(il.ac.technion.cs.course236308.e3.med.gui.treenodes.MedNode)
	 */
	public Vector getPopUpMenuComponentsForNode(MedNode node) {
		return new Vector();
	}

}
