/*
 * Created on May 28, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.controllers;
import il.ac.technion.cs.course236308.e3.med.control.ModelChangesListener;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.control.actions.MultiSelectionAction;
import il.ac.technion.cs.course236308.e3.med.control.actions.test.TestVersionRemoveFromTestAct;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.MedTree;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.TestVersionsTableModel;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.panels.TestVersionsPanel;
import il.ac.technion.cs.course236308.e3.med.gui.states.GuiState;
import il.ac.technion.cs.course236308.e3.med.gui.states.TestVersionsPanelGuiState;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.MedNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestCategoryNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestQuestionsListNode;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;
import il.ac.technion.cs.course236308.e3.med.stats.AnswerInfo;
import il.ac.technion.cs.course236308.e3.med.stats.QuestionsStats;
import il.ac.technion.cs.course236308.e3.med.stats.StatisticData;

import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;

import javax.swing.JMenuItem;
import javax.swing.JPanel;

/**
 * @author svali
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TestVersionsPanelController extends ParentOfVersionPropertyController{

	private TestVersionsPanel testVersionsPanel;
	
	private TestVersionsTableModel testVersionsTableModel;
	
	private int selectedUnsortedTestVerIndex = -1;
	private MedNode selectedNode;
    
	private VersionPropertyPanelController versionController;
	
	public TestVersionsPanelController(MainWindow mainWindow,MedTree tree){
		super(mainWindow,tree);
		versionController = new VersionPropertyPanelController(mainWindow,this);
		testVersionsPanel = new TestVersionsPanel(this);
		testVersionsPanel.setTestVersionsTableModel(testVersionsTableModel = new TestVersionsTableModel());
		testVersionsPanel.init();
		Vector listeners = new Vector();
		listeners.add(new VersionRefresher());
		versionController.addListenersForActions(listeners);
	}

	public JPanel getMainPanel(){
		return testVersionsPanel;
	}

	public JPanel getVersionPanel(){
		return versionController.getMainPanel();
	}

	public boolean isNodeEditionAllowed(MedNode node) {
		return false;
	}

	public Vector getPopUpMenuComponentsForNode(MedNode node) {
		return new Vector();
	}
	        	
	public void showGUI(MedNode activeNode){
		selectedNode = activeNode;
		versionController.setActiveNode(selectedNode);
		List testVersions = new LinkedList();
		String testCatName = "";
		if(selectedNode instanceof TestQuestionsListNode){
			testVersions = ((TestQuestionsListNode)selectedNode).getTestQuestions();
			testCatName = "Test: " + ((TestQuestionsListNode)selectedNode).getTest().toString();
			setTestCategoryStatistics(null);
		}
		if(selectedNode instanceof TestCategoryNode){
			testVersions = ((TestCategoryNode)selectedNode).getTestCategory().getTestVersions();
			testCatName = "Category: " + ((TestCategoryNode)selectedNode).getTestCategory().getLongName();
			setTestCategoryStatistics((TestCategoryNode)selectedNode);
		}
		testVersionsPanel.setTestCategoryName(testCatName);
		testVersionsTableModel.setTestVersions(testVersions);
//		testVersionsTableModel.fireTableDataChanged();
		testVersionsPanel.selectSortedTestVersion(0);
	}
	
	private void setTestCategoryStatistics(TestCategoryNode testCatNode){
		testVersionsPanel.setTestAnsCorrelation(null);
		testVersionsPanel.setTestAnsNormGradeAvg(null);
		testVersionsPanel.setTestAnsNumAnsweringStudents(0);
		testVersionsPanel.setTestAnsPercentAnsweringStudents(null);
		if(testCatNode == null){
			testVersionsPanel.setTestCatPercentOfWeightCatAndBellow(null);
			testVersionsPanel.setTestCatPercentOfWeightCatOnly(null);
			testVersionsPanel.setTestCatAvgDifficultyCatAndBellow(null);
			testVersionsPanel.setTestCatAvgDifficultyCatOnly(null);
			testVersionsPanel.setTestCatAvgValidityCatAndBellow(null);
			testVersionsPanel.setTestCatAvgValidityCatOnly(null);
		}else{
			testVersionsPanel.setTestCatPercentOfWeightCatAndBellow(testCatNode.getPercentOfWeightCatAndBellow());
			testVersionsPanel.setTestCatPercentOfWeightCatOnly(testCatNode.getPercentOfWeightCatOnly());
			testVersionsPanel.setTestCatAvgDifficultyCatAndBellow(testCatNode.getAvgDifficultyCatAndBellow().getAvg());
			testVersionsPanel.setTestCatAvgDifficultyCatOnly(testCatNode.getAvgDifficultyCatOnly().getAvg());
			testVersionsPanel.setTestCatAvgValidityCatAndBellow(testCatNode.getAvgValidityCatAndBellow().getAvg());
			testVersionsPanel.setTestCatAvgValidityCatOnly(testCatNode.getAvgValidityCatOnly().getAvg());			
		}
		testVersionsPanel.setTestVerDifficulty(null);
		testVersionsPanel.setTestVerValidity(null);
		testVersionsPanel.setTestVerRemarks("");
	}
	
	public void finalizeScreenHandling(){
		versionController.finalizeScreenHandling();
	}

	public void testVersionSelected(int testVerIndex){
		selectedUnsortedTestVerIndex = testVerIndex;
		TestVersion testVer = testVersionsTableModel.getTestVersionAtRow(testVerIndex);
		versionController.versionSelected(testVer.getVersion());
		QuestionsStats qs = StatisticData.getInstance().getQuestionsStats(testVer.getTestId());
		testVersionsPanel.setTestVerDifficulty(qs.getDifficulty(testVer.getVersion().getId()));
		testVersionsPanel.setTestVerValidity(qs.getValidity(testVer.getVersion().getId()));
		testVersionsPanel.setTestVerRemarks(qs.getRemarks(testVer.getVersion().getId()));		
	}
    
    public GuiState saveGuiState(MedNode node){
        return new TestVersionsPanelGuiState(selectedNode,this,selectedUnsortedTestVerIndex);
    }   
    
    public void restoreGuiState(GuiState state){
        super.restoreGuiState(state);
        if(state.getNode() instanceof TestQuestionsListNode && 
           ((TestQuestionsListNode)state.getNode()).getTestQuestions().size() == 0 ){
            return;
        }
        if(state.getNode() instanceof TestCategoryNode && 
           ((TestCategoryNode)state.getNode()).getTestCategory().getTestVersions().size() == 0 ){
            return;
        }        
        testVersionsPanel.selectUnsortedTestVersion(((TestVersionsPanelGuiState)state).getVersionIndex());
    }


	public void nodeNameChanged(MedNode node, String newName) throws RetriableException, CriticalException{
	}
	
        
	public Vector getTestVersionPopUpItems(List testVersions){
		Vector v = new Vector();
		if(testVersions.size() == 1){
			v.add(new JMenuItem(getTestVersionRemoveFromTest((TestVersion) testVersions.get(0))));
			return v;
		}
		List actions = new Vector();
		for(Iterator it=testVersions.iterator();it.hasNext();){
			actions.add(getTestVersionRemoveFromTest((TestVersion)it.next()));			
		}
		MultiSelectionAction act = new MultiSelectionAction(actions,getMainWindow());
		act.putValue(CommandAction.SMALL_ICON,GeneralParams.ICON_REMOVE);
		act.putValue(CommandAction.NAME,"Remove from Test");
		act.putValue(CommandAction.SHORT_DESCRIPTION,"Remove selected versions from Test");
		v.add(new JMenuItem(act));
		return v;
	}
	
	public void answerSelected(int ansId) {
		TestVersion testVer = testVersionsTableModel.getTestVersionAtRow(selectedUnsortedTestVerIndex);
		QuestionsStats qs = StatisticData.getInstance().getQuestionsStats(testVer.getTestId());
		HashMap answersMap = qs.getAnswersInfo(testVer.getVersion().getId());
		AnswerInfo aI = (AnswerInfo) answersMap.get(new Integer(ansId));
		testVersionsPanel.setTestAnsCorrelation(aI.getCorelation());
		testVersionsPanel.setTestAnsNormGradeAvg(aI.getNormGradeAvg());
		testVersionsPanel.setTestAnsNumAnsweringStudents(aI.getNumAnsweringStudents());
		testVersionsPanel.setTestAnsPercentAnsweringStudents(aI.getPercentAnsweringStudents());
	}
     
    private CommandAction getTestVersionRemoveFromTest(TestVersion testVer){
		CommandAction act = new TestVersionRemoveFromTestAct(testVer.getTestId(),testVer.getVersion().getId(),getMainWindow()); 
        return act.addListener(new PanelShowerListener()); 
    }
    
    
	public CommandAction getAnswerCreateMenuItem() {
		if(testVersionsTableModel.getRowCount() == 0){
			return null;
		}
		return versionController.getAnswerCreateAct();
	}

	public CommandAction getAnswerDeleteMenuItem() {
		if(testVersionsTableModel.getRowCount() == 0){
			return null;
		}
		return versionController.getAnswerDeleteAct();
	}

	public CommandAction getAnswerSetAsCorrectMenuItem() {
		if(testVersionsTableModel.getRowCount() == 0){
			return null;
		}
		return versionController.getAnswerSetAsCorrectAct();
	}

	public CommandAction getAnswerSetMixableMenuItem() {
		if(testVersionsTableModel.getRowCount() == 0){
			return null;
		}
		return versionController.getAnswerSetMixableMenuItem();
	}
	
    class PanelShowerListener implements ModelChangesListener{
        public void nodeAdded(MedNode childNode) {}
        public void nodePropertiesChanged() {
        	try{
        		getTree().selectNode(selectedNode);
        		showGUI(selectedNode);
        	}catch(Throwable e){}
        }
        public void nodeRemoved(MedNode parentNode, MedNode removedNode,int index) {}       
    }
    
    class VersionRefresher implements ModelChangesListener{
		public void nodeRemoved(MedNode parentNode, MedNode removedNode, int index) {}
		public void nodeAdded(MedNode childNode) {}
		public void nodePropertiesChanged() {
			testVersionsTableModel.fireTableDataChanged();
		}
    	
    }

}
