/*
 * Created on May 28, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.control.controllers;
import il.ac.technion.cs.course236308.e3.med.control.ModelChangesListener;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.control.actions.answer.AnswerCloneAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.answer.AnswerCreateAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.answer.AnswerDeleteAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.answer.AnswerMarkAsCorrectAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.answer.AnswerMoveDownAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.answer.AnswerMoveUpAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.answer.AnswerSetLanguageAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.answer.AnswerSetMixableAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.answer.AnswerSetNotesAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.answer.AnswerSetTextAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.version.VersionSetBodyAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.version.VersionSetCommentAct;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.AnswersTableModel;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.panels.VersionPropertyPanel;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.MedNode;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.util.Vector;

import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JSeparator;

/**
 * @author svali
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class VersionPropertyPanelController {
	private VersionPropertyPanel versionPropertyPanel;

	private AnswersTableModel ansTableModel;

	private Version selectedVersion;
	private MedNode selectedNode;
	private int selectedAnswerIndex;
	
	private MainWindow mainWindow;
	
	private Vector externalListeners = new Vector();
	
	private ParentOfVersionPropertyController parentController; 

	public VersionPropertyPanelController(MainWindow mainWindow,ParentOfVersionPropertyController parentController) {
		this.mainWindow = mainWindow;
		this.parentController = parentController;
		init();
	}

	public void init() {
		versionPropertyPanel = new VersionPropertyPanel(this);
		versionPropertyPanel.setAnswersTableModel(
			ansTableModel = new AnswersTableModel(this));
		versionPropertyPanel.init();
	}
	
	public void addListenersForActions(Vector v){
		externalListeners = v;
	}
	
	public MainWindow getMainWindow(){
		return mainWindow;
	}

	public JPanel getMainPanel() {
		return versionPropertyPanel;
	}
	
	public Version getSelectedVersion(){
		return selectedVersion;
	}
	
	public Answer getSelectedAnswer(){
		return ansTableModel.getAnswerAtRow(selectedAnswerIndex);
	}

	public void setActiveNode(MedNode activeNode) {
		selectedNode = activeNode;
	}
	
	public MedNode getActiveNode(){
		return selectedNode;
	}

	public void restoreGuiState(int ansIndex){
		setSelectedAnswer(ansIndex);
	}
	
	public void versionSelected(Version ver) {
		selectedVersion = ver;
		versionPropertyPanel.setRTLOrientation(GeneralParams.isRtlLanguage(ver.getLanguage()));
		versionPropertyPanel.setVerBodyText(selectedVersion.getBody());
		versionPropertyPanel.setVerNotesText(selectedVersion.getNotes());
		mainWindow.getStatisticsPanel().setAvgGradeAnsLabel(null);
		mainWindow.getStatisticsPanel().setAvgPercentageAnsLabel(null);
		mainWindow.getStatisticsPanel().setAvgCorrelationAnsLabel(null);
		ansTableModel.setVersion(selectedVersion);
		ansTableModel.fireTableDataChanged();
		selectedAnswerIndex = 0;
		versionPropertyPanel.selectAnswer(0);
	}

	public void answerSelected(int selectedRow) {
		Answer ans = ansTableModel.getAnswerAtRow(selectedRow);
		mainWindow.getStatisticsPanel().setAvgGradeAnsLabel(ans.getAvgGrade());
		mainWindow.getStatisticsPanel().setAvgPercentageAnsLabel(ans.getAvgPercentage());
		mainWindow.getStatisticsPanel().setAvgCorrelationAnsLabel(ans.getAvgCorrelation());
		versionPropertyPanel.setAnswerText(ans.getText());
		versionPropertyPanel.setAnswerNotesText(ans.getNotes());
		selectedAnswerIndex = selectedRow;
		parentController.answerSelected(ans.getId());
	}
	
	public void setSelectedAnswer(int row){
		versionPropertyPanel.refreshAnswersTable();
		versionPropertyPanel.selectAnswer(row);
	}
	
	public int getSelectedAnswerIndex(){
		return selectedAnswerIndex;
	}
	
	public Vector getAnsPopUpItems(Answer ans,Version ver) {
		Vector v = new Vector();

		v.add(new JMenuItem(getAnswerCreateAct(ver)));
		v.add(new JMenuItem(getAnswerDeleteAct(ans)));
		v.add(new JMenuItem(getAnswerCloneAct(ver,ans)));
		v.add(new JSeparator());

		JMenuItem asCorrect = new JMenuItem(getAnswerSetAsCorrectAct(ans));
		if (ver.getCorrectAnswerId() == ans.getId()) {
			asCorrect.setEnabled(false);
		}
		v.add(asCorrect);
		
		boolean toMix = !ans.isMixable();
		v.add(new JMenuItem(getAnswerSetMixableAct(ans,toMix)));

		v.add(new JSeparator());

		JMenuItem up = new JMenuItem(getAnswerMoveUpAct(ans));
		if (ans.getOrdinal() == 1) {
			up.setEnabled(false);
		}
		v.add(up);

		JMenuItem down = new JMenuItem(getAnswerMoveDownAct(ans));
		if (ans.getOrdinal() == ver.getAnswers().size()) {
			down.setEnabled(false);
		}
		v.add(down);

		return v;
	}
	
	public void setFocusOnAnswer(Answer ans){
		versionPropertyPanel.selectAnswer(ans.getOrdinal() -1);
	}

	public void setAnswerLanguage(Answer ans, String lang) {
		getAnswerSetLanguageAct(ans,lang).actionPerformed(null);
	}

	public void setAnswerAsCorrect(Answer ans) {
		getAnswerSetAsCorrectAct(ans).actionPerformed(null);
	}

	public void setAnswerMixable(Answer ans, Boolean mixable) {
		getAnswerSetMixableAct(ans,mixable.booleanValue()).actionPerformed(null);
	}

	public void answerTextChanged(Answer ans, String newText) {
		getAnswerSetTextAct(ans,newText).actionPerformed(null);
	}
	
	public void answerNotesTextChanged(Answer ans, String newNotes) {
		getAnswerSetNotesAct(ans,newNotes).actionPerformed(null);
//		versionPropertyPanel.selectAnswer(selectedAnswerIndex);
	}
	
	public void versionBodyChanged(Version ver,String verBody) {
		CommandAction act = new VersionSetBodyAct(ver.getId(),verBody,getMainWindow());
		act.addAllListeners(externalListeners);
		act.actionPerformed(null);
	}

	public void versionNotesChanged(Version ver,String verNotes) {
		CommandAction act = new VersionSetCommentAct(ver.getId(),verNotes,getMainWindow());
		act.addAllListeners(externalListeners);
		act.actionPerformed(null);
	}

	public void finalizeScreenHandling(){
		try{
			if(versionPropertyPanel.isVersionBodyChanged()){
				versionPropertyPanel.setVersionBodyChanged(false);
				versionBodyChanged(selectedVersion,versionPropertyPanel.getVerBodyText());
				versionPropertyPanel.setVerBodyText(selectedVersion.getBody());
			}
			if(versionPropertyPanel.isVersionNotesChanged()){
				versionPropertyPanel.setVersionNotesChanged(false);
				versionNotesChanged(selectedVersion,versionPropertyPanel.getVerNotesText());
				versionPropertyPanel.setVerNotesText(selectedVersion.getNotes());
			}
			if(versionPropertyPanel.isAnswerTextChanged()){
				versionPropertyPanel.setAnswerTextChanged(false);
				Answer ans = ansTableModel.getAnswerAtRow(selectedAnswerIndex);
				answerTextChanged(ans,versionPropertyPanel.getAnswerText());
				versionPropertyPanel.setAnswerText(ans.getText());
			}
			if(versionPropertyPanel.isAnswerNotesChanged()){
				versionPropertyPanel.setAnswerNotesChanged(false);
				Answer ans = ansTableModel.getAnswerAtRow(selectedAnswerIndex);
				answerNotesTextChanged(ans,versionPropertyPanel.getAnswerNotes());
				versionPropertyPanel.setAnswerNotesText(ans.getNotes());
			}
		}catch(Throwable e){}

	}

	
	public CommandAction getAnswerCreateAct(){
		return getAnswerCreateAct(selectedVersion);
	}
	
	public CommandAction getAnswerDeleteAct(){
		if(ansTableModel.getRowCount() <= 0){
			return null;
		}
		return getAnswerDeleteAct(ansTableModel.getAnswerAtRow(selectedAnswerIndex));
	}
	
	public CommandAction getAnswerCloneAct(){
		if(ansTableModel.getRowCount() <= 0){
			return null;
		}
		return getAnswerCloneAct(selectedVersion,ansTableModel.getAnswerAtRow(selectedAnswerIndex));
	}

	public CommandAction getAnswerSetAsCorrectAct(){
		if(ansTableModel.getRowCount() <= 0){
			return null;
		}
		Answer ans = ansTableModel.getAnswerAtRow(selectedAnswerIndex);
		if (selectedVersion.getCorrectAnswerId() == ans.getId()) {
			return null;
		}
		return getAnswerSetAsCorrectAct(ans);		
	}
	
	public CommandAction getAnswerSetMixableMenuItem(){
		if(ansTableModel.getRowCount() <= 0){
			return null;
		}
		Answer ans = ansTableModel.getAnswerAtRow(selectedAnswerIndex);
		return getAnswerSetMixableAct(ans,!ans.isMixable());
	}
	 	 
	private CommandAction getAnswerCreateAct(Version ver){
		CommandAction act = new AnswerCreateAct(ver.getId(), getMainWindow());
		act.addListener(new AnswersRefresher(selectedAnswerIndex));
		act.addAllListeners(externalListeners);
		return act;	
	}

	private CommandAction getAnswerDeleteAct(Answer ans){
		CommandAction act = new AnswerDeleteAct(ans.getId(), getMainWindow());
		act.addListener(new AnswersRefresher(selectedAnswerIndex));
		act.addAllListeners(externalListeners);
		return act;
	}

	private CommandAction getAnswerCloneAct(Version ver,Answer ans){
		CommandAction act = new AnswerCloneAct(ver.getId(),ans.getId(), getMainWindow());
		act.addListener(new AnswersRefresher(selectedAnswerIndex));
		act.addAllListeners(externalListeners);
		return act;		
	}
	
	private CommandAction getAnswerSetAsCorrectAct(Answer ans){
		CommandAction act =
			new AnswerMarkAsCorrectAct(ans.getId(), getMainWindow());
		act.addListener(new AnswersRefresher(ans.getOrdinal()-1));
		act.addAllListeners(externalListeners);
		return act;
	}
	
	private CommandAction getAnswerSetMixableAct(Answer ans,boolean mixable){
		CommandAction act =
			new AnswerSetMixableAct(ans.getId(),mixable,getMainWindow());
		act.addListener(new AnswersRefresher(ans.getOrdinal()-1));
		act.addAllListeners(externalListeners);
		return act;
	}
	
	private CommandAction getAnswerSetTextAct(Answer ans,String newText){
		CommandAction act =
				new AnswerSetTextAct(ans.getId(), newText, getMainWindow());
		act.addListener(new AnswersRefresher(selectedAnswerIndex));
		act.addAllListeners(externalListeners);
		return act;
	}

	private CommandAction getAnswerSetNotesAct(Answer ans,String newNotes){
		CommandAction act =
				new AnswerSetNotesAct(ans.getId(), newNotes, getMainWindow());
		act.addListener(new AnswersRefresher(selectedAnswerIndex));
		act.addAllListeners(externalListeners);
		return act;
	}
	
	private CommandAction getAnswerSetLanguageAct(Answer ans,String lang){
		CommandAction act =
			new AnswerSetLanguageAct(ans.getId(), lang, getMainWindow());
		act.addListener(new AnswersRefresher(selectedAnswerIndex));
		act.addAllListeners(externalListeners);		
		return act;
	}

	private CommandAction getAnswerMoveUpAct(Answer ans){
		CommandAction act = new AnswerMoveUpAct(ans.getId(), getMainWindow());
		act.addListener(new AnswersRefresher(selectedAnswerIndex));
		act.addAllListeners(externalListeners);
		return act;	
	}
	
	private CommandAction getAnswerMoveDownAct(Answer ans){
		CommandAction act = new AnswerMoveDownAct(ans.getId(), getMainWindow());;
		act.addListener(new AnswersRefresher(selectedAnswerIndex));
		act.addAllListeners(externalListeners);
		return act;
	}

	private class AnswersRefresher implements ModelChangesListener{
		int answerIndex;
		public AnswersRefresher(int answerIndex){
			this.answerIndex = answerIndex;
		}
		public void nodeRemoved(MedNode parentNode, MedNode removedNode, int index) {}
		public void nodeAdded(MedNode childNode) {}
		public void nodePropertiesChanged() {	
			ansTableModel.fireTableDataChanged();
			setSelectedAnswer(answerIndex);
		}
		
	}
}
