/*
 * Created on May 28, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.gui;

import il.ac.technion.cs.course236308.e3.med.control.MedContainer;
import il.ac.technion.cs.course236308.e3.med.control.ModelChangesListener;
import il.ac.technion.cs.course236308.e3.med.control.actions.CommandAction;
import il.ac.technion.cs.course236308.e3.med.control.actions.MultiSelectionAction;
import il.ac.technion.cs.course236308.e3.med.control.actions.category.CategorySetParentAct;
import il.ac.technion.cs.course236308.e3.med.control.actions.question.QuestionSetMainCategoryAct;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.CategoryNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.MedNode;
import il.ac.technion.cs.course236308.e3.med.model.Category;
import il.ac.technion.cs.course236308.e3.med.model.Question;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Point;
import java.awt.dnd.DnDConstants;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.EventObject;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeCellEditor;
import javax.swing.tree.TreePath;

/**
 * @author svali
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class CategoriesTree extends MedTree {

	public CategoriesTree(MedNode root, MainWindow theParentWindow) {
		super(root, theParentWindow);
		setCellEditor(new NavigationTreeEditor(this));
		setEditable(true);	
	}

	public class NavigationTreeEditor extends DefaultTreeCellEditor 	{
		private boolean bActiveEditing;
		private JTextField activeTextField;
		private MedNode activeNode;
		private CategoriesTree tree;
				
		NavigationTreeEditor(CategoriesTree nTree) {
			super(nTree,null);
			tree = nTree;
			bActiveEditing = false;
		}

		public Component getTreeCellEditorComponent(
			JTree arg0,
			Object arg1,
			boolean arg2,
			boolean arg3,
			boolean arg4,
			int arg5) {

			MedNode node = (MedNode) arg1;
			
			JPanel panel = new JPanel(new BorderLayout());
			int fieldSize = node.toString().length()+2;
			if(fieldSize < 6)
				fieldSize = 6;
			if(fieldSize > 15)
				fieldSize = 15;
			
			JTextField text = new JTextField(fieldSize);

			ImageIcon icon = node.getIcon();  
			panel.add(new JLabel(icon),BorderLayout.WEST);
			panel.add(text,BorderLayout.CENTER);


			text.setText(node.toString()); 
			panel.setOpaque(false);
			text.setBorder(BorderFactory.createLineBorder(new Color(100,0,200),2));
			text.selectAll();
			text.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {		
					cancelCellEditing();
				}
			});	
			
			text.addFocusListener(new FocusListener() {
				public void focusGained(FocusEvent arg0) {
				}
				public void focusLost(FocusEvent e) {
					stopEditing();
				}
			});
			
			text.addKeyListener(new KeyListener() {
					public void keyTyped(KeyEvent arg0) {
					}
					public void keyPressed(KeyEvent e) {
						if(e.getKeyCode() == KeyEvent.VK_ESCAPE) 
							cancelEditing();
					}
					public void keyReleased(KeyEvent arg0) {
					}
				});
			
			bActiveEditing = true;
			activeTextField = text;	
			activeNode = node;
			return panel;
			
		}
		
	   public boolean isCellEditable(EventObject e) {
			boolean res = super.isCellEditable(e);			
			if(res == false)
				return false;			
			if(bActiveEditing) 
				cancelEditing();
			return true;
			//return tree.isNodeEditionAllowed();
		}

		public boolean shouldSelectCell(EventObject arg0) {
			return false;
		}

		private void cancelEditing() {
			if(!bActiveEditing)
				return;						
			cancelCellEditing();			
			bActiveEditing = false;
		}
		
		private void stopEditing() {
			if(bActiveEditing == false)
				return ;
			bActiveEditing = false;
			
			cancelCellEditing();			
			String newValue = activeTextField.getText();
			
			if(activeNode == null){
				System.err.println("Error during edition: no active node");
				return;
			}
			tree.setNodeNewName(activeNode,newValue);
		}
	}
	
	public int dragUnderFeedback(Point p, MedContainer container) {
		if(container.isOnlyOfClass(Question.class)){
			return DnDConstants.ACTION_LINK;	
		}
		if(container.isOnlyOfClass(Category.class)){
			return DnDConstants.ACTION_LINK;	
		}		
		return DnDConstants.ACTION_NONE;
	}

	public void undoDragUnderFeedback() {
	
	}

	public void drop(Point p, MedContainer c) {
		TreePath path = getClosestPathForLocation(p.x,p.y);
		MedNode node = (MedNode)path.getLastPathComponent();
    	if(!(c.isOnlyOfClass(Question.class) || c.isOnlyOfClass(Category.class))){
    		return;
    	}
		if(c.isOnlyOfClass(Category.class)){
			dropCategory((CategoryNode)node,c);
			return;
		}
		Category cat = ((CategoryNode)node).getCategory();
		Question quest;
		List commandsList = new LinkedList();
		for(Iterator it =c.getIncludedObjects().iterator();it.hasNext();){
			quest = (Question)it.next();
			commandsList.add(new QuestionSetMainCategoryAct(quest.getId(),cat.getId(),mainWindow).addListener(new CategoryPanelRefresher()));
		}
		new MultiSelectionAction(commandsList,mainWindow).actionPerformed(null);
	}

	private void dropCategory(CategoryNode dropToCatNode,MedContainer c){
		Category cat = (Category)c.getIncludedObjects().iterator().next();
		CategoryNode catNode = (CategoryNode) getNodeByObject(cat);
		CommandAction act = new CategorySetParentAct(catNode.getCategory().getId(),dropToCatNode.getCategory().getId(),mainWindow);
		act.addListener(this).actionPerformed(null);
	}
	
	class CategoryPanelRefresher implements ModelChangesListener{
		public void nodeRemoved(MedNode parentNode, MedNode removedNode, int index) {}
		public void nodeAdded(MedNode childNode) {}
		public void nodePropertiesChanged() {
			mainWindow.restoreLastTreeSelection();
			mainWindow.getMainWindowController().getActivePanel().showGUI(mainWindow.getMainWindowController().getActiveNode());
			
		}
		
	}

}
