package il.ac.technion.cs.course236308.e3.med.gui;

import java.awt.Component;
import java.awt.Font;

//import javax.swing.BorderFactory;
import javax.swing.JLabel;


/**
 * A label to be used as window headers in the TRS application.
 */
public class HeaderLabel extends JLabel
{
    
    public static final int DEFAULT_FONT_SIZE = 14;
    
    /**
     * Creates and configures a header label with the specified text.
     * @param text Text of label.
     * @param size size of label's font.
     */
    public HeaderLabel(String text, int size)
    {
	super(text);
//	setBorder(BorderFactory.createEmptyBorder(0,0,size,0));
	setFont(new Font("Serif", Font.BOLD, size));
	setAlignmentX(Component.CENTER_ALIGNMENT);
    }
    

    /**
     * Creates and configures a header label with the specified text
     * and the default font size.
     */
    public HeaderLabel(String text)
    {
	this(text, DEFAULT_FONT_SIZE);
    }

}

