/*
 * Created on May 28, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.gui;

import il.ac.technion.cs.course236308.e3.med.control.DndAdapter;
import il.ac.technion.cs.course236308.e3.med.control.DndComponent;
import il.ac.technion.cs.course236308.e3.med.control.MedContainer;
import il.ac.technion.cs.course236308.e3.med.control.ModelChangesListener;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.MedNode;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.AbstractAction;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JSeparator;
import javax.swing.JTree;
import javax.swing.event.TreeExpansionEvent;
import javax.swing.event.TreeExpansionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;

/**
 * @author svali
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class MedTree extends JTree implements MouseListener,TreeSelectionListener,
											ModelChangesListener,DndComponent,KeyListener,TreeExpansionListener{
	protected MainWindow mainWindow;
//	private MedNode lastDropTargetNode;
//	private MedNode selectedNode;
//	int lastDropTargetAction;
//	private TreePath[] lastSelectedPaths = new TreePath[0];

	private boolean reactToExpadCollapse = true;
	

	public MedTree(MedNode root, MainWindow theParentWindow){
		setModel(new DefaultTreeModel(root));
		mainWindow = theParentWindow;
		setCellRenderer(new MedTreeRenderer());
		addMouseListener(this);
		addTreeSelectionListener(this);
		addKeyListener(this);
		addTreeExpansionListener(this);

		initGui();
		new DndAdapter(this);
        setDragEnabled(true);
	}
	public void initGui() {
		setRootVisible(true);		
		setForeground(Color.blue);
		setShowsRootHandles(true);
		setScrollsOnExpand(true);
	}

	public void mouseClicked(MouseEvent e) {}

	public void mouseEntered(MouseEvent arg0) {}

	public void mouseExited(MouseEvent arg0) {}

	public void mousePressed(MouseEvent e) {}

	public void mouseReleased(MouseEvent e) {
		TreePath path = getClosestPathForLocation(e.getX(),e.getY());		
		if(e.getButton() == 1){
			selectNode((MedNode) path.getLastPathComponent());
			return;
		}	
		if(e.getButton() != 3){
			return;
		}
		selectNode((MedNode) path.getLastPathComponent());
		showPopUpMenu(e,path);
	}

	private void showPopUpMenu(MouseEvent e, TreePath path){
		MedNode menuSelectedNode = (MedNode) path.getLastPathComponent();
		final JMenuItem expandMenuItem = new JMenuItem(new ContexMenuNodeExpandAction(menuSelectedNode)); 
		final JMenuItem collapseMenuItem = new JMenuItem(new ContexMenuNodeCollapseAction(menuSelectedNode)); 
		
		JPopupMenu tmenu = new JPopupMenu();
		if(isCollapsed(path))
			tmenu.add(expandMenuItem);
		else
			tmenu.add(collapseMenuItem);
		
		tmenu.add(new JSeparator());
		Vector menuItems = mainWindow.requestMenuComponentsForNode(menuSelectedNode);
		if(menuItems != null){
			for(Iterator it=menuItems.iterator();it.hasNext();){
				tmenu.add((Component)it.next());
			}
		}
		tmenu.show(this,e.getX(),e.getY());
	}

	public TreePath getPath(MedNode node) {
		if(node == null)
			return null;		
		MedNode rootNode = (MedNode) getModel().getRoot();	
		TreePath rPath = new TreePath(rootNode.getRelativePath(node.getPath()));
		return rPath;	
	}
	
	public class ContexMenuNodeExpandAction extends AbstractAction {
		MedNode actionNode;
		public ContexMenuNodeExpandAction(MedNode node) {
			super("Expand", GeneralParams.ICON_COLLAPSE);
			putValue(SHORT_DESCRIPTION, "Expand currently selected node");
			actionNode = node;
		}
		public void actionPerformed(ActionEvent e) {
			expandPath(getPath(actionNode));
		}
		public boolean isEnabled() {
			if(actionNode.getChildCount() == 0)
				return false;
			return isCollapsed(getPath(actionNode));
		}
	}

	class ContexMenuNodeCollapseAction extends AbstractAction {
		MedNode actionNode;
		public ContexMenuNodeCollapseAction(MedNode node) {
			super("Collapse", GeneralParams.ICON_EXPAND);
			putValue(SHORT_DESCRIPTION, "Collapse currently selected node");
			actionNode = node;
		}
		public void actionPerformed(ActionEvent e) {
			setSelectionPath(null);
			collapsePath(getPath(actionNode));
		}

		public boolean isEnabled() {
			if(actionNode.getChildCount() == 0)
				return false;
			return isExpanded(getPath(actionNode));
		}
	}

	public void nodePropertiesChanged(MedNode node) {
		DefaultTreeModel model = (DefaultTreeModel) getModel();
		model.nodeStructureChanged(node);	
		this.repaint();
	}

	public void nodePropertiesChanged() {}
	
 
 	public void nodeAdded(MedNode childNode) {
		DefaultTreeModel model = (DefaultTreeModel) getModel();	
		int[] index = { model.getIndexOfChild(childNode.getParent(),childNode)};
		model.nodesWereInserted(childNode.getParent(),index);
		selectNode(childNode);
	}
	
	public void nodeRemoved(MedNode removedNode,MedNode parentNode,int index){
		DefaultTreeModel model = (DefaultTreeModel) getModel();
		int[] indexes = {index};
		Object[] nodes = {removedNode};
		model.nodesWereRemoved(parentNode,indexes,nodes);				
		selectNode(parentNode);
	}
	
	public void replaceNode(MedNode oldNode,MedNode newNode){
		DefaultTreeModel model = (DefaultTreeModel) getModel();
		MedNode parentNode = oldNode.getParentNode();
		int index = model.getIndexOfChild(parentNode,oldNode);
		int[] indexes = {index};
		Object[] nodes = {oldNode};
		parentNode.remove(oldNode);
		model.nodesWereRemoved(parentNode,indexes,nodes);				
		parentNode.insert(newNode,index);
		model.nodesWereInserted(parentNode,indexes);
		selectNode(parentNode);
	}

	public Component getComponent() {
		return this;
	}

	public MedContainer initDrag(Point p) {
		TreePath[] paths = getSelectionPaths();		
		if(paths == null)
			return null;						
		MedContainer container = new MedContainer();
		for(int i = 0; i < paths.length; i++) {
			container.addObject(((MedNode) paths[i].getLastPathComponent()).getUserObject());
		}
		return container;	
	}

	public void dragFinalize() {
		mainWindow.restoreLastTreeSelection();
	}

	
	public void setNodeNewName(MedNode node, String newValue) {
		mainWindow.setNodeNewName(node,newValue);
	}
	
	public void requestNodeEdition(MedNode node) {
		TreePath path = new TreePath(node.getPath()); 
		if(!isVisible(path))
			expandPath(path);
		MedNode rootNode = (MedNode) getModel().getRoot();	
		MedNode[] rpath = rootNode.getRelativePath(node.getPath());
		startEditingAtPath(new TreePath(rpath));	
	}

	boolean bKeyPressed = false;
	public void valueChanged(TreeSelectionEvent e) {
		TreePath path = e.getNewLeadSelectionPath();
		if(path == null){
			path = e.getPath();
		}
		if(path != null && bKeyPressed) {
		   selectNode((MedNode) path.getLastPathComponent());
		}
	}

	public void keyTyped(KeyEvent e) {}
	
	public void keyPressed(KeyEvent e) {
		if(e.getKeyCode() == KeyEvent.VK_LEFT || e.getKeyCode() == KeyEvent.VK_RIGHT ||
			e.getKeyCode() == KeyEvent.VK_UP || e.getKeyCode() == KeyEvent.VK_DOWN ||
			e.getKeyCode() == KeyEvent.VK_PAGE_UP || e.getKeyCode() == KeyEvent.VK_PAGE_DOWN ||
			e.getKeyCode() == KeyEvent.VK_END || e.getKeyCode() == KeyEvent.VK_HOME) {
			bKeyPressed = true;
			return;
		}
		bKeyPressed = false;
	}
	
	public void keyReleased(KeyEvent e) {
		bKeyPressed = false;
	}
	
	public void selectNode(MedNode node){
		reactToExpadCollapse = false;
		setSelectionPath(getPath(node));
		repaint();
		mainWindow.treeSelectionChanged(node);
		reactToExpadCollapse = true;
	}
	
	public void treeCollapsed(TreeExpansionEvent e) {
		if(reactToExpadCollapse){
			selectNode((MedNode)e.getPath().getLastPathComponent());
		}
	}

	public void treeExpanded(TreeExpansionEvent e) {
		if(reactToExpadCollapse){	
			selectNode((MedNode)e.getPath().getLastPathComponent());
		}
	}
	
	public MedNode getNodeByObject(Object obj){
		return recursiveSearch((MedNode)getModel().getRoot(),obj);
	}
	
	private MedNode recursiveSearch(MedNode from, Object lookFor){
		if(from.getUserObject() == null){
			return null;
		}
		if(from.getUserObject().equals(lookFor)){
			return from;
		}
		MedNode node;
		for(int i=0;i<from.getChildCount();++i){
			MedNode child = (MedNode)from.getChildAt(i); 
			if((node=recursiveSearch(child,lookFor)) != null){
				return node;
			}
		}
		return null;
	}
	
	private class MedTreeRenderer extends DefaultTreeCellRenderer {		
		public void paint(Graphics g) {
			super.paint(g);
		}		
		public Component getTreeCellRendererComponent(JTree tree,Object value,boolean selected,
							  boolean expanded,boolean leaf,int row,boolean hasFocus) {
			JLabel label =  (JLabel) super.getTreeCellRendererComponent(tree,value,selected,
													  expanded,leaf,row,false);
			ImageIcon icon =  ((MedNode)value).getIcon();
			if(icon!=null){
				label.setIcon(icon);
			}
			return label;
		}
	}
}
