/*
 * Created on May 29, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.gui.datamodels;

import il.ac.technion.cs.course236308.e3.med.control.controllers.VersionPropertyPanelController;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.model.Version;

import java.util.Collections;

import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;

/**
 * @author svali
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class AnswersTableModel extends AbstractTableModel {

	private Version ver = new Version();
	private static final String[] columnNames =
		{ " ","#", "Answer Text", "Language", "Correct", "Mixable" };
	private VersionPropertyPanelController controller;

	public AnswersTableModel(VersionPropertyPanelController controller) {
		this.controller = controller;
		this.addTableModelListener(new TableModelListener() {
			public void tableChanged(TableModelEvent arg0) {
				setVersion(ver);
			}
		});

	}
	public void setVersion(Version ver) {
		this.ver = ver;
		Collections.sort(ver.getAnswers());
	}

	public String getColumnName(int col) {
		return columnNames[col];
	}

	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return ver.getAnswers().size();
	}

	public boolean isCellEditable(int row, int col) {
		if (col > 2) {
			return true;
		}
		return false;
	}

	public Object getValueAt(int row, int col) {
		Answer ans = (Answer) ver.getAnswers().get(row);

		switch (col) {
			case 0:
				return ans.getIcon();
			case 1:
				return new Integer(ans.getOrdinal());
			case 2:
				return ans.getText();
			case 3:
				return ans.getLanguage();
			case 4:
				return new Boolean(ver.getCorrectAnswerId() == ans.getId());
			case 5:
				return new Boolean(ans.isMixable());
			default :
				System.err.println(
					"Internal error - " + "Add column to QuestinsModel");
				System.exit(1);
		}
		return null; // never reached
	}

	public Class getColumnClass(int c) {
		return getValueAt(0, c).getClass();
	}

	public Answer getAnswerAtRow(int row) {
		return (Answer) ver.getAnswers().get(row);
	}

	public void setValueAt(Object value, int row, int col) {
		switch (col) {
			case 3 :
				controller.setAnswerLanguage(getAnswerAtRow(row),(String) value);
				return;
			case 4 :
				controller.setAnswerAsCorrect(getAnswerAtRow(row));
				return;
			case 5 :
				controller.setAnswerMixable(getAnswerAtRow(row),(Boolean) value);
				return;
		}
	}

}
