/*
 * Created on Jul 14, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.gui.datamodels;

import il.ac.technion.cs.course236308.e3.med.control.controllers.TestGradingPolicyController;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestAnswer;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;
import il.ac.technion.cs.course236308.e3.med.stats.QuestionsStats;
import il.ac.technion.cs.course236308.e3.med.stats.StatisticData;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;

/**
 * @author Shraer Alexander
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class GradingTestAnswersTableModel extends AbstractTableModel {
	private Test test = new Test();
	private static String[] columnNames =
		{ "Question", "Version", "Version Text","weight", "A", "P1","P2", "B","P1","P2", 
		  "C", "P1","P2","D", "P1","P2", "E", "P1","P2", "F", "P1","P2", "G", 
          "P1","P2", "H", "P1","P2", "I", "P1","P2", "J","P1","P2",};
	private TestGradingPolicyController controller;
    private MyCellRenderer mcr;
	public GradingTestAnswersTableModel(TestGradingPolicyController controller) {
		this.controller = controller;
		mcr = new MyCellRenderer(test);
	/*	this.addTableModelListener(new TableModelListener() {
			public void tableChanged(TableModelEvent arg0) {
				setTest(test);
			}
		});*/

	}

	public void setTest(Test t){
		test = t;
		try {
			test.toCanonical();
		} catch (Throwable e) {
			e.printStackTrace();
		}
		mcr.setTest(test);
		
	}
	
	public String getColumnName(int col) {
		return columnNames[col];
	}

	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return test.getTestVersions().size();
	}

	public boolean isCellEditable(int row, int col) {
		TestVersion tv = (TestVersion)test.getTestVersions().get(row);
		int numAnswers = tv.getTestAnswers().size();
		if (col<3) return false;
		if (col==3) return true;
		if ((col-4)%3==0 && (col-4)/3 < numAnswers) {
			return true;
		}
		return false;
	}

	public Object getValueAt(int row, int col) {
		TestVersion tv = (TestVersion)test.getTestVersions().get(row);
		
		switch (col) {
			case 0 :
				try{
					return new Integer(tv.getVersion().getQuestionId());	
				}catch(Throwable e){
					return "";
				}			
			case 1 :
				return new Integer(tv.getVersion().getId());
			case 2 :
				try{
					return tv.getVersion().getBody()==null ? "" : tv.getVersion().getBody();
				}catch(Throwable e){
					return "";
				}					
			case 3 :
				return tv.getWeight();
		}
		int ansInd;
		if ((col-4)%3 == 0) { 
			ansInd = (col-4)/3;
			if (tv.getTestAnswers().size()<= ansInd) return "";
			Byte weight = new Byte(((TestAnswer)(tv.getTestAnswers().get(ansInd))).getWeight()); 
            return weight.toString() + "%";
		}
		
        QuestionsStats qs = StatisticData.getInstance().getQuestionsStats(test.getId());
		if ((col-5)%3 == 0) { 
			ansInd = (col-5)/3;
			if (tv.getTestAnswers().size()<= ansInd) return "";
            return qs.calcP1(tv.getVersion().getId(), (col-5)/3 + 1);
		}
		ansInd = (col-6)/3;
		if (tv.getTestAnswers().size()<= ansInd) return "";
		return qs.calcP2(tv.getVersion().getId(), (col-6)/3 + 1);
	}
	
	
	public Class getColumnClass(int c) {
		return getValueAt(0, c).getClass();
	}

	public TestVersion getTestVersionAtRow(int row) {
		return (TestVersion) test.getTestVersions().get(row);
	}
	
	public TableCellRenderer getCellRenderer() { 
			return mcr; 
	} 

	public void setValueAt(Object value, int row, int col) {
		if (col==3){
            controller.setTestVersionWeight(getTestVersionAtRow(row), (Double) value);
		}
        if ((col-4)%3 == 0){
			int answerNum = (col-4)/3;
			TestAnswer ta = (TestAnswer)getTestVersionAtRow(row).getTestAnswers().get(answerNum);
			controller.setTestAnswerWeight(ta, (String)value);
		}
	}
    
	class MyCellRenderer extends DefaultTableCellRenderer { 
		private Test test;
		public void setTest(Test test){
			this.test = test;
		}
		public MyCellRenderer(Test test){
			this.test = test;
		}
		public Component getTableCellRendererComponent 
			(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) { 

			// Obtains default cell settings 
			Component cell = super.getTableCellRendererComponent ( table, value,isSelected, hasFocus, row, column); 
			TestVersion tv = (TestVersion) test.getTestVersions().get(row);
			int numAnswers = tv.getTestAnswers().size();
			int numColumns = 4 + numAnswers*3;
			if (column>=numColumns) 
				cell.setBackground(Color.gray);
			else cell.setBackground(Color.WHITE);
			return cell; 
		} 
	} 

 
}
