/*
 * Created on May 29, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.gui.datamodels;

import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.panels.MainWindow;
import il.ac.technion.cs.course236308.e3.med.model.LegalObject;

import java.util.LinkedHashSet;
import java.util.Set;

import javax.swing.JLabel;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;

/**
 * @author svali
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class IllegalStatesTableModel extends AbstractTableModel {

	private static Set illegalObjects = new LinkedHashSet();
	private JLabel countLabel;
	private static IllegalStatesTableModel instance = new IllegalStatesTableModel();
	private MainWindow mainWindow;
	
	private IllegalStatesTableModel(){
		addTableModelListener(new TableModelListener(){
			public void tableChanged(TableModelEvent arg0) {
				countLabel.setText(String.valueOf(illegalObjects.size()) + " item(s) in illegal state (double-click on item to set focus):");
			}});
	}
	
	public static IllegalStatesTableModel getInstance(){
		return instance;
	}
	
	public void setMainWindow(MainWindow mainWindow){
		this.mainWindow = mainWindow;
	}
	
	public void refreshTrees(){
		try{
			mainWindow.getCategoryTree().repaint();
			mainWindow.getTestTree().repaint();
		}catch(Throwable e){}
	}
	
	private static final String[] columnNames =
		{ " ", "Problem Description", "Object Type", "Object Description" };
	
	public void setIllegalObjects(Set illegalObjects) {
		IllegalStatesTableModel.illegalObjects = illegalObjects;
	}
	
	public void setCountLabel(JLabel label){
		this.countLabel = label;
	}

	public String getColumnName(int col) {
		return columnNames[col];
	}

	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return illegalObjects.size();
	}

	public boolean isCellEditable(int row, int col) {
		return false;
	}

	public Object getValueAt(int row, int col) {
		LegalObject[] objArr = new LegalObject[illegalObjects.size()];
		illegalObjects.toArray(objArr);
		LegalObject obj = objArr[row];
		
		switch (col) {
			case 0 :
				return obj.getIcon();
			case 1 :
				try{
					obj.isSelfLegal();
					return "";
				}catch(RetriableException e){
					return e.getMessage();
				}
			case 2 :
				return obj.getClass().toString().substring(obj.getClass().toString().lastIndexOf(".")+1);
			case 3 :
				return obj.toString();
			default :
				System.err.println(
					"Internal error - " + "Add column to IllegalItemsModel");
				System.exit(1);
		}
		return null; // never reached
	}

	public Class getColumnClass(int c) {
		return getValueAt(0, c).getClass();
	}

	public LegalObject getIllegalObjectAtRow(int row) {
		LegalObject[] objArr = new LegalObject[illegalObjects.size()];
		illegalObjects.toArray(objArr);
		return objArr[row];

	}
}
