/*
 * Created on May 29, 2004
 * Benny
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.gui.datamodels;

import il.ac.technion.cs.course236308.e3.med.model.CategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.model.Category;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.util.Collections;
import java.util.List;

import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;

/**
 * @author svali
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class QuestionsTableModel extends AbstractTableModel {

	private Category category = new Category();
	private List questions;
	private List linksToQuestions;
	private static final String[] columnNames = {" ","Ordinal","Id","Main Category","Versions Number","Cancelled"}; 
	
	public QuestionsTableModel(){
		this.addTableModelListener(new TableModelListener(){
			public void tableChanged(TableModelEvent arg0) {
		        setCategory(category);
			}});
	}
	
	public void setCategory(Category category){
		this.category = category;
		questions = category.getQuestions();
		linksToQuestions = category.getAllLinkedQuestions();
		Collections.sort(questions);
	}

	public String getColumnName(int col){
		return columnNames[col];
	}
        
	public int getColumnCount(){
		return columnNames.length;
	}
    
	public int getRowCount(){
		return questions.size() + linksToQuestions.size();
	}
    
	public boolean isCellEditable(int row, int col){
		return false;
	}
    
	public Object getValueAt(int row, int col){
		Question quest;
		if(row < questions.size()){
			quest = (Question)questions.get(row);
		}else{
			quest = (Question)linksToQuestions.get(row-questions.size());
		}
		
		switch (col) {
		case 0:
			if(row < questions.size()){
				return quest.getIcon();
			}
			try{
				quest.isLegal();
				return GeneralParams.ICON_QUESTION_SHORTCUT;
			}catch(Throwable e){
				return GeneralParams.ICON_QUESTION_SHORTCUT_ILLEGAL;
			}
		case 1:
			return new Integer(quest.getOrdinal());
		case 2:
			return new Integer(quest.getId());
		case 3:
			CategoriesFactory cf = CategoriesFactory.getInstance();
			try {
				
				return cf.getCategory(quest.getMainCategoryId()).getFullName();
			} catch (Throwable e) {
				e.printStackTrace();
				return "";
			}
		case 4:
			return new Integer(quest.getVersions().size());
		case 5:
			return String.valueOf(quest.isCancelled());
		default:
			System.err.println("Internal error - " +
					   "Add column to QuestinsModel");
			System.exit(1);
		}
		return null; // never reached
	}
        
	public Class getColumnClass(int c) {
		return getValueAt(0, c).getClass();
	}

	public Question getQuestionAtRow(int row){
		if(row<questions.size()){
			return (Question)questions.get(row);
		}
		return (Question)linksToQuestions.get(row-questions.size());
	}
   
   


}
