/*
 * Created on Jun 13, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.gui.panels;

import il.ac.technion.cs.course236308.e3.med.control.DndAdapter;
import il.ac.technion.cs.course236308.e3.med.control.DndComponent;
import il.ac.technion.cs.course236308.e3.med.control.MedContainer;
import il.ac.technion.cs.course236308.e3.med.control.TableSorter;
import il.ac.technion.cs.course236308.e3.med.control.controllers.CategoryPanelController;
import il.ac.technion.cs.course236308.e3.med.gui.HeaderLabel;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.QuestionsTableModel;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.SecondaryCatTableModel;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.VersionsSingleSelectionModel;
import il.ac.technion.cs.course236308.e3.med.model.CategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.model.Category;
import il.ac.technion.cs.course236308.e3.med.model.Question;
import il.ac.technion.cs.course236308.e3.med.model.Version;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.awt.Component;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.dnd.DnDConstants;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.text.SimpleDateFormat;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;

import javax.swing.AbstractAction;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 * @author Valentin Kravtsov
 *
 * Created in DS Laboratory - Technion, Israel 2004
 */
public class CategoryPanel extends JPanel {
	private CategoryPanelController controller;

	private JButton verActive = new JButton("Set as Active",GeneralParams.ICON_A);
	private JTextField verLanguageText = new JTextField("");
	private JLabel catName = new HeaderLabel("");
	private JLabel verCreatedText = new JLabel();
	private JLabel verUpdatedText = new JLabel();
	private JLabel verIsLockedLabel = new JLabel();
	private JLabel verIdLabel = new JLabel();

	private QuestionsTableModel questTableModel;
	private TableSorter questTableSorter;
	private SecondaryCatTableModel secCatTableModel;
	private TableSorter secCatTableSorter;
	private VersionsSingleSelectionModel versionsModel;

	private SecCatTable secCatTable = new SecCatTable();
	private QuestTable questTable = new QuestTable();
	private JTabbedPane tabbedPane;
	private JComponent oneVersionPanel;
		
	private JSplitPane questVerSplitPane;
	
	private int lastSelectedQuestionIndex = 0;
	
	private boolean verLangChanged = false;

	public CategoryPanel(CategoryPanelController controller) {
		this.controller = controller;
	}

	public void init() {
		this.setLayout(new GridLayout(1, 1));
		oneVersionPanel = createVersionPanel();
		this.add(createMainPanel());
		questVerSplitPane.setDividerLocation((int)(Toolkit.getDefaultToolkit().getScreenSize().getHeight()/6));
		addListeners();
	}

	public void setQuestionsTableModel(QuestionsTableModel model) {
		questTableModel = model;
		questTableSorter = new TableSorter(model);
		questTable.setModel(questTableSorter);
		questTableSorter.setTableHeader(questTable.getTableHeader());
		questTableSorter.setColumnComparator(Integer.class,TableSorter.COMPARABLE_COMAPRATOR);
		questTable.getColumnModel().getColumn(0).setMaxWidth(16);
		questTable.getColumnModel().getColumn(1).setMaxWidth(80);
		questTable.getColumnModel().getColumn(2).setMaxWidth(50);
		questTable.getColumnModel().getColumn(3).setPreferredWidth(300);
		questTable.getColumnModel().getColumn(4).setPreferredWidth(50);
		questTable.getColumnModel().getColumn(5).setPreferredWidth(50);
	}

	public void setSecondaryCatTableModel(SecondaryCatTableModel model) {
		this.secCatTableModel = model;
		secCatTableSorter = new TableSorter(model);
		this.secCatTable.setModel(secCatTableSorter);
		secCatTableSorter.setTableHeader(secCatTable.getTableHeader());
	}
	
	public void setVersionsSingleSelectionModel(VersionsSingleSelectionModel model){
		this.versionsModel = model;
	}

	public void setCatName(String text) {
		catName.setText("Questions in Category: " + text);
	}

	public void setVerCreatedText(String text) {
		verCreatedText.setText(text);
	}

	public void setVerUpdatedText(String text) {
		verUpdatedText.setText(text);
	}

	public void setVerIdLabelText(String text){
		verIdLabel.setText(text);
	}
	
	public void setVerIsLockedText(String text) {
		verIsLockedLabel.setText(text);
	}

	public void setVerLanguageText(String text) {
		verLanguageText.setText(text);
	}

	public String getVerLanguageText(){
		return verLanguageText.getText();
	}
	
	public boolean isVerLanguageChanged(){
		return verLangChanged;
	}
	
	public void setVerLanguageChanged(boolean isChanged){
		verLangChanged = isChanged;
	}
			
	public void setVerActive(boolean isActive) {
		verActive.setEnabled(!isActive);
	}
		
	public void addVersionsTabs() {
		tabbedPane.removeAll();
		int i = 1;
		int activeVerIndex = -1;
		for (Iterator it = versionsModel.getVersions().iterator(); it.hasNext();) {
			Version ver = (Version) it.next();
			if (versionsModel.getActiveVersionId() != null && versionsModel.getActiveVersionId().intValue() == ver.getId()) {
				activeVerIndex = i - 1;
			}
			tabbedPane.addTab("Version " + (i++),ver.getIcon(),new JPanel(new GridLayout(1, 1)),"Version id: " + ver.getId());
		}
		tabbedPane.setSelectedIndex(activeVerIndex);
	}
	
	public void refreshVersionsIcons(){
		questTable.repaint();
		int i =0;
		for (Iterator it = versionsModel.getVersions().iterator(); it.hasNext();++i) {
			Version ver = (Version) it.next();
			tabbedPane.setIconAt(i,ver.getIcon());			
		}
	}
	
	public void selectSortedQuestion(int viewRow){
		try {
			questTable.clearSelection();
			questTable.setRowSelectionInterval(viewRow, viewRow);
		} catch (Throwable e) {
			tabbedPane.removeAll();
		}		
	}
	
	public void selectUnsortedQuestion(int modelRow) {
		try{
			selectSortedQuestion(questTableSorter.viewIndex(modelRow));
		}catch(Throwable e){
			tabbedPane.removeAll();
		}
	}
	
	public void selectVersion(int versionIndex){
		try{
			versionsModel.clearSelection();
			versionsModel.setSelectedIndex(versionIndex);
		}catch(IndexOutOfBoundsException e){
			versionsModel.setSelectedIndex(0);
		}
	}
	
	private void selectSecondaryCategory(int row){
		try{
			secCatTable.clearSelection();
			secCatTable.setRowSelectionInterval(row,row);
		}catch(Throwable e){}
	}
	
	public void refreshVersionDates(){
		Version ver = versionsModel.getVersionByIndex(tabbedPane.getSelectedIndex());
		setVerCreatedText(new SimpleDateFormat("yyyy-MM-dd   HH:mm").format(ver.getCreated().getTime()));
		setVerUpdatedText(new SimpleDateFormat("yyyy-MM-dd   HH:mm").format(ver.getUpdated().getTime()));
	}

	private JComponent createMainPanel() {
		JPanel versionsPanel = new JPanel();
		versionsPanel.setLayout(new GridLayout(1, 1));
		tabbedPane = new JTabbedPane();
		tabbedPane.setModel(versionsModel);
		versionsPanel.add(tabbedPane);
		questVerSplitPane =	new JSplitPane(JSplitPane.VERTICAL_SPLIT,createQuestionsPanel(),versionsPanel);
		questVerSplitPane.setOneTouchExpandable(true);
		return questVerSplitPane;
	}

	private JPanel createQuestionsPanel() {
		JPanel questPanel = new JPanel();
		questPanel.setLayout(new BoxLayout(questPanel, BoxLayout.Y_AXIS));
		JPanel catNamePanel = new JPanel(new GridLayout(1, 1));
		catNamePanel.add(catName);
		JScrollPane jScrollPane1 = new JScrollPane(questTable);
		questPanel.add(catNamePanel);
		questPanel.add(jScrollPane1);
		return questPanel;
	}

	private JComponent createVersionPanel() {
		JSplitPane pane =
			new JSplitPane(
				JSplitPane.HORIZONTAL_SPLIT,
				createLeftVersionPanel(),
				controller.getVersionsPanel());
		pane.setOneTouchExpandable(true);
		return pane;
	}

	private JComponent createLeftVersionPanel() {
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		JPanel subCatsPanel = createSubCategoriesPanel();
		subCatsPanel.setAlignmentX(LEFT_ALIGNMENT);
		panel.add(subCatsPanel);
		JPanel detailsPanel = createDetailsPanel();
		detailsPanel.setAlignmentX(LEFT_ALIGNMENT);
		panel.add(detailsPanel);
		return panel;
	}

	private JPanel createSubCategoriesPanel() {
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		panel.setBorder(
			BorderFactory.createCompoundBorder(
				BorderFactory.createTitledBorder("Secondary Categories:"),
				BorderFactory.createEmptyBorder(5, 5, 5, 5)));
		panel.add(new JLabel("Drag from Categories Tree to add..."));
		JScrollPane jScrollPane = new JScrollPane(secCatTable);
		panel.add(jScrollPane);
		return panel;
	}

	private JPanel createDetailsPanel() {
		JPanel panel = new JPanel(new GridLayout(6, 2));
		panel.setBorder(
			BorderFactory.createCompoundBorder(
				BorderFactory.createTitledBorder("Version Details:"),
				BorderFactory.createEmptyBorder(5, 5, 5, 5)));
		panel.add(new JLabel("Version id:"));
		panel.add(verIdLabel);
		panel.add(new JLabel("Locked:"));
		panel.add(verIsLockedLabel);
		panel.add(new JLabel("Language"));
		panel.add(verLanguageText);
		panel.add(new JLabel("Active:"));
		panel.add(verActive);
		panel.add(new JLabel("Creation date: "));
		panel.add(verCreatedText);
		panel.add(new JLabel("Last modified: "));
		panel.add(verUpdatedText);
		return panel;
	}
	
	public List getSelectedQuestions(){
        List selectedQuestions = new LinkedList();
		ListSelectionModel model = questTable.getSelectionModel();
    	for(int i=model.getMinSelectionIndex();i<=model.getMaxSelectionIndex();++i){
    		if(model.isSelectedIndex(i)){
    			selectedQuestions.add(questTableModel.getQuestionAtRow(questTableSorter.modelIndex(i)));
        	}
        }
    	return selectedQuestions;
	}

	private void addListeners() {
		tabbedPane.addMouseListener(new MouseListener(){
			public void mouseClicked(MouseEvent e) {}
			public void mouseEntered(MouseEvent e) {}
			public void mouseExited(MouseEvent e) {}
			public void mousePressed(MouseEvent e) {}
			public void mouseReleased(MouseEvent e) {
				if (e.getButton() != 3) {
					return;
				}
				JPopupMenu tmenu = new JPopupMenu();
				Question quest;
				Version ver;
				try {
					quest =	questTableModel.getQuestionAtRow(questTableSorter.modelIndex(questTable.getSelectedRow()));
					ver = versionsModel.getSelectedVersion();
				} catch (Throwable e1) {
					return;
				}
				Vector v = controller.getVersionPopUpItems(quest, ver);
				for (Iterator it = v.iterator(); it.hasNext();) {
					tmenu.add((Component) it.next());
				}
				tmenu.show(tabbedPane, e.getX(), e.getY());		
			}
		});
		
		questTable.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				if (e.getValueIsAdjusting()) {
					return;
				}
				controller.finalizeScreenHandling();
				ListSelectionModel lsm = (ListSelectionModel) e.getSource();
				if(lsm.isSelectionEmpty()){
					selectUnsortedQuestion(lastSelectedQuestionIndex);
					return;
				}
				lastSelectedQuestionIndex = questTableSorter.modelIndex(lsm.getMinSelectionIndex());
				controller.questionSelected(lastSelectedQuestionIndex);
			}
		});
		
		verLanguageText.addKeyListener(new KeyListener(){
			public void keyPressed(KeyEvent arg0) {}
			public void keyReleased(KeyEvent arg0) {
				if (arg0.getKeyCode() == KeyEvent.VK_ESCAPE) {
					verLanguageText.setText(versionsModel.getSelectedVersion().getLanguage());
					verLangChanged = false;					
					return;
				}
				if(!GeneralParams.equalNullableStrings(verLanguageText.getText(),versionsModel.getSelectedVersion().getLanguage())){
					verLangChanged = true;
				}
			}
			public void keyTyped(KeyEvent arg0) {}
		});
		
		verLanguageText.addFocusListener(new FocusListener() {
			public void focusGained(FocusEvent arg0) {	}
			public void focusLost(FocusEvent e) {
				if(e.isTemporary()){
					return;
				}
				controller.finalizeScreenHandling();
			}
		});

		verActive.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				int selVer = tabbedPane.getSelectedIndex();
				if (selVer < 0) {
					return;
				}
				Version ver = versionsModel.getSelectedVersion();
				controller.versionSetAsActivePressed(ver);
			}
		});
		
		tabbedPane.getModel().addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent arg0) {
				if (tabbedPane.getSelectedIndex() < 0) {
					return;
				}
				controller.finalizeScreenHandling();
				JPanel activePanel =
					(JPanel) tabbedPane.getComponentAt(tabbedPane.getSelectedIndex());
				activePanel.add(oneVersionPanel);
				controller.versionSelected(tabbedPane.getSelectedIndex());
			}

		});
	}

	class SecCatTable extends JTable implements DndComponent, MouseListener {
		public SecCatTable() {
			new DndAdapter(this);
			addMouseListener(this);
			setDragEnabled(false);
		}

		public void drop(Point p, MedContainer c) {
			Question quest =questTableModel.getQuestionAtRow(questTableSorter.modelIndex(questTable.getSelectedRow()));
			for(Iterator iter = c.getIncludedObjects().iterator();iter.hasNext();){
				Category cat = (Category) iter.next();
				AbstractAction act = controller.getAddSecCatAction(cat, quest);
				act.actionPerformed(null);
			}
			secCatTableModel.fireTableDataChanged();
		}

		public String getToolTipText(MouseEvent event) {
			int secCatRow = secCatTable.rowAtPoint(event.getPoint());
			try {
				return secCatTableModel.getCategoryAtRow(secCatTableSorter.modelIndex(secCatRow)).getFullName();
			} catch (Throwable e) {
				return "";
			}
		}

		public void mouseReleased(MouseEvent e) {
			if (e.getButton() != 3) {
				return;
			}
			ListSelectionModel model = getSelectionModel(); 
	        if(model.isSelectionEmpty() || model.getMinSelectionIndex()==model.getMaxSelectionIndex()){
	        	selectSecondaryCategory(secCatTable.rowAtPoint(e.getPoint()));
	        }
	        List selectedSecCategories = new LinkedList();
	        JPopupMenu tmenu = new JPopupMenu();
	        try {
	        	for(int i=model.getMinSelectionIndex();i<=model.getMaxSelectionIndex();++i){
	        		if(model.isSelectedIndex(i)){
	        			selectedSecCategories.add(secCatTableModel.getCategoryAtRow(secCatTableSorter.modelIndex(i)));
	            	}
	            }
	        } catch (Throwable e1) {
	        	return;
	        }
            Vector v = controller.getSecCatPopUpItems(selectedSecCategories);
            for (Iterator it = v.iterator(); it.hasNext();) {
                tmenu.add((Component) it.next());
            }
            tmenu.show(this, e.getX(), e.getY());
		}

		public Component getComponent() {
			return this;
		}

		public MedContainer initDrag(Point p) {
			return null;
		}

		public int dragUnderFeedback(Point p, MedContainer container) {
			if (container.isOnlyOfClass(Category.class)) {
				return DnDConstants.ACTION_LINK;
			}
			return DnDConstants.ACTION_NONE;
		}

		public void undoDragUnderFeedback() {}
		public void dragFinalize() {}
		public void mouseClicked(MouseEvent e) {}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {	}
		public void mousePressed(MouseEvent e) {}

	}

	class QuestTable extends JTable	implements DndComponent,MouseListener {

		public QuestTable(){
			setDragEnabled(true);
			addMouseListener(this);
			new DndAdapter(this);
		}

		public void mouseReleased(MouseEvent e) {
			if (e.getButton() != 3) {
				return;
			}
			ListSelectionModel model = getSelectionModel(); 
	        if(model.isSelectionEmpty() || model.getMinSelectionIndex()==model.getMaxSelectionIndex()){
	        	selectSortedQuestion(questTable.rowAtPoint(e.getPoint()));
	        }
	        JPopupMenu tmenu = new JPopupMenu();
            Vector v = controller.getQuestPopUpItems(getSelectedQuestions());
            for (Iterator it = v.iterator(); it.hasNext();) {
                tmenu.add((Component) it.next());
            }
            tmenu.show(this, e.getX(), e.getY());
		}

		public String getToolTipText(MouseEvent event) {
			int questRow = questTable.rowAtPoint(event.getPoint());
			try {
				Question quest = questTableModel.getQuestionAtRow(questTableSorter.modelIndex(questRow)); 
				Category cat = CategoriesFactory.getInstance().getCategory(quest.getMainCategoryId());
				return "<html>Question Id: "+ quest.getId() + "<br>Main Category full path: " + cat.getFullName() + "<html>";
			} catch (Throwable e) {
				return "";
			}
		}

		public void mouseClicked(MouseEvent e) {}
		public void mouseEntered(MouseEvent e) {}
		public void mouseExited(MouseEvent e) {}
		public void mousePressed(MouseEvent e) {}

		public Component getComponent() {
			return this;
		}

		public MedContainer initDrag(Point p) {
			MedContainer container = new MedContainer();
			for(int i=0;i<getSelectedRows().length;++i){
				container.addObject(questTableModel.getQuestionAtRow(questTableSorter.modelIndex(getSelectedRows()[i])));
			}
			return container;
			
		}
		public int dragUnderFeedback(Point p, MedContainer container) {
			return 0;
		}

		public void undoDragUnderFeedback() {
		}

		public void drop(Point p, MedContainer container) {
		}

		public void dragFinalize() {
		}
	}
}
