/*
 * Created on 22/07/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.gui.panels;

import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestCategoryNode;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestCategoriesFactory;
import il.ac.technion.cs.course236308.e3.med.stats.ComputeColumnWidthDFS;
import il.ac.technion.cs.course236308.e3.med.stats.QuestionsStats;
import il.ac.technion.cs.course236308.e3.med.stats.StatisticData;
import il.ac.technion.cs.course236308.e3.med.stats.StudentsStats;

import java.awt.Color;
import java.awt.Font;
import java.awt.GridLayout;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.TreeSet;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.ListSelectionModel;
import javax.swing.table.AbstractTableModel;

import com.objectplanet.chart.BarChart;
import com.objectplanet.chart.Chart;
import com.objectplanet.chart.PieChart;


/**
 * @author svekant
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ChartPanels extends JPanel {
		
	// bar chart (2 series)
	public static JPanel getRoundedGradesStatPanel(int testId){
		

		String title = "Rounded Grades";
		int studentsNum = 0;
		int maxGrade = 0;
		
		QuestionsStats qs = StatisticData.getInstance().getQuestionsStats(testId);
		if(qs == null)
			return new JPanel();
		StudentsStats ss = qs.getStudentStats();
		
		if(ss == null)
			return new JPanel();
		studentsNum = ss.getNumStudents();
		maxGrade = (int) Math.round(ss.getMax());
		HashMap gradesHash = ss.getRoundedGradeHash();
		
		int size = gradesHash.keySet().size();
		String[] labels = new String[size];		
		double[] values = new double[2*size];;
		
		TreeSet ts = new TreeSet(gradesHash.keySet());
		int count = 0;
		int i = 0;
		for(Iterator it = ts.iterator();it.hasNext();){
			Integer lab = (Integer) it.next();
			values[2*i] = ((Integer)gradesHash.get(lab)).doubleValue();
			count += values[2*i];
			values[2*i + 1] = count;
			labels[i] = lab.toString();
			i++;
		}
		

		
		return getTwoLegensBarChart(labels, values, title,studentsNum,maxGrade);
		
		
	}	
	
	
	// slot diagram - bar chart with 4 series
	public static JPanel getTestGradesStatBarChartPanel(Test test){
		int testId = test.getId();
		String title = "Slots Diagram";
		int studentsNum = 0;
		
		QuestionsStats qs = StatisticData.getInstance().getQuestionsStats(testId);
		if(qs == null)
			return new JPanel();
		StudentsStats ss = qs.getStudentStats();
		
		if(ss == null)
			return new JPanel();
		studentsNum = ss.getNumStudents();
		
		double minGrade = test.getMinGrade();
		double maxGrade = test.getMaxGrade();
		double diff = (maxGrade-minGrade)/10;
		String[] labels = new String[10];		
		double[] values = new double[40];;
		
		int i = 0;
		while(minGrade < maxGrade){
			int[] grades;
			if(i == 9){ // last interval
				grades = ss.getRangeGradesInfo(minGrade,minGrade+diff+1);
			}else{
				grades = ss.getRangeGradesInfo(minGrade,minGrade+diff);
			}
			labels[i] = "[" + String.valueOf(Math.round(minGrade)) + "," + String.valueOf(minGrade+diff) + "]";
			values[4*i + 2] = grades[0];
			values[4*i + 3] = grades[1];
			
			values[4*i] = Math.round(grades[0]*100/studentsNum);
			values[4*i + 1] = Math.round(grades[1]*100/studentsNum);
				   
			i++;
			minGrade += diff;
		}
		
		return getFourLegensBarChart(labels, values, title,studentsNum,test.getPassingGrade());
		
	}	
	
	public static JPanel getTestStatisticPanel(int testId){
		JPanel panel = new JPanel();
		
		QuestionsStats qs = StatisticData.getInstance().getQuestionsStats(testId);
		if(qs == null)
			return new JPanel();
		StudentsStats ss = qs.getStudentStats();
		
		if(ss == null)
			return panel;
		
		
		String[] columnNames = {"Characteristic","Value","Description"};

		Object[][] data = {{"N:",new Integer(ss.getNumStudents()),"number of valid specimens"}, // 0
			       {"MIN:",doubleParser(ss.getMin()),"lowest value"},							// 1
			       {"MAX:",doubleParser(ss.getMax()),"largest value"},
			       {"Failed:",doubleParser(ss.getNumStudentsFailed()),"failed students number"},
			       {"Range:",doubleParser(ss.getRange()),"Max - Min"},
			       {"AVG:",new Double(0),"mean value"},											// 5
			       {"STD:",new Double(0),"standard deviation"},
				   {"ERR:",new Double(0),"standard error"},
			       {"STD/AVG:",new Double(0),"coefficient of variation"},
				   {"MED:",doubleParser(ss.Med(0.5)),"median"},
				   {"IMBAL:",new Double(0),"(median-average)/err"},								// 10
				   {"AV_MED:",new Double(0),"mean[Avg,mean[Q1,Q3]]"},
				   {"AVG/MAX:",new Double(0),""},
				   {"STD/Range:",new Double(0),""},												// 13
				   {"","",""},
				   {"Q1:",doubleParser(ss.Med(0.25)),"lower quartile"},
				   {"Q2:",doubleParser(ss.Med(0.5)),"median"},
				   {"Q3:",doubleParser(ss.Med(0.75)),"upper quartile"},
				   {"","",""},
				   {"D1:",doubleParser(ss.Med(0.1)),"1st dectile"},
				   {"D2:",doubleParser(ss.Med(0.2)),"2nd dectile"},
				   {"D3:",doubleParser(ss.Med(0.3)),"3rd dectile"},
				   {"D4:",doubleParser(ss.Med(0.4)),"4th dectile"},
				   {"D5:",doubleParser(ss.Med(0.5)),"5th dectile"},
				   {"D6:",doubleParser(ss.Med(0.6)),"6th dectile"},
				   {"D7:",doubleParser(ss.Med(0.7)),"7th dectile"},
				   {"D8:",doubleParser(ss.Med(0.8)),"8th dectile"},
				   {"D9:",doubleParser(ss.Med(0.9)),"9th dectile"},
				   };

		// override values that can be null
		Double avg = ss.getAverage();
		if(avg == null){
			data[5][1] = "N/A";
			data[11][1] = "N/A";// AV_MED
			data[12][1] = "N/A";// AVG/MAX
		}else{
			data[5][1] = doubleParser(avg.doubleValue());
			data[11][1] = doubleParser(avg.doubleValue()/2 + ss.Med(0.25)/4 + ss.Med(0.75)/4);
			data[12][1] = doubleParser(avg.doubleValue()/ss.getMax());
			
		}
		Double std = ss.getStd();		
		if(std == null){
			data[6][1] = "N/A";
			data[13][1] = "N/A";//STD/Range
		}else{
			data[6][1] = doubleParser(std.doubleValue());
			data[13][1] = doubleParser(std.doubleValue()/ss.getRange());
		}
		Double err = ss.getStandardError();
		if(err == null){
			data[7][1] = "N/A";
		}else{
			data[7][1] = doubleParser(err.doubleValue());
		}		
		// STD/AVG
		if(std == null || avg == null){
			data[8][1] = "N/A";
		}else{
			data[8][1] = doubleParser(std.doubleValue()/avg.doubleValue());
		}
		// IMBAL
		if(err == null || avg == null){
			data[10][1] = "N/A";
		}else{
			data[10][1] = doubleParser((ss.Med(0.5)-avg.doubleValue())/err.doubleValue());
		}
		

		JTable table = new JTable(); 
		table.setModel(new MyTableModel(data, columnNames));
		table.setBackground(new Color(204,204,204));
		table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		JScrollPane scrollPane = new JScrollPane(table);
		panel.add(scrollPane);	
		return panel;		
	}
	
	public static JPanel getOverallBarChart(String[] labels, double[] values, String title,Double overall){
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel,BoxLayout.Y_AXIS));
		BarChart chart = new BarChart();
		
		initChart(chart);
		chart.setTitle(title);
		chart.setTitleOn(true);
		chart.setSeriesCount(1);
		chart.setSampleCount(values.length);
		
		double min = 0;
		double max = 30;
		for(int i = 0; i < values.length ; i++){
			if(values[i] < min){
				min = values[i];
			}
			if(values[i] > max){
				max = values[i];
			}
		}
				
		chart.setRange(0,max);
		chart.setLowerRange(0,min);

		chart.setBarAlignment(BarChart.HORIZONTAL);
		
		chart.setBarLabels(labels);
		chart.setSampleValues(0, values);
		if(overall != null)
			chart.setTargetValueLine("Norm.Grade",doubleParser(overall.doubleValue()).doubleValue(),Color.RED,Chart.TARGET_LINE_ID_AND_VALUE_LABEL);

		JLabel lab = new JLabel("* All values are multiplied by 100 for better visualization reason.");
		Font font = new Font("DIALOG", Font.ITALIC, 12);
		lab.setFont(font);
		 		
		panel.add(chart);
		panel.add(lab);
			
			
		return panel;
		
	}
	
	public static JPanel getTwoLegensBarChart(String[] labels, double[] values, String title,int studentsNum,int maxGrade){
		int factor = 2;
		JPanel panel = new JPanel();
		BarChart chart = new BarChart();
		
		initChart(chart);		
		chart.setTitle(title);
		chart.setTitleOn(true);
		chart.setSeriesCount(factor);

		chart.setSampleCount(maxGrade+1);
		String[] legends = {"Specimens","Accumulated"};
		Color[] colors = {new Color(251,197,60), new Color(208,144,251)};
		chart.setLegendLabels(legends);
		chart.setLegendColors(colors);
		chart.setSampleColors(colors);

		chart.setValueLabelsOn(true);
		chart.setMultiSeriesOn(true);
		chart.setRange(0, studentsNum + 1);		
		chart.setValueLabelStyle(BarChart.VALUE_LABELS_FLOATING);
		chart.set3DDepth(3);	
					
		double[] values_0 = new double[values.length / factor];
		double[] values_1 = new double[values.length / factor];
		for(int i = 0; i < values_0.length; i++){
			values_0[i] = values[(i * factor) + 0];
			values_1[i] = values[(i * factor) + 1];
		}
		
		for(int j = 0, k = 0, i = 0; j <= maxGrade; j++){
			if((k < labels.length)&& (j == new Integer(labels[k]).intValue())){
				chart.setSampleValue(0,j,values_0[i]);
				chart.setSampleValue(1,j,values_1[i]);
				chart.setSampleLabel(j, labels[k]);
				i++;
				k++;
			}
			else{
				chart.setSampleValue(0,j,0);
				chart.setSampleValue(1,j,0);
			}
						
		}
			
		panel.add(chart);
	
		return panel;
	
	}
	
	public static JPanel getFourLegensBarChart(String[] labels, double[] values, String title,int studentsNum, int overall){
		int factor = 4;
		JPanel panel = new JPanel();
		BarChart chart = new BarChart();
		
		initChart(chart);		
		chart.setTitle(title + "\n Passing grade is " + overall);
		chart.setTitleOn(true);
		chart.setSeriesCount(factor);
		chart.setSampleCount(values.length/factor);
		chart.setValueLabelsOn(true);
				
		chart.setBarLabels(labels);
		String[] legends = {"Percentage","Percentage\n(Accumulated)","Specimens","Specimens\n(Accumulated)"};
		Color[] colors = {new Color(153,153,255),new Color(0,153,153),new Color(255,102,204),new Color(255,153,102)};
		chart.setLegendLabels(legends);
		chart.setLegendColors(colors);
		chart.setSampleColors(colors);
		chart.setRangeOn(1,true);
		chart.setRange(1, studentsNum + 5);
		chart.setMultiSeriesOn(true);
		chart.setValueLabelStyle(BarChart.VALUE_LABELS_FLOATING);
		double[] values_0 = new double[values.length / factor];
		double[] values_1 = new double[values_0.length];
		double[] values_2 = new double[values_0.length];
		double[] values_3 = new double[values_0.length];
		for(int i = 0; i < values_0.length; i++){
			values_0[i] = values[(i * factor) + 0];
			values_1[i] = values[(i * factor) + 1];
			values_2[i] = values[(i * factor) + 2];
			values_3[i] = values[(i * factor) + 3];
		}
		chart.setSampleValues(0, values_0);
		chart.setSampleValues(1, values_1);
		chart.setSampleValues(2, values_2);
		chart.setSampleValues(3, values_3);
		chart.setSeriesRange(2,1);
		chart.setSeriesRange(3,1);

		
		panel.add(chart);

		return panel;
	
	}
	
	public static JPanel getPieChart(String[] labels, double[] values, String title){
			if(labels.length == 0)
				return getNotAvailableStatPanel();
			JPanel panel = new JPanel();
			panel.setLayout(new GridLayout(1,1));
		
			PieChart chart = new PieChart();
				
			chart.setSampleCount(values.length);
			chart.setSampleValues(0,values);
			chart.setTitle(title);
			chart.setTitleOn(true);
			chart.setSampleLabels(labels);
			chart.setSampleLabelsOn(true);
			chart.setBackground(new Color(204,204,204));
			chart.setSampleScrollerOn(true);
			chart.setSampleLabels(labels);
			chart.setSampleLabelsOn(true);
			chart.setValueLabelStyle(PieChart.FLOATING);
			chart.setValueLabelsOn(true);
			chart.setFloatingOnLegendOn(true);
			chart.setPercentLabelsOn(true);
			chart.setSelectionStyle(PieChart.SELECTION_STYLE_DETACHED);
			chart.setPercentLabelStyle(PieChart.INSIDE);
			chart.setPercentLabelsOn(true);
			chart.setLegendOn(true);
			chart.set3DDepth(5);
			chart.set3DModeOn(true);

			panel.add(chart);			
			return panel;
		}
	
	public static JPanel getTestGradesStatisticPanel(int testId){
		JPanel panel = new JPanel();
		panel.setLayout(new GridLayout(1,1));
		
		QuestionsStats qs = StatisticData.getInstance().getQuestionsStats(testId);
		if(qs == null)
			return new JPanel();
		StudentsStats ss = qs.getStudentStats();		
		if(ss == null)
			return new JPanel();
			
		int studentsNum = ss.getNumStudents();
		
		String[] columnNames = {"Student's ID",
				"Exam's number",
				"Number of correct answers ",
				"Grade",
				"Normalized grade",
				"Dectile (1-10)",
				"Rank"};
		
		JTable table = new JTable(); 
		Object[][] data = new Object[studentsNum][columnNames.length];
		TreeSet studIds = ss.getStudentIds();
		int i = 0;
		for(Iterator it = studIds.iterator();it.hasNext();){

			String studId = (String)it.next();
			data[i][0] = studId;
			data[i][1] = new Integer(testId);
			data[i][2] = new Integer(ss.getNumCorrectAnswers(studId));
			data[i][3] = doubleParser(ss.getStudentGrade(studId));
			
			Double norm = ss.getStudentNormalizedGrade(studId);
			
			if(norm == null || norm.isNaN()){
				data[i][4] = new String("N/A");
			}else{
				data[i][4] = doubleParser(norm.doubleValue());				
			}
			if(studentsNum < 30){
				data[i][5] = new String("N/A");
			}else{
				data[i][5] = new Integer(ss.getStudentDectile(studId));
			}
			data[i][6] = new Integer(ss.getStudentRank(studId));
			i++;
		}
		table.setModel(new MyTableModel(data, columnNames));
		table.setBackground(new Color(255,255,255));
		table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		JScrollPane scrollPane = new JScrollPane(table);
		panel.add(scrollPane);
		
		return panel;
	}
	
	public static JPanel getTestStudentsTableStatisticPanel(Test test){
		
		JPanel panel = new JPanel();
		//return panel;
		
		panel.setLayout(new GridLayout(1,1));
		
		QuestionsStats qs = StatisticData.getInstance().getQuestionsStats(test.getId());
		if(qs == null)
			return new JPanel();
		StudentsStats ss = qs.getStudentStats();		
		if(ss == null)
			return new JPanel();
			
		int studentsNum = ss.getNumStudents();
		
		ArrayList nodesDfsOrdered = new ArrayList();
		ComputeColumnWidthDFS cwDfs = new ComputeColumnWidthDFS(ss, nodesDfsOrdered);
		cwDfs.dfs(TestCategoriesFactory.getInstance().getTestCategoryNode("/",test));
		
		ArrayList tableHeader = new ArrayList();
		tableHeader.add("Student ID");
		tableHeader.add("Grade");
		
		for(Iterator it = nodesDfsOrdered.iterator();it.hasNext();){
			TestCategoryNode node = (TestCategoryNode)it.next();
			String catName = node.getTestCategory().getLongName();
			tableHeader.add(catName);
			if (!node.isLeaf()){
				tableHeader.add(catName + " + sub-categories");
			}	
		}
		
		String[] columnNames = new String[tableHeader.size()];
		tableHeader.toArray(columnNames);
		JTable table = new JTable(); 
		Object[][] data = new Object[studentsNum][columnNames.length];
		TreeSet studIds = ss.getStudentIds();
		int i = 0;
		for(Iterator it = studIds.iterator();it.hasNext();){
			String studId = (String)it.next();
			data[i][0] = studId;
			data[i][1] = doubleParser(ss.getStudentGrade(studId));
			
			List studStats = ss.getStudentCategoriesRow(studId,nodesDfsOrdered);
			
			int j = 2;
			for(Iterator it2 = studStats.iterator();it2.hasNext();){
				Double value = (Double)it2.next();
				if(value == null){
					data[i][j] = new String("N/A");
				}else{
					data[i][j] = doubleParser(value.doubleValue());
				}
				j++;
			}
		}				
		table.setModel(new MyTableModel(data, columnNames));
		table.setBackground(new Color(204,204,204));
		table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		JScrollPane scrollPane = new JScrollPane(table);
		panel.add(scrollPane);
		
		return panel;
		
	}
	
	
	public static JPanel getTestStudentBarChartPanel(Test test,String studId){		
		QuestionsStats qs = StatisticData.getInstance().getQuestionsStats(test.getId());
		if(qs == null)
			return new JPanel();
		StudentsStats ss = qs.getStudentStats();		
		if(ss == null)
			return new JPanel();
					
		ArrayList nodesDfsOrdered = new ArrayList();
		ComputeColumnWidthDFS cwDfs = new ComputeColumnWidthDFS(ss, nodesDfsOrdered);
		cwDfs.dfs(TestCategoriesFactory.getInstance().getTestCategoryNode("/",test));
		
		ArrayList categories = new ArrayList();	
		ArrayList values = new ArrayList();
		
		List studStats = ss.getStudentCategoriesRow(studId,nodesDfsOrdered);		
		Iterator it = studStats.iterator();
		int i = 0;
		for(Iterator it2 = nodesDfsOrdered.iterator();it2.hasNext();){
			if(!it.hasNext())
				break;
			TestCategoryNode node = (TestCategoryNode)it2.next();
			
			Double value = (Double)it.next();
			String catName = node.getTestCategory().getLongName();
			
			if(value != null){
				values.add(value);
				categories.add(catName);
			}
			
			if (!node.isLeaf()){
				it.next();
			}
			i++;	
		}
		
		 
		double[] valArray = new double[values.size()];
		int k = 0;
		if(values.size() != 0){
			for(Iterator iter = values.iterator();iter.hasNext();){
				Double val = (Double)iter.next();
				valArray[k] = doubleParser(val.doubleValue()).doubleValue()*100;
				k++;
			}
		}
		
		Double overall = ss.getStudentNormalizedGrade(studId);
		if(overall != null){
			overall = new Double(overall.doubleValue()*100);
		}
		
		
		String[] catArray = new String[categories.size()];
		categories.toArray(catArray);
		return getOverallBarChart(catArray, 
									valArray, 
									"Student ID : " + studId,
									overall);		
		
	}
	
	
	
	
	public static JPanel getTestQuestionsPointsPiePanel(Test test){
		
		JPanel panel = new JPanel();
		panel.setLayout(new GridLayout(1,1));
		
		QuestionsStats qs = StatisticData.getInstance().getQuestionsStats(test.getId());
		if(qs == null)
			return new JPanel();
		StudentsStats ss = qs.getStudentStats();		
		if(ss == null)
			return new JPanel();
					
		ArrayList nodesDfsOrdered = new ArrayList();
		ComputeColumnWidthDFS cwDfs = new ComputeColumnWidthDFS(ss, nodesDfsOrdered);
		cwDfs.dfs(TestCategoriesFactory.getInstance().getTestCategoryNode("/",test));
		
		ArrayList categories = new ArrayList();	
		ArrayList values = new ArrayList();
		
		for(Iterator it2 = nodesDfsOrdered.iterator();it2.hasNext();){
					
			TestCategoryNode node = (TestCategoryNode)it2.next();
			Double value = doubleParser(node.getPercentOfWeightCatOnly().doubleValue());
				
			String catName = node.getTestCategory().getLongName();
			if(value != null){
				categories.add(catName);
				values.add(value);
			}				
		}
		String[] catArray = new String[categories.size()];
		categories.toArray(catArray);
		double[] valArray = new double[values.size()];
		
		int i = 0;
		for(Iterator it = values.iterator();it.hasNext();){
			valArray[i] = doubleParser(((Double)it.next()).doubleValue()).doubleValue();
			i++;
		}

		return  getPieChart(catArray,valArray, "Categories points");
	}
	

	public static JPanel getQuestionStatGeneralInfo(Test test){
		
		JPanel highPanel = new JPanel();
		JPanel middlePanel = new JPanel();
		JPanel lowPanel = new JPanel();
		
		// highPanel
		highPanel.setBorder(BorderFactory.createCompoundBorder
                (BorderFactory.createTitledBorder("Correct replies per question : "), 
                 BorderFactory.createEmptyBorder(5,5,5,5)));              
		highPanel.setLayout(new GridLayout(1,1));
		QuestionsStats qs;		
		qs = StatisticData.getInstance().getQuestionsStats(test.getId());
		if(qs == null)
			return new JPanel();
						
		String[] columnNames = {"Characteristic",
								"Value"};
		
		JTable table = new JTable(); 
		Object[][] data = new Object[4][columnNames.length];
		
		data[0][0] = "AVG";
		Double avgQst = qs.getAvgNumCorrectRepliesPerQuestion();
		if(avgQst == null){
			data[0][1] = "N/A";
		}else{
			data[0][1] = doubleParser(avgQst.doubleValue());	
		}
			
		data[1][0] = "STD";
		Double stdQst = qs.getStdNumCorrectRepliesPerQuestion();
		if(stdQst == null){
			data[1][1] = "N/A";
		}else{
			data[1][1] = doubleParser(stdQst.doubleValue());	
		}
					
		data[2][0] = "Low Third Num";	
		data[2][1] = doubleParser(qs.getLowThirdNumCorrectRepliesPerQuestion());		
		data[3][0] = "High Third Num";
		data[3][1] = doubleParser(qs.getHighThirdNumCorrectRepliesPerQuestion());
		
		table.setModel(new MyTableModel(data, columnNames));
		table.setBackground(new Color(255,255,255));
		table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		JScrollPane scrollPane = new JScrollPane(table);
		highPanel.add(scrollPane);
		
		
		//		middlePanel
		middlePanel.setBorder(BorderFactory.createCompoundBorder
					 (BorderFactory.createTitledBorder("Correct replies per student : "), 
					  BorderFactory.createEmptyBorder(5,5,5,5)));              
		middlePanel.setLayout(new GridLayout(1,1));			 				
		String[] columnNamesMiddle = {"Characteristic",
									 "Value"};
		
		JTable tableMiddle = new JTable(); 
		Object[][] dataMiddle = new Object[4][columnNamesMiddle.length];
		
		dataMiddle[0][0] = "AVG";
		Double avgSt = qs.getAvgRightAnswersPerStudent();
		if( avgSt == null){
			dataMiddle[0][1] = "N/A";
		}else{
			dataMiddle[0][1] = doubleParser(avgSt.doubleValue());	
		}
			
		dataMiddle[1][0] = "STD";
		Double astdSt = qs.getStdRightAnswersPerStudent();
		if(astdSt == null){
			dataMiddle[1][1] = "N/A";
		}else{
			dataMiddle[1][1] = doubleParser(astdSt.doubleValue());	
		}
					
		dataMiddle[2][0] = "Low Third Num";	
		dataMiddle[2][1] = doubleParser(qs.getLowThirdRightAnswersPerStudent());		
		dataMiddle[3][0] = "High Third Num";
		dataMiddle[3][1] = doubleParser(qs.getHighThirdRightAnswersPerStudent());
		
		tableMiddle.setModel(new MyTableModel(dataMiddle, columnNamesMiddle));
		tableMiddle.setBackground(new Color(255,255,255));
		tableMiddle.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		JScrollPane scrollPaneMiddle = new JScrollPane(tableMiddle);
		middlePanel.add(scrollPaneMiddle);
				
		
		// low panel 
		lowPanel.setBorder(BorderFactory.createCompoundBorder
                (BorderFactory.createTitledBorder("Heuristics : "), 
                 BorderFactory.createEmptyBorder(5,5,5,5)));              
		lowPanel.setLayout(new BoxLayout(lowPanel,BoxLayout.X_AXIS));
		JPanel labelsPanel = new JPanel();
		labelsPanel.setLayout(new BoxLayout(labelsPanel,BoxLayout.Y_AXIS));
		labelsPanel.add(new JLabel("Num. of heuristics:    "));
		labelsPanel.add(new JLabel("Num. versions without heuristics: "));
		JPanel numbersPanel = new JPanel();
		numbersPanel.setLayout(new BoxLayout(numbersPanel,BoxLayout.Y_AXIS));
		numbersPanel.add(new JLabel(String.valueOf(qs.getTotalNumRemarks())));
		numbersPanel.add(new JLabel(String.valueOf(qs.getNumQuestionsWithoutRemarks())));
		lowPanel.add(labelsPanel);
		lowPanel.add(numbersPanel);
		
		JPanel panel = new JPanel(new GridLayout(3,1));		
/*		panel.setBorder(BorderFactory.createCompoundBorder
                (BorderFactory.createTitledBorder("General info : "), 
                 BorderFactory.createEmptyBorder(5,5,5,5)));
*/		
		panel.add(highPanel);
		panel.add(middlePanel);
		panel.add(lowPanel);
				
		return panel;
		
	}
	
	
	public static JPanel getVersionHeuristicPanel(int testId,int verId){
		JPanel panel = new JPanel(new GridLayout(1,1));
		panel.setBorder(BorderFactory.createCompoundBorder
                (BorderFactory.createTitledBorder("Version "+ verId + " heuristic : "), 
                 BorderFactory.createEmptyBorder(5,5,5,5)));
		
		QuestionsStats qs;
		qs = StatisticData.getInstance().getQuestionsStats(testId);
		if(qs == null)
			return new JPanel();
		String showRemarks = qs.getRemarks(verId).replaceAll("\\.\\s*",".\n\r");
		JTextArea ta = new JTextArea(showRemarks);
		ta.setRows(4);
		ta.setEditable(false);
		ta.setBackground(new Color(255,255,255));
		panel.add(new JScrollPane(ta));
		
		return panel;
	}

	public static JPanel getNotAvailableStatPanel(){
		 JPanel panel = new JPanel();
		 JLabel lab = new JLabel("<html><center>No statistics are available. <br>Probably the exam status is \"UNDER CONSTRACTION\".</center></html>");
		 panel.add(lab);
		 return panel;
	}
	
	private static void initChart(BarChart chart){
		chart.setBackground(new Color(204,204,204));
		chart.setMultiColorOn(true);
		chart.setLegendOn(true);
		chart.set3DModeOn(true);
		chart.setBarLabelsOn(true);
		chart.setValueLabelsOn(true);
		chart.setChartBackground(new Color(204,204,204));
		chart.setSampleScrollerOn(true);
		chart.setFloatingOnLegendOn(true);
		chart.setLegendOn(true);
		chart.set3DModeOn(true);
	}
	
	public static Double doubleParser(double value){
		return new Double((double)Math.round(value * 100)/100);
	}
	
	public static class MyTableModel extends AbstractTableModel {
		String[] columnNames;
		Object[][] data;
		public MyTableModel(){
		}
		public MyTableModel(Object[][] aData, String[] aColumnNames){
			columnNames = aColumnNames;
			data = aData;
		}
		public int getColumnCount() {
        	return columnNames.length;
	    }
	    public int getRowCount() {
	        return data.length;
	    }
	    public String getColumnName(int col) {
	        return columnNames[col];
	    }
	    public Object getValueAt(int row, int col) {
	        return data[row][col];
	    }
		public boolean isCellEditable(int row, int col){
			return false;
		}
	}

}
