/*
 * Created on Jul 13, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.gui.panels;


import il.ac.technion.cs.course236308.e3.med.control.controllers.TestGradingPolicyController;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.GradingTestAnswersTableModel;
import il.ac.technion.cs.course236308.e3.med.model.Test;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.DefaultCellEditor;
import javax.swing.DefaultSingleSelectionModel;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;



/**
 * @author shralex
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class GradingPolicyPanel  extends JPanel {
	private TestGradingPolicyController controller;
	
	private JTextField factorATxt = new JTextField();
	private JTextField factorBTxt = new JTextField();
	private JTextField passThersholdTxt = new JTextField();
	private JTextField minGradeTxt = new JTextField();
	private JTextField maxGradeTxt = new JTextField();
	private JLabel examId = new JLabel();
	private JLabel studentsNum = new JLabel();
	private JLabel failedPercent = new JLabel();
	private JTabbedPane tabbedPane;
	private JTable gradingTvTable; 
	
	JPanel statisticsPanel = new JPanel();
	
	private GradingTestAnswersTableModel grModel;
	
	public GradingPolicyPanel(TestGradingPolicyController controller, GradingTestAnswersTableModel grModel){
		this.controller = controller;
		this.grModel = grModel;
	}
	
	public void init(){
		this.setLayout(new GridLayout(1,1));
		this.add(createMainPanel());
		addListeners();
	}
	
	private JComponent createMainPanel(){
		statisticsPanel.setLayout(new GridLayout(1,1));
		tabbedPane = new JTabbedPane();
		tabbedPane.setModel(new DefaultSingleSelectionModel());
		tabbedPane.setTabPlacement(JTabbedPane.BOTTOM);
		tabbedPane.addTab("Exam Statistics",createExamStatisticsPanel());
		tabbedPane.addTab("Grades List",createGradesListPanel());					
		statisticsPanel.add(tabbedPane);
		double height = java.awt.Toolkit.getDefaultToolkit().getScreenSize().getHeight();
		JSplitPane pane2 = new JSplitPane(JSplitPane.VERTICAL_SPLIT,
									createGradingTablePanel(), statisticsPanel);
		pane2.setOneTouchExpandable(true);
		pane2.setDividerLocation((int)height/4);
							
		JSplitPane pane = new JSplitPane(JSplitPane.VERTICAL_SPLIT,
									createFactorPanel(), pane2);
		pane.setOneTouchExpandable(true);
		pane.setDividerLocation((int)height/9);						
		return pane;
	}
	
	private JPanel createGradingTablePanel(){
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		gradingTvTable = new JTable(grModel){ 
		public TableCellRenderer getCellRenderer(int row, int column) { 
			return grModel.getCellRenderer(); 
		} 
		}; 

		gradingTvTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		gradingTvTable.setPreferredScrollableViewportSize(new Dimension(350, 350));
		//gradingTvTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		gradingTvTable.setRowSelectionAllowed(false);
		gradingTvTable.setColumnSelectionAllowed(false);
		TableColumn column = null;
		for (int i = 0; i < 2; i++) {
			column = gradingTvTable.getColumnModel().getColumn(i);
			column.setMinWidth(50);
			column.setPreferredWidth(60);
		}
		gradingTvTable.getColumnModel().getColumn(2).setMinWidth(200);
		gradingTvTable.getColumnModel().getColumn(2).setPreferredWidth(200);
		for (int j = 3; j < grModel.getColumnCount(); j++) {
			column = gradingTvTable.getColumnModel().getColumn(j);
			column.setMinWidth(60);
			column.setPreferredWidth(60);
		}
		for (int k=4; k<34; k = k+3){
			column = gradingTvTable.getColumnModel().getColumn(k);
			JComboBox comboBox = new JComboBox();
			for (int k1 = 0; k1<=100; k1 = k1+10){
				comboBox.addItem(k1 + "%");
			}
			column.setCellEditor(new DefaultCellEditor(comboBox));

		}
		
		JScrollPane jScrollPane = new JScrollPane(gradingTvTable);
		jScrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		
		panel.add(jScrollPane);
		
		JLabel comment1 = new JLabel(" *  P1 - num. of students that chose the answer out of students that took the test.");
		Font font = new Font("DIALOG", Font.ITALIC, 12);
		comment1.setFont(font);
		JLabel comment2 = new JLabel("**  P2 - num. of students that chose the answer out of students that answered this question.");
		comment2.setFont(font);
		
		panel.add(comment1);
		panel.add(comment2);
				
		return panel;
	}
	private JPanel createFactorPanel(){
		JPanel panel = new JPanel();
		GridLayout layout = new GridLayout(2,4,15,5);
		panel.setLayout(layout);
		panel.setBorder(BorderFactory.createCompoundBorder
				  (BorderFactory.createTitledBorder("Exam Grading Policy"), 
				   BorderFactory.createEmptyBorder(5,5,5,5)));
		JPanel examIdPanel = new JPanel();
		examIdPanel.setLayout(new BoxLayout(examIdPanel,BoxLayout.X_AXIS));
		examIdPanel.add(new JLabel("Exam ID : "));
		examIdPanel.add(examId);
		panel.add(examIdPanel);
		JPanel numStudentsPanel = new JPanel();
		numStudentsPanel.setLayout(new BoxLayout(numStudentsPanel,BoxLayout.X_AXIS));
		numStudentsPanel.add(new JLabel("Students number    :  "));
		numStudentsPanel.add(studentsNum);
		panel.add(numStudentsPanel);
		JPanel factorFormulaPanel = new JPanel();
		factorFormulaPanel.setLayout(new BoxLayout(factorFormulaPanel,BoxLayout.X_AXIS));
		factorFormulaPanel.add(new JLabel("Factor :    "));
		/*
			factorATxt.setHorizontalAlignment(JTextField.RIGHT);
			factorBTxt.setHorizontalAlignment(JTextField.RIGHT);
			minGradeTxt.setHorizontalAlignment(JTextField.RIGHT);
			maxGradeTxt.setHorizontalAlignment(JTextField.RIGHT);
			passThersholdTxt.setHorizontalAlignment(JTextField.RIGHT);
		*/
		factorFormulaPanel.add(factorATxt);
		factorFormulaPanel.add(new JLabel("*x + "));
		factorFormulaPanel.add(factorBTxt);
		panel.add(factorFormulaPanel);
		JPanel minGradePanel = new JPanel();
		minGradePanel.setLayout(new BoxLayout(minGradePanel,BoxLayout.X_AXIS));
		minGradePanel.add(new JLabel("Min grade :    "));
		minGradePanel.add(minGradeTxt);
		panel.add(minGradePanel);
		panel.add(new JLabel(""));
		JPanel failedPanel = new JPanel();
		failedPanel.setLayout(new BoxLayout(failedPanel,BoxLayout.X_AXIS));
		failedPanel.add(new JLabel("Students failed(%)   :  "));
		failedPanel.add(failedPercent);
		panel.add(failedPanel);
		JPanel passthrPanel = new JPanel();
		passthrPanel.setLayout(new BoxLayout(passthrPanel,BoxLayout.X_AXIS));
		passthrPanel.add(new JLabel("Pass threshold : "));
		passthrPanel.add(passThersholdTxt);
		panel.add(passthrPanel);	
		JPanel maxGradePanel = new JPanel();
		maxGradePanel.setLayout(new BoxLayout(maxGradePanel,BoxLayout.X_AXIS));
		maxGradePanel.add(new JLabel("Max grade :   "));
		maxGradePanel.add(maxGradeTxt);
		panel.add(maxGradePanel);
		return panel;
	}
	
	private JComponent createExamStatisticsPanel(){
		Test test = controller.getTest();
		
		if(test == null || test.getStatus().equals("U")){		
			return ChartPanels.getNotAvailableStatPanel();
		}
		
		JPanel highPanel1;
		highPanel1 = ChartPanels.getTestStatisticPanel(controller.getTest().getId());
		highPanel1.setLayout(new GridLayout(1,1));
		JPanel highPanel2;
		highPanel2 = ChartPanels.getTestGradesStatBarChartPanel(controller.getTest());
		highPanel2.setLayout(new GridLayout(1,1));
		JSplitPane pane2 = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,
							highPanel1, highPanel2);      			
		pane2.setDividerLocation(400); 	        
		return pane2;
	}
	
	private JPanel createGradesListPanel(){
		Test test = controller.getTest();
		if(test == null || test.getStatus().equals("U")){		
			return ChartPanels.getNotAvailableStatPanel();
		}
		
		JPanel panel = null;		
		panel = ChartPanels.getTestGradesStatisticPanel(controller.getTest().getId());
		panel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
		return panel;		
	}
	
	public void setFactorAText(double a){
		factorATxt.setText(Double.toString(a));
	}
	
	public void setFactorBText(double b){
		factorBTxt.setText(Double.toString(b));
	}
	
	public void setMinGradeText(int grade){
		minGradeTxt.setText(Integer.toString(grade));
	}
	
	public void setMaxGradeText(int grade){
		maxGradeTxt.setText(Integer.toString(grade));
	}
	
	public void setThreshGradeText(int grade){
		passThersholdTxt.setText(Integer.toString(grade));
	}
	public void setTestId(int id){
		examId.setText(Integer.toString(id));
	}

	public void setNumStudents(int num){
		studentsNum.setText(Integer.toString(num));
	}
	
	public void setStudentsFailed(Double val, int studNum){
		if(val == null || studNum == 0){
			failedPercent.setText("N/A");
		}else{
			double perc = (val.doubleValue()*100)/studNum;
			long percLong = Math.round(perc);
			failedPercent.setText(String.valueOf(percLong));
		}	
	}
	
	public void setStatistics(){
		tabbedPane.removeAll();
		tabbedPane.addTab("Exam Statistics",createExamStatisticsPanel());
		tabbedPane.addTab("Grades List",createGradesListPanel());	
	}
	public Double parseDouble(String text){
		try {
			return (new Double(text));	
		} catch(NumberFormatException e){}
		return null;
	}
	
	public Integer parseInt(String text){
		try {
			return (new Integer(text));	
		} catch(NumberFormatException e){}
		return null;
	}

	
	private void addListeners(){
		factorATxt.addKeyListener(new KeyListener(){
			public void keyPressed(KeyEvent arg0) {
				if(arg0.getKeyCode()==KeyEvent.VK_ESCAPE){
					setFactorAText(controller.getTest().getFactorConstA()); 
				}				
			}
			public void keyReleased(KeyEvent arg0) {}
			public void keyTyped(KeyEvent arg0) {}
		});
        
		factorATxt.addFocusListener(new FocusListener(){
			public void focusGained(FocusEvent arg0) {}
			public void focusLost(FocusEvent arg0) {
				Double val = parseDouble(factorATxt.getText());
				if (val == null){
					JOptionPane.showMessageDialog
							(controller.getMainWindow(), "Factor parameters must be floating-point values", "Error",JOptionPane.ERROR_MESSAGE);
					setFactorAText(controller.getTest().getFactorConstA());
					return;		
				}	
				controller.factorAChanged(val.doubleValue());				
			}
		});

		factorBTxt.addKeyListener(new KeyListener(){
			public void keyPressed(KeyEvent arg0) {
				if(arg0.getKeyCode()==KeyEvent.VK_ESCAPE){
					setFactorBText(controller.getTest().getFactorConstB()); 
				}				
			}
			public void keyReleased(KeyEvent arg0) {}
			public void keyTyped(KeyEvent arg0) {}
		});
        
		factorBTxt.addFocusListener(new FocusListener(){
			public void focusGained(FocusEvent arg0) {}
			public void focusLost(FocusEvent arg0) {
				Double val = parseDouble(factorBTxt.getText());
				if (val == null){
					JOptionPane.showMessageDialog
							(controller.getMainWindow(), "Factor parameters must be floating-point values", "Error",JOptionPane.ERROR_MESSAGE);
					setFactorBText(controller.getTest().getFactorConstB());
					return;		
				}	
				controller.factorBChanged(val.doubleValue());				
			}
		});
        
		passThersholdTxt.addKeyListener(new KeyListener(){
			public void keyPressed(KeyEvent arg0) {
				if(arg0.getKeyCode()==KeyEvent.VK_ESCAPE){
					setThreshGradeText(controller.getTest().getPassingGrade()); 
				}				
			}
			public void keyReleased(KeyEvent arg0) {}
			public void keyTyped(KeyEvent arg0) {}
		});
        
		passThersholdTxt.addFocusListener(new FocusListener(){
			public void focusGained(FocusEvent arg0) {}
			public void focusLost(FocusEvent arg0) {
				Integer val = parseInt(passThersholdTxt.getText());
				if (val == null){
					JOptionPane.showMessageDialog
							(controller.getMainWindow(), "Pass Threshold must be an integer value", "Error",JOptionPane.ERROR_MESSAGE);
					setThreshGradeText(controller.getTest().getPassingGrade());
					return;		
				}	
				controller.passGradeChanged(val.intValue());				
			}
		});
		
		minGradeTxt.addKeyListener(new KeyListener(){
			public void keyPressed(KeyEvent arg0) {
				if(arg0.getKeyCode()==KeyEvent.VK_ESCAPE){
					setMinGradeText(controller.getTest().getMinGrade()); 
				}				
			}
			public void keyReleased(KeyEvent arg0) {}
			public void keyTyped(KeyEvent arg0) {}
		});
        
		minGradeTxt.addFocusListener(new FocusListener(){
			public void focusGained(FocusEvent arg0) {}
			public void focusLost(FocusEvent arg0) {
				Integer val = parseInt(minGradeTxt.getText());
				if (val == null){
					JOptionPane.showMessageDialog
							(controller.getMainWindow(), "Min/Max grades must be integer values", "Error",JOptionPane.ERROR_MESSAGE);
					setMinGradeText(controller.getTest().getMinGrade());
					return;		
				}	
				controller.minGradeChanged(val.intValue());				
			}
		});
		maxGradeTxt.addKeyListener(new KeyListener(){
			public void keyPressed(KeyEvent arg0) {
				if(arg0.getKeyCode()==KeyEvent.VK_ESCAPE){
					setMaxGradeText(controller.getTest().getMaxGrade()); 
				}				
			}
			public void keyReleased(KeyEvent arg0) {}
			public void keyTyped(KeyEvent arg0) {}
		});
        
		maxGradeTxt.addFocusListener(new FocusListener(){
			public void focusGained(FocusEvent arg0) {}
			public void focusLost(FocusEvent arg0) {
				Integer val = parseInt(maxGradeTxt.getText());
				if (val == null){
					JOptionPane.showMessageDialog
							(controller.getMainWindow(), "Min/Max grades must be integer values", "Error",JOptionPane.ERROR_MESSAGE);
					setMaxGradeText(controller.getTest().getMaxGrade());
					return;		
				}	
				controller.maxGradeChanged(val.intValue());				
			}
		});

		
	}
/*	class GradingTvTable extends JTable	 {
		public GradingTvTable(AbstractTableModel tm){
			super(tm);
		}

	}*/
}
