/*
 * Created on 25/07/2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package il.ac.technion.cs.course236308.e3.med.gui.panels;

import il.ac.technion.cs.course236308.e3.med.control.OptionsLoader;
import il.ac.technion.cs.course236308.e3.med.control.controllers.MainWindowController;
import il.ac.technion.cs.course236308.e3.med.parameters.CategoryParams;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;
import il.ac.technion.cs.course236308.e3.med.parameters.QuestionParams;
import il.ac.technion.cs.course236308.e3.med.parameters.TestParams;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.JTextField;

/**
 * @author svali
 *
 */
public class OptionsDialog extends JDialog {
	private JCheckBox confirmCheck = new JCheckBox("Show confirmation dialogs");
	private JCheckBox showIllegalItemsCheck = new JCheckBox("Show illegal items list");
	private JCheckBox showQuestIncludingLinks = new JCheckBox("Show links to questions (aka. secondary category) in category view");
	private JCheckBox showSubCatQuest = new JCheckBox("Show questions that belong to sub-categories in category view");
	private JTextField defaultQuestLang = new JTextField();
	private JTextField defaultNewCatName = new JTextField();
	private JTextField testXMLExt = new JTextField();
	private JTextField questXMLExt = new JTextField();
	private JTextField xhtmlFileExt = new JTextField();
	private JButton okButton = new JButton("OK");
	private JButton cancelButton = new JButton("Cancel");
	private MainWindow mainWindow;
	
	public OptionsDialog(MainWindow mainWindow){
		super(mainWindow,"Options",true);
		this.mainWindow = mainWindow;
		setContentPane(createMainPanel());
		pack();
		setResizable(false);
		addListeners();
	}
	
	private void init(){
		confirmCheck.setSelected(GeneralParams.showConfirmDialogs);
		showIllegalItemsCheck.setSelected(GeneralParams.showIllegalStates);
		showQuestIncludingLinks.setSelected(CategoryParams.showIncludingLinks);
		showSubCatQuest.setSelected(CategoryParams.showAllSubQuestions);
		defaultQuestLang.setText(QuestionParams.defaultQuestionLanguage);
		defaultNewCatName.setText(CategoryParams.newCategoryDefaultName);
		testXMLExt.setText(TestParams.xmlFileExtension);
		questXMLExt.setText(QuestionParams.xmlQuestionFileExtension);
		xhtmlFileExt.setText(TestParams.xhtmlFileExtension);
	}
	
	public void activate(){
		init();
		setLocation(mainWindow.getX() + mainWindow.getWidth()/2 - getWidth()/2,mainWindow.getY() + mainWindow.getHeight()/2 - getHeight()/2);
		setVisible(true);
	}
	
	private JPanel createMainPanel(){
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		panel.add(createOptionsPanel());
		panel.add(createButtonsPanel());		
		return panel;
	}
	
	private JPanel createOptionsPanel(){
		JPanel panel = new JPanel();	
		panel.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		panel.add(Box.createRigidArea(new Dimension(10,1)));
		panel.add(createFirstOptionsPanel());
		panel.add(Box.createRigidArea(new Dimension(10,10)));
		panel.add(new JSeparator());
		panel.add(Box.createRigidArea(new Dimension(10,10)));
		panel.add(createSecondOptionsPanel());
		panel.add(Box.createRigidArea(new Dimension(10,10)));
		panel.add(new JSeparator());
		panel.add(Box.createRigidArea(new Dimension(10,10)));
		panel.add(createThirdOptionsPanel());
		panel.add(Box.createRigidArea(new Dimension(10,10)));
		panel.add(new JSeparator());
		panel.add(Box.createRigidArea(new Dimension(10,10)));
		panel.add(createFourthOptionsPanel());
		panel.add(Box.createRigidArea(new Dimension(10,10)));
		return panel;
	}
	
	private JPanel createFirstOptionsPanel(){
		JPanel panel = new JPanel(new GridLayout(2,1,5,5));
		panel.add(confirmCheck);
		panel.add(showIllegalItemsCheck);
		return panel;

	}
	
	private JPanel createSecondOptionsPanel(){
		JPanel panel = new JPanel(new GridLayout(2,1));
		panel.add(showQuestIncludingLinks);
		panel.add(showSubCatQuest);
		return panel;
	}
	
	private JPanel createThirdOptionsPanel(){
		JPanel panel = new JPanel(new GridLayout(1,2,5,5));
		panel.add(new JLabel("Default language:"));
		panel.add(defaultQuestLang);
		return panel;
	}
	
	private JPanel createFourthOptionsPanel(){
		JPanel panel = new JPanel(new GridLayout(4,2,5,5));
		panel.add(new JLabel("Default name for new category:"));
		panel.add(defaultNewCatName);
		panel.add(new JLabel("XML file extension for Tests export:"));
		panel.add(testXMLExt);
		panel.add(new JLabel("XML file extension for Questions export:"));
		panel.add(questXMLExt);
		panel.add(new JLabel("XHTML file extension:"));
		panel.add(xhtmlFileExt);
		return panel;
	}
	
	private JPanel createButtonsPanel(){
		JPanel panel = new JPanel(new GridLayout(1,2,10,5));
		panel.add(okButton);
		panel.add(cancelButton);
		return panel;
	}
	
	private void saveSettings(){
		boolean needRefresh = false;
		if(CategoryParams.showIncludingLinks != showQuestIncludingLinks.isSelected() ||
				CategoryParams.showAllSubQuestions != showSubCatQuest.isSelected()){
			needRefresh = true;
		}
		GeneralParams.showConfirmDialogs = confirmCheck.isSelected();
		CategoryParams.showIncludingLinks = showQuestIncludingLinks.isSelected();
		CategoryParams.showAllSubQuestions = showSubCatQuest.isSelected();
		QuestionParams.defaultQuestionLanguage = defaultQuestLang.getText();
		CategoryParams.newCategoryDefaultName = defaultNewCatName.getText();
		TestParams.xmlFileExtension = testXMLExt.getText();
		QuestionParams.xmlQuestionFileExtension = questXMLExt.getText();
		TestParams.xhtmlFileExtension = xhtmlFileExt.getText();
		mainWindow.showIllegalItemsPanel(showIllegalItemsCheck.isSelected());
		OptionsLoader.Store();
		setVisible(false);
		if(!needRefresh){
			return;
		}
		mainWindow.getCategoryTree().repaint();
		MainWindowController controller = mainWindow.getMainWindowController();
		controller.getActivePanel().showGUI(controller.getActiveNode());
	}
	
	private void addListeners(){
		okButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				saveSettings();
		}});
		
		cancelButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				hide();
		}});
	}
}
