package il.ac.technion.cs.course236308.e3.med.gui.panels;
import il.ac.technion.cs.course236308.e3.med.control.controllers.ReplyPanelController;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.RepliesTableModel;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.ReplyTableCellRenderer;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.awt.Point;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Hashtable;

import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;


public class RepliesTable extends JTable {
	private int[] answers;
	private int firstQuestionId;
	public static final int QUESTION_NUM = 20;
	public static final int ANSWERS_NUM = 10;

	ReplyPanelController controller;
	
	private RepliesTableModel model;
	
	private int lastSelectedRow = 0;

	public RepliesTable(Hashtable answersHash,ReplyPanelController controller ){
       	this.controller = controller;
		if (answersHash!=null){
			answers = new int[answersHash.size()];
			for (int i=0;i<answersHash.size();i++){
				Integer my_key = (Integer) answersHash.get(new Integer(1+i));
				answers[i] =my_key.intValue();
			}
		}
		else {
			answers = new int[100];
		}
			
		model = new RepliesTableModel(QUESTION_NUM,ANSWERS_NUM, firstQuestionId);
		setModel(model);
		getTableHeader().setReorderingAllowed(false);
		setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		getColumnModel().getColumn(0).setMaxWidth(100);
		getColumnModel().getColumn(0).setMinWidth(100);
		getColumnModel().getColumn(1).setMaxWidth(30);
		getColumnModel().getColumn(1).setMinWidth(30);
			
		ReplyTableCellRenderer cr = new ReplyTableCellRenderer();
		for (int i = 0; i<ANSWERS_NUM+3; i++){
			if (i > 1 && i < ANSWERS_NUM + 2){
				getColumnModel().getColumn(i).setMaxWidth(45);
				getColumnModel().getColumn(i).setMinWidth(45);
			}	
			getColumnModel().getColumn(i).setCellRenderer(cr);
				
		}
		setRowHeight(25);
		addListeners();

			
	}
	
	/**
	 * 
	 */
	public void init(int first) {
		firstQuestionId = first;
		setTableEmpty();
		
		
	    ((RepliesTableModel)getModel()).setFirstQuestionNum(first);	
		for (int i = 0 ; i<QUESTION_NUM ; i++){
				if ((firstQuestionId -1 + i) < answers.length){ //still in vector
					int col =(answers[firstQuestionId -1 + i] + 1);
					if (answers[firstQuestionId -1 + i] > 0 ){
						setValueAt(new Boolean(true),i, col);
						actionAtLineAtCol(i,col,true);
					}
	       		}
		}
	}
	
	/**
	 * 
	 */
	private void setTableEmpty() {
		int i;
		for (i = 0; i< QUESTION_NUM; i++)
			for (int j = 0; j< ANSWERS_NUM; j++)
				setValueAt(new Boolean(false), i,j+2);
		for (; i<QUESTION_NUM+3 ;i++){
			for (int j = -1; j< ANSWERS_NUM; j++)
					setValueAt(new Integer(0),i,j+2);
		}
		
		
	}

	public void setAnswers(int[] anAnswers){
		answers = anAnswers;
		
	}

	/**
	 * 
	 */
	private void addListeners() {
		
		addMouseListener(new MouseAdapter(){
			public void mouseClicked(MouseEvent e){
				int row = rowAtPoint(new Point (e.getX(),e.getY()));
				lastSelectedRow = row;
				updateSelectedRow();
			}

			public void mouseReleased(MouseEvent e){
				
				int col = getColumnModel().getColumnIndexAtX(e.getX());
				int row = rowAtPoint(new Point (e.getX(),e.getY()));
				lastSelectedRow = row;
				if (controller.isDetailsSet()==false){
					JOptionPane.showMessageDialog(controller.getMainWindow(), 
						"Please insert student details first", "Error",JOptionPane.ERROR_MESSAGE);
					return;
				}
				try {
					int myLength =  controller.getSelectedNode().getStudentsRepliesNode().getTest().getTestVersions().size();
					if (controller.isCellAllowed(firstQuestionId+row-1,col-2)
						&& (row + firstQuestionId) <= myLength	){
						boolean val = ((Boolean)getValueAt(row,col)).booleanValue(); 
					//	answers = new int[myLength];
						setValueAt(new Boolean(!val),row,col);
						actionAtLineAtCol(row,col,false);
						
					}
				} catch (Throwable e1) {}
					
					
				
						
					
			}
		});
		addKeyListener(new KeyListener(){

			public void keyTyped(KeyEvent e) {
				if (e.getKeyChar() > '0' && e.getKeyChar() <= '9'){
					int row = getSelectedRow();
					if (row < 0 || row >= QUESTION_NUM ||((row + firstQuestionId) > answers.length)){
						return;
					}
					int col = (e.getKeyChar()-'0')+1;
					
					setValueAt(new Boolean(true),row,col);
					actionAtLineAtCol(row,col,false);
					setNextSelectedRow(row);
					
					return;
	 
				}
				//tab
				if (e.getKeyChar() == '	'){
					releaseFocus();
				}
				
								
		
			}

			public void keyPressed(KeyEvent arg0) {
				// TODO Auto-generated method stub

			}

			public void keyReleased(KeyEvent arg0) {
				// TODO Auto-generated method stub

			}
		});
		
		addFocusListener(new FocusListener(){

			public void focusGained(FocusEvent e) {
				
				updateSelectedRow();
			}

			public void focusLost(FocusEvent e) {
				lastSelectedRow = getSelectedRow();
				getSelectionModel().clearSelection();
			}
			
		});
		
		getSelectionModel()
			.addListSelectionListener(new ListSelectionListener(){

			public void valueChanged(ListSelectionEvent e) {
				if (e.getFirstIndex() > QUESTION_NUM - 2)
					getSelectionModel().setLeadSelectionIndex(QUESTION_NUM-1);
			}
		});


		
	}
	
	private void setNextSelectedRow(int row){
		if (row + firstQuestionId == answers.length){
			return;
		}
		if (row >= 0 && row < QUESTION_NUM -1){
			lastSelectedRow = getSelectedRow()+1;
		}
		else {
			
			if ( row == QUESTION_NUM - 1 ){
				lastSelectedRow = 0;
				//listener.tableFilled();
			}
		}
		updateSelectedRow();
		
		
	}

	public int getFirstQuestionId(){
		return firstQuestionId; 
	}
	
	private void updateSelectedRow(){
		getSelectionModel().setLeadSelectionIndex(lastSelectedRow);
	}
	
	

	/**
	 * @param col
	 * @param row
	 */
	protected void actionAtLineAtCol(int row, int col,boolean init) {
		String prevAns = (String)getValueAt(row,1);
		if (((Boolean)getValueAt(row,col)).booleanValue()){
			
			// set answered ANS
			
			String choosenAns = ""+ (char)('A'+(col-2));
			if (choosenAns.equals(prevAns))
				return;
			//int prevCol = prevAns.compareTo("A") + 2;
			
			for (int i = 0; i < ANSWERS_NUM; i++){
				if ( i+2 != col && ((Boolean)getValueAt(row,i+2)).booleanValue()){
					setValueAt(new Boolean(false),row,i+2);
					answerReset(row,i+2);
				}
			}
				
				
			setValueAt(choosenAns,row,1);
			answerSet(row,col);
			if (answers.length>0)
				answers[firstQuestionId - 1 + row ] = col - 1;

			int q = firstQuestionId - 1 + row;
			int a = col - 1;
			if (!init)
				controller.setReply(q,a,true);
			return;
		}
		String choosenAns = "";
		if (choosenAns.equals(getValueAt(row,1)) ||
			prevAns.compareTo("A") + 2!= col)
			return;

		
		setValueAt("",row,1);
		answerReset(row,col);
		
//		vector reset
		int q = firstQuestionId - 1 + row;
		int a = col - 1;
		if (answers.length>0)
			answers[firstQuestionId - 1 + row ] = 0;
		if (!init)
			controller.setReply(q,a,false);

		
	}
	

	private void answerReset(int row, int col ){
		
		Integer valSum = (Integer)getValueAt(QUESTION_NUM+2,col);
		
		setValueAt(new Integer(valSum.intValue()-1), QUESTION_NUM+2, col);
		if (GeneralParams.isGreyField(row,col-2)){
			Integer valLight = (Integer)getValueAt(QUESTION_NUM,col);
			Integer sumLight = (Integer)getValueAt(QUESTION_NUM,1);
			
			setValueAt(new Integer(valLight.intValue()-1), QUESTION_NUM,col);
			setValueAt(new Integer(sumLight.intValue()-1), QUESTION_NUM,1);
			
			
		}
		else{
			Integer valDark = (Integer)getValueAt(QUESTION_NUM+1,col);
			Integer sumDark = (Integer)getValueAt(QUESTION_NUM+1,1);
			
			setValueAt(new Integer(valDark.intValue()-1), QUESTION_NUM+1, col);
			setValueAt(new Integer(sumDark.intValue()-1), QUESTION_NUM+1, 1);

		}
		int sum = ((Integer)getValueAt(QUESTION_NUM,1)).intValue() + ((Integer)getValueAt(QUESTION_NUM+1,1)).intValue();
		setValueAt(new Integer(sum), QUESTION_NUM+2, 1);

	}
	
	private void answerSet(int row, int col) {
		Integer valSum = (Integer)getValueAt(QUESTION_NUM+2,col);
		setValueAt(new Integer(valSum.intValue()+1), QUESTION_NUM+2, col);
		if (GeneralParams.isGreyField(row,col-2)){	
			Integer valLight = (Integer)getValueAt(QUESTION_NUM,col);
			Integer sumLight = (Integer)getValueAt(QUESTION_NUM,1);
			
			setValueAt(new Integer(valLight.intValue()+1), QUESTION_NUM, col);
			setValueAt(new Integer(sumLight.intValue()+1), QUESTION_NUM,1);
			
		}
		else{
			Integer valDark = (Integer)getValueAt(QUESTION_NUM+1,col);
			Integer sumDark = (Integer)getValueAt(QUESTION_NUM+1,1);
			
			setValueAt(new Integer(valDark.intValue()+1), QUESTION_NUM+1, col);
			setValueAt(new Integer(sumDark.intValue()+1), QUESTION_NUM+1, 1);

		}
		int sum = ((Integer)getValueAt(QUESTION_NUM,1)).intValue() + ((Integer)getValueAt(QUESTION_NUM+1,1)).intValue();
		setValueAt(new Integer(sum), QUESTION_NUM+2, 1);

		
	}
	protected void releaseFocus() {
		setFocusable(false);
		setFocusable(true);
	}
	

}
