/*
 * Created on 07/07/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
 
package il.ac.technion.cs.course236308.e3.med.gui.panels;

import il.ac.technion.cs.course236308.e3.med.control.controllers.TestPanelController;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.text.SimpleDateFormat;
import java.util.Calendar;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTextField;

import de.wannawork.jcalendar.JCalendarDialog;


/**
 * @author svekant
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TestPanel extends JPanel {
    private TestPanelController controller;
    
    private JLabel examIdText = new JLabel();
    private JLabel examCreatedText = new JLabel();
    private JLabel examUpdatedText = new JLabel();
    private JLabel examDateText = new JLabel(); 
    private JTextField examCourseNameText =  new JTextField();
    
    private String[] statusOptions = {"UNDER CONSTRUCTION", "ASSIGNED", "CHECKED"};
	
    private JComboBox examStatus = new JComboBox(statusOptions);
    private JEditorPane examDesc1 = new JEditorPane();
    private JEditorPane examDesc2 = new JEditorPane();
    private JEditorPane examInstr = new JEditorPane();   
    private JComponent testPanel;
	private JButton dateButton;
    
    private String examDescription1 = "";
    private String examDescription2 = "";
    private String examInstructions = "";
    private String examCourseName = "";
    
    private JPanel statisticsPanel = new JPanel();
    private JPanel leftTestPanel = new JPanel();
        
    public TestPanel(TestPanelController controller){
        this.controller = controller;
    }
    
    public void init(){
        this.setLayout(new GridLayout(1,1));
        this.add(createMainPanel());
        addListeners();
    }
    
    private JComponent createMainPanel(){
        testPanel = new JPanel();
        testPanel.setLayout(new GridLayout(1,1));

		leftTestPanel = (JPanel) createLeftTestPanel();
        JSplitPane pane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,
			leftTestPanel, createRightTestPanel());
        pane.setOneTouchExpandable(true);
        pane.setDividerLocation(420);                               
        return pane;
    }

    private JComponent createLeftTestPanel(){
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		JPanel pane = createTestsDetailsPanel();
		
		pane.setMaximumSize(new Dimension(400,100));
		panel.add(pane);
		statisticsPanel = createStatisticsPanel();
		statisticsPanel.setBorder(BorderFactory.createCompoundBorder
						(BorderFactory.createTitledBorder("Statistics : "), 
						 BorderFactory.createEmptyBorder(5,5,5,5)));              
						 
		panel.add(statisticsPanel);
		return panel;
		
    }

    private JComponent createRightTestPanel(){
        JPanel panel = new JPanel();
        panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));         
        
        JSplitPane pane1 = new JSplitPane(JSplitPane.VERTICAL_SPLIT,
                CreateEditPanel(examDesc1,"Exam description 1: "), CreateEditPanel(examDesc2,"Exam description 2: "));
                pane1.setOneTouchExpandable(true);
                pane1.setDividerLocation(200);     
        

        JSplitPane pane2 = new JSplitPane(JSplitPane.VERTICAL_SPLIT, pane1,
                CreateEditPanel(examInstr,"Exam instructions: "));
                              pane2.setOneTouchExpandable(true);
                              pane2.setDividerLocation(400);     
                                                                           
        return pane2;
    }
  
  
    private JPanel createStatisticsPanel() {
    	
    	try {
 			JPanel panel = ChartPanels.getTestQuestionsPointsPiePanel(controller.getTest());
			return panel;
		} catch (Throwable e) {
			//e.printStackTrace();
			JPanel panel = new JPanel(new BorderLayout());
			panel.add(new JLabel("No statistics available"),BorderLayout.NORTH);
			return panel;
			
		} 

    } 

    private JPanel createTestsDetailsPanel(){
    	 JPanel panel = new JPanel();
         panel.setLayout(new BoxLayout(panel,BoxLayout.X_AXIS));
         
         JPanel leftPanel = new JPanel();
         leftPanel.setLayout(new GridLayout(6,1));         
         leftPanel.add(new JLabel("Exam id: "));
         leftPanel.add(new JLabel("Course name : "));                
         leftPanel.add(new JLabel("Status:  "));
         leftPanel.add(new JLabel("Created date: "));
         leftPanel.add(new JLabel("Updated date: "));
         leftPanel.add(new JLabel("Exam date: "));
         
         JPanel rigthPanel = new JPanel();
         rigthPanel.setLayout(new GridLayout(6,1)); 
                
         rigthPanel.add(examIdText);      
         rigthPanel.add(examCourseNameText);       
         rigthPanel.add(examStatus);
         rigthPanel.add(examCreatedText);   
         rigthPanel.add(examUpdatedText);
                 
         JPanel datePanel = new JPanel();
         datePanel.setLayout(new GridLayout(1,2));
         datePanel.add(examDateText);		
 		 dateButton = new JButton("Set date");
 		 datePanel.add(dateButton);
 		 rigthPanel.add(datePanel);
         
 		panel.add(leftPanel);
 		panel.add(rigthPanel);
 		
 		return panel;
         
    }
    
    private JComponent CreateEditPanel(JEditorPane edit,String description){
        JPanel panel = new JPanel();
        panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));         
        panel.setLayout(new GridLayout(1,1));
        panel.setBorder(BorderFactory.createCompoundBorder
                                  (BorderFactory.createTitledBorder(description), 
                                   BorderFactory.createEmptyBorder(15,15,15,15)));
                                   
        JScrollPane editorScrollPane = new JScrollPane(edit);
        editorScrollPane.setVerticalScrollBarPolicy(
                        JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);

        panel.add(editorScrollPane);
        return panel;
    }
    
    public void setExamIdText(String text){
        examIdText.setText(text);
    }
    
    public void setExamCreatedText(String text){
        examCreatedText.setText(text);
    }
    
    public void setExamUpdatedText(String text){
        examUpdatedText.setText(text);
    }
    
    public void setExamDateText(String text){
        examDateText.setText(text);
    }
    
    public void setExamCourseNameText(String text){
        examCourseNameText.setText(text);
    }
    
    public void setExamStatusCombo(String currStatus){
        examStatus.setSelectedItem(currStatus);
    }
    
    public void setExamDesc1(String text){
        examDesc1.setText(text);
    }
    
    public void setExamDesc2(String text){
        examDesc2.setText(text);
    }
    
    public void setExamInstructions(String text){
        examInstr.setText(text);
    }     
 
 	public void setStatistics(){
 		leftTestPanel.remove(statisticsPanel);
		statisticsPanel = createStatisticsPanel();
		statisticsPanel.setLayout(new GridLayout(1,1));
		
		statisticsPanel.setBorder(BorderFactory.createCompoundBorder
								(BorderFactory.createTitledBorder("Statistics : "), 
								 BorderFactory.createEmptyBorder(50,50,50,50))); 
		leftTestPanel.add(statisticsPanel);
 	}
 	
    private void addListeners(){
            
			examDesc1.addKeyListener(new KeyListener(){
					public void keyPressed(KeyEvent arg0) {
						if(arg0.getKeyCode()==KeyEvent.VK_ESCAPE){
							String examOrgDesc1 = controller.getTest().getDescription1(); 
							examDesc1.setText(examOrgDesc1);
							examDescription1 = examOrgDesc1;
						}				
					}

					public void keyReleased(KeyEvent arg0) {
						examDescription1 = examDesc1.getText();
					}

					public void keyTyped(KeyEvent arg0) {
					}
			});
				
		   examDesc1.addFocusListener(new FocusListener(){
				Test test = null;
				public void focusGained(FocusEvent arg0) {
					test = controller.getTest();
					examDescription1 = examDesc1.getText();
				}

				public void focusLost(FocusEvent e) {
					if(e.isTemporary()){
						return;
					}				
					if(test==null) return;
					String testDesc1 = test.getDescription1()==null?"":test.getDescription1();
					if(test != null && !examDescription1.equals(testDesc1)){
						controller.testDescriptionChanged(test,examDescription1,1);	
					}
					setExamDesc1(test.getDescription1());
					setExamUpdatedText(new SimpleDateFormat("yyyy-MM-dd HH:mm   ").format(test.getUpdated().getTime()));
					test = null;			
				}

				
					
				});	
				
		examDesc2.addKeyListener(new KeyListener(){
				public void keyPressed(KeyEvent arg0) {
					if(arg0.getKeyCode()==KeyEvent.VK_ESCAPE){
						String examOrgDesc2 = controller.getTest().getDescription2(); 
						examDesc2.setText(examOrgDesc2);
						examDescription2 = examOrgDesc2;
					}				
				}

				public void keyReleased(KeyEvent arg0) {
					examDescription2 = examDesc2.getText();
				}

				public void keyTyped(KeyEvent arg0) {
				}
		});
				
	   examDesc2.addFocusListener(new FocusListener(){
			Test test = null;
			public void focusGained(FocusEvent arg0) {
				test = controller.getTest();
				examDescription2 = examDesc2.getText();
			}

			public void focusLost(FocusEvent e) {
				if(e.isTemporary()){
					return;
				}				
				if(test==null) return;
				String testDesc2 = test.getDescription2()==null?"":test.getDescription2();
				if(test != null && !examDescription2.equals(testDesc2)){
					controller.testDescriptionChanged(test,examDescription2,2);	
				}
				setExamDesc2(test.getDescription2());	
				setExamUpdatedText(new SimpleDateFormat("yyyy-MM-dd HH:mm   ").format(test.getUpdated().getTime()));
				test = null;			
			}

				
					
			});	
					
		examInstr.addKeyListener(new KeyListener(){
				public void keyPressed(KeyEvent arg0) {
					if(arg0.getKeyCode()==KeyEvent.VK_ESCAPE){
						String examOrgInst = controller.getTest().getInstructions(); 
						examInstr.setText(examOrgInst);
						examInstructions = examOrgInst;
					}				
				}

				public void keyReleased(KeyEvent arg0) {
					examInstructions = examInstr.getText();
				}

				public void keyTyped(KeyEvent arg0) {
				}
		});
				
		examInstr.addFocusListener(new FocusListener(){
			Test test = null;
			public void focusGained(FocusEvent arg0) {
				test = controller.getTest();
				examInstructions = examInstr.getText();
				if(!GeneralParams.equalNullableStrings(test.getInstructions(),examInstructions)){
					controller.testInstructionsChanged(test,examInstructions);
				}
				controller.getMainWindow().enableTextActions(examInstr);
			}

			public void focusLost(FocusEvent e) {
				if(e.isTemporary()){
					return;
				}				
				if(test==null) return;
				controller.getMainWindow().setTextActionSelection(examInstr.getSelectionStart(),examInstr.getSelectionEnd());
				String testInst = test.getInstructions()==null?"":test.getInstructions();
				if(test != null && !examInstructions.equals(testInst)){
					controller.testInstructionsChanged(test,examInstructions);	
				}
				setExamInstructions(test.getInstructions());
				setExamUpdatedText(new SimpleDateFormat("yyyy-MM-dd HH:mm   ").format(test.getUpdated().getTime()));
				test = null;	
				if(!controller.getMainWindow().isTextButton(e.getOppositeComponent())){
					controller.getMainWindow().disableTextActions();
				}

			}			
			});	
			
		examCourseNameText.addKeyListener(new KeyListener(){
				public void keyPressed(KeyEvent arg0) {
					if(arg0.getKeyCode()==KeyEvent.VK_ESCAPE){
						String examOrgCourse = controller.getTest().getCourseName(); 
						examCourseNameText.setText(examOrgCourse);
						examCourseName = examOrgCourse;
					}				
				}

				public void keyReleased(KeyEvent arg0) {
					examCourseName = examCourseNameText.getText();
				}

				public void keyTyped(KeyEvent arg0) {
				}
		});
				
		examCourseNameText.addFocusListener(new FocusListener(){
			Test test = null;
			public void focusGained(FocusEvent arg0) {
				test = controller.getTest();
				examCourseName = examCourseNameText.getText();
			}

			public void focusLost(FocusEvent arg0) {
				if(test==null) return;
				String testCrs = test.getCourseName()==null?"":test.getCourseName();
				if(test != null && !examCourseName.equals(testCrs)){
					controller.testCourseNameChanged(test,examCourseName);	
				}
				setExamCourseNameText(test.getCourseName());
				setExamUpdatedText(new SimpleDateFormat("yyyy-MM-dd HH:mm   ").format(test.getUpdated().getTime()));
				test = null;	
					
			}

				
					
			});
		
		dateButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				try{
					JCalendarDialog calendPanel = new JCalendarDialog(dateButton, "Exam date selection", "Please select the date");
					Calendar cal = calendPanel.getCalendar();
					if(cal != null){
						cal.set(Calendar.HOUR_OF_DAY,23);
						cal.set(Calendar.MINUTE,59);
						controller.testDateChanged(controller.getTest(),cal);
						setExamDateText(new SimpleDateFormat("yyyy-MM-dd        ").format(controller.getTest().getDate().getTime()));
					}
				}catch(Throwable e1){}
			}
		});
		
		
		examStatus.addActionListener(new ActionListener(){

			public void actionPerformed(ActionEvent e){				
				String newStatus = statusOptions[examStatus.getSelectedIndex()];
				if(!newStatus.equals(statusToWords(controller.getTest().getStatus()))){
					controller.testStatusChanged(controller.getTest(),statusOptions[examStatus.getSelectedIndex()]);
					setExamStatusCombo(statusToWords(controller.getTest().getStatus()));
				}
			}
			
			private String statusToWords(String letter){
				String tmp = null;
				if(letter.equals("U")){
					tmp = "UNDER CONSTRUCTION";
				}else if(letter.equals("P")){
					tmp = "ASSIGNED";
				}else if(letter.equals("G")){
					tmp = "CHECKED";
				}
				return tmp;
			
			}
		});
		


			
					            
            
    }

}
