/*
 * Created on 06/07/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.gui.panels;

import il.ac.technion.cs.course236308.e3.med.control.TableSorter;
import il.ac.technion.cs.course236308.e3.med.control.controllers.TestVersionsPanelController;
import il.ac.technion.cs.course236308.e3.med.gui.HeaderLabel;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.TestVersionsTableModel;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 * @author svali
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TestVersionsPanel extends JPanel {
	private TestVersionsPanelController controller;

	private TestVersionsTableModel testVersionsTableModel;
	private TableSorter testVersionsTableSorter;

	private JLabel catName = new HeaderLabel("");
	private TestVersionsTable testVersionsTable = new TestVersionsTable();   
	
	private JPanel versionPanel = new JPanel(new GridLayout(1, 1));
	private JPanel versionFullPanel;
	
	private JLabel testCatPercentOfWeightCatOnly = new JLabel("N/A");
	private JLabel testCatPercentOfWeightCatAndBellow  = new JLabel("N/A");
	private JLabel testCatAvgDifficultyCatOnly  = new JLabel("N/A");
	private JLabel testCatAvgDifficultyCatAndBellow  = new JLabel("N/A");
	private JLabel testCatAvgValidityCatOnly  = new JLabel("N/A");
	private JLabel testCatAvgValidityCatAndBellow  = new JLabel("N/A");
	private JLabel testVerDifficulty  = new JLabel("N/A");
	private JLabel testVerValidity  = new JLabel("N/A");
	private JTextArea testVerRemarks = new JTextArea(2,2);
	private JLabel testAnsCorrelation  = new JLabel("N/A");
	private JLabel testAnsNormGradeAvg  = new JLabel("N/A");
	private JLabel testAnsNumAnsweringStudents  = new JLabel("N/A");
	private JLabel testAnsPercentAnsweringStudents  = new JLabel("N/A");

	private int lastSelectedTestVerIndex = 0;

	public TestVersionsPanel(TestVersionsPanelController controller){
		this.controller = controller;
	}

	public void init(){     
       	setLayout(new GridLayout(1,1));
        add(createMainPanel());
        versionFullPanel = controller.getVersionPanel();
		addListeners();
	}
	
	public void setTestAnsCorrelation(Double value) {
		testAnsCorrelation.setText(makeString(value));
	}

	public void setTestAnsNormGradeAvg(Double value) {
		testAnsNormGradeAvg.setText(makeString(value));
	}

	public void setTestAnsNumAnsweringStudents(int value) {
		testAnsNumAnsweringStudents.setText(String.valueOf(value));
	}

	public void setTestAnsPercentAnsweringStudents(Double value) {
		testAnsPercentAnsweringStudents.setText(makeString(value));
	}

	public void setTestCatAvgDifficultyCatAndBellow(Double value) {
		testCatAvgDifficultyCatAndBellow.setText(makeString(value));
	}

	public void setTestCatAvgDifficultyCatOnly(Double value) {
		testCatAvgDifficultyCatOnly.setText(makeString(value));
	}

	public void setTestCatAvgValidityCatAndBellow(Double value) {
		testCatAvgValidityCatAndBellow.setText(makeString(value));
	}

	public void setTestCatAvgValidityCatOnly(Double value) {
		testCatAvgValidityCatOnly.setText(makeString(value));
	}

	public void setTestCatPercentOfWeightCatAndBellow(Double value) {
		testCatPercentOfWeightCatAndBellow.setText(makeString(value)+(value==null?"":"%"));
	}

	public void setTestCatPercentOfWeightCatOnly(Double value) {
		testCatPercentOfWeightCatOnly.setText(makeString(value)+(value==null?"":"%"));
	}

	public void setTestVerDifficulty(Double value) {
		testVerDifficulty.setText(makeString(value));
	}

	public void setTestVerValidity(Double value) {
		testVerValidity.setText(makeString(value));
	}
	
	public void setTestVerRemarks(String remarks) {
		String showRemarks = remarks.replaceAll("\\.\\s*",".\n\r");
		testVerRemarks.setText(showRemarks);
	}
	
	private String makeString(Double value){
		if(value==null){
			return "N/A";
		}
		String str = value.toString();
		int ind = str.indexOf(".");
		if (ind>=0){ 
			str = str.substring(0,(str.length()>=(ind+4))? ind+4: str.length());
		}
		return str;
	}

	
	public void setTestVersionsTableModel(TestVersionsTableModel model) {
		testVersionsTableModel = model;
		testVersionsTableSorter = new TableSorter(model);
		testVersionsTable.setModel(testVersionsTableSorter);
		testVersionsTableSorter.setTableHeader(testVersionsTable.getTableHeader());
		testVersionsTableSorter.setColumnComparator(Integer.class,TableSorter.COMPARABLE_COMAPRATOR);
		testVersionsTable.getColumnModel().getColumn(0).setMaxWidth(16);
        testVersionsTable.getColumnModel().getColumn(1).setPreferredWidth(50);
        testVersionsTable.getColumnModel().getColumn(2).setPreferredWidth(50);
        testVersionsTable.getColumnModel().getColumn(3).setPreferredWidth(50);
        testVersionsTable.getColumnModel().getColumn(4).setPreferredWidth(300);
	}
	
	public void setTestCategoryName(String newName){
		catName.setText("Test versions in " + newName);
	}
	
	public void selectSortedTestVersion(int viewRow) {
		versionPanel.removeAll();
        versionPanel.repaint();
        testVersionsTableModel.fireTableDataChanged();
        if(testVersionsTableModel.getRowCount() == 0){
            return; 
        }
		try {
            versionPanel.add(versionFullPanel);
			testVersionsTable.clearSelection();
			testVersionsTable.setRowSelectionInterval(viewRow, viewRow);			
		} catch (IllegalArgumentException e) {
            versionPanel.removeAll();
		}
	}
	
	public void selectUnsortedTestVersion(int modelRow){
		try{
			selectSortedTestVersion(testVersionsTableSorter.viewIndex(modelRow));
		}catch(Throwable e){
			versionPanel.removeAll();
		}
	}
    
    public int getSelectedVersionIndex(){
        return testVersionsTable.getSelectedRow();
    }

	private void addListeners(){
		testVersionsTable.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				if (e.getValueIsAdjusting()) {
					return;
				}
				ListSelectionModel lsm = (ListSelectionModel) e.getSource();
				if(lsm.isSelectionEmpty()){
					selectUnsortedTestVersion(lastSelectedTestVerIndex);
					return;
				}
				controller.finalizeScreenHandling();
				lastSelectedTestVerIndex = testVersionsTableSorter.modelIndex(lsm.getMinSelectionIndex());
				controller.testVersionSelected(lastSelectedTestVerIndex);
			}
		});

	}
    
	private JComponent createMainPanel() {
		JSplitPane pane = new JSplitPane(JSplitPane.VERTICAL_SPLIT,createQuestionsPanel(),createVersionPanel());
		pane.setOneTouchExpandable(true);
		pane.setDividerLocation(120);
		return pane;
	}	
	
	private JPanel createQuestionsPanel(){
		JPanel questPanel = new JPanel();
		questPanel.setLayout(new BoxLayout(questPanel, BoxLayout.Y_AXIS));
		JPanel catNamePanel = new JPanel(new GridLayout(1, 1));
		catNamePanel.add(catName);
		JScrollPane jScrollPane1 = new JScrollPane(testVersionsTable);
		questPanel.add(catNamePanel);
		questPanel.add(jScrollPane1);
		return questPanel;
	}
	
	private JComponent createVersionPanel(){
		JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,createStatisticsPanel(),versionPanel);
		splitPane.setOneTouchExpandable(true);
		splitPane.setDividerLocation(300);		
		return splitPane;
	}
	
	private JPanel createStatisticsPanel(){
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel,BoxLayout.Y_AXIS));
		panel.add(createTestCategoryStatPanel());
		panel.add(createTestVersionStatPanel());
		panel.add(createTestVersionRemarksPanel());
		panel.add(createTestAnswerStatPanel());
		return panel;
	}
	
	private JPanel createTestCategoryStatPanel(){
		JPanel panel = new JPanel(new BorderLayout());
		panel.add(new JLabel("<html><u>Test Category Statistics</u><html>"),BorderLayout.NORTH);
		JPanel catLabels = new JPanel();
		catLabels.setLayout(new BoxLayout(catLabels,BoxLayout.Y_AXIS));
		catLabels.add(new JLabel("Relative weight:"));
		catLabels.add(new JLabel("Relative weight of sub-tree:"));
		catLabels.add(new JLabel("Avg. Diff.:"));
		catLabels.add(new JLabel("Avg. Diff. of sub-tree:"));
		catLabels.add(new JLabel("Avg. Validity:"));
		catLabels.add(new JLabel("Avg. Validity of sub-tree:"));
		JPanel catNumbers = new JPanel();
		catNumbers.setLayout(new BoxLayout(catNumbers,BoxLayout.Y_AXIS));
		catNumbers.add(testCatPercentOfWeightCatOnly);
		catNumbers.add(testCatPercentOfWeightCatAndBellow);
		catNumbers.add(testCatAvgDifficultyCatOnly);
		catNumbers.add(testCatAvgDifficultyCatAndBellow);
		catNumbers.add(testCatAvgValidityCatOnly);
		catNumbers.add(testCatAvgValidityCatAndBellow);
		JPanel catLabelsNumbersPanel = new JPanel();
		catLabelsNumbersPanel.setLayout(new BoxLayout(catLabelsNumbersPanel,BoxLayout.X_AXIS));
		catLabelsNumbersPanel.add(Box.createRigidArea(new Dimension(20,5)));
		catLabelsNumbersPanel.add(catLabels);
		catLabelsNumbersPanel.add(Box.createRigidArea(new Dimension(5,5)));
		catLabelsNumbersPanel.add(catNumbers);
		panel.add(catLabelsNumbersPanel,BorderLayout.CENTER);
		return panel;
	}
	
	private JPanel createTestVersionStatPanel(){
		JPanel panel = new JPanel(new BorderLayout());
		panel.add(new JLabel("<html><u>Test Version Statistics</u><html>"),BorderLayout.NORTH);
		JPanel catLabels = new JPanel();
		catLabels.setLayout(new BoxLayout(catLabels,BoxLayout.Y_AXIS));
		catLabels.add(new JLabel("Difficulty:"));
		catLabels.add(new JLabel("Validity:"));
		JPanel catNumbers = new JPanel();
		catNumbers.setLayout(new BoxLayout(catNumbers,BoxLayout.Y_AXIS));
		catNumbers.add(testVerDifficulty);
		catNumbers.add(testVerValidity);
		JPanel catLabelsNumbersPanel = new JPanel();
		catLabelsNumbersPanel.setLayout(new BoxLayout(catLabelsNumbersPanel,BoxLayout.X_AXIS));
		catLabelsNumbersPanel.add(Box.createRigidArea(new Dimension(20,5)));
		catLabelsNumbersPanel.add(catLabels);
		catLabelsNumbersPanel.add(Box.createRigidArea(new Dimension(5,5)));
		catLabelsNumbersPanel.add(catNumbers);
		panel.add(catLabelsNumbersPanel,BorderLayout.CENTER);
	
		//add remarks text
		return panel;
	}
	
	private JPanel createTestVersionRemarksPanel(){
		JPanel remarksPanel = new JPanel(new BorderLayout());
		remarksPanel.add(new JLabel("       Remarks:"),BorderLayout.NORTH);
		remarksPanel.add(new JScrollPane(testVerRemarks),BorderLayout.CENTER);
		remarksPanel.add(Box.createRigidArea(new Dimension(20,5)),BorderLayout.WEST);
		remarksPanel.add(Box.createRigidArea(new Dimension(20,5)),BorderLayout.EAST);
		testVerRemarks.setEditable(false);
		return remarksPanel;
	}
	
	private JPanel createTestAnswerStatPanel(){
		JPanel panel = new JPanel(new BorderLayout());
		panel.add(new JLabel("<html><u>Test Answer Statistics</u><html>"),BorderLayout.NORTH);
		JPanel catLabels = new JPanel();
		catLabels.setLayout(new BoxLayout(catLabels,BoxLayout.Y_AXIS));
		catLabels.add(new JLabel("Correlation:"));
		catLabels.add(new JLabel("Avg. Norm. Grade:"));
		catLabels.add(new JLabel("Num. of students answered:"));
		catLabels.add(new JLabel("Perc. of students answered:"));
		JPanel catNumbers = new JPanel();
		catNumbers.setLayout(new BoxLayout(catNumbers,BoxLayout.Y_AXIS));
		catNumbers.add(testAnsCorrelation);
		catNumbers.add(testAnsNormGradeAvg);
		catNumbers.add(testAnsNumAnsweringStudents);
		catNumbers.add(testAnsPercentAnsweringStudents);
		JPanel catLabelsNumbersPanel = new JPanel();
		catLabelsNumbersPanel.setLayout(new BoxLayout(catLabelsNumbersPanel,BoxLayout.X_AXIS));
		catLabelsNumbersPanel.add(Box.createRigidArea(new Dimension(20,5)));
		catLabelsNumbersPanel.add(catLabels);
		catLabelsNumbersPanel.add(Box.createRigidArea(new Dimension(5,5)));
		catLabelsNumbersPanel.add(catNumbers);
		panel.add(catLabelsNumbersPanel,BorderLayout.CENTER);
		return panel;
	}
    
    class TestVersionsTable extends JTable implements MouseListener {

        public TestVersionsTable() {
            addMouseListener(this);
        }

        public void mouseReleased(MouseEvent e) {
            if (e.getButton() != 3) {
                return;
            }
            ListSelectionModel model = getSelectionModel(); 
            if(model.isSelectionEmpty() || model.getMinSelectionIndex()==model.getMaxSelectionIndex()){
            	selectSortedTestVersion(testVersionsTable.rowAtPoint(e.getPoint()));
            }
            List selectedTestVersions = new LinkedList();
            JPopupMenu tmenu = new JPopupMenu();
            try {
            	for(int i=model.getMinSelectionIndex();i<=model.getMaxSelectionIndex();++i){
            		if(model.isSelectedIndex(i)){
            			selectedTestVersions.add(testVersionsTableModel.getTestVersionAtRow(testVersionsTableSorter.modelIndex(i)));
            		}
            	}
            } catch (Throwable e1) {
                return;
            }
            Vector v = controller.getTestVersionPopUpItems(selectedTestVersions);
            for (Iterator it = v.iterator(); it.hasNext();) {
                tmenu.add((Component) it.next());
            }
            tmenu.show(this, e.getX(), e.getY());
        }

        public void mouseClicked(MouseEvent e) {
        }

        public void mouseEntered(MouseEvent e) {
        }

        public void mouseExited(MouseEvent e) {
        }

        public void mousePressed(MouseEvent e) {
        }
    }
}
