/*
 * Created on Jun 13, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.gui.panels;

import il.ac.technion.cs.course236308.e3.med.control.controllers.VersionPropertyPanelController;
import il.ac.technion.cs.course236308.e3.med.gui.datamodels.AnswersTableModel;
import il.ac.technion.cs.course236308.e3.med.model.Answer;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.awt.Component;
import java.awt.ComponentOrientation;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 * @author Valentin Kravtsov
 *
 * Created in DS Laboratory - Technion, Israel 2004
 */
public class VersionPropertyPanel extends JPanel {
	private VersionPropertyPanelController controller;

	private JTextArea verBodyText = new JTextArea("");
	private JTextArea verNotesText = new JTextArea("");
	private JTextArea answerText = new JTextArea("");
	private JTextArea answerNotesText = new JTextArea("");

	private AnswersTableModel ansTableModel;

	private AnsTable ansTable = new AnsTable();

	private boolean answerTextChanged = false;
	private boolean answerNotesChanged = false; 
	private boolean versionBodyChanged = false;
	private boolean versionNotesChanged = false;
	
	private JSplitPane verAnsSplitPane;
	
	private JPanel tablePanel;
	
	public VersionPropertyPanel(VersionPropertyPanelController controller) {
		this.controller = controller;
	}

	public void init() {
		this.setLayout(new GridLayout(1, 1));
		this.add(createVersionsPanel());
		verAnsSplitPane.setDividerLocation((int)(Toolkit.getDefaultToolkit().getScreenSize().getHeight()/6));
		addListeners();
	}

	public void setAnswersTableModel(AnswersTableModel model) {
		ansTableModel = model;
		ansTable.setModel(model);
		ansTable.setColumnSelectionAllowed(false);
		ansTable.getColumnModel().getColumn(0).setMaxWidth(16);
		ansTable.getColumnModel().getColumn(1).setPreferredWidth(30);
		ansTable.getColumnModel().getColumn(2).setPreferredWidth(200);
		ansTable.getColumnModel().getColumn(3).setPreferredWidth(30);
		ansTable.getColumnModel().getColumn(4).setPreferredWidth(20);
		ansTable.getColumnModel().getColumn(5).setPreferredWidth(20);
	}

	public void setRTLOrientation(boolean isRTL){
		ComponentOrientation orient;
		if(isRTL){
			orient = ComponentOrientation.RIGHT_TO_LEFT;
		}else{
			orient = ComponentOrientation.LEFT_TO_RIGHT;
		}
		verBodyText.setComponentOrientation(orient);
		verNotesText.setComponentOrientation(orient);
		answerText.setComponentOrientation(orient);
		answerNotesText.setComponentOrientation(orient);
	}
	
	public String getVerBodyText(){
		return verBodyText.getText();
	}
	
	public void setVerBodyText(String text) {
		verBodyText.setText(text);
	}

	public boolean isVersionBodyChanged(){
		return versionBodyChanged;
	}
	
	public void setVersionBodyChanged(boolean isVerBodyChanged){
		versionBodyChanged = isVerBodyChanged;
	}
	
	public String getVerNotesText(){
		return verNotesText.getText();
	}
	
	public void setVerNotesText(String text) {
		verNotesText.setText(text);
	}
	
	public boolean isVersionNotesChanged(){
		return versionNotesChanged;
	}
	
	public void setVersionNotesChanged(boolean isVerNotesChanged){
		versionNotesChanged = isVerNotesChanged;
	}

	public String getAnswerText() {
		return answerText.getText();
	}

	public void setAnswerText(String text) {
		answerText.setText(text);
	}
	
	public boolean isAnswerTextChanged(){
		return answerTextChanged;
	}
	
	public void setAnswerTextChanged(boolean isAnsTextChanged){
		answerTextChanged = isAnsTextChanged;
	}

	public String getAnswerNotes(){
		return answerNotesText.getText();
	}
	
	public void setAnswerNotesText(String notes){
		answerNotesText.setText(notes);
	}
	
	public boolean isAnswerNotesChanged(){
		return answerNotesChanged;
	}
	
	public void setAnswerNotesChanged(boolean isAnsNotesChanged){
		answerNotesChanged = isAnsNotesChanged;
	}
	
	public void refreshAnswersTable(){
		int[] sizes = new int[ansTableModel.getColumnCount()];
		for(int i=1;i<ansTableModel.getColumnCount();++i){
			sizes[i] = ansTable.getColumnModel().getColumn(i).getPreferredWidth();  
		}
		ansTableModel.fireTableStructureChanged();
		ansTable.getColumnModel().getColumn(0).setMaxWidth(16);
		for(int i=1;i<ansTableModel.getColumnCount();++i){
			ansTable.getColumnModel().getColumn(i).setPreferredWidth(sizes[i]);  
		}
	}
	
	public void selectAnswer(int row) {
		try {
			ansTable.clearSelection();
			if(row >= ansTableModel.getRowCount()){
				row = 0;
			}
			ansTable.setRowSelectionInterval(row, row);
			answerText.setEnabled(true);
			answerNotesText.setEnabled(true);
		} catch (IllegalArgumentException e) {
			answerText.setText("");
			answerNotesText.setText("");
			answerText.setEnabled(false);
			answerNotesText.setEnabled(false);
		}
	}

	private JComponent createVersionsPanel() {
		verAnsSplitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT,createTextCommentPanel(),createAnswersPanel());
		verAnsSplitPane.setOneTouchExpandable(true);
		return verAnsSplitPane;
	}

	private JPanel createTextCommentPanel() {
		JPanel panel = new JPanel(new GridLayout(1, 1));
		JTabbedPane tabbedPane = new JTabbedPane(JTabbedPane.BOTTOM);
		tabbedPane.addTab("Version Body",null,createVersionTextPanel());
		tabbedPane.addTab("Version Notes",null,createVersionNotesPanel());
		panel.add(tabbedPane);
		return panel;
	}
	
	private JPanel createVersionNotesPanel(){
		JPanel questNotesPanel = new JPanel(new GridLayout(1, 1));
		questNotesPanel.setBorder(
			BorderFactory.createCompoundBorder(
				BorderFactory.createTitledBorder("Version Notes:"),
				BorderFactory.createEmptyBorder(5, 5, 5, 5)));
		JScrollPane questNotesPane = new JScrollPane(verNotesText);
		questNotesPanel.add(questNotesPane);
		return questNotesPanel;
	}
	
	private JPanel createVersionTextPanel(){
		JPanel questTextPanel = new JPanel(new GridLayout(1, 1));
		questTextPanel.setBorder(
			BorderFactory.createCompoundBorder(
				BorderFactory.createTitledBorder("Version Body:"),
				BorderFactory.createEmptyBorder(5, 5, 5, 5)));
		JScrollPane questTextPane = new JScrollPane(verBodyText);
		questTextPanel.add(questTextPane);
		return questTextPanel;
	}

	private JComponent createAnswersPanel() {
		JPanel panel = new JPanel(new GridLayout(2, 1));
		panel.add(createAnswersTablePanel());
		panel.add(createAnswersTabbedPanel());
		return panel;
	}

		private JComponent createAnswersTablePanel() {
		tablePanel = new JPanel(new GridLayout(1, 1));
		tablePanel.setBorder(
			BorderFactory.createCompoundBorder(
				BorderFactory.createTitledBorder("Answers:"),
				BorderFactory.createEmptyBorder(5, 5, 5, 5)));
		ansTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		JScrollPane jScrollPane = new JScrollPane(ansTable);
		tablePanel.add(jScrollPane);
		return tablePanel;
	}
		
	private JPanel createAnswersTabbedPanel(){
		JPanel panel = new JPanel(new GridLayout(1,1));
		JTabbedPane tabbedPane = new JTabbedPane(JTabbedPane.BOTTOM);
		tabbedPane.addTab("Answer Text",null,createAnswerTextPanel());
		tabbedPane.addTab("Answer Notes",null,createAnswerNotesPanel());
		panel.add(tabbedPane);
		return panel;
	}

	private JComponent createAnswerTextPanel() {
		JPanel panel = new JPanel(new GridLayout(1, 1));
		panel.setBorder(
			BorderFactory.createCompoundBorder(
				BorderFactory.createTitledBorder("Answer Text:"),
				BorderFactory.createEmptyBorder(5, 5, 5, 5)));

		JScrollPane scrollPane = new JScrollPane(answerText);
		panel.add(scrollPane);
		return panel;
	}

	private JComponent createAnswerNotesPanel() {
		JPanel panel = new JPanel(new GridLayout(1, 1));
		panel.setBorder(
			BorderFactory.createCompoundBorder(
				BorderFactory.createTitledBorder("Answer Notes:"),
				BorderFactory.createEmptyBorder(5, 5, 5, 5)));

		JScrollPane scrollPane = new JScrollPane(answerNotesText);
		panel.add(scrollPane);
		return panel;
	}

	private void addListeners() {
		ansTable.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				if (e.getValueIsAdjusting())
					return;
				controller.finalizeScreenHandling();
				ListSelectionModel lsm = (ListSelectionModel) e.getSource();
				if (lsm.isSelectionEmpty()) {
//					selectAnswer(0);
					return;
				}
				answerText.setEnabled(true);
				answerNotesText.setEnabled(true);
				controller.answerSelected(lsm.getMinSelectionIndex());
				return;
			}
		});
		
		verBodyText.addKeyListener(new KeyListener() {
			public void keyPressed(KeyEvent arg0) {			}
			public void keyReleased(KeyEvent arg0) {
				if (arg0.getKeyCode() == KeyEvent.VK_ESCAPE) {
					verBodyText.setText(controller.getSelectedVersion().getBody());
					versionBodyChanged = false;
					return;
				}
				if(!GeneralParams.equalNullableStrings(verBodyText.getText(),controller.getSelectedVersion().getBody())){
					versionBodyChanged = true;
				}
			}
			public void keyTyped(KeyEvent arg0) {}
		});		

		verBodyText.addFocusListener(new FocusListener() {
			public void focusGained(FocusEvent e) {
				if(e.isTemporary()){
					return;
				}
				if(!GeneralParams.equalNullableStrings(verBodyText.getText(),controller.getSelectedVersion().getBody())){
					versionBodyChanged = true;
					controller.finalizeScreenHandling();
					verBodyText.requestFocus();
				}
				controller.getMainWindow().enableTextActions(verBodyText);
			}
			public void focusLost(FocusEvent e) {
				if(e.isTemporary()){
					return;
				}
				controller.getMainWindow().setTextActionSelection(verBodyText.getSelectionStart(),verBodyText.getSelectionEnd());
				controller.finalizeScreenHandling();
				if(!controller.getMainWindow().isTextButton(e.getOppositeComponent())){
					controller.getMainWindow().disableTextActions();
				}
			}
		});

		verNotesText.addKeyListener(new KeyListener() {
			public void keyPressed(KeyEvent arg0) {	}
			public void keyReleased(KeyEvent arg0) {
				if (arg0.getKeyCode() == KeyEvent.VK_ESCAPE) {
					verNotesText.setText(controller.getSelectedVersion().getNotes());
					versionNotesChanged = false;
					return;
				}
				if(!GeneralParams.equalNullableStrings(verNotesText.getText(),controller.getSelectedVersion().getNotes())){
					versionNotesChanged = true;	
				}				
			}
			public void keyTyped(KeyEvent arg0) {}
		});

		verNotesText.addFocusListener(new FocusListener() {
			public void focusGained(FocusEvent e) {
				if(e.isTemporary()){
					return;
				}
				if(!GeneralParams.equalNullableStrings(verNotesText.getText(),controller.getSelectedVersion().getNotes())){
					versionNotesChanged = true;
					controller.finalizeScreenHandling();
					verNotesText.requestFocus();
				}
				controller.getMainWindow().enableTextActions(verNotesText);
			}
			public void focusLost(FocusEvent e) {
				if(e.isTemporary()){
					return;
				}
				controller.getMainWindow().setTextActionSelection(verNotesText.getSelectionStart(),verNotesText.getSelectionEnd());
				controller.finalizeScreenHandling();
				if(!controller.getMainWindow().isTextButton(e.getOppositeComponent())){
					controller.getMainWindow().disableTextActions();
				}
			}
		});

		answerText.addKeyListener(new KeyListener() {
			public void keyPressed(KeyEvent arg0) {	}
			public void keyReleased(KeyEvent arg0) {
				if (arg0.getKeyCode() == KeyEvent.VK_ESCAPE) {
					answerText.setText(controller.getSelectedAnswer().getText());
					answerTextChanged = false;
					return;
				}
				if(!GeneralParams.equalNullableStrings(answerText.getText(),controller.getSelectedAnswer().getText())){
					answerTextChanged = true;					
				}
			}
			public void keyTyped(KeyEvent arg0) { }
		});

		answerText.addFocusListener(new FocusListener() {
			public void focusGained(FocusEvent e) {
				if(e.isTemporary()){
					return;
				}
				if(!GeneralParams.equalNullableStrings(answerText.getText(),controller.getSelectedAnswer().getText())){
					answerTextChanged = true;
					controller.finalizeScreenHandling();
					answerText.requestFocus();
				}
				controller.getMainWindow().enableTextActions(answerText);
			}
			public void focusLost(FocusEvent e) {
				if(e.isTemporary()){
					return;
				}
				controller.getMainWindow().setTextActionSelection(answerText.getSelectionStart(),answerText.getSelectionEnd());
				controller.finalizeScreenHandling();
				if(!controller.getMainWindow().isTextButton(e.getOppositeComponent())){
					controller.getMainWindow().disableTextActions();
				}
			}		
		});
		
		answerNotesText.addKeyListener(new KeyListener() {
			public void keyPressed(KeyEvent arg0) {}
			public void keyReleased(KeyEvent arg0) {
				if (arg0.getKeyCode() == KeyEvent.VK_ESCAPE) {
					answerNotesText.setText(controller.getSelectedAnswer().getNotes());
					answerNotesChanged = false;
					return;
				}
				if(!GeneralParams.equalNullableStrings(answerNotesText.getText(),controller.getSelectedAnswer().getNotes())){
					answerNotesChanged = true;
				}
			}
			public void keyTyped(KeyEvent arg0) { }
		});

		answerNotesText.addFocusListener(new FocusListener() {
			public void focusGained(FocusEvent e) {
				if(e.isTemporary()){
					return;
				}
				if(!GeneralParams.equalNullableStrings(answerNotesText.getText(),controller.getSelectedAnswer().getNotes())){
					answerNotesChanged = true;
					controller.finalizeScreenHandling();
					answerNotesText.requestFocus();
				}
				controller.getMainWindow().enableTextActions(answerNotesText);
			}
			public void focusLost(FocusEvent e) {
				if(e.isTemporary()){
					return;
				}
				controller.getMainWindow().setTextActionSelection(answerNotesText.getSelectionStart(),answerNotesText.getSelectionEnd());
				controller.finalizeScreenHandling();
				if(!controller.getMainWindow().isTextButton(e.getOppositeComponent())){
					controller.getMainWindow().disableTextActions();
				}
			}		
		});
	}

	class AnsTable extends JTable implements MouseListener {

		public AnsTable() {
			addMouseListener(this);
		}

		public void mouseReleased(MouseEvent e) {
			int ansRow = ansTable.rowAtPoint(e.getPoint());
			if (e.getButton() != 3) {
				return;
			}
			selectAnswer(ansRow);
			JPopupMenu tmenu = new JPopupMenu();
			Answer ans;
			try {
				ans = ansTableModel.getAnswerAtRow(ansRow);
			} catch (Throwable e1) {
				return;
			}
			Vector v =
				controller.getAnsPopUpItems(ans,controller.getSelectedVersion());
			for (Iterator it = v.iterator(); it.hasNext();) {
				tmenu.add((Component) it.next());
			}
			tmenu.show(this, e.getX(), e.getY());
		}

		public void mouseClicked(MouseEvent e) {
		}

		public void mouseEntered(MouseEvent e) {
		}

		public void mouseExited(MouseEvent e) {
		}

		public void mousePressed(MouseEvent e) {
		}
	}
}
