/*
 * Created on 11/07/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.gui.treenodes;

import il.ac.technion.cs.course236308.e3.med.model.StudentReply;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestRepliesList;
import il.ac.technion.cs.course236308.e3.med.model.TestsFactory;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.util.Iterator;

import javax.swing.ImageIcon;

/**
 * @author svali
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TestRepliesNode extends MedNode {

 
    private TestRepliesList trList;
    public TestRepliesNode(Test test) {
            super(test);
            TestsFactory tf = TestsFactory.getInstance();
            Test canonTest;
			try {
				canonTest = tf.getCopyOfTest(test.getId());
				canonTest.toCanonical();
				trList = canonTest.getTestRepliesList();
			} catch (Throwable e) {
				e.printStackTrace();
			}
             
            initInternalStructure(); // trList initialized inside
    }
    public Test getTest(){
        return (Test) getUserObject();
    }
    
    public TestRepliesList getExamRepliesList() {
       return trList; 
    }

    public TestNode getExamNode() {
        return (TestNode) getParentNode();
    }
  	public int getReplyIndex(StudentReply sr){
  		for (int i=0;i<this.getChildCount();i++){
  			if (((StudentReplyNode)getChildAt(i)).getStudentReply().getStudentId().equals(sr.getStudentId())){
				return i;  			
  			}
  		}
  		return -1;
  	}
    
    // This procedure should create sons of this node (Replies of each student)
    private void initInternalStructure() {
       
       Iterator iter = getExamRepliesList().getReplies().iterator();
       while (iter.hasNext()){
           StudentReply sr = (StudentReply) iter.next();  
           StudentReplyNode newNode = new StudentReplyNode(sr, this);
           add(newNode);   
       }
       
                
        
}

public String toString() {
    return "Student replies";
}

/* (non-Javadoc)
 * @see framework.MemsNode#getNodeTypeName()
 */
public String getNodeTypeName() {
    return "Students' replies";
}

/* (non-Javadoc)
 * @see framework.MemsNode#nodeRemoved(framework.MemsNode, framework.MemsNode, int)
 */
public void nodeRemoved(MedNode removedNode) {
    
    StudentReplyNode sNode = (StudentReplyNode) removedNode;
    getExamRepliesList().removeStudentReply(sNode.getStudentReply());
	
}

public void nodeAdded(MedNode childNode) {
    StudentReplyNode sNode = (StudentReplyNode) childNode;
    getExamRepliesList().addStudentReply(sNode.getStudentReply());
  }
/* (non-Javadoc)
 * @see il.ac.technion.cs.course236308.e3.med.gui.treenodes.MedNode#getIcon()
 */
public ImageIcon getIcon() {
    return GeneralParams.ICON_STUDENT_REPLIES;
}

}
