/*
 * Created on 18/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.model;

import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.db.DBConnect;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.util.Iterator;

import javax.swing.ImageIcon;

import org.jdom.Element;

/**
 * @author svali
 *
 *
 */
public class Question implements Comparable, LegalObject{
	private int numStudentsDI = 0;
	private int numStudentsDifficulty = 0;
	private Double avgDifficulty = null;
	private Double avgDI = null;

	private RetriableException isSelfLegal;
	private RetriableException isDescendantsLegal = null;
	protected Integer activeVersionId;
	protected java.util.List versions = new java.util.LinkedList();
	protected int ordinal;
	protected int mainCategoryId;
	protected java.util.List secondaryCategoryIds = new java.util.LinkedList();
	protected int id;
	protected boolean cancelled;

	/**
	 * @return Returns the avgDI.
	 */
	public Double getAvgDI() {
		return avgDI;
	}
	/**
	 * @param avgDI The avgDI to set.
	 */
	public void setAvgDI(Double avgDI) {
		this.avgDI = avgDI;
	}
	/**
	 * @return Returns the avgDifficulty.
	 */
	public Double getAvgDifficulty() {
		return avgDifficulty;
	}
	/**
	 * @param avgDifficulty The avgDifficulty to set.
	 */
	public void setAvgDifficulty(Double avgDifficulty) {
		this.avgDifficulty = avgDifficulty;
	}
	public int getNumStudentsDifficulty(){
		return numStudentsDifficulty;
	}
	
	public int getNumStudentsDI(){
		return numStudentsDI;
	}

	/**
	 * Method getActiveVersionId
	 * @return Integer
	 */
	public Integer getActiveVersionId() {
		return activeVersionId;
	}

	/**
	 * Method setActiveVersionId
	 * @param value
	 */
	public void setActiveVersionId(Integer value) {
		activeVersionId = value;
	}

	/**
	 * Method getVersions
	 * @return java.util.List
	 */
	public java.util.List getVersions() {
		return versions;
	}

	/**
	 * Method getOrdinal
	 * @return int
	 */
	public int getOrdinal() {
		return ordinal;
	}

	/**
	 * Method setOrdinal
	 * @param value
	 */
	public void setOrdinal(int value) {
		ordinal = value;
	}

	/**
	 * Method getMainCategoryId
	 * @return int
	 */
	public int getMainCategoryId() {
		return mainCategoryId;
	}

	/**
	 * Method setMainCategoryId
	 * @param value
	 */
	public void setMainCategoryId(int value) {
		mainCategoryId = value;
	}
	
	public void setNumStudentsDifficulty(int num){
		numStudentsDifficulty = num;
	}
	
	public void setNumStudentsDI(int num){
		numStudentsDI = num;
	}
	/**
	 * Method getSecondaryCategoryIds
	 * @return java.util.List
	 */
	public java.util.List getSecondaryCategoryIds() {
		return secondaryCategoryIds;
	}

	/**
	 * Method getId
	 * @return int
	 */
	public int getId() {
		return id;
	}

	/**
	 * Method setId
	 * @param value
	 */
	public void setId(int value) {
		id = value;
	}

	/**
	 * Method isCancelled
	 * @return boolean
	 */
	public boolean isCancelled() {
		return cancelled;
	}

	/**
	 * Method setCancelled
	 * @param value
	 */
	public void setCancelled(boolean value) {
		cancelled = value;
	}


	/**
	 * 
	 * @return how many DB records were effected by this command 
	 * @throws CriticalException
	 */
	
	public int updateDB() throws CriticalException{
		return DBConnect.updateQuestion(this);
	}
	
	/**
	 * Method equals
	 * @see Object#equals(Object)
	 */
	public boolean equals(Object obj){
		if(!(obj instanceof Question)){
			return false;
		}
		return ((Question)obj).getId() == getId();
	}
	
	/**
	 * Method hashCode
	 * @see Object#hashCode()
	 */
	public int hashCode(){
		return getId();
	}
	
	/**
	 * Method containsLockedVersion
	 * @return boolean
	 * @throws CriticalException
	 * @throws RetriableException
	 */
	public boolean hasVersionsInExams(){
		for(Iterator it=getVersions().iterator();it.hasNext();){
			Version ver = (Version)it.next();
			if(ver.isAppearInTests()){
				return true;
			}
		}
		return false; 
	}
	
	/**
	 * Method getUpdatedVersion
	 * @return Version
	 * @throws CriticalException
	 * @throws RetriableException
	 */
	public Version getUpdatedVersion() 
		throws RetriableException, CriticalException{
		if(this.getActiveVersionId() != null){
			return VersionsFactory.getInstance().
				getVersion(getActiveVersionId().intValue());
		}
		Iterator it = this.getVersions().iterator();
		Version updatedVersion = (Version)it.next();
		for(;it.hasNext();){
			Version ver = (Version)it.next(); 
			if(ver.getUpdated().after(updatedVersion.getUpdated())){
				updatedVersion = ver; 
			}
		}
		return updatedVersion;
	}
	
	public ImageIcon getIcon(){
		try{
			isLegal();
			return GeneralParams.ICON_QUESTION;	
		}catch(RetriableException e){
			return GeneralParams.ICON_QUESTION_ILLEGAL;
		}
	}
	
	public boolean isSelfLegal() throws RetriableException{
		if(isSelfLegal != null){
			throw isSelfLegal;
		}
		return true;		
	}
	
	/**
	 * Method isLegal
	 * @return boolean
	 * @throws RetriableException
	 */
	public boolean isLegal() throws RetriableException{
		if(isSelfLegal != null){
			throw isSelfLegal;
		}
		if(isDescendantsLegal != null){
			throw isDescendantsLegal;
		}
		return true;
	}
	
	public void recalculateLegality() throws CriticalException{
		recalculateDescendandsLegality();
		recalculateSelfLegality();
	}
	
	public void recalculateSelfLegality() throws  CriticalException{
		isSelfLegal = null;
		try{
			if(getVersions().size() < 1){
				throw new RetriableException("Question "+ getId() + " contains no version");
			}
			if(getActiveVersionId() == null){
				throw new RetriableException("Question "+ getId() + " does not contain Active Version");
			}
			Category mainCat = CategoriesFactory.getInstance().getCategory(getMainCategoryId());
			for(Iterator it=getSecondaryCategoryIds().iterator();it.hasNext();){
				Category secCat = CategoriesFactory.getInstance().getCategory(((Integer)it.next()).intValue());
				if(mainCat.isDescendant(secCat)){throw new 
								RetriableException("Question "+ getId() +
								"  contains secondary category "
						        + secCat.getFullName() + " which is ancestor" +
								" of its main category "  + mainCat.getFullName());	
				}
			}
		}catch(RetriableException e){
			CommandDispatcher.getIllegalObjects().add(this);
			isSelfLegal = e;
		}
		if(isSelfLegal == null){
			CommandDispatcher.getInstance().removeIllegalObject(this);
		}
		isDescendantsLegal = null;
		try{
			for(Iterator it=getVersions().iterator();it.hasNext();){
				((Version)it.next()).isLegal();
			}			
		}catch(RetriableException e){
			isDescendantsLegal = e;
		}
	}
	
	private void recalculateDescendandsLegality() throws CriticalException{
		for(Iterator it=getVersions().iterator();it.hasNext();){
			((Version)it.next()).recalculateLegality();
		}
	}

	/**
	 * Method toElement
	 * @return Element
	 * @throws CriticalException
	 * @throws RetriableException
	 */
	public Element toElement(boolean exportDirection) throws RetriableException, CriticalException{
		Element quest = new Element("question");
		Element mainCatElement = new Element("mainCategory");
		Category mainCategory = 
		CategoriesFactory.getInstance().getCategory(getMainCategoryId());
		quest.addContent(mainCatElement.setText(mainCategory.getFullName()));
		quest.setAttribute("canceled",String.valueOf(isCancelled()));
		for(Iterator it=getVersions().iterator();it.hasNext();){
			Version ver = (Version)it.next();
			quest.addContent(ver.toElement(exportDirection));
		}
		return quest;
	}

	public int compareTo(Object obj) {
		Question quest = (Question)obj;
		return new Integer(getId()).compareTo(new Integer(quest.getId()));
	}

	public String toString(){
		return "Question " + getId();
	}
	
}
