/*
 * Created on 17/04/2004
 *
 * Created by: svali
 *  */
package il.ac.technion.cs.course236308.e3.med.model;

import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.db.DBConnect;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestGradingNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestQuestionsListNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestRepliesNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestStatisticsNode;
import il.ac.technion.cs.course236308.e3.med.model.testscrambler.TestScrambler;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;
import il.ac.technion.cs.course236308.e3.med.xmlTools.ChangeAnsRefs;
import il.ac.technion.cs.course236308.e3.med.xmlTools.FindAnsRefs;

import java.io.IOException;
import java.io.StringReader;
import java.text.SimpleDateFormat;
import java.util.Collections;
import java.util.Enumeration;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;

import javax.swing.ImageIcon;
import javax.swing.tree.DefaultMutableTreeNode;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.xml.sax.InputSource;

/**
 * @author svali
 *
 */
public class Test implements Comparable,LegalObject{
	private RetriableException isSelfLegal = null;
	private RetriableException isDescendantsLegal = null;
	protected String status = "U";
	protected int minGrade = 55;
	protected int maxGrade = 100;
	protected String courseName = "course name was not set";
	protected String description2;
	protected String instructions;
	protected java.util.Calendar date;
	protected double factorConstA = 1;
	protected String description1;
	protected int passingGrade = 55;
	protected double factorConstB = 0;
	protected java.util.Calendar updated = new GregorianCalendar();
	protected java.util.List testVersions = new java.util.LinkedList();
	protected java.util.Calendar created = new GregorianCalendar();
	protected int id;
	
	public Object clone(){
		Test test = new Test();
		test.status = status==null?null:new String(status);
		test.minGrade = minGrade;
		test.maxGrade = maxGrade;
		test.courseName = courseName==null?null:new String(courseName);
		test.description2 = description2==null?null:new String(description2);
		test.instructions = instructions==null?null:new String(instructions);
		test.date = date==null?null:(java.util.Calendar)date.clone();
		test.factorConstA = factorConstA;
		test.description1 = description1==null?null:new String(description1);
		test.passingGrade = passingGrade;
		test.factorConstB = factorConstB;
		test.updated = updated==null?null:(java.util.Calendar)updated.clone();
		test.testVersions = new java.util.LinkedList();
		for(Iterator it=testVersions.iterator();it.hasNext();){
			test.testVersions.add(((TestVersion)it.next()).clone());
		}
		test.created = created==null?null:(java.util.Calendar)created.clone();
		test.id = id;
		return test;
	}
	
    public int getTestVersionOrdinal(TestReply tr) throws RetriableException, CriticalException{
            int place=0;
            Answer ans = AnswersFactory.getInstance().getAnswer(tr.getAnswerId());
            Version ver = VersionsFactory.getInstance().getVersion(ans.getVersionId());
    //        Test test = TestsFactory.getInstance().getTest(tr.getTestId());
//			Test test = TestsFactory.getInstance().getCopyOfTest(tr.getTestId());
//			test.toCanonical();
            TestVersion[] tVersions = new TestVersion[getTestVersions().size()];
            TestVersion[] testVersions =  (TestVersion[]) getTestVersions().toArray(tVersions);
            for (place=0;place<testVersions.length;place++){
                if (testVersions[place].getVersion().getId()==ver.getId())
                    return place+1;
            }
            return place;
        }
   
    public TestRepliesList getTestRepliesList(){

        TestRepliesList trList = new TestRepliesList(this);
        // Now we should create StudentReply structs and add them to trList        
        TestRepliesFactory trf = TestRepliesFactory.getInstance();
        TestTakersFactory ttf = TestTakersFactory.getInstance();
        try {
	            List testReplies = trf.getTestRepliesList(getId());
                Iterator iter = testReplies.iterator();
                Hashtable srHash = new Hashtable();
                while(iter.hasNext()){
                    TestReply tr =(TestReply) iter.next();
                    if (srHash.containsKey(tr.getTestTakerId())==false){
                    	TestTaker tTaker = ttf.getTestTaker(tr.getTestTakerId(),getId());	
						StudentReply sr = 
							new StudentReply(tr.getTestTakerId(),tTaker.getNotebookNumber());
						sr.setStudentName(tTaker.getName()); 
						srHash.put(tr.getTestTakerId(),sr);
                    }
                   
                    Answer ans = AnswersFactory.getInstance().getAnswer(tr.getAnswerId());
                    StudentReply cur_sr = (StudentReply)srHash.get(tr.getTestTakerId());
                    cur_sr.addAnswer(new Integer(getTestVersionOrdinal(tr)),
                                     new Integer(ans.getOrdinal()));
                    srHash.put(tr.getTestTakerId(),cur_sr);
                    
                }
                        // here we added one testReply
                	
               		Enumeration replies = srHash.elements();  
               		while (replies.hasMoreElements())
               			trList.addStudentReply((StudentReply)replies.nextElement());
                // now we should fill trlist with empty replies
                	List tTakers = ttf.getTestTakersOfTest(this);
                	Iterator it = tTakers.iterator();
                	while (it.hasNext()){
                		TestTaker tt= (TestTaker)it.next();
                		String tTakerId = tt.getId();
                		if (srHash.containsKey(tTakerId)==false){
                			StudentReply srNew = new StudentReply(tTakerId);
                			srNew.setStudentName(tt.getName());
                			srNew.setRID(tt.getNotebookNumber());
                			trList.addStudentReply(srNew);
                		}
                	}                	
                } catch (Throwable e1) {
                    e1.printStackTrace();
                }
  
       return trList;
    }
	
	/**
	 * Method getStatus
	 * @return String
	 */
	public String getStatus() {
		return status;
	}

	/**
	 * Method setStatus
	 * @param value
	 */
	public void setStatus(String value) {
		status = value;
	}

	/**
	 * Method getMinGrade
	 * @return int
	 */
	public int getMinGrade() {
		return minGrade;
	}

	/**
	 * Method setMinGrade
	 * @param value
	 */
	public void setMinGrade(int value) {
		minGrade = value;
	}

	/**
	 * Method getMaxGrade
	 * @return int
	 */
	public int getMaxGrade() {
		return maxGrade;
	}

	/**
	 * Method setMaxGrade
	 * @param value
	 */
	public void setMaxGrade(int value) {
		maxGrade = value;
	}

	/**
	 * Method getCourseName
	 * @return String
	 */
	public String getCourseName() {
		return courseName;
	}

	/**
	 * Method setCourseName
	 * @param value
	 */
	public void setCourseName(String value) {
		courseName = value;
	}

	/**
	 * Method getDescription2
	 * @return String
	 */
	public String getDescription2() {
		return description2;
	}

	/**
	 * Method setDescription2
	 * @param value
	 */
	public void setDescription2(String value) {
		description2 = value;
	}

	/**
	 * Method getInstructions
	 * @return String
	 */
	public String getInstructions() {
		return instructions;
	}

	/**
	 * Method setInstructions
	 * @param value
	 */
	public void setInstructions(String value) {
		instructions = value;
	}

	/**
	 * Method getDate
	 * @return java.util.Calendar
	 */
	public java.util.Calendar getDate() {
		return date;
	}

	/**
	 * Method setDate
	 * @param value
	 */
	public void setDate(java.util.Calendar value) {
		date = value;
	}

	/**
	 * Method getFactorConstA
	 * @return double
	 */
	public double getFactorConstA() {
		return factorConstA;
	}

	/**
	 * Method setFactorConstA
	 * @param value
	 */
	public void setFactorConstA(double value) {
		factorConstA = value;
	}

	/**
	 * Method getDescription1
	 * @return String
	 */
	public String getDescription1() {
		return description1;
	}

	/**
	 * Method setDescription1
	 * @param value
	 */
	public void setDescription1(String value) {
		description1 = value;
	}

	/**
	 * Method getPassingGrade
	 * @return int
	 */
	public int getPassingGrade() {
		return passingGrade;
	}

	/**
	 * Method setPassingGrade
	 * @param value
	 */
	public void setPassingGrade(int value) {
		passingGrade = value;
	}

	/**
	 * Method getFactorConstB
	 * @return double
	 */
	public double getFactorConstB() {
		return factorConstB;
	}

	/**
	 * Method setFactorConstB
	 * @param value
	 */
	public void setFactorConstB(double value) {
		factorConstB = value;
	}

	/**
	 * Method getUpdated
	 * @return java.util.Calendar
	 */
	public java.util.Calendar getUpdated() {
		return updated;
	}

	/**
	 * Method setUpdated
	 * @param value
	 */
	public void setUpdated(java.util.Calendar value) {
		updated = value;
	}

	/**
	 * Method getTestVersions
	 * @return java.util.List
	 */
	public java.util.List getTestVersions() {
		return testVersions;
	}

	/**
	 * Method getCreated
	 * @return java.util.Calendar
	 */
	public java.util.Calendar getCreated() {
		return created;
	}

	/**
	 * Method setCreated
	 * @param value
	 */
	public void setCreated(java.util.Calendar value) {
		created = value;
	}

	/**
	 * Method getId
	 * @return int
	 */
	public int getId() {
		return id;
	}

	/**
	 * Method setId
	 * @param value
	 */
	public void setId(int value) {
		id = value;
	}

	/**
	 * Method updateDB
	 * @return int
	 * @throws CriticalException
	 */
	public int updateDB() throws CriticalException{
		return DBConnect.updateTest(this);
	}
	
	public int compareTo(Object obj){
		Test test = (Test)obj;
		String myDate = 
			getDate()!=null?" - " + new SimpleDateFormat("yyyy-MM-dd").format(getDate().getTime()):"";
		String objDate= 
			test.getDate()!=null?" - " + new SimpleDateFormat("yyyy-MM-dd").format(test.getDate().getTime()):"";
		return new String(getCourseName()+myDate).compareTo(test.getCourseName() + objDate);
	}

	/**
	 * Method equals
	 * @see Object#equals(Object)
	 */
	public boolean equals(Object obj){
		if(!(obj instanceof Test)){
			return false;
		}
		return ((Test)obj).getId() == getId();
	}
	
	/**
	 * Method hashCode
	 * @see Object#hashCode()
	 */
	public int hashCode(){
		return getId();
	}
	
	/**
	 * Method getNumGraded
	 * @return int
	 * @throws CriticalException
	 * @throws RetriableException
	 */
	public int getNumGraded(){
		return TestTakersFactory.getInstance().countTestTakers(this);		
	}
	
	/**
	 * Method containsQuestion
	 * @param quest
	 * @return boolean
	 * @throws CriticalException
	 */
	public boolean containsQuestion(Question quest){
		for(Iterator it=getTestVersions().iterator();it.hasNext();){
			TestVersion tv = (TestVersion)it.next();
			int qId= tv.getVersion().getQuestionId();
			if(qId == quest.getId()){
				return true;
			}
		}
		return false;		
	}
	
	/**
	 * Method setScrambledOrdinals
	 * @throws RetriableException
	 * @throws CriticalException
	 */
	public void setScrambledOrdinals() throws RetriableException{
		for(Iterator it = this.getTestVersions().iterator();it.hasNext();){
			TestVersion tv = (TestVersion)it.next();
			HashMap ansRefs = new HashMap();
			byte ordinal = 1;
			Version ver = tv.getVersion();
			for(Iterator it2=ver.getAnswers().iterator();it2.hasNext();){
				Answer ans = (Answer)it2.next();
				ansRefs.put(String.valueOf(ans.getOrdinal()),String.valueOf(ordinal));
				ans.setOrdinal(ordinal);
				++ordinal;
			}
			
			for(Iterator it2=ver.getAnswers().iterator();it2.hasNext();){
				Answer ans = (Answer)it2.next();
				String[] refsArr = FindAnsRefs.findAnsRefs(ans.getText());
				String[] newArr = new String[refsArr.length];
				
				for(int i=0; i<refsArr.length;i++){
					String newRef = (String)ansRefs.get(refsArr[i]);
					newArr[i] = newRef==null? refsArr[i]:newRef;
				}
				ans.setText(ChangeAnsRefs.changeAnsRefs(ans.getText(),newArr));
				 
			}
		}
		
	}
	
	/**
	 * Method toCanonical
	 * @throws RetriableException
	 * @throws CriticalException
	 */
	public void toCanonical() throws RetriableException{
		if (getTestVersions()==null || getTestVersions().size()==0) return;
		Collections.sort(getTestVersions());
		for(Iterator it = this.getTestVersions().iterator();it.hasNext();){
			TestVersion tv = (TestVersion)it.next();
			Version ver = tv.getVersion();
			Collections.sort(ver.getAnswers());
		}
		setScrambledOrdinals();
	}
	/**
	 * Method toScrambled
	 * @param copyNum
	 * @throws RetriableException
	 * @throws CriticalException
	 */
	public void toScrambled(int copyNum) throws RetriableException{
		toCanonical();
		TestScrambler ts = new TestScrambler(this);
		ts.scramble(copyNum);
		setScrambledOrdinals();
	}
	
	/**
	 * Method isLegal
	 * @return boolean
	 * @throws CriticalException
	 * @throws RetriableException
	 */
	
	public ImageIcon getIcon() {
		try{
			isLegal();
			return GeneralParams.ICON_EXAM;
		}catch(Throwable e){
			return GeneralParams.ICON_EXAM_ILLEGAL;
		}

	}

	public RetriableException getIllegalityDescription(){
		return isSelfLegal;
	}
	
	public boolean isSelfLegal() throws RetriableException{
		if(isSelfLegal != null){
			throw isSelfLegal;
		}
		return true;		
	}
	
	public boolean isLegal() throws RetriableException{
		if(isSelfLegal != null){
			throw isSelfLegal;
		}
		if(isDescendantsLegal != null){
			throw isDescendantsLegal;
		}
		return true;
	}

	public void recalculateLegality() throws CriticalException {
		recalculateSelfLegality();
	}
	
	private void setIllegalDescription(RetriableException e){
		CommandDispatcher.getIllegalObjects().add(this);
		isSelfLegal = e;
	}
	
	public void recalculateSelfLegality() throws CriticalException {
		isSelfLegal = null;
		if(getTestVersions().size() == 0){
			setIllegalDescription(new RetriableException("Test contains no versions"));
			return;
		}
		if(getDate() != null && getStatus().equals("U") && 
				getDate().before(new GregorianCalendar())){
					setIllegalDescription(new RetriableException("Exam is UnderConstraction with Date < Today"));
					return;
			}
		if(getDate()!=null && (getStatus().equals("G") ||
			 getStatus().equals("P")) && getDate().after(new GregorianCalendar())){
				setIllegalDescription(new RetriableException("Exam with status P or G must have Date < Today"));
				return;
		}
		for(Iterator it=getTestVersions().iterator();it.hasNext();){
			TestVersion tv = (TestVersion)it.next();
			Version ver = tv.getVersion();
			Question quest;
			try {
				quest = QuestionsFactory.getInstance().getQuestion(ver.getQuestionId());
			} catch (Throwable e) {
				return;			
			}
			if(getStatus().equals("U") && quest.isCancelled()){
				setIllegalDescription(new RetriableException("Test contains version " + ver.getId() 
				+ " which belongs to cancelled question"));
				return;
			}			
			if(getStatus().equals("U") && (quest.getActiveVersionId() == null || ver.getId() != quest.getActiveVersionId().intValue())){	
				setIllegalDescription(new RetriableException("Test contains Not Active version " 
						+ver.getId() + " of question " + quest.getId()));
				return;
			}
			boolean have100Perc = false;
			for(Iterator itAns=tv.getTestAnswers().iterator();itAns.hasNext();){
				if(((TestAnswer)itAns.next()).weight == 100){
					have100Perc = true;
					break;
				}
			}
			if(!have100Perc){
				setIllegalDescription(new RetriableException("Version " 
						+ver.getId() + " does not have answer with 100% weight"));
				return;
			}
		}
		CommandDispatcher.getInstance().removeIllegalObject(this);
		isDescendantsLegal = null;
		try{
			for(Iterator it=getTestVersions().iterator();it.hasNext();){
				((TestVersion)it.next()).getVersion().isLegal();
			}			
		}catch(RetriableException e){
			isDescendantsLegal = e;
		}
	}
		
	/**
	 * Method toElement
	 * @return Element
	 * @throws CriticalException
	 * @throws RetriableException
	 */
	public Element toElement() throws RetriableException, CriticalException{
		Element test = new Element("test");
		Element mycourseName = 
			(new Element("courseName")).setText(getCourseName());
		test.addContent(mycourseName);
		if(getDescription1() !=null){
			Element desc1 = 
				(new Element("description1")).setText(getDescription1());
			test.addContent(desc1);
		}
		if(getDescription2() !=null){
			Element desc2 = (
				new Element("description2")).setText(getDescription2());
			test.addContent(desc2);
		}
		if(getDate()!=null){
			Element mydate= (
				new Element("date")).setText((new 
				SimpleDateFormat("yyyy-MM-dd HH:mm:ss")).
				format(getDate().getTime()).replaceFirst(" ","T"));
			test.addContent(mydate);
		}
		if(getInstructions() != null){
			Document doc;
			try {
				String mybody = "<instructions>"+getInstructions()+"</instructions>";
				InputSource source = new InputSource(new StringReader(mybody));
				SAXBuilder sb = GeneralParams.saxBuilder;
				doc = (sb).build(source);
			} catch (JDOMException e1) {
				throw new 
				RetriableException("Converting text to XML element failed");			
			} catch (IOException e1) {
				throw new 
				RetriableException("Converting text to XML element failed");
			}
			Element elementbody = (Element) doc.getRootElement().detach();
			test.addContent(elementbody);
		}
		for(Iterator it=getTestVersions().iterator();it.hasNext();){
			TestVersion tv = (TestVersion)it.next();
			test.addContent(tv.toElement());
		}
		return test;
	}
	
	public String toString(){
		return this.getCourseName()  + 
		(getDate()!=null?" - "+ new SimpleDateFormat("yyyy-MM-dd").format(getDate().getTime()):"");
	}
	
	public DefaultMutableTreeNode toTreeNode(){
		TestNode dmtn = new TestNode(this);
		TestQuestionsListNode dmtn1 = new TestQuestionsListNode("Questions",dmtn.getTest());
		TestGradingNode dmtn2 = new TestGradingNode("Grading Policy");
        TestRepliesNode dmtn3 = new TestRepliesNode(dmtn.getTest());
		TestStatisticsNode dmtn4 = new TestStatisticsNode(null);
		dmtn.add(dmtn1);
		dmtn.add(dmtn2);
		dmtn.add(dmtn3);
		dmtn.add(dmtn4);
		return dmtn;
	}
   
  
}
