/*
 * Created on 17/04/2004
 *
 * Created by: svali
 *  */
package il.ac.technion.cs.course236308.e3.med.model;

import il.ac.technion.cs.course236308.e3.med.gui.treenodes.MedNode;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestCategoryNode;

import java.util.HashMap;
import java.util.Iterator;
import java.util.StringTokenizer;

/**
 * @author svali
 *
 */
public class TestCategoriesFactory{	
	private static TestCategoriesFactory instance = new TestCategoriesFactory();
	private HashMap testCategories_ = new HashMap();

	private TestCategoriesFactory(){}
	
	/**
	 * Method getInstance
	 * @return CategoriesFactory
	 */
	public static synchronized TestCategoriesFactory getInstance(){
		return instance; 
	}
	
	/**
	 * Method getRootCategory
	 * @return Category
	 * @throws CriticalException
	 * @throws RetriableException
	 */
    private String hash(String testCatLongName,Test test){
		return testCatLongName + test.getId();
    }
    
    private String hash(TestCategory testCat){
        return hash(testCat.getLongName(),testCat.getTest());
    }
    
    
	/**
	 * Method getCategory
	 * @param id
	 * @return Category
	 * @throws CriticalException
	 * @throws RetriableException
	 */
	public synchronized TestCategoryNode getTestCategoryNode(String longName,Test test){
		TestCategoryNode testCatNode = null;
		if((testCatNode =(TestCategoryNode)testCategories_.get(hash(longName,test))) != null){
			return testCatNode;
		}
        TestCategory testCat = new TestCategory();
        testCat.setLongName(longName);
        testCat.setTest(test);
        testCatNode = new TestCategoryNode(testCat);
        testCategories_.put(hash(testCat), testCatNode);
        return testCatNode;
	}
	
	public synchronized void removeTestCategoriesPath(TestCategoryNode testCatNode){
		testCategories_.remove(hash(testCatNode.getTestCategory()));
		try{
			testCatNode.getTestCategory().getTestVersions().clear();
			((MedNode)testCatNode.getParent()).remove(testCatNode);
			testCatNode.setParent(null);
			for(int i=0;i<testCatNode.getChildCount();++i){
				removeTestCategoriesPath((TestCategoryNode) testCatNode.getChildAt(i));
			}
		}catch(Throwable e){}
	}
	
 	
	public TestCategoryNode buildTree(Test test){
		TestCategoryNode rootNode = getTestCategoryNode("/",test);
		for(Iterator it=test.getTestVersions().iterator();it.hasNext();){
			TestVersion testVer = (TestVersion)it.next();
            addTreePath(rootNode,testVer);
		}
		return rootNode;
	}
    
    private void addTreePath(TestCategoryNode root,TestVersion testVer){
        StringTokenizer st = new StringTokenizer(testVer.getFullCategoryName(),"/");
        String categoryName = "";
		TestCategoryNode lastCatNode = root;
        while(st.hasMoreTokens()){
        	categoryName+="/" + st.nextToken();
			TestCategoryNode testCatNode = getTestCategoryNode(categoryName,root.getTestCategory().getTest());
			lastCatNode.add(testCatNode);
			lastCatNode = testCatNode;
        }
        lastCatNode.getTestCategory().getTestVersions().add(testVer);
    }
    
    public TestCategoryNode getTestCategoryNode(TestVersion testVersion){
        Test test;
         try {
             test = TestsFactory.getInstance().getTest(testVersion.getTestId());
         } catch (Throwable e) {
             e.printStackTrace();
             return null;
         }
         return getTestCategoryNode(testVersion.getFullCategoryName(), test);
    }
}
