/*
 * Created on 23/04/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.script;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.StreamTokenizer;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.Iterator;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type MedScript
 * @author sybenny
 * @version 1.0
 */
public class MedScript {
	private MedScript(){}
	/** Field INTERACTIVE_MODE */
	public static final int INTERACTIVE_MODE = 0;
	/** Field BATCH_MODE */
	public static final int BATCH_MODE = 1;
	/** Field mode */
	static int mode;
	/** Field cont */
	static boolean cont = false;
	/** Field in */
	static BufferedReader in;

	/**
	 * Method getMode
	 * @return int
	 */
	public static int getMode() {
		return mode;
	}

	/**
	 * Method askMissingParameter
	 * @param parameterName
	 * @param usage
	 * @return String
	 * @throws IOException
	 * @throws RetriableException
	 */
	public static String askMissingParameter(
		String parameterName,
		String usage)
		throws IOException, RetriableException {
		if (getMode() == BATCH_MODE)
			throw new RetriableException(usage);
		MedReporter.report(
			"? Please provide a value for \""
				+ parameterName
				+ "\", or press Enter to abort this command");
		return in.readLine();
	}
	/**
	 * Method getPackageName
	 * @param command
	 * @return String
	 */
	public static String getPackageName(String command){
		String prefix = 
		new String("il.ac.technion.cs.course236308.e3.med.script.command.");
		if (command.startsWith("answer")) return prefix.concat("answer");
		if (command.startsWith("database")) return prefix.concat("database");
		if (command.startsWith("version")) return prefix.concat("version");
		if (command.startsWith("test")) return prefix.concat("test");
		if (command.startsWith("question")) return prefix.concat("question");
		if (command.startsWith("category")) return prefix.concat("category");
		return prefix.concat("general");
	}
	/**
	 * Method parseParams
	 * @param text
	 * @return String[]
	 * @throws CriticalException
	 * @throws IOException
	 */
	public static String[] parseParams(String text) 
	throws IOException, CriticalException {
		ArrayList cl = new ArrayList();
		Reader reader = new StringReader(text);
		StreamTokenizer tok = new StreamTokenizer(reader);
		tok.quoteChar('"');
		tok.slashSlashComments(false);
		tok.slashStarComments(false);
		tok.eolIsSignificant(false);
		tok.lowerCaseMode(false);
		//	tok.ordinaryChar('.');
		//	tok.ordinaryChar('-');
		//	tok.ordinaryChar('\'');
				
		while (tok.nextToken() != StreamTokenizer.TT_EOF) {
			String s = null;
			switch (tok.ttype) {
				case StreamTokenizer.TT_NUMBER :
					if (tok.nval == (int) tok.nval) {
						s = (new Integer((int) tok.nval)).toString();
					} else {
						s = Double.toString(tok.nval);
					}
					break;
				case '"' :
					s = (new String("\"")).concat(tok.sval).concat("\"");
					break;
				case StreamTokenizer.TT_WORD :
					s = tok.sval;
					break;
				default: // single character in ttype
					s = String.valueOf((char)tok.ttype);
					break;
				}
			if (s == null)
				throw new CriticalException("Internal Error in Parser (1)");
				//System.out.println(s);
				cl.add(s);
		}
		String[] commandLine = new String[cl.size()];
		int i = 0;
		for (Iterator it = cl.iterator(); it.hasNext(); i++) {
				commandLine[i] = (String) it.next();
		}
		return commandLine;
	}
	
	/**
	 * Method run
	 */
	public static void run() {

		while (true) {
			try {
				String str = in.readLine();
				if(str == null)
					break;
				str = str.trim();
				if(str.equals(""))
					continue;
				if (str.startsWith("//"))
					continue;
				if (str.compareTo("quit") == 0)
					break;
				
				String com = str.split("\\s+")[0];
				
				if (com.length() == 0 || com.charAt(0) > 'z' 
					|| com.charAt(0) < 'a') {
					throw new RetriableException("No such command: " + com);
				}
				System.out.println("# -------> " + str);
				String packageName = getPackageName(com);			
				String sufix = com.substring(0, 1).toUpperCase().
								concat(com.substring(1));
				String commandName = packageName.concat(".").concat(sufix);
				ScriptCommand command;

				try {
					command =
						(ScriptCommand) Class
							.forName(commandName)
							.newInstance();
				} catch (InstantiationException e) {
					throw new RetriableException(
						"No such command: " + com);
				} catch (IllegalAccessException e) {
					throw new RetriableException(
						"No such command: " + com);
				} catch (ClassNotFoundException e) {
					throw new RetriableException(
						"No such command: " + com);
				} catch (NoClassDefFoundError e) {
					throw new RetriableException(
						"No such command: " + com);
				}
				String params = str.substring(com.length()).trim();
				command.setParams(parseParams(params));
				command.execute();

			} catch (IOException e) {
				MedReporter.report("IO Error while reading input");
				break;
			} catch (CriticalException e) {
				MedReporter.report("!F " + e.getMessage());
				//e.printStackTrace();
				break;
			} catch (MedException e) {
				MedReporter.report("!E " + e.getMessage());
				//e.printStackTrace();
				if (!cont)
					break;
			}

		}
		MedReporter.report("# Bye!");
	}

	/**
	 * Method main
	 * @param args
	 */
	public static void main(String[] args) {
		GeneralParams.scriptMode = true;
		try {
			
			if (args.length == 0) {
				in = new BufferedReader(new InputStreamReader(System.in));
				mode = INTERACTIVE_MODE;
				cont = true;
			} else if (args.length >= 1) {
				try {
	//System.setOut(new PrintStream(new FileOutputStream(args[0]+".out")));
					in = new BufferedReader(new FileReader(args[0]));
					mode = BATCH_MODE;
				} catch (FileNotFoundException e) {
					MedReporter.report("Error: File "+args[0]+" not found.");
					return;
				}
				if (args.length == 2) {
					String flag = args[1];
					if (flag.equals("-cont")) {
						cont = true;
					} else {
						throw new CriticalException("Usage");
					}
				}
			}
		} catch (CriticalException e) {
			MedReporter.report("Wrong parameters");
			MedReporter.report("Usage: java MedScript.class");
			MedReporter.report(
				"Usage: java MedScript.class <command file> [-cont]");
			return;
		}
		
		
		try {
			BufferedReader lastOpenedDB = 
			new BufferedReader
				(new FileReader(GeneralParams.LAST_DATABASEOPEN_INFO_FILE));
			String url = lastOpenedDB.readLine();
			String username = lastOpenedDB.readLine();
			String password = lastOpenedDB.readLine();
			lastOpenedDB.close();
			if (url==null || url.length()==0 || 
						username==null || password==null) 
				throw new RetriableException("Wrong url");
			Command c = new 
			il.ac.technion.cs.course236308.e3.med.command.database.
									DatabaseOpen(url, username, password);			
			CommandDispatcher.getInstance().run(c);
			MedReporter.report("# default database " +
				"(from last session) successfully opened, ready to work");
		} catch (FileNotFoundException e1) {
		} catch (IOException e2){
		} catch (MedException e3) {
		}
		// We would like to do nothing in case that one of these exceptions 
		// happened			
		run();
	}

}
