/*
 * Created on 06/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.category;

import java.util.Iterator;
import java.util.List;
import java.util.TreeSet;

import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Category;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type CategoryGetSubcategories
 * @author sybenny
 * @version 1.0
 */
public class CategoryGetSubcategories extends ScriptCommand {
	
	/**
	 * Method CategoryGetSubcategories
	 */
	public CategoryGetSubcategories(){
		usage = "Should be: categoryGetSubcategories"; 
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException {
		assertMaxParams(0);			
		Category c = CommandDispatcher.getInstance().getCurrentCategory();
		if (c==null) {throw new 
			RetriableException("Can't execute - no current category defined");
		} 
		List subCats = c.getCategories();
		TreeSet sortedIds = new TreeSet();
		for (Iterator it = subCats.iterator(); it.hasNext();) {
			Category sub = (Category) it.next();
			sortedIds.add(new Integer(sub.getId()));
		}
		for (Iterator it = sortedIds.iterator(); it.hasNext();) {
			MedReporter.report(((Integer)it.next()).toString());
		}
	}

}