/*
 * Created on 05/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.test;


import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.command.MedReporter;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type TestGetStatus
 * @author sybenny
 * @version 1.0
 */
public class TestGetStatus extends ScriptCommand {
	
	/**
	 * Method TestGetStatus
	 */
	public TestGetStatus(){
		usage = "Should be: testGetStatus"; 
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException {	
		assertMaxParams(0);				
		Test t = CommandDispatcher.getInstance().getCurrentTest();
		if (t==null) {throw new 
			RetriableException("Can't execute - no current test defined");} 
		String statusCode = t.getStatus();
		String statusStr = new String("");
		if (statusCode.equals("U")) statusStr = new String("underConstruction");
		else if (statusCode.equals("G")) statusStr = new String("graded");
		else if (statusCode.equals("P")) statusStr = new String("published");
		MedReporter.report(statusStr);
	}
}
