/*
 * Created on 06/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.test;

import java.io.IOException;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.script.MedScript;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type TestSelectStudent
 * @author sybenny
 * @version 1.0
 */
public class TestSelectStudent extends ScriptCommand {
	/**
	 * Method TestSelectStudent
	 */
	public TestSelectStudent(){
		usage = "Should be: testSelectStudent id \"name\" notebookNum";  
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException, IOException {
		
		String id = null, name;
		int notebookNum;
		final int idSize = 9;
		
		assertMaxParams(3);				
		if (params.size()>0)
			id = (String)params.get(0);
		if (id==null || id.length()> idSize || !id.matches("[0-9]+")) {
			params.add(0,MedScript.askMissingParameter("id", usage));			
			id = (String)params.get(0);
			if (id==null || id.length() > idSize || !id.matches("[0-9]+")){
				throw new RetriableException("id should be a 9 digit number");
			}
		}
		
		if (!paramOfType(1,STRING)) 
			params.add(1,MedScript.askMissingParameter("name", usage));	
		name = extractString((String)params.get(1),"name");				
		
		if (!paramExists(2)) 
			params.add(2,MedScript.askMissingParameter("notebookNum", usage));	
		notebookNum = extractInt((String)params.get(2),"notebookNum");				
		
		Command c = new il.ac.technion.cs.course236308.e3.med.command.grading.
									TestSelectStudent(id, name, notebookNum);
		CommandDispatcher.getInstance().run(c);
	}

}
