/*
 * Created on 05/05/2004
 *
 */
package il.ac.technion.cs.course236308.e3.med.script.command.test;

import java.io.IOException;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.script.MedScript;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type TestSetDescription
 * @author sybenny
 * @version 1.0
 */
public class TestSetDescription extends ScriptCommand {
	/**
	 * Method TestSetDescription
	 */
	public TestSetDescription (){
		usage = "Should be: testSetDescription descNum  \"newDescText\"";  
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException, IOException {
		
		String newDescText;
		int descNum;
		
		assertMaxParams(2);				
		if (!paramOfType(0,INTEGER)) 
			params.add(0,MedScript.askMissingParameter("descNum", usage));			
		descNum = extractInt((String)params.get(0),"descNum");
		
		if (descNum!=1 && descNum!=2)
			throw new RetriableException("descNum should be 1 or 2");
		
		if (!paramExists(1))
			params.add(1,MedScript.askMissingParameter("newDescText", usage));	
		newDescText = extractString((String)params.get(1),"newDescText");				
				
		Command c = 
			new il.ac.technion.cs.course236308.e3.med.command.test.
								TestSetDescription(descNum,newDescText);
		CommandDispatcher.getInstance().run(c);
	}

}
