/*
 * Created on May 6, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.script.command.test;

import java.io.IOException;

import il.ac.technion.cs.course236308.e3.med.command.Command;
import il.ac.technion.cs.course236308.e3.med.command.CommandDispatcher;
import il.ac.technion.cs.course236308.e3.med.exception.MedException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.script.MedScript;
import il.ac.technion.cs.course236308.e3.med.script.command.ScriptCommand;

/**
 * Type TestSetStudentAnswers
 * @author sybenny
 * @version 1.0
 */
public class TestSetStudentAnswers extends ScriptCommand {
	
	/**
	 * Method TestSetStudentAnswers
	 */
	public TestSetStudentAnswers(){
		usage="Should be: testSetStudentAnswers \"answersStr\" [\"checkSums\"]"; 
	}
	/**
	 * Method execute
	 * @see ScriptCommand#execute()
	 */
	public void execute() throws MedException, IOException {
		
		String answersStr, checkSums=null;
		assertMaxParams(2);				
		if (!paramExists(0)) 
			params.add(0,MedScript.askMissingParameter("answersStr", usage));			
		answersStr = extractString((String)params.get(0),"answersStr");
		if (!answersStr.matches("[a-jx]+"))
			throw new RetriableException("answersStr should be a sequence of" +
							" letters from {a,b,...,j,x}");
			
		if (paramExists(1)) {
			checkSums = extractString((String)params.get(1),"checkSums");		
		}
		
		char[] answers = new char[answersStr.length()]; 
		for (int i=0; i<answersStr.length(); i++){
			answers[i] = answersStr.charAt(i);
		}
		String[] checkSumStrs = null;
		int[] checks = null;
		if (checkSums!=null){
		  try{
			checkSums = checkSums.trim();
			// \d means a digit and \s means any kind of space character. 
		  	if (!checkSums.matches("\\d+(\\s*,\\s*\\d+)*"))
		  		 throw new NumberFormatException();
			checkSumStrs = checkSums.split(",\\s*");
			checks = new int[checkSumStrs.length];
			for (int i=0; i<checkSumStrs.length; i++){
				checks[i] = (new Integer(checkSumStrs[i].trim())).intValue();
			}
		  }catch(NumberFormatException e){
			 throw new 
				 RetriableException("checkSums should be a list of comma " +
			 	"separated positive numbers");
		  }
		}
		/* FOR TESTING - PRINTING THE RESULTING VECTORS
		System.out.println("answers: ");
		for (int i=0; i<answers.length; i++){
			System.out.print(answers[i]+" ");
		}
		System.out.println("");
		if (checks!=null) {
			System.out.println("checks: "); 
			for (int i=0; i<checks.length; i++){
				System.out.print(checks[i]+" ");
			}
		}
		System.out.println("");	
		*/
		Command c = new il.ac.technion.cs.course236308.e3.med.command.
							grading.TestSetStudentAnswers(answers,checks);
		CommandDispatcher.getInstance().run(c);
	}

}
