package il.ac.technion.cs.course236308.e3.med.stats;

import java.util.Iterator;
import java.util.List;

import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestCategoryNode;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;

/**
 * @author Shraer Alexander
 *
 * Created in DS Laboratory - Technion, Israel 2004
 */
public class ComputeTestStatisticsDFS extends AbstractTreeDFS{
    double totalPoints;
    public ComputeTestStatisticsDFS(double totalPointsInTest){
        totalPoints = totalPointsInTest;
	}
	public void lastVisit(TestCategoryNode node){
		List tvsListCatOnly = node.getTestCategory().getTestVersions();
        Counter difficultyCounterCatOnly = new Counter();
        Counter validityCounterCatOnly = new Counter();
        double pointsCatOnly = 0;
        for (Iterator it = tvsListCatOnly.iterator(); it.hasNext();){
            TestVersion tv = (TestVersion)it.next();
            if (tv.getWeight()!=null) pointsCatOnly += tv.getWeight().doubleValue();
            difficultyCounterCatOnly.count(tv.getDifficulty(), 1);
            validityCounterCatOnly.count(tv.getDI(), 1);
        }
        node.setAvgDifficultyCatOnly(difficultyCounterCatOnly);
        node.setAvgValidityCatOnly(validityCounterCatOnly);
        node.setPercentOfWeightCatOnly(totalPoints==0? null : new Double(100*pointsCatOnly/totalPoints));
        node.setWeightCatOnly(pointsCatOnly);
        
        if (!node.isLeaf()){
            Counter difficultyCounterCatAndBellow  = new Counter(difficultyCounterCatOnly);
            Counter validityCounterCatAndBellow  =  new Counter(validityCounterCatOnly);
            double pointsCatAndBellow = pointsCatOnly;
            for (int i = 0; i<node.getChildCount(); i++){
                TestCategoryNode childNode = (TestCategoryNode)node.getChildAt(i);
                difficultyCounterCatAndBellow.count(childNode.getAvgDifficultyCatAndBellow().getAvg(), childNode.getAvgDifficultyCatAndBellow().getNumSpeciments());
                validityCounterCatAndBellow.count(childNode.getAvgValidityCatAndBellow().getAvg(), childNode.getAvgValidityCatAndBellow().getNumSpeciments());
                pointsCatAndBellow += childNode.getWeightCatAndBellow();
            }
            node.setAvgDifficultyCatAndBellow(difficultyCounterCatAndBellow);
            node.setAvgValidityCatAndBellow(validityCounterCatAndBellow);
            node.setPercentOfWeightCatAndBellow(totalPoints==0? null : new Double(100*pointsCatAndBellow/totalPoints));
            node.setWeightCatAndBellow(pointsCatAndBellow);
        }else {
            node.setAvgDifficultyCatAndBellow(difficultyCounterCatOnly);
            node.setAvgValidityCatAndBellow(validityCounterCatOnly);
            node.setPercentOfWeightCatAndBellow(totalPoints==0? null : new Double(100*pointsCatOnly/totalPoints));
            node.setWeightCatAndBellow(pointsCatOnly);
        }        
    }	
}