/*
 * Created on Apr 21, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.stats;

import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;

import java.util.*;




/**
 */
public class GradingTable {

	private HashMap questList = new HashMap(); //versionId -> GradingTableItem
    private Test test;
    private double sumQuestionWeight;
	
	public GradingTable(Test test){
        this.test = test;
        sumQuestionWeight = 0;
        for (Iterator it = test.getTestVersions().iterator(); it.hasNext();){
            TestVersion tv = (TestVersion)it.next(); 
            GradingTableItem gti = new GradingTableItem(tv);
            questList.put(new Integer(tv.getVersion().getId()), gti);
            sumQuestionWeight += tv.getWeight().doubleValue();
        }
 	}
	
   public Test getTest(){
        return test;
    }
    public HashMap getQuestionHash(){
    	return questList;
    }
    public double getPointsForAnswer(Integer verId, Integer ansId){
         GradingTableItem gti = (GradingTableItem)questList.get(verId);
         double questionWeight = gti.getQuestionWeight();
         double answerWeight = gti.getAnswerWeight(ansId)/100.0;
         return questionWeight * answerWeight;     
    }
    public double getSumQuestionsWeight(){
        return sumQuestionWeight;
    }
    public boolean isRightAnswer(Integer verId, Integer ansId){
        GradingTableItem gti = (GradingTableItem)questList.get(verId);
        int rightAnsId = gti.getRightAnswer();
        return (rightAnsId == ansId.intValue());
    }
}
