/*
 * Created on Jul 30, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.stats;

import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestCategoryNode;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Enumeration;


/**
 * @author Shraer Alexander
 *
 * Created in DS Laboratory - Technion, Israel 2004
 */
public class PrintTable {
	private TestCategoryNode root;
	private PrintWriter fileWriter;
	private String fileName;
	private StudentsStats studentStats;
	private ArrayList nodesDfsOrdered = new ArrayList();
	
	public PrintTable(TestCategoryNode node, String fileName, StudentsStats studentStats){
		root = node;
		this.fileName = fileName;
		this.studentStats = studentStats;
	}
	public void run() throws IOException{
		fileWriter = new PrintWriter(new BufferedWriter(new FileWriter(fileName)));
		ComputeColumnWidthDFS cwDfs = new ComputeColumnWidthDFS(studentStats, nodesDfsOrdered);
		cwDfs.dfs(root);
		int maxLevel = cwDfs.getMaxLevel();
		String picFilename = null;
		try{
			File pic = GeneralParams.ICON_HEADER2;
			picFilename = pic.getAbsolutePath();
		}catch (Exception e){}
		BufferedReader reader = null;
		try{
			File expl = new File("..\\images\\text\\InfoPageExplanation.txt");
			reader = new BufferedReader(new FileReader(expl.getAbsolutePath()));
		}catch (Exception e){}
		printHTMLHeader(picFilename, reader);
		printHeader(maxLevel);
		studentStats.printStudentsCategoryData(fileWriter, nodesDfsOrdered);
		printHTMLFooter();
		fileWriter.close();
	}
	private void printHTMLHeader(String picFilename, BufferedReader reader){
		fileWriter.println("<HTML>");
		fileWriter.println("<meta content=\"text/html; charset="+ GeneralParams.ENCODING +"\" http-equiv=\"Content-Type\" />");
		fileWriter.println("<HEAD><center>");
		if (picFilename!=null) fileWriter.println("<IMG SRC= \""+ picFilename +"\">");
		fileWriter.println("</center>");
		while (true){
			String str = null;
			try {
				str = reader.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			if(str == null)
				break;
			fileWriter.println(str);
		}
		fileWriter.println("</HEAD>");
		fileWriter.println("<BODY>");
		fileWriter.println("<TABLE border=\"1\">");
	}
	private void printHTMLFooter(){
		fileWriter.println("</TABLE>");
		fileWriter.println("<p/><TABLE>");
		fileWriter.println("<TR><TD><font color = green>Green</TD><TD>-</TD><TD>Student's normal grade in this category >= 0 (avg. norm. grade in the category)</TD></TR>");
		fileWriter.println("<TR><TD><font color = red>Red</TD><TD>-</TD><TD>Student's normal grade in this category < 0 (avg. norm. grade in the category)</TD></TR>");
		fileWriter.println("</TABLE>");
		fileWriter.println("</BODY>");
		fileWriter.println("</HTML>");
	}
	private void printHeader(int maxLevel){
		TestCategoryNode lastVisitedNode = null;
		int prevLevel =-1;
		int curWidthSum = 0;
		fileWriter.println("<THEAD>");
		for (Enumeration e = root.breadthFirstEnumeration();e.hasMoreElements() ;){
			TestCategoryNode node = (TestCategoryNode)e.nextElement();
			String catName = node.getTestCategory().getShortName();
			int columnWidth = node.getColumnWidth();
			boolean rowChanged = node.getRelativeLevel()!=prevLevel;
			boolean fatherChanged = lastVisitedNode!=null && node.getParent()!=lastVisitedNode.getParent();
			if(rowChanged || fatherChanged){
				if (prevLevel>0 && (((TestCategoryNode)lastVisitedNode.getParent()).getColumnWidth() > curWidthSum)){
					fileWriter.println("<TH align=\"center\" rowspan = " + (maxLevel - lastVisitedNode.getRelativeLevel() + 1) + ">"+((TestCategoryNode)lastVisitedNode.getParent()).getTestCategory().getShortName()+"</TH>");
					fileWriter.println("<TH align=\"center\" rowspan = " + (maxLevel - lastVisitedNode.getRelativeLevel() + 1) + ">Tot</TH>");
				}
				if (rowChanged){
					if (lastVisitedNode!=null) fileWriter.println("</TR>");
					fileWriter.println("<TR>");
					if (node.getRelativeLevel()==maxLevel){
						fileWriter.println("<TH>ID</TH>");
						fileWriter.println("<TH>Grade</TH>");
						fileWriter.println("<TH>N. Correct</TH>");
						fileWriter.println("<TH>Norm. Grade</TH>");
						fileWriter.println("<TH>Rel. Position</TH>");
						fileWriter.println("<TH>Dectile</TH>");
					}else {
						fileWriter.println("<TH colspan = 6/>");
					}
				}
				lastVisitedNode = node;
				curWidthSum = 0;
			}
			prevLevel = node.getRelativeLevel();
			curWidthSum += columnWidth;
			int rowspan = node.getDepth()==0? maxLevel - node.getRelativeLevel() + 1 : 1;
			fileWriter.println("<TH rowspan = " +  rowspan + " colspan=\"" + columnWidth + "\" align=\"center\">" + catName + "</TH>");
		}
		if (prevLevel>0 && (((TestCategoryNode)lastVisitedNode.getParent()).getColumnWidth() > curWidthSum)){
			fileWriter.println("<TH align=\"center\" rowspan = " + (maxLevel - lastVisitedNode.getRelativeLevel() + 1) + ">"+((TestCategoryNode)lastVisitedNode.getParent()).getTestCategory().getShortName()+"</TH>");
			fileWriter.println("<TH align=\"center\" rowspan = " + (maxLevel - lastVisitedNode.getRelativeLevel() + 1) + ">Tot</TH>");
		}
		if (lastVisitedNode!=null) fileWriter.println("</TR>");
		fileWriter.println("</THEAD>");
	}


	


}
