/*
 * Created on 20/07/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.stats;

import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestCategoryNode;
import il.ac.technion.cs.course236308.e3.med.model.TestVersion;

import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

/**
 * @author shralex
 *
 *  */
public class StudentAnswers implements Comparable
{
	
	private HashMap tv2Amap;  //verId -> ansId  
	private String studentId;
	private double grade = -1;
	private int rank = -1;
	private int numCorrectAnswers = -1;
	private HashSet correctAnsweredVersions; //set of all verIds answered correctly by this student
	private GradingTable gt;
	private HashMap catsHash; //catFullName -> StudentCatInfo 
	public StudentAnswers(String studentId)
	{
		tv2Amap = new HashMap();
		this.studentId = studentId;
		catsHash = new HashMap();
	}
	
	public void addReply(Integer verId, Integer ansId){
		tv2Amap.put(verId, ansId);
	}
	public int getChosenAnswer(int verId){
		return ((Integer)tv2Amap.get(new Integer(verId))).intValue();
	}
	public HashSet getCorrectlyAnsweredVersions(){
		return correctAnsweredVersions;
	}
	public double setGrade(GradingTable gt){
		this.gt = gt;
		grade = 0;
        numCorrectAnswers = 0;
        correctAnsweredVersions = new HashSet();
        
        double points = 0;
		for (Iterator it = tv2Amap.keySet().iterator(); it.hasNext();){
			Integer verId = (Integer)it.next();
			Integer ansId = (Integer)tv2Amap.get(verId);
			double ansPoints = gt.getPointsForAnswer(verId, ansId);
            points += ansPoints;
            if (gt.isRightAnswer(verId, ansId)) {
            	numCorrectAnswers++;
            	correctAnsweredVersions.add(verId);
            }
		}
        double totalPoints = gt.getSumQuestionsWeight();
        int maxGrade = gt.getTest().getMaxGrade();
        int minGrade = gt.getTest().getMinGrade();
        double factA = gt.getTest().getFactorConstA();
        double factB = gt.getTest().getFactorConstB();
        if (totalPoints>0) {
        	grade = (points/totalPoints)*(maxGrade-minGrade) + minGrade; 
        	grade = factA*grade + factB;
        	if (grade > maxGrade) grade = maxGrade;
        	else if (grade<minGrade) grade = minGrade;
		}
        return grade;
	}

	public double getGrade(){
        return grade;
	}
	public void setRank(int rank){
		this.rank = rank;
	}
	public int getRank(){
		return rank;
	}
	public int getNumCorrectAnswers(){
        return numCorrectAnswers;
	}
	public String getStudentId(){
		return studentId;
	}
	public HashMap getAnswersHash(){
		return tv2Amap;
	}
	public int compareTo(Object o)
	{
		StudentAnswers other = (StudentAnswers)o;	
		if (this.getGrade()<other.getGrade()) return -1;
		else if (this.getGrade()>other.getGrade()) return 1;
		int compRes = studentId.compareTo(other.getStudentId());
		if (compRes>0) return 1;
		if (compRes<0) return -1;
		return 0;
	}
	

	public double getPointsForVersion(TestVersion tv){
		Integer verId = new Integer(tv.getVersion().getId());
		Integer ansId = (Integer)tv2Amap.get(verId);
		return ansId==null ? 0: gt.getPointsForAnswer(verId, ansId);
	}

	public void processCategory(TestCategoryNode node){
		String catFullName = node.getTestCategory().getLongName();
		List tvsList = node.getTestCategory().getTestVersions();
		StudentCatInfo sci = new StudentCatInfo(studentId, catFullName);
		catsHash.put(catFullName, sci);
		double pointsBellow = 0;
		double pointsHere = 0;
		double totalPointsBellow = 0;
		double totalPointsHere = 0;
		
		if (!node.isLeaf()){
			for (int i=0; i<node.getChildCount(); i++){
				String childName = ((TestCategoryNode)node.getChildAt(i)).getTestCategory().getLongName();
				StudentCatInfo childSCI = (StudentCatInfo)catsHash.get(childName);
				pointsBellow += childSCI.getPointsCatAndBellow();
				totalPointsBellow += childSCI.getTotalPointsCatAndBellow();
			}
		}
		for (Iterator it = tvsList.iterator(); it.hasNext(); ){
			TestVersion tv = (TestVersion)it.next();
			pointsHere += getPointsForVersion(tv);
			totalPointsHere += tv.getWeight().doubleValue();				
		}
		sci.setPointsCatOnly(pointsHere);
		sci.setTotalPointsCatOnly(totalPointsHere);
		sci.setPointsCatAndBellow(pointsHere + pointsBellow);
		sci.setTotalPointsCatAndBellow(totalPointsBellow + totalPointsHere);
	}
	
	public Double getGradeCategoryOnly(String catFullName){
		StudentCatInfo sci = (StudentCatInfo)catsHash.get(catFullName);
		double totalPoints = sci.getTotalPointsCatOnly();
		if (totalPoints == 0) return null;
		int maxGrade = gt.getTest().getMaxGrade();
		int minGrade = gt.getTest().getMinGrade();
		double factA = gt.getTest().getFactorConstA();
		double factB = gt.getTest().getFactorConstB();
		double grade = (sci.getPointsCatOnly() / totalPoints)*(maxGrade-minGrade) + minGrade;
		grade = grade * factA + factB;
		return new Double(grade);
	}
	public Double getGradeCategoryAndBellow(String catFullName){
		StudentCatInfo sci = (StudentCatInfo)catsHash.get(catFullName);
		double totalPoints = sci.getTotalPointsCatAndBellow();
		if (totalPoints == 0) return null;
		int maxGrade = gt.getTest().getMaxGrade();
		int minGrade = gt.getTest().getMinGrade();
		double factA = gt.getTest().getFactorConstA();
		double factB = gt.getTest().getFactorConstB();
		double grade = (sci.getPointsCatAndBellow() / totalPoints)*(maxGrade-minGrade) + minGrade;
		grade = grade * factA + factB;
		return new Double(grade);
	}
	public StudentCatInfo getCatInfo(String fullName){
		return (StudentCatInfo)catsHash.get(fullName);
	}
	public Double getNormalGradeCatOnly(String catFullName){
		StudentCatInfo sci = (StudentCatInfo)catsHash.get(catFullName);
		return sci.getNormalGradeCatOnly();
	}
	public Double getNormalGradeCatAndBellow(String catFullName){
		StudentCatInfo sci = (StudentCatInfo)catsHash.get(catFullName);
		return sci.getNormalGradeCatAndBellow();
	}
	public List getStudentTableRow(List orderedNodes){
		ArrayList resList = new ArrayList();
		for (Iterator it = orderedNodes.iterator(); it.hasNext();){
			TestCategoryNode node = (TestCategoryNode)it.next();
			String catFullName = node.getTestCategory().getLongName();
			StudentCatInfo sci = (StudentCatInfo)catsHash.get(catFullName);
			Double catOnlyNormalGrade = sci.getNormalGradeCatOnly();
			Double catAndBellowNormalGrade = sci.getNormalGradeCatAndBellow();
			resList.add(catOnlyNormalGrade);
			if (!node.isLeaf()) resList.add(catAndBellowNormalGrade);		
		}
		return resList; 
	}

	public void printStudentTableRow(PrintWriter fileWriter, List orderedNodes, Double normGrade){
		for (Iterator it = getStudentTableRow(orderedNodes).iterator(); it.hasNext();){
			Double curNormGrade = (Double) it.next();
			fileWriter.print("<TD align = \"center\">");
			if (curNormGrade == null){
				fileWriter.print("N/A");
			}else {
				String curNormGradeStr = curNormGrade.toString();
				int ind = curNormGradeStr.indexOf(".");
				if (ind>=0) curNormGradeStr = curNormGradeStr.substring(0,(curNormGradeStr.length()>=(ind+4))? ind+4: curNormGradeStr.length());
				curNormGrade = new Double(curNormGradeStr);
				if (normGrade!=null) {
					String normGradeStr = normGrade.toString();
					ind = normGradeStr.indexOf(".");
					if (ind>=0) normGradeStr = normGradeStr.substring(0,(normGradeStr.length()>=(ind+4))? ind+4: normGradeStr.length());
					double normGradeVal = (new Double(normGradeStr)).doubleValue();
					if (curNormGrade.doubleValue() < 0){//normGradeVal) {
						fileWriter.print("<font color = red>");
					} 
					else fileWriter.print("<font color = green>");
				}
				fileWriter.print(curNormGradeStr);				
			}
			fileWriter.print("</TD>");
		}
	}
	

		
	
}
