/*
 * Created on 20/07/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.stats;

import il.ac.technion.cs.course236308.e3.med.exception.CriticalException;
import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.gui.treenodes.TestCategoryNode;
import il.ac.technion.cs.course236308.e3.med.model.AnswersFactory;
import il.ac.technion.cs.course236308.e3.med.model.Test;
import il.ac.technion.cs.course236308.e3.med.model.TestRepliesFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestReply;
import il.ac.technion.cs.course236308.e3.med.model.TestTaker;
import il.ac.technion.cs.course236308.e3.med.model.TestTakersFactory;
import il.ac.technion.cs.course236308.e3.med.model.TestsFactory;

import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.TreeSet;


/**
 * @author shralex
 *
 *  */
public class StudentsStats
{
	private GradingTable gradingTable;
	private HashMap allStudents = new HashMap();
	private TreeSet sortedStudents;
	private TreeSet sortedNumCorrectAnswers;
	private int numStudents;
	private int testId;
	private int numStudentsFailed;
	private double gradeSum;
	private Double std;
	private HashMap roundedValues;
	private int totalCorrectAnswersNum, totalCorrectAnswersNum2;
	private HashMap numCorrectAnswersToQuestions; //verId -> numCorrectAnswers 
	private HashMap answersHash; //answerId -> AnswerInfo
								 //answersHash is only those that were answered - not all answers!
	private HashMap numAnswersForQuestion; //verId -> Integer
	
	public StudentsStats(int testId) throws RetriableException, CriticalException 
	{
		this.testId = testId;
		collectReplies();
	}
	
	public void updateGradingTable() throws RetriableException, CriticalException {
		gradingTable = new GradingTable(TestsFactory.getInstance().getTest(testId));
		calcGrades(gradingTable);
	}
	
	public void collectReplies() throws RetriableException, CriticalException{
		numCorrectAnswersToQuestions = new HashMap();
		numAnswersForQuestion = new HashMap();
		List allReplies = TestRepliesFactory.getInstance().getTestRepliesList(testId);
		for (Iterator iter = allReplies.iterator(); iter.hasNext();){
			TestReply tr = (TestReply)iter.next();
			if (!allStudents.containsKey(tr.getTestTakerId())){
				allStudents.put(tr.getTestTakerId(), new StudentAnswers(tr.getTestTakerId()));
			}
			StudentAnswers sa = (StudentAnswers)allStudents.get(tr.getTestTakerId());
			Integer verId = new Integer(AnswersFactory.getInstance().getAnswer(tr.getAnswerId()).getVersionId());
			sa.addReply(verId, new Integer(tr.getAnswerId()));
			if (!numAnswersForQuestion.containsKey(verId)){
				numAnswersForQuestion.put(verId, new Integer(1));
			}else {
				int cur =  ((Integer)numAnswersForQuestion.get(verId)).intValue();
				numAnswersForQuestion.put(verId, new Integer(cur+1));
			}
		}
		Test test = TestsFactory.getInstance().getTest(testId);
		List testTakers = TestTakersFactory.getInstance().getTestTakersOfTest(test);
		for (Iterator it = testTakers.iterator();it.hasNext();){
			TestTaker tt = (TestTaker)it.next();
			if (!allStudents.containsKey(tt.getId())){
				allStudents.put(tt.getId(), new StudentAnswers(tt.getId()));
			}		
		}
		numStudents = allStudents.size();
	}

	private void calcGrades(GradingTable gt) throws CriticalException, RetriableException{
		roundedValues = new HashMap();
		answersHash = new HashMap();
		gradeSum = 0;
		int gradeSum2 = 0;
		totalCorrectAnswersNum = 0;
		totalCorrectAnswersNum2 = 0;
		numStudentsFailed = 0;
		int passThresh = gt.getTest().getPassingGrade();
		
		sortedNumCorrectAnswers = new TreeSet(new StudentAnswersCorrectAnswersComparator());
		for (Iterator it = gt.getQuestionHash().keySet().iterator(); it.hasNext();){
			Integer verId = (Integer)it.next();
			numCorrectAnswersToQuestions.put(verId, new Integer(0));
			if (!numAnswersForQuestion.containsKey(verId)){
				numAnswersForQuestion.put(verId, new Integer(0));
			}
		}
		
		for (Iterator it = allStudents.keySet().iterator(); it.hasNext();){
			String testTakerId = (String) it.next();
			StudentAnswers sa = (StudentAnswers)allStudents.get(testTakerId);
			double grade = sa.setGrade(gt);
			if (grade<passThresh) numStudentsFailed++;
			gradeSum += grade;
			gradeSum2 += grade * grade;
			Integer intGrade = new Integer(Math.round((float)grade));
			
			int correctAnswersNum = sa.getNumCorrectAnswers();
			sortedNumCorrectAnswers.add(sa);
		
			HashSet saCorrectVersions = sa.getCorrectlyAnsweredVersions();
			for (Iterator iter = saCorrectVersions.iterator(); iter.hasNext();){
				Integer verId = (Integer)iter.next();
				Integer curNum = (Integer)numCorrectAnswersToQuestions.get(verId);
				numCorrectAnswersToQuestions.put(verId, new Integer(curNum.intValue() + 1));
			}
			
			totalCorrectAnswersNum += correctAnswersNum;
            totalCorrectAnswersNum2 += correctAnswersNum * correctAnswersNum;
			if(roundedValues.containsKey(intGrade)){
				int speciments = ((Integer)roundedValues.get(intGrade)).intValue();
				roundedValues.put(intGrade,new Integer(speciments + 1));
			}
			else{
				roundedValues.put(intGrade,new Integer(1));
			}
		}
		// (m0*m2-m1*m1)/(m0*(m0-1))
		if (numStudents >1) {
			double variance = (numStudents*gradeSum2 - gradeSum * gradeSum)/
										((double)numStudents*(numStudents-1));
			std = new Double(Math.sqrt(variance));
		} else std = null;
		
		sortedStudents = new TreeSet(allStudents.values());		
		int rank = numStudents;
		for (Iterator it = sortedStudents.iterator(); it.hasNext(); rank = rank -1){
			StudentAnswers sa = ((StudentAnswers)it.next());
			sa.setRank(rank);
			updateAnswersHash(sa, sa.getAnswersHash());
		}
		

	}
	private void updateAnswersHash(StudentAnswers sa, HashMap studentAnswersHash) throws CriticalException, RetriableException{
		double grade = sa.getGrade();
		Double normGrade = getStudentNormalizedGrade(sa.getStudentId());
		for (Iterator it = studentAnswersHash.keySet().iterator(); it.hasNext();){
			Integer verId = (Integer)it.next();
			Integer chosenAnsId =  (Integer)studentAnswersHash.get(verId);
			if (!answersHash.containsKey(chosenAnsId)){
				answersHash.put(chosenAnsId, new AnswerInfo(chosenAnsId));
			}
			AnswerInfo aInfo = (AnswerInfo)answersHash.get(chosenAnsId);
			aInfo.addStudentInfo(grade, normGrade);
		}
	}
	public int getNumStudentsFailed(){
		return numStudentsFailed;
	}
	public HashMap getRoundedGradeHash(){
        return roundedValues;
	}
    public HashMap getAnswersHash(){
    	return answersHash;
    }
	public int getNumStudents(){
		return numStudents;
	}
	public double getMin(){
		return ((StudentAnswers)sortedStudents.first()).getGrade();
	}
	public double getMax(){
		return ((StudentAnswers)sortedStudents.last()).getGrade();
	}
	public double getRange(){
		return getMax() - getMin();
	}
	public Double getStd(){
		return std;
	}
	public Double getAverage(){
		if (numStudents == 0) return null;
		return new Double(gradeSum / numStudents);
	}
	
	public Double getStandardError(){
		if (numStudents==0 || std == null) return null;
		return new Double(std.doubleValue()/numStudents);
	}
	
	public Double getStdDivAvg(){
		Double avg = getAverage();
		if (std==null || avg==null || avg.doubleValue() == 0) return null;
		return new Double(std.doubleValue()/avg.doubleValue());
	}
	public TreeSet getStudentIds(){
		TreeSet ts = new TreeSet(allStudents.keySet());
		return ts;
	}
    public double getStudentGrade(String studentId){
        StudentAnswers sa = (StudentAnswers)allStudents.get(studentId);
        return sa.getGrade();
    }
    public int getNumCorrectAnswers(String studentId){
        StudentAnswers sa = (StudentAnswers)allStudents.get(studentId);
        return sa.getNumCorrectAnswers();
    }

    public Double getStudentNormalizedGrade(String studentId){
        if (std==null || std.doubleValue() == 0) return null;
        return new Double((getStudentGrade(studentId)-getAverage().doubleValue())/std.doubleValue());
    }
    public int getStudentRank(String studentId){
        StudentAnswers sa = (StudentAnswers)allStudents.get(studentId);
        return sa.getRank();
    }

    public int getStudentDectile(String studentId){
        int i = 0;
        double grade = ((StudentAnswers)allStudents.get(studentId)).getGrade();
        do{
            i += 1;
        }while (i<10 && Med(i/10.0)<grade);
        if (i<10 && Med(i/10.0)==grade) i++;
        return i;
    }
     
	/**
	 *  lower quartile = Med(0.25),
	 *  median = Med(0.5),
	 *  upper quartile = Med(0.75),
	 *  D1, D2, ... ,D9 = Med(0.1), Med(0.2), ...,  Med(0.9)
	**/	
	public double Med(double fract){
	  int low = (int)Math.floor(fract * (numStudents- 1));
	  int high =(int)Math.round(fract * (numStudents- 1));
	  StudentAnswers[] studArray = new StudentAnswers[sortedStudents.size()];
	  sortedStudents.toArray(studArray);
	  return fract * (studArray[low]).getGrade() + 
	  		(1 - fract) * (studArray[high]).getGrade();
	}
	
    public List getStudentsInLowThirdGrades(){
    	ArrayList lst = new ArrayList();
    	double lowThird = Med(1.0/3);
    	Iterator it = sortedStudents.iterator();
    	while (it.hasNext()){
    		StudentAnswers sa = (StudentAnswers)it.next();
    		if (sa.getGrade()>lowThird) break;
    		lst.add(sa);
    	}
    	return lst;
    }
    
    public List getStudentsInHighThirdGrades(){
    	ArrayList lst = new ArrayList();
    	double highThird = Med(2.0/3);
    	Iterator it = sortedStudents.iterator();
    	while (it.hasNext()){
    		StudentAnswers sa = (StudentAnswers)it.next();
    		if (sa.getGrade()>=highThird)
    			lst.add(sa);
    	}
    	return lst;
    }
    
	/**
     * 
     * @param lowGrade - inclusive
     * @param highGrade - exclusive
     * @return array of 2 elements: index 0: num students in range 
     *                              index 1: num students in range or below range
     */
	public int[] getRangeGradesInfo(double lowGrade, double highGrade){
        int[] res = new int[2];
        res[0]=0;res[1]=0;
        for (Iterator it = sortedStudents.iterator(); it.hasNext();){
            double grade = ((StudentAnswers)it.next()).getGrade();
            if (grade<highGrade){
                res[1]++;
                if (grade>=lowGrade) res[0]++;    
            }
        }
        return res;
	}
    	

	public GradingTable getGradingTable() {
		return gradingTable;
	}
	/**
	 * @return Returns the total number of correct answers in the test
	 */
	
	public Double getAvgRightAnswersPerStudent(){
		if (numStudents == 0) return null;
		return new Double(((double)totalCorrectAnswersNum)/ numStudents);
	}
	
	public Double getStdRightAnswersPerStudent(){
		double m0 = numStudents;
		double m1 = totalCorrectAnswersNum;
		double m2 = totalCorrectAnswersNum2;
		if (m0<2) return null;
		double stdCorrectAnswers = Math.sqrt((m0*m2-m1*m1)/(m0*(m0-1)));
		return new Double(stdCorrectAnswers);
	}
	public double getLowThirdRightAnswersPerStudent(){
		return MedCorrectAnswers(1.0/3);
	}
	public double getHighThirdRightAnswersPerStudent(){
		return MedCorrectAnswers(2.0/3);
	}
	private double MedCorrectAnswers(double fract){
		int low = (int)Math.floor(fract * (numStudents- 1));
		int high =(int)Math.round(fract * (numStudents- 1));
		StudentAnswers[] arr = new StudentAnswers[sortedNumCorrectAnswers.size()];
		sortedNumCorrectAnswers.toArray(arr);
		return fract * (arr[low]).getNumCorrectAnswers() + 
		  		(1 - fract) * (arr[high]).getNumCorrectAnswers();
	}
	
	public HashMap getCorrectAnswersPerQuestion(){
		return numCorrectAnswersToQuestions;
	}
	
	
	public Double getNormalGradeCatOnly(String studentId, String catFullName){
		StudentAnswers sa = (StudentAnswers)allStudents.get(studentId);
		return sa.getNormalGradeCatOnly(catFullName);
	}
	public Double getNormalGradeCatAndBellow(String studentId, String catFullName){
		StudentAnswers sa = (StudentAnswers)allStudents.get(studentId);
		return sa.getNormalGradeCatAndBellow(catFullName);
	}
	
	public void processCategory(TestCategoryNode node){
		String catFullName = node.getTestCategory().getLongName();
		double sumGradesCatOnly = 0;
		double sumGradesCatOnly2 = 0;
		double sumGradesCatAndBellow = 0;
		double sumGradesCatAndBellow2 = 0;
		for (Iterator it = sortedStudents.iterator(); it.hasNext();){
			StudentAnswers sa = (StudentAnswers)it.next();
			sa.processCategory(node);
			Double gradeCatOnly =  sa.getGradeCategoryOnly(catFullName);
			if (gradeCatOnly!=null) {
				sumGradesCatOnly += gradeCatOnly.doubleValue();
				sumGradesCatOnly2 += gradeCatOnly.doubleValue()*gradeCatOnly.doubleValue();
			} 
			Double gradeCatAndBellow = sa.getGradeCategoryAndBellow(catFullName);
			if (gradeCatAndBellow!=null) {
				sumGradesCatAndBellow += gradeCatAndBellow.doubleValue();
				sumGradesCatAndBellow2 += gradeCatAndBellow.doubleValue()*gradeCatAndBellow.doubleValue();
			} 
		}		
		Double stdCatOnly = null, avgCatOnly = null, stdCatAndBellow = null, avgCatAndBellow = null;
		double m0 = numStudents;
		double m1 = sumGradesCatOnly;
		double m2 = sumGradesCatOnly2;
		if (m0>1) stdCatOnly = new Double(Math.sqrt((m0*m2-m1*m1)/(m0*(m0-1))));
		if (m0>0) avgCatOnly = new Double(sumGradesCatOnly / numStudents);
		
		m1 = sumGradesCatAndBellow;
		m2 = sumGradesCatAndBellow2;
		if (m0>1) stdCatAndBellow = new Double(Math.sqrt((m0*m2-m1*m1)/(m0*(m0-1))));
		if (m0>0) avgCatAndBellow = new Double(sumGradesCatAndBellow / numStudents);
		
		for (Iterator it = sortedStudents.iterator(); it.hasNext();){
			StudentAnswers sa = (StudentAnswers)it.next();
			Double gradeCatOnly =  sa.getGradeCategoryOnly(catFullName);
			StudentCatInfo sci = sa.getCatInfo(catFullName);
			if (gradeCatOnly!=null && stdCatOnly!=null && avgCatOnly!=null && stdCatOnly.doubleValue()!=0) {
				double normGrade = (gradeCatOnly.doubleValue() - avgCatOnly.doubleValue())/stdCatOnly.doubleValue();
				sci.setNormalGradeCatOnly(new Double(normGrade));
			}else {sci.setNormalGradeCatOnly(null);} 
			Double gradeCatAndBellow = sa.getGradeCategoryAndBellow(catFullName);
			if (gradeCatAndBellow!=null && avgCatAndBellow!=null && stdCatAndBellow!=null && stdCatAndBellow.doubleValue()!=0) {
				double normGrade = (gradeCatAndBellow.doubleValue() - avgCatAndBellow.doubleValue())/stdCatAndBellow.doubleValue();
				sci.setNormalGradeCatAndBellow(new Double(normGrade));
			} else {sci.setNormalGradeCatAndBellow(null);} 
		}
   }
	
   public List getCatsPercentsRow(List orderedNodes){
	   ArrayList resList = new ArrayList();

	   for (Iterator it = orderedNodes.iterator(); it.hasNext();){
		   TestCategoryNode node = (TestCategoryNode)it.next();
		   Double percentsCatOnly = node.getPercentOfWeightCatOnly();
		   Double percentsCatAndBellow = node.getPercentOfWeightCatAndBellow();
		   resList.add(percentsCatOnly);
		   if (!node.isLeaf()) 
			   resList.add(percentsCatAndBellow);
	   }
	   return resList;
   }
   public void printCatsPercents(PrintWriter fileWriter, List orderedNodes){
	   for (Iterator it = getCatsPercentsRow(orderedNodes).iterator(); it.hasNext();){
		   Double percent = (Double)it.next();
		   fileWriter.print("<TD align = \"center\">");
		   if (percent==null) fileWriter.print("N/A");
		   else {
				String percentStr = percent.toString(); 
				int ind = percentStr.indexOf(".");
				if (ind>=0) percentStr = percentStr.substring(0,ind);
		   		fileWriter.print(percentStr + "%");
		   	} 
		   fileWriter.print("</TD>");
	   }
   }
	public  void printStudentsCategoryData(PrintWriter fileWriter, List orderedNodes){
		fileWriter.println("<TR>");
		fileWriter.println("<TD align = \"left\" colspan = 6>Categories Info</TD>");
		printCatsPercents(fileWriter,orderedNodes);
		fileWriter.println("</TR>");
		for (Iterator it = sortedStudents.iterator(); it.hasNext();){
			fileWriter.println("<TR>");
			StudentAnswers sa = (StudentAnswers)it.next();
			String studentId = sa.getStudentId();

			Double normGrade = getStudentNormalizedGrade(studentId);
			String normGradeStr = "N/A";
			if (normGrade!=null) {
				normGradeStr = normGrade.toString(); 
				int ind = normGradeStr.indexOf(".");
				if (ind>=0) normGradeStr = normGradeStr.substring(0,(normGradeStr.length()>=(ind+4))? ind+4: normGradeStr.length());
			}	
			String gradeStr = Double.toString(sa.getGrade());
			int ind = gradeStr.indexOf(".");
			if (ind>=0) gradeStr = gradeStr.substring(0,(gradeStr.length()>=(ind+2))? ind+2: gradeStr.length());
			
			fileWriter.println("<TD align = \"center\">"+ sa.getStudentId()+ "</TD>");
			fileWriter.println("<TD align = \"center\">"+ gradeStr + "</TD>");
			fileWriter.println("<TD align = \"center\">"+ sa.getNumCorrectAnswers() + "</TD>");
			fileWriter.println("<TD align = \"center\">"+ normGradeStr + "</TD>");
			fileWriter.println("<TD align = \"center\">"+ sa.getRank()+ "</TD>");
   		    fileWriter.println("<TD align = \"center\">"+ ((numStudents < 30) ? "N/A" : Integer.toString(getStudentDectile(studentId)))+ "</TD>");
	//		fileWriter.println("<TD align = \"center\">"+ getStudentDectile(studentId)+ "</TD>");
			sa.printStudentTableRow(fileWriter,orderedNodes, normGrade);
			fileWriter.println("</TR>");
		}
	}
	public List getStudentCategoriesRow(String studentId, List orderedNodes){
		StudentAnswers sa = (StudentAnswers)allStudents.get(studentId);
		return sa.getStudentTableRow(orderedNodes);
	}

	
	private class  StudentAnswersCorrectAnswersComparator implements Comparator{
	    public int compare(Object obj1, Object obj2){
	        StudentAnswers sa1 = (StudentAnswers) obj1;
	        StudentAnswers sa2 = (StudentAnswers) obj2;
	        if(sa1.getNumCorrectAnswers() > sa2.getNumCorrectAnswers())
	            return 1;
	        if(sa1.getNumCorrectAnswers() < sa2.getNumCorrectAnswers())
	 			return -1;
	 		int cmpRes = sa1.getStudentId().compareTo(sa2.getStudentId());
	        if(cmpRes > 0) return 1;
	 		else if (cmpRes < 0) return -1;
	        return 0;
	   }
	}
	
	public Integer getNumAnswersToQuestion(int verId){
		return (Integer)numAnswersForQuestion.get(new Integer(verId));
	}
}
