package il.ac.technion.cs.course236308.e3.med.xmlTools;


import il.ac.technion.cs.course236308.e3.med.parameters.AnswerParams;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.XMLFilterImpl;

/**
 * Type AnswerXML2HTML
 * @author sybenny
 * @version 1.0
 */
public class AnswerXML2HTML extends XMLFilterImpl
{ 
  /**
   * Method AnswerXML2HTML
   */
  public AnswerXML2HTML ()
  {
  }

  /**
   * Method AnswerXML2HTML
   * @param parent
   */
  public AnswerXML2HTML (XMLReader parent)
  {
    super(parent);
  }

 /**
 * Method startElement
 * @see XMLFilterImpl#startElement(String, String, String, Attributes)
 */
  public void startElement (String uri,String localName,String qName,
  					Attributes atts)throws SAXException{
  	 String ans;
     if (qName.equals("ref") && (ans = atts.getValue("ans"))!=null){
       	byte ansInt = Byte.parseByte(ans);
       	if (ansInt>AnswerParams.MAX_ANSWERS_PER_VERSION || ansInt<1) 
       				throw new NumberFormatException(); 
       	char ansChr = (char)(ansInt+'A'-1);
		char[] ansChrs = new char[1];
  	    ansChrs[0] = ansChr;
		super.characters(ansChrs, 0, 1);
       
     }
      super.startElement(uri, localName, qName, atts);
  }
	
  
  /*public static void main (String args[]) {

	 XMLReader xmlReader = null;
      
	 try {

		SAXParserFactory spfactory = 
			   SAXParserFactory.newInstance();
		spfactory.setValidating(false);
		SAXParser saxParser = 
					  spfactory.newSAXParser();

		xmlReader = saxParser.getXMLReader();

		AnswerFilter xmlFilter = new AnswerFilter();
		xmlFilter.setParent(xmlReader);


		xmlFilter.setContentHandler(new AnswerFilter());

		xmlFilter.setErrorHandler(new AnswerFilter());
		 
		InputSource source = new InputSource("test.xml");

		xmlFilter.parse(source);		 
 
		} catch (Exception e) {
			  System.err.println(e);
			  System.exit(1);
		}
	 }
*/
}
