package il.ac.technion.cs.course236308.e3.med.xmlTools;

/**
 * @author shralex
 *
 *
 */

import java.io.IOException;
import java.io.StringReader;

import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.parameters.AnswerParams;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.xml.sax.InputSource;

/**
 * Type TextCorrectnessChecker
 * @author sybenny
 * @version 1.0
 */
public class TextCorrectnessChecker {
	
	private String text;
	
	private static SAXBuilder builder =	new SAXBuilder("org.apache.xerces.parsers.SAXParser", true);

	/**
	 * Method TextCorrectnessChecker
	 * @param text
	 */
	public TextCorrectnessChecker(String text) {
		this.text = 
		"<text xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"  " +
				"xsi:noNamespaceSchemaLocation=\"" + 
							AnswerParams.XSD_RELATIVE_FILE_PATH
			                                  + "\"> " + text +  "</text>";
	}
	/**
	 * Method validate
	 * @throws RetriableException
	 */
	public void validate() throws RetriableException {
		InputSource source = new InputSource(new StringReader(text));
		source.setEncoding(GeneralParams.ENCODING);
		try {
			builder.setFeature
				("http://apache.org/xml/features/validation/schema", true);
			builder.build(source);
		} catch (IOException e) {
			String s = e.getMessage();
			if (s.lastIndexOf("line ")>=0) {
				s = s.substring(s.lastIndexOf("line "));
				if (s.indexOf(":")>=0) s = s.substring(s.indexOf(":")+1);
			}
			if (s.lastIndexOf("cvc-")>=0) {
				s = s.substring(s.lastIndexOf("cvc-"));
				if (s.indexOf(":")>=0) s = s.substring(s.indexOf(":")+1);
			}
			throw new RetriableException(s.trim());
		} catch (JDOMException e) {
			String s = e.getMessage();
		if (s.lastIndexOf("line ")>=0) {
			s = s.substring(s.lastIndexOf("line "));
			if (s.indexOf(":")>=0) s = s.substring(s.indexOf(":")+1);
		}
		if (s.lastIndexOf("cvc-")>=0) {
			s = s.substring(s.lastIndexOf("cvc-"));
			if (s.indexOf(":")>=0) s = s.substring(s.indexOf(":")+1);
		}
		throw new RetriableException(s.trim());
		}
	}
}


