/*
 * Created on 16/05/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package il.ac.technion.cs.course236308.e3.med.xmlTools;

/**
 * @author svali
 *
 * 
 */
import java.io.FileWriter;
import java.io.IOException;

import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import il.ac.technion.cs.course236308.e3.med.parameters.GeneralParams;

import org.jdom.DocType;
import org.jdom.Document;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;
import org.jdom.transform.XSLTransformer;
import org.xml.sax.helpers.XMLFilterImpl;
/**
 * Type XML2HTML
 * @author Shraer Alexander
 * @version 1.0
 */
public class XML2HTML {
	private XML2HTML() {}

	/**
	 * Method xml2html
	 * @param xmlFilename
	 * @param xslFilename
	 * @param htmlFilename
	 * @throws RetriableException
	 */
	public static void xml2html(String xmlFilename,	String xslFilename,	
						String htmlFilename) throws RetriableException{
		String docname = xmlFilename;
		String sheetname = xslFilename;
		try {
			SAXBuilder builder = new SAXBuilder();
			XMLFilterImpl echo = new XMLFilterImpl();
			builder.setXMLFilter(new AnswerXML2HTML(echo));
			Document doc;
			doc = builder.build(docname);
		
		XSLTransformer transformer = new XSLTransformer(sheetname);
		
		Document doc2 = transformer.transform(doc);
		doc2.setDocType(new DocType("html", "-//W3C//DTD XHTML 1.0 Transitional//EN", "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"));
		XMLOutputter outp = new XMLOutputter(Format.getPrettyFormat());
		
		outp.getFormat().setEncoding(GeneralParams.ENCODING);
		FileWriter fw = new FileWriter(htmlFilename);
		outp.output(doc2, fw);
		fw.close();
		} catch (IOException e1) {
			throw new RetriableException(e1.getMessage());
		} catch (JDOMException e) {
			throw new RetriableException(e.getMessage());
		}
	  }
	  public static void main(String[] args) throws RetriableException{
	  	XML2HTML.xml2html("c:\\students.xml", "c:\\students.xsl","c:\\students.html");
	  }
}


