package il.ac.technion.cs.course236308.e3.med.xmlTools;

/**
 * @author shralex
 *
 * 
 */

import java.io.File;
import java.io.IOException;

import il.ac.technion.cs.course236308.e3.med.exception.RetriableException;
import org.jdom.Document;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;


/**
 * Type XMLImporter
 * @author sybenny
 * @version 1.0
 */
public class XMLImporter {
	
	private String xmlFileName;
	private String xsdFileName;
	public static SAXBuilder builder =
        new SAXBuilder("org.apache.xerces.parsers.SAXParser", true);
	/**
	 * Method XMLImporter
	 * @param xmlFileName
	 * @param xsdFileName
	 */
	public XMLImporter(String xmlFileName, String xsdFileName) {
		this.xmlFileName = xmlFileName;
		File f = new File(xsdFileName);
		this.xsdFileName = f.getAbsolutePath();
		
	}
	/**
	 * Method build
	 * @return Document
	 * @throws RetriableException
	 */
	public Document build() throws RetriableException {
		try {
			
			builder.setFeature
			("http://apache.org/xml/features/validation/schema", true);
			builder.setProperty
			("http://apache.org/xml/properties/schema/external-" +
				"noNamespaceSchemaLocation",xsdFileName); 
			
			Document doc = builder.build(xmlFileName);
			return doc;
		} catch (IOException e) {
			throw new RetriableException(e.getMessage().trim());
		} catch (JDOMException e) {
			throw new RetriableException(e.getMessage().trim());
		}
	}
}
